#pragma once

#include "../sdk/inc/TUCamApi.h"

#ifdef _WIN64
#pragma comment(lib, "../sdk/lib/x64/TUCam.lib")
#else
#pragma comment(lib, "../sdk/lib/x86/TUCam.lib")
#endif

class CameraManager
{
public:
	static CameraManager *GetInstance();
	~CameraManager();

	TUCAMRET InitApi(); /* Init the TUCAM API */	
	TUCAMRET UnInitApi(); /* UnInit the TUCAM API */	
	TUCAMRET OpenCamera(UINT uiIdx); /* Open the camera by index number */	
	TUCAMRET CloseCamera(); /* Close the current camera */

	char *GetCameraName();
	int GetVID();
	int GetPID();
	int GetCameraChannels();
	char *GetUSBType();
	char *GetFirmwareVersion();
	char *GetAPIVersion();

private:
	CameraManager();
	static CameraManager *instance;

	TUCAM_INIT m_itApi; // SDK API initialized object
	TUCAM_OPEN m_opCam; // Open camera object	
};

