#include "stdafx.h"
#include "CameraManager.h"

CameraManager *CameraManager::instance = NULL;

CameraManager *CameraManager::GetInstance()
{
	if (instance == NULL)
	{
		instance = new CameraManager();
	}
	return instance;
}

CameraManager::CameraManager()
{
}

CameraManager::~CameraManager()
{
}

/* Init the TUCAM API */
TUCAMRET CameraManager::InitApi()
{
	/* Get the current directory */
	m_itApi.uiCamCount = 0;
	m_itApi.pstrConfigPath = "./";

	TUCAM_Api_Init(&m_itApi);

	printf("Connect %d camera\r\n", m_itApi.uiCamCount);

	if (0 == m_itApi.uiCamCount)
	{
		return TUCAMRET_NO_CAMERA;
	}

	return TUCAMRET_SUCCESS;
}

/* UnInit the TUCAM API */
TUCAMRET CameraManager::UnInitApi()
{
	return TUCAM_Api_Uninit();
}

char *CameraManager::GetCameraName(UINT uiIdx)
{
	TUCAM_VALUE_INFO m_viCam; // Value info object
	m_viCam.nID = (int)TUIDI_CAMERA_MODEL;
	if (TUCAMRET_SUCCESS == TUCAM_Dev_GetInfoEx(uiIdx, &m_viCam))
	{
		return m_viCam.pText;
	}
	return "";
}

int CameraManager::GetVID(UINT uiIdx)
{
	TUCAM_VALUE_INFO m_viCam; // Value info object
	m_viCam.nID = (int)TUIDI_VENDOR;
	if (TUCAMRET_SUCCESS == TUCAM_Dev_GetInfoEx(uiIdx, &m_viCam))
	{
		return m_viCam.nValue;
	}
	return 0;
}

int CameraManager::GetPID(UINT uiIdx)
{
	TUCAM_VALUE_INFO m_viCam; // Value info object
	m_viCam.nID = (int)TUIDI_PRODUCT;
	if (TUCAMRET_SUCCESS == TUCAM_Dev_GetInfoEx(uiIdx, &m_viCam))
	{
		return m_viCam.nValue;
	}
	return 0;
}

char *CameraManager::GetUSBType(UINT uiIdx)
{
	TUCAM_VALUE_INFO m_viCam; // Value info object
	m_viCam.nID = (int)TUIDI_BUS;
	if (TUCAMRET_SUCCESS == TUCAM_Dev_GetInfoEx(uiIdx, &m_viCam))
	{
		if (0x200 == m_viCam.nValue || 0x210 == m_viCam.nValue)
		{
			return "2.0";
		}
		else
		{
			return "3.0";
		}
	}
	return "";
}

char *CameraManager::GetAPIVersion(UINT uiIdx)
{
	TUCAM_VALUE_INFO m_viCam; // Value info object
	m_viCam.nID = (int)TUIDI_VERSION_API;
	if (TUCAMRET_SUCCESS == TUCAM_Dev_GetInfoEx(uiIdx, &m_viCam))
	{
		return m_viCam.pText;
	}
	return "";
}