#pragma once

#include "../sdk/inc/TUCamApi.h"

#ifdef _WIN64
#pragma comment(lib, "../sdk/lib/x64/TUCam.lib")
#else
#pragma comment(lib, "../sdk/lib/x86/TUCam.lib")
#endif

class CameraManager
{
public:
	static CameraManager *GetInstance();
	~CameraManager();

	TUCAMRET InitApi(); /* Init the TUCAM API */	
	TUCAMRET UnInitApi(); /* UnInit the TUCAM API */	

	char *GetCameraName(UINT uiIdx);
	int GetVID(UINT uiIdx);
	int GetPID(UINT uiIdx);
	char *GetUSBType(UINT uiIdx);
	char *GetAPIVersion(UINT uiIdx);

private:
	CameraManager();
	static CameraManager *instance;

	TUCAM_INIT m_itApi; // SDK API initialized object
	TUCAM_OPEN m_opCam; // Open camera object	
};

