// C++03_capa_list.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"


#include <conio.h> 
#include "../sdk/inc/TUCamApi.h"                         // SDKͷļ

#ifdef _WIN64
#pragma comment(lib, "../sdk/lib/x64/TUCam.lib")
#else
#pragma comment(lib, "../sdk/lib/x86/TUCam.lib")
#endif

static TUCAM_INIT m_itApi;       // SDK API initialized object
static TUCAM_OPEN m_opCam;       // Open camera object

static char m_strArrCapa[][128] = { "TUIDC_RESOLUTION          : [Resolution]                 ",
"TUIDC_PIXELCLOCK          : [Pixel Clock]                ",
"TUIDC_BITOFDEPTH          : [Bit Of Depth]               ",
"TUIDC_ATEXPOSURE          : [Auto Exposure]              ",
"TUIDC_HORIZONTAL          : [Horizontal]                 ",
"TUIDC_VERTICAL            : [Vertical]                   ",
"TUIDC_ATWBALANCE          : [Auto White Balance]         ",
"TUIDC_FAN_GEAR            : [Fan Gear]                   ",
"TUIDC_ATLEVELS            : [Auto Levels]                ",
"TUIDC_SHIFT               : [Shift]                      ",
"TUIDC_HISTC               : [Histogram Statistic]        ",
"TUIDC_CHANNELS            : [Current Channel]            ",
"TUIDC_ENHANCE             : [Enhance]                    ",
"TUIDC_DFTCORRECTION       : [Defect Correction]          ",
"TUIDC_ENABLEDENOISE       : [Enable Denoise]             ",
"TUIDC_FLTCORRECTION       : [Flat Field Correction]      ",
"TUIDC_RESTARTLONGTM       : [Restart Long Time]          ",
"TUIDC_DATAFORMAT          : [Data format]                ",
"TUIDC_DRCORRECTION        : [Dynamic Range Of Correction]",
"TUIDC_VERCORRECTION       : [Vertical Correction]        ",
"TUIDC_MONOCHROME          : [Monochromatic]              ",
"TUIDC_BLACKBALANCE        : [Black Balance]              ",
"TUIDC_IMGMODESELECT       : [Image mode(CMS)]            ",
"TUIDC_CAM_MULTIPLE        : [Multiple Cameras]           ",
"TUIDC_ENABLEPOWEEFREQUENCY: [Enable Power frequency]     ",
"TUIDC_ROTATE_R90          : [Rotate Right 90]          ",
"TUIDC_ROTATE_L90          : [Rotate Left 90]           ",
"TUIDC_NEGATIVE            : [Enable Negative Film]       ",
"TUIDC_HDR                 : [Enable HDR]                 ",
"TUIDC_ENABLEIMGPRO        : [Enable Image Process]       ",
"TUIDC_ENABLELED           : [Enable USB Led]             ",
"TUIDC_ENABLETIMESTAMP     ; [Enable Time Stamp]          ",
"TUIDC_ENABLEBLACKLEVEL    : [Enable Black Level]         " "TUIDC_ATFOCUS             : [Auto Focus Enable]          ",
"TUIDC_ATFOCUS_STATUS      : [Auto Focus Status]          ",
"TUIDC_PGAGAIN             : [Sensor PGA Gain]            ",
"TUIDC_ATEXPOSURE_MODE     : [Automatic Exposure Time Mode]",
"TUIDC_BINNING_SUM         : [Summation Binning]          ",
"TUIDC_BINNING_AVG         : [Average Binning]            ",
"TUIDC_FOCUS_C_MOUNT       : [Focus c-mount Mode]         ",
"TUIDC_ENABLEPI            : [PI Enable]                  ",
"TUIDC_ATEXPOSURE_STATUS   : [Auto Exposure Status]       ",
"TUIDC_ATWBALANCE_STATUS   : [Auto WhiteBalance Status]   ",
"TUIDC_TESTIMGMODE         : [Test Image Mode Select]     ",
"TUIDC_SENSORRESET         : [Sensor Reset]               ",
"TUIDC_PGAHIGH             : [PGA High Gain]              ",
"TUIDC_PGALOW              : [PGA Low Gain]               ",
"TUIDC_PIXCLK1_EN          : [Pix2 Clock Enable]          ",
"TUIDC_PIXCLK2_EN          : [Pix1 Clock Enable]          ",
"TUIDC_ATLEVELGEAR         : [Auto Level Gear]            ",
"TUIDC_ENABLEDSNU          : [Enable DSNU]                ",
"TUIDC_ENABLEOVERLAP       : [Enable Exposure Time Overlap Mode]       ",
"TUIDC_CAMSTATE            : [Camera State]               ",
"TUIDC_ENABLETRIOUT        ; [Enable Trigger Out]         ",
"TUIDC_ROLLINGSCANMODE     : [Rolling Scan Mode]          ",
"TUIDC_ROLLINGSCANLTD      : [Rolling Scan Line Time Delay] ",
"TUIDC_ROLLINGSCANSLIT     : [Rolling Scan Slit Height]     ",
"TUIDC_ROLLINGSCANDIR      : [Rolling Scan Direction]       ",
"TUIDC_ROLLINGSCANRESET    : [Rolling Scan Direction Reset] ",
"TUIDC_ENABLETEC           : [Tec Enable]                   ",
"TUIDC_ENABLEBLC           : [Backlight Compensation Enable]",
"TUIDC_ENABLETHROUGHFOG    : [Electronic Through Fog Enable]",
"TUIDC_ENABLEGAMMA         : [Gamma Enable]                 ",
"TUIDC_ENABLEFILTER        ; [Filter Enable]                ",
"TUIDC_ENABLEHLC           : [Strong Light Inhibition Enable]         ",
"TUIDC_CAMPARASAVE         : [Camera Pamameter Save]       ",
"TUIDC_CAMPARALOAD         : [Camera Parameter Load]       ",
"TUIDC_ENABLEISP           : [Isp Enable]                  ",
"TUIDC_BUFFERHEIGHT        : [Buffer Height]               ",
"TUIDC_VISIBILITY          ; [Visibility]                  ",
"TUIDC_SHUTTER             : [Shutter Mode]                ",
"TUIDC_SIGNALFILTER        ; [Signal Filter]               "
};

/* Init the TUCAM API */
TUCAMRET InitApi()
{
	/* Get the current directory */
	m_itApi.uiCamCount = 0;
	m_itApi.pstrConfigPath = "./";

	TUCAM_Api_Init(&m_itApi);

	printf("Connect %d camera\r\n", m_itApi.uiCamCount);

	if (0 == m_itApi.uiCamCount)
	{
		return TUCAMRET_NO_CAMERA;
	}

	return TUCAMRET_SUCCESS;
}

/* UnInit the TUCAM API */
TUCAMRET UnInitApi()
{
	return TUCAM_Api_Uninit();
}

/* Open the camera by index number */
TUCAMRET OpenCamera(UINT uiIdx)
{
	if (uiIdx >= m_itApi.uiCamCount)
	{
		return TUCAMRET_OUT_OF_RANGE;
	}

	m_opCam.uiIdxOpen = uiIdx;

	return TUCAM_Dev_Open(&m_opCam);
}

/* Close the current camera */
TUCAMRET CloseCamera()
{
	if (NULL != m_opCam.hIdxTUCam)
	{
		TUCAM_Dev_Close(m_opCam.hIdxTUCam);
	}

	printf("Close the camera success\r\n");

	return TUCAMRET_SUCCESS;
}

/* Print the camera capability list */
void PrintCameraCapabilityList()
{
	int nVal = 0;

	TUCAM_CAPA_ATTR capa;
	capa.idCapa = 0;
	capa.nValDft = 0;
	capa.nValMin = 0;
	capa.nValMax = 0;
	capa.nValStep = 0;

	char szRes[64] = { 0 };
	TUCAM_VALUE_TEXT valText;
	valText.nID = 0;
	valText.dbValue = 0;
	valText.nTextSize = 64;
	valText.pText = &szRes[0];

	/* Get capability list information */
	printf("Get capability information list\r\n");

	for (int i = (int)TUIDC_RESOLUTION; i < (int)TUIDC_ENDCAPABILITY; ++i)
	{
		capa.idCapa = i;

		if (TUCAMRET_SUCCESS == TUCAM_Capa_GetAttr(m_opCam.hIdxTUCam, &capa))
		{
			printf("\n0x%02X.%s \nRange[%d, %d] Default:%d Step:%d\r\n", i, m_strArrCapa[i], capa.nValMin, capa.nValMax, capa.nValDft, capa.nValStep);

			if ((int)TUIDC_RESOLUTION == i)        /* Resolution */
			{
				int nCnt = capa.nValMax - capa.nValMin + 1;

				valText.nID = i;

				for (int j = 0; j < nCnt; ++j)
				{
					valText.dbValue = j;
					TUCAMRET n = TUCAM_Capa_GetValueText(m_opCam.hIdxTUCam, &valText);
					if (TUCAMRET_SUCCESS == TUCAM_Capa_GetValueText(m_opCam.hIdxTUCam, &valText))
					{
						printf("%d: %s\r\n", j, valText.pText);
					}
				}
			}
			else if ((int)TUIDC_PIXELCLOCK == i)    /* Pixel Clock */
			{
				int nCnt = capa.nValMax - capa.nValMin + 1;

				valText.nID = i;

				for (int j = 0; j < nCnt; ++j)
				{
					valText.dbValue = j;
					TUCAMRET n = TUCAM_Capa_GetValueText(m_opCam.hIdxTUCam, &valText);
					if (TUCAMRET_SUCCESS == TUCAM_Capa_GetValueText(m_opCam.hIdxTUCam, &valText))
					{
						printf("%d: %s\r\n", j, valText.pText);
					}
				}
			}
		}
		else
		{
			printf("0x%02X.%s Not support\r\n", i, m_strArrCapa[i]);
		}
	}

	printf("\r\n");

	/* Set capability default value */
	printf("Set capability default value\r\n");

	for (int i = (int)TUIDC_RESOLUTION; i < (int)TUIDC_ENDCAPABILITY; ++i)
	{
		capa.idCapa = i;

		if (TUCAMRET_SUCCESS == TUCAM_Capa_GetAttr(m_opCam.hIdxTUCam, &capa))
		{
			TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, i, capa.nValDft);
			printf("0x%02X.%s Set default value %d success\r\n", i, m_strArrCapa[i], capa.nValDft);
		}
	}

	printf("\r\n");

	/* Get capability current value */
	printf("Get capability current value\r\n");

	for (int i = (int)TUIDC_RESOLUTION; i < (int)TUIDC_ENDCAPABILITY; ++i)
	{
		if (TUCAMRET_SUCCESS == TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, i, &nVal))
		{
			printf("0x%02X.%s The current value is %d\r\n", i, m_strArrCapa[i], nVal);
		}
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	if (TUCAMRET_SUCCESS == InitApi())
	{
		if (TUCAMRET_SUCCESS == OpenCamera(0))
		{
			printf("Open the camera success\r\n");
			printf("\r\n");
			PrintCameraCapabilityList();
			printf("\r\n");

			CloseCamera();
		}
		else
		{
			printf("Open the camera failure\r\n");
		}

		UnInitApi();
	}

	printf("Press any key to exit...\r\n");
	_getch();

	return 0;
}

