// C++08_save_video.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"

#include <conio.h> 
#include "../sdk/inc/TUCamApi.h"                         // SDKͷļ

#ifdef _WIN64
#pragma comment(lib, "../sdk/lib/x64/TUCam.lib")
#else
#pragma comment(lib, "../sdk/lib/x86/TUCam.lib")
#endif

static TUCAM_INIT m_itApi;       // SDK API initialized object
static TUCAM_OPEN m_opCam;       // Open camera object
static TUCAM_FRAME m_frame;      // The frame object
static TUCAM_REC_SAVE m_rs;      // The record save object

/* Init the TUCAM API */
TUCAMRET InitApi()
{
	/* Get the current directory */
	m_itApi.uiCamCount = 0;
	m_itApi.pstrConfigPath = "./";

	TUCAM_Api_Init(&m_itApi);

	printf("Connect %d camera\r\n", m_itApi.uiCamCount);

	if (0 == m_itApi.uiCamCount)
	{
		return TUCAMRET_NO_CAMERA;
	}

	return TUCAMRET_SUCCESS;
}

/* UnInit the TUCAM API */
TUCAMRET UnInitApi()
{
	return TUCAM_Api_Uninit();
}

/* Open the camera by index number */
TUCAMRET OpenCamera(UINT uiIdx)
{
	if (uiIdx >= m_itApi.uiCamCount)
	{
		return TUCAMRET_OUT_OF_RANGE;
	}

	m_opCam.uiIdxOpen = uiIdx;

	return TUCAM_Dev_Open(&m_opCam);
}

/* Close the current camera */
TUCAMRET CloseCamera()
{
	if (NULL != m_opCam.hIdxTUCam)
	{
		TUCAM_Dev_Close(m_opCam.hIdxTUCam);
	}

	printf("Close the camera success\r\n");

	return TUCAMRET_SUCCESS;
}

/* Save video */
void SaveVideo()
{
	int nTimes = 50;

	m_frame.pBuffer = NULL;
	m_frame.ucFormatGet = TUFRM_FMT_USUAl;
	m_frame.uiRsdSize = 1;

	TUCAM_Buf_Alloc(m_opCam.hIdxTUCam, &m_frame);

	if (TUCAMRET_SUCCESS == TUCAM_Cap_Start(m_opCam.hIdxTUCam, (UINT32)TUCCM_SEQUENCE))
	{
		char strPath[] = ".\\example.avi";
		m_rs.fFps = 25.0f;                                              /* The frame speed of video display */
		m_rs.nCodec = 0;                                                /* if non compression set 541215044 MAKETAG('D', 'I', 'B', ' ') */
		m_rs.pstrSavePath = strPath;                                    /* path */

		if (TUCAMRET_SUCCESS == TUCAM_Rec_Start(m_opCam.hIdxTUCam, m_rs))
		{
			printf("Start video success\r\n");

			for (int i = 0; i < nTimes; ++i)
			{
				if (TUCAMRET_SUCCESS == TUCAM_Buf_WaitForFrame(m_opCam.hIdxTUCam, &m_frame))
				{
					TUCAM_Rec_AppendFrame(m_opCam.hIdxTUCam, &m_frame);

					printf("Save the frames of video success, index number is %d\r\n", i);
				}
				else
				{
					printf("Grab the frame failure, index number is %d\r\n", i);
				}
			}

			TUCAM_Rec_Stop(m_opCam.hIdxTUCam);

			printf("Stop video success\r\n");

		}

		TUCAM_Buf_AbortWait(m_opCam.hIdxTUCam);
		TUCAM_Cap_Stop(m_opCam.hIdxTUCam);
	}

	TUCAM_Buf_Release(m_opCam.hIdxTUCam);
}

int _tmain(int argc, _TCHAR* argv[])
{
	if (TUCAMRET_SUCCESS == InitApi())
	{
		if (TUCAMRET_SUCCESS == OpenCamera(0))
		{
			printf("Open the camera success\r\n");
			printf("\r\n");
			SaveVideo();
			printf("\r\n");
			CloseCamera();
		}
		else
		{
			printf("Open the camera failure\r\n");
		}

		UnInitApi();
	}

	printf("Press any key to exit...\r\n");
	//system("pause");
	_getch();

	return 0;
}


