// C++09_read_write_profiles.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"

#include <conio.h> 
#include "../sdk/inc/TUCamApi.h"                         // SDKͷļ

#ifdef _WIN64
#pragma comment(lib, "../sdk/lib/x64/TUCam.lib")
#else
#pragma comment(lib, "../sdk/lib/x86/TUCam.lib")
#endif

static TUCAM_INIT m_itApi;       // SDK API initialized object
static TUCAM_OPEN m_opCam;       // Open camera object

/* Init the TUCAM API */
TUCAMRET InitApi()
{
	/* Get the current directory */
	m_itApi.uiCamCount = 0;
	m_itApi.pstrConfigPath = "./";

	TUCAM_Api_Init(&m_itApi);

	printf("Connect %d camera\r\n", m_itApi.uiCamCount);

	if (0 == m_itApi.uiCamCount)
	{
		return TUCAMRET_NO_CAMERA;
	}

	return TUCAMRET_SUCCESS;
}

/* UnInit the TUCAM API */
TUCAMRET UnInitApi()
{
	return TUCAM_Api_Uninit();
}

/* Open the camera by index number */
TUCAMRET OpenCamera(UINT uiIdx)
{
	if (uiIdx >= m_itApi.uiCamCount)
	{
		return TUCAMRET_OUT_OF_RANGE;
	}

	m_opCam.uiIdxOpen = uiIdx;

	return TUCAM_Dev_Open(&m_opCam);
}

/* Close the current camera */
TUCAMRET CloseCamera()
{
	if (NULL != m_opCam.hIdxTUCam)
	{
		TUCAM_Dev_Close(m_opCam.hIdxTUCam);
	}

	printf("Close the camera success\r\n");

	return TUCAMRET_SUCCESS;
}

/* Read/Write profiles */
void ReadWriteProfiles()
{
	char strParam[] = "Parameter_A";                             /* Parameter name */

	if (TUCAMRET_SUCCESS == TUCAM_File_SaveProfiles(m_opCam.hIdxTUCam, strParam))
	{
		printf("Save %s profile success\r\n", strParam);
	}
	else
	{
		printf("Save %s profile failure\r\n", strParam);
	}

	if (TUCAMRET_SUCCESS == TUCAM_File_LoadProfiles(m_opCam.hIdxTUCam, strParam))
	{
		printf("Load %s profile success\r\n", strParam);
	}
	else
	{
		printf("Load %s profile failure\r\n", strParam);
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	if (TUCAMRET_SUCCESS == InitApi())
	{
		if (TUCAMRET_SUCCESS == OpenCamera(0))
		{
			printf("Open the camera success\r\n");
			printf("\r\n");
			ReadWriteProfiles();
			printf("\r\n");
			CloseCamera();
		}
		else
		{
			printf("Open the camera failure\r\n");
		}

		UnInitApi();
	}

	printf("Press any key to exit...\r\n");
	_getch();

	return 0;
}



