// C++12_output_trigger.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"


#include <conio.h> 
#include "../sdk/inc/TUCamApi.h"                         // SDKͷļ

#ifdef _WIN64
#pragma comment(lib, "../sdk/lib/x64/TUCam.lib")
#else
#pragma comment(lib, "../sdk/lib/x86/TUCam.lib")
#endif

static TUCAM_INIT m_itApi;       // SDK API initialized object
static TUCAM_OPEN m_opCam;       // Open camera object
static TUCAM_TRGOUT_ATTR m_tgrout;  // The output trigger object

static char m_strPort[][64] = { "TRIG.OUT1",
"TRIG.OUT2",
"TRIG.OUT3",
};

static char m_strKind[][64] = { "Low",
"High",
"IN",
"Exposure Start",
"Global Exposure",
"Read End",
};

static char m_strEdge[][64] = { "Rising",
"Failing",
};

/* Init the TUCAM API */
TUCAMRET InitApi()
{
	/* Get the current directory */
	m_itApi.uiCamCount = 0;
	m_itApi.pstrConfigPath = "./";

	TUCAM_Api_Init(&m_itApi);

	printf("Connect %d camera\r\n", m_itApi.uiCamCount);

	if (0 == m_itApi.uiCamCount)
	{
		return TUCAMRET_NO_CAMERA;
	}

	return TUCAMRET_SUCCESS;
}

/* UnInit the TUCAM API */
TUCAMRET UnInitApi()
{
	return TUCAM_Api_Uninit();
}

/* Open the camera by index number */
TUCAMRET OpenCamera(UINT uiIdx)
{
	if (uiIdx >= m_itApi.uiCamCount)
	{
		return TUCAMRET_OUT_OF_RANGE;
	}

	m_opCam.uiIdxOpen = uiIdx;

	return TUCAM_Dev_Open(&m_opCam);
}

/* Close the current camera */
TUCAMRET CloseCamera()
{
	if (NULL != m_opCam.hIdxTUCam)
	{
		TUCAM_Dev_Close(m_opCam.hIdxTUCam);
	}

	printf("Close the camera success\r\n");

	return TUCAMRET_SUCCESS;
}

/* Do OutPut trigger */
void DoOutputTrigger()
{
	if (TUCAMRET_SUCCESS == TUCAM_Cap_GetTriggerOut(m_opCam.hIdxTUCam, &m_tgrout))
	{
		printf("Get output trigger success, Port:%s, Kind:%s, Edge:%s, Delay time:%d, Width:%d\r\n", m_strPort[m_tgrout.nTgrOutPort], m_strKind[m_tgrout.nTgrOutMode], m_strEdge[m_tgrout.nEdgeMode], m_tgrout.nDelayTm, m_tgrout.nWidth);
	}
	else
	{
		printf("Get output trigger failure\r\n");
	}

	if (TUCAMRET_SUCCESS == TUCAM_Cap_SetTriggerOut(m_opCam.hIdxTUCam, m_tgrout))
	{
		printf("Set output trigger success, Port:%s, Kind:%s, Edge:%s, Delay time:%d, Width:%d\r\n", m_strPort[m_tgrout.nTgrOutPort], m_strKind[m_tgrout.nTgrOutMode], m_strEdge[m_tgrout.nEdgeMode], m_tgrout.nDelayTm, m_tgrout.nWidth);
	}
	else
	{
		printf("Set output trigger failure\r\n");
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	if (TUCAMRET_SUCCESS == InitApi())
	{
		if (TUCAMRET_SUCCESS == OpenCamera(0))
		{
			printf("Open the camera success\r\n");
			printf("\r\n");
			DoOutputTrigger();
			printf("\r\n");
			CloseCamera();
		}
		else
		{
			printf("Open the camera failure\r\n");
		}

		UnInitApi();
	}

	printf("Press any key to exit...\r\n");
	_getch();

	return 0;
}

