#!/usr/bin/env python
# coding: utf-8
'''
Created on 2024-01-02
@author:fdy
'''

import ctypes
from ctypes import *
from TUCam import *
from enum import Enum
import time

class Tucam():
    def __init__(self):
        self.Path = './'
        self.TUCAMINIT = TUCAM_INIT(0, self.Path.encode('utf-8'))
        self.TUCAMOPEN = TUCAM_OPEN(0, 0)
        TUCAM_Api_Init(pointer(self.TUCAMINIT))
        print(self.TUCAMINIT.uiCamCount)
        print(self.TUCAMINIT.pstrConfigPath)
        print('Connect %d camera' % self.TUCAMINIT.uiCamCount)

    def UnInitApi(self):
        TUCAM_Api_Uninit()

    # Get Camera Info
    def PrintCameraInfoEx(self, uiIdex):

        if uiIdex >= self.TUCAMINIT.uiCamCount:
            print('PrintCameraInfoEx: The index number of camera is out of range')
            return

        # Camera name:
        m_infoid = TUCAM_IDINFO
        TUCAMVALUEINFO = TUCAM_VALUE_INFO(m_infoid.TUIDI_CAMERA_MODEL.value, 0, 0, 0)
        TUCAM_Dev_GetInfoEx(uiIdex, pointer(TUCAMVALUEINFO))
        print('Camera Name:%#s' %TUCAMVALUEINFO.pText)

        # Camera VID
        TUCAMVALUEINFO = TUCAM_VALUE_INFO(m_infoid.TUIDI_VENDOR.value, 0, 0, 0)
        TUCAM_Dev_GetInfoEx(uiIdex, pointer(TUCAMVALUEINFO))
        print('Camera  VID:%#X' % TUCAMVALUEINFO.nValue)

        # Camera PID
        TUCAMVALUEINFO = TUCAM_VALUE_INFO(m_infoid.TUIDI_PRODUCT.value, 0, 0, 0)
        TUCAM_Dev_GetInfoEx(uiIdex, pointer(TUCAMVALUEINFO))
        print('Camera  PID:%#X' % TUCAMVALUEINFO.nValue)

        # Camera Bus
        TUCAMVALUEINFO = TUCAM_VALUE_INFO(m_infoid.TUIDI_BUS.value, 0, 0, 0)
        TUCAM_Dev_GetInfoEx(uiIdex, pointer(TUCAMVALUEINFO))
        print('Camera  Bus:%#X' % TUCAMVALUEINFO.nValue)

        # Sdk API
        TUCAMVALUEINFO = TUCAM_VALUE_INFO(m_infoid.TUIDI_VERSION_API.value, 0, 0, 0)
        TUCAM_Dev_GetInfoEx(uiIdex, pointer(TUCAMVALUEINFO))
        print('Version API:%#s' %TUCAMVALUEINFO.pText)

if __name__ == '__main__':
    demo = Tucam()
    demo.PrintCameraInfoEx(0)
    demo.UnInitApi()