﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Collections;
using System.Configuration;
using System.Web;
using System.IO;

using HANDLE = System.IntPtr;
using System.Drawing.Imaging;

namespace TUCAMERA
{
    

    public partial class TUCam : Form
    {

        #region Global Variable
        TUCAM_INIT m_itApi;                        // 初始化SDK环境
        TUCAM_OPEN m_opCam;                        // 打开相机参数

        List<TUCAM_OPEN> m_opCamList;
        int m_nCamIndex;

        TUCAM_VALUE_INFO valueinfo;
        TUCAM_CAPA_ATTR attrCapa;
        TUCAM_PROP_ATTR attrProp;
        TUCAM_VALUE_TEXT valText;
        TUCAM_FRAME m_drawframe;                   // Drawing帧对象
        TUCAM_DRAW m_drawing;
        TUCAM_DRAW_INIT m_itDraw;                  // 绘制初始化参数
        TUCAM_FILE_SAVE fileSaveDraw;              //Drawing文件保存
        TUCAM_REG_RW regRW;
        TUCAM_TRIGGER_ATTR attrTgr;                //触发

        TUCAM_TRGOUT_ATTR tgrOutAttr;              //触发输出
        TUCAM_TRGOUTPUT tgrOutput;

        BITMAPINFOHEADER m_bmpInfo;                // 位图头部信息

        Thread WaitForFrameThread;                 //等待线程

        HANDLE m_hDC;                              
        HANDLE m_hDib;
        HANDLE hDraw;                              //显示区域句柄
        HANDLE hMainWin;                           //主窗口句柄

        HANDLE m_hThdWaitForFrame;

        string m_strFilePath = null;			   //文件地址
        string m_szPicName = null;                 //图片名称
        string m_szSN = null;

        bool m_bTrigger = false;                   // 触发状态
        bool m_bSaving = false;                    // 图像保存
        bool m_bRLvlRange = true;                  // 设置右色阶范围
        bool m_bRedRange = true;                   // 设置红色通道范围
        bool m_bGreenRange = true;                 // 设置红色通道范围
        bool m_bBlueRange = true;                  // 设置红色通道范围
        bool m_bSaturationRange = true;            // 设置饱和度范围
        bool m_bHueRange = true;                   // 设置色调范围
        bool m_bLightRange = true;                 // 设置亮度范围
        bool m_bWaitting = false;                  // 捕获相机数据
        bool m_bGainRange = true;                  // 设置增益范围

//        bool m_bCoolChange = false;
        uint m_dwSTm = 0;                          // 开始计数
        uint m_dwITm = 0;                          // 间隔时间
        uint m_dwFrmCnt = 0;                       // 帧数统计

        uint m_uiExpStep = 0;
        uint m_uMin = 0;				           // 分钟
        uint m_uSec = 0;				           // 秒钟
        uint m_uMs = 0;				               // 毫秒
        uint m_uUs = 0;				               // 微秒

        uint m_uiTriFrame = 0;
        uint m_uiTriDelay = 0;
        uint m_uiHOffset = 0;
        uint m_uiVOffset = 0;
        uint m_uiWidth = 100;
        uint m_uiHeight = 100;

        int m_nTgrPort;                           //触发输出口
        int m_nKind;                              //触发输出类型
        int m_nEdge;                               //触发输出边沿
        int m_nDelay;                             //触发输出延迟
        int m_nWidth;                             //触发输出脉宽

        int m_nDelaySec = 0;
        int m_nDelayMs = 0;
        int m_nDelayUs = 0;
        int m_nWidthSec = 0;
        int m_nWidthMs = 0;
        int m_nWidthUs = 0;

        int m_nPID = 0;                            // 相机PID
        int m_nFmtSave = 0;                        // 保存格式
        int m_nFmtCnt = 0;                         // 格式计数
        int m_nGain = 0;                           // 增益模式
        int m_nMaxGain = 0;                        // 最大增益值
        int m_nTriMode = 0;
        int m_nTriExp = 0;
        int m_nMidTemp = 0;                        // 温度换算值
        int m_nCntSave = 0;                        // 保存计数
        int m_nTriEdge = 0;
        int m_nPicNum = 0;
        int m_nCurWidth = 0;                       // 当前宽度
        int m_nCurHeight = 0;                      // 当前高度
        int m_nCliWidth = 0;                       // 当前客户端宽度
        int m_nCliHeight = 0;                      // 当前客户端高度
        int m_nDrawOffX = 0;                       // 水平偏移  
        int m_nDrawOffY = 0;                       // 垂直偏移
        int m_nDrawWidth = 0;                      // 绘制宽度
        int m_nDrawHeight = 0;                     // 绘制高度
        int m_nImgMode = 0;                        // 图像模式

        float m_fScale = 0;                        // 缩放比例
        float m_fFps = 0;                          // 帧率

        double dblVal = 0.0;

        public const int USER                       = 0X500;
        public const int REFRESH_FRAMELABEL         = USER + 1;
        public const int REFRESH_TEMPERATURELABEL   = USER + 2;
        public const int REFRESH_CAPTURELABEL       = USER + 3;

        System.Timers.Timer timer;

        #endregion

        public TUCam()
        {
            InitializeComponent();

            timer = new System.Timers.Timer(1000);
            timer.Elapsed += new System.Timers.ElapsedEventHandler(wb_timer);
            timer.AutoReset = true;
            timer.Enabled = false;
        }

        public void TUCam_SizeChanged(object sender, EventArgs e)
        {
            //固定相机参数设置区域宽度
            this.CameraSettingMode.Size = new System.Drawing.Size(380, this.Size.Height - 50);

            //实时改变显示区域的大小
            this.ShowpictureBox.Size = new System.Drawing.Size(this.Size.Width - 400, this.Size.Height - 50);

            //刷新显示区域（去除阴影）
            ShowpictureBox.Refresh();
        }
        public void TUCam_Load(object sender, EventArgs e)
        {
            //全屏显示
            this.WindowState = FormWindowState.Maximized;

            IntPtr strPath = Marshal.StringToHGlobalAnsi(System.Environment.CurrentDirectory);

            m_opCamList = new List<TUCAM_OPEN>();

            m_itApi.uiCamCount = 0;
            m_itApi.pstrConfigPath = strPath;
            m_strFilePath = Marshal.PtrToStringAnsi(strPath) + "\\img";

            PathtextBox.Text = m_strFilePath;

            TUCamera.TUCAM_Api_Init(ref m_itApi);

            if (0 == m_itApi.uiCamCount)
            {
                MessageBox.Show("Init Camera Error!");
                return;
            }

            for (int i = 0; i < m_itApi.uiCamCount; i++ )
            {
                m_opCam.uiIdxOpen = (uint)i;
                TUCamera.TUCAM_Dev_Open(ref m_opCam);
                m_opCamList.Add(m_opCam);

                valueinfo.nValue = 1;
                valueinfo.nID = (int)TUCAM_IDINFO.TUIDI_CAMERA_CHANNELS;
                TUCamera.TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, ref valueinfo);

                if (1 < m_itApi.uiCamCount)
                    TUCamera.TUCAM_Capa_SetValue(m_opCamList[m_nCamIndex].hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_CAM_MULTIPLE, (int)m_itApi.uiCamCount);

                m_itDraw.hWnd = ShowpictureBox.Handle;
                m_itDraw.ucChannels = (sbyte)valueinfo.nValue;
                m_itDraw.nWidth = 2048;
                m_itDraw.nHeight = 2048;
                m_itDraw.nMode = 0;
                TUCamera.TUCAM_Draw_Init(m_opCam.hIdxTUCam, m_itDraw);
            }

            if (0 == (int)m_opCam.hIdxTUCam)
            {
                MessageBox.Show("Open Camera Faild!");
                return;
            }

            m_nCamIndex = 0;
            m_opCam = m_opCamList[m_nCamIndex];

            double dbExp = 0;
            double dbGain = 0;

            // 获取增益值
            TUCamera.TUCAM_Prop_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_GLOBALGAIN, ref dbGain, 0);

            // 获取曝光时间
            TUCamera.TUCAM_Prop_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_EXPOSURETM, ref dbExp, 0);

            // 关闭自动曝光
            TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_ATEXPOSURE, 0);
            // 关闭自动白平衡
            TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_ATWBALANCE, 0);

            // 设置曝光时间
            TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_EXPOSURETM, dbExp, 0);

            // 设置增益值
            TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_GLOBALGAIN, dbGain, 0);


            InitDrawingResource();
            EnableControl(false);
            InitInformation(m_opCam);
            InitCameraControl(m_opCam);
            RefreshValue(m_opCam);
        }
        private void TUCam_FormClosed(object sender, FormClosedEventArgs e)
        {
            for (int i = 0; i < m_opCamList.Count; i++ )
            {
                TUCamera.TUCAM_Dev_Close(m_opCamList[i].hIdxTUCam);
                TUCamera.TUCAM_Draw_Uninit(m_opCamList[i].hIdxTUCam);
            }

            TUCamera.TUCAM_Api_Uninit();                     // 释放SDK 资源环境
            TUCamera.ReleaseDC(hDraw, m_hDC);
            TUCamera.CloseHandle(m_hThdWaitForFrame);
            TUCamera.CloseHandle(hMainWin);

            System.Environment.Exit(0);
        }

        /// <summary>
        /// 其他函数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //初始化相机信息
        private void InitInformation(TUCAM_OPEN openCam)
        {
            if (0 != (int)m_opCam.hIdxTUCam)
            {
                //获取相机名称
                valueinfo.nID = (int)TUCAM_IDINFO.TUIDI_CAMERA_MODEL;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Dev_GetInfo(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref valueinfo))
                {
                    CameraLabel.Text = Marshal.PtrToStringAnsi(valueinfo.pText);
                }

                // 读取SN值
                SNLabel.TextChanged -= new EventHandler(this.SNLabel_TextChanged);
                regRW.nBufSize = 64;
                string snStr = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
                regRW.pBuf = Marshal.StringToHGlobalAnsi(snStr);
                regRW.nRegType = (int)TUREG_FORMATS.TUREG_SN;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Reg_Read(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, regRW))
                {
                    string str = Marshal.PtrToStringAnsi(regRW.pBuf);
                    SNLabel.Text = str;
                }
                else
                {
                    SNLabel.Text = "";

                }
                SNLabel.TextChanged += new EventHandler(this.SNLabel_TextChanged);

                //相机名称
                valueinfo.nID = (int)TUCAM_IDINFO.TUIDI_CAMERA_MODEL;
                string[] szCam = new string[m_itApi.uiCamCount];

                // 读取SN值
                regRW.nBufSize = 64;
                regRW.pBuf = Marshal.StringToHGlobalAnsi(snStr);
                regRW.nRegType = (int)TUREG_FORMATS.TUREG_SN;

                for (int i = 0; i < m_itApi.uiCamCount; i++ )
                {
                    TUCamera.TUCAM_Dev_GetInfoEx((uint)i, ref valueinfo);
                    if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Reg_Read(m_opCamList[i].hIdxTUCam, regRW))
                    {
                        szCam[i] = Marshal.PtrToStringAnsi(valueinfo.pText) + "  " +Marshal.PtrToStringAnsi(regRW.pBuf);
                    }
                    else
                    {
                        szCam[i] = Marshal.PtrToStringAnsi(valueinfo.pText);
                    }      
                }

                CamCombox.SelectedValueChanged -= new EventHandler(this.CamCombox_SelectedValueChanged);
                CamCombox.DataSource = szCam;
                CamCombox.SelectedIndex = m_nCamIndex;
                CamCombox.SelectedValueChanged += new EventHandler(this.CamCombox_SelectedValueChanged);

                //获取固件版本
                valueinfo.nID = (int)TUCAM_IDINFO.TUIDI_VERSION_FRMW;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Dev_GetInfo(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref valueinfo))
                {
                    if (valueinfo.nValue == 0)
                    {
                        int nLength = valueinfo.nTextSize / 2;
                        string szFw, szFw1, sz;
                        sz    = Marshal.PtrToStringAnsi(valueinfo.pText);
                        szFw = sz.Substring(0, nLength);
                        szFw1= sz.Substring(nLength, nLength);
                        FSNLabel.Text = szFw + "\r\n" + szFw1;
                    }
                    else
                    {
                        string camvertion = valueinfo.nValue.ToString();

                        FSNLabel.Text = System.Convert.ToString(int.Parse(camvertion), 16);
                    }
                   
                }

                //获取TUCAM_API版本
                valueinfo.nID = (int)TUCAM_IDINFO.TUIDI_VERSION_API;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Dev_GetInfo(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref valueinfo))
                {
                    SDKSLabel.Text = Marshal.PtrToStringAnsi(valueinfo.pText);
                }

                //获取TUCAM_API的PID
                valueinfo.nID = (int)TUCAM_IDINFO.TUIDI_PRODUCT;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Dev_GetInfo(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref valueinfo))
                {
                    m_nPID = valueinfo.nValue;
                }

                //获取USB接口类型
                valueinfo.nID = (int)TUCAM_IDINFO.TUIDI_BUS;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Dev_GetInfo(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref valueinfo))
                {
                    if (0x210 == valueinfo.nValue)
                    {
                        USBLabel.Text = "2.0";
                    }
                    else
                    {
                        USBLabel.Text = "3.0";
                    }
                }
            }
        }

        #region //初始化相机控制值

        private void InitCameraControl(TUCAM_OPEN openCam)
        {
            if (0 != (int)openCam.hIdxTUCam/*m_opCam.hIdxTUCam*/)
            {
                valText.nTextSize = 64;
                string strp = "000000000000000000000000000";
                valText.pText = Marshal.StringToHGlobalAnsi(strp);

                // 获取分辨率范围
                attrCapa.idCapa = (int)TUCAM_IDCAPA.TUIDC_RESOLUTION;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Capa_GetAttr(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref attrCapa))
                {
                    int nCnt = attrCapa.nValMax - attrCapa.nValMin + 1;
                    string[] szRes = new string[nCnt];

                    valText.nID = (int)TUCAM_IDCAPA.TUIDC_RESOLUTION;
                    for (int i = 0; i < nCnt; ++i)
                    {
                        valText.dbValue = i;
                        TUCamera.TUCAM_Capa_GetValueText(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref valText);
                        szRes[i] = Marshal.PtrToStringAnsi(valText.pText);
                    }
                    ResCombox.SelectedIndexChanged -= new EventHandler(this.ResCombox_SelectedIndexChanged);
                    ResCombox.DataSource = szRes;
                    ResCombox.SelectedIndexChanged += new EventHandler(this.ResCombox_SelectedIndexChanged);
                }

                //获取曝光时间
                attrProp.idProp = (int)TUCAM_IDPROP.TUIDP_GLOBALGAIN;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetAttr(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref attrProp))
                {
                    double dbVal = 0;
                    TUCamera.TUCAM_Prop_GetValue(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_GLOBALGAIN, ref dbVal, 0);
                    TUCamera.OutputDebugString("GainRange=" + dbVal.ToString());
                    m_nMaxGain = (int)attrProp.dbValMax;
                    m_bGainRange = false;
                    if (m_nMaxGain > 5)
                    {
                        GaintrackBar.SetRange((int)attrProp.dbValMin, (int)attrProp.dbValMax);
                        GaintrackBar.Value = (int)attrProp.dbValMin;
                        HDRradio.Hide();
                        HGradio.Hide();
                        LGradio.Hide();
                        CMSradio.Hide();
                    }
                    else
                    {
                        GainLabel.Hide();
                        GaintrackBar.Hide();
                        GaintextBox.Hide();
                    }
                }

                //获取曝光时间
                attrProp.idProp = (int)TUCAM_IDPROP.TUIDP_EXPOSURETM;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetAttr(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref attrProp))
                {
                    m_uiExpStep = (uint)(attrProp.dbValStep * 1000 + 0.5f);
                    uint m_uiMaxExp = (uint)(attrProp.dbValMax);
                    uint m_uiSecExp = m_uiMaxExp / 1000;
                    if (m_uiSecExp == 0)
                    {
                        SecUpDown.Enabled = false;
                        MinUpDown.Enabled = false;
                    }
                    else
                    {
                        if (m_uiSecExp <= 60)
                        {
                            MinUpDown.Enabled = false;
                        }
                    }
                }

                //获取温度范围
                attrProp.idProp = (int)TUCAM_IDPROP.TUIDP_TEMPERATURE;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetAttr(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref attrProp))
                {
                    CoolingtrackBar.Enabled = true;
                    m_nMidTemp = (int)(attrProp.dbValMax / 2)-10;
                    CoolingtrackBar.SetRange((int)attrProp.dbValMin, (int)attrProp.dbValMax);
                    CoolingtrackBar.Value = m_nMidTemp;
                }
                else
                {
                    CoolingtrackBar.Enabled = false;
                }

                // 获取风扇档位范围
                attrCapa.idCapa = (int)TUCAM_IDCAPA.TUIDC_FAN_GEAR;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Capa_GetAttr(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref attrCapa))
                {
                    int nCnt = attrCapa.nValMax - attrCapa.nValMin + 1;
                    string[] szFan = new string[nCnt];
                    valText.nID = (int)TUCAM_IDCAPA.TUIDC_FAN_GEAR;
                    for (int i = 0; i < nCnt; ++i)
                    {
                        valText.dbValue = i;
                        TUCamera.TUCAM_Capa_GetValueText(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref valText);
                        szFan[i] = Marshal.PtrToStringAnsi(valText.pText);
                    }

                    Curtempcombox.SelectedIndexChanged -= new EventHandler(this.Curtempcombox_SelectedIndexChanged);
                    Curtempcombox.DataSource = szFan;
                    Curtempcombox.SelectedIndexChanged += new EventHandler(this.Curtempcombox_SelectedIndexChanged);
                }
                else
                {

                }

                // 获取图像模式范围
                attrCapa.idCapa = (int)TUCAM_IDCAPA.TUIDC_IMGMODESELECT;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Capa_GetAttr(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref attrCapa))
                {
                    m_nImgMode = attrCapa.nValMax;
                }

                // 获取色阶范围
                attrProp.nIdxChn = 0;                    // 使用默认通道
                attrProp.idProp = (int)TUCAM_IDPROP.TUIDP_LFTLEVELS;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetAttr(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref attrProp))
                {
                    LevelLtrackBar.SetRange((int)attrProp.dbValMin, (int)attrProp.dbValMax);
                    LevelLtrackBar.Value = (int)attrProp.dbValMin;
                }

                attrProp.idProp = (int)TUCAM_IDPROP.TUIDP_RGTLEVELS;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetAttr(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref attrProp))
                {
                    m_bRLvlRange = false;
                    LevelRtrackBar.SetRange((int)attrProp.dbValMin, (int)attrProp.dbValMax);
                    LevelRtrackBar.Value = (int)attrProp.dbValMax;
                }

                // 获取白平衡
                attrCapa.idCapa = (int)TUCAM_IDCAPA.TUIDC_ATWBALANCE;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Capa_GetAttr(openCam.hIdxTUCam, ref attrCapa))
                {
                    if (attrCapa.nValMax > 1)
                    {
                        chkAWB.Visible = true;
                        btnWB.Visible = false;
                    }
                    else
                    {
                        chkAWB.Visible = false;
                        btnWB.Visible = true;
                    }
                }
                else
                {
                    chkAWB.Visible = false;
                    btnWB.Visible = true;
                    btnWB.Enabled = false;
                }

                // 获取红色通道
                attrProp.idProp = (int)TUCAM_IDPROP.TUIDP_CHNLGAIN;
                attrProp.nIdxChn = 1;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetAttr(m_opCam.hIdxTUCam, ref attrProp))
                {
                    tbRed.Enabled = true;
                    tbvRed.Enabled = true;
                    labnRed.Enabled = true;

                    m_bRedRange = false;
                    tbRed.SetRange((int)attrProp.dbValMin, (int)attrProp.dbValMax);
                    tbRed.Value = (int)attrProp.dbValMax;
                }
                else
                {
                    tbRed.Enabled = false;
                    tbvRed.Enabled = false;
                    labnRed.Enabled = false;
                }

                // 获取绿色通道
                attrProp.idProp = (int)TUCAM_IDPROP.TUIDP_CHNLGAIN;
                attrProp.nIdxChn = 2;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetAttr(m_opCam.hIdxTUCam, ref attrProp))
                {
                    tbGreen.Enabled = true;
                    tbvGreen.Enabled = true;
                    labnGreen.Enabled = true;

                    m_bGreenRange = false;
                    tbGreen.SetRange((int)attrProp.dbValMin, (int)attrProp.dbValMax);
                    tbGreen.Value = (int)attrProp.dbValMax;
                }
                else
                {
                    tbGreen.Enabled = false;
                    tbvGreen.Enabled = false;
                    labnGreen.Enabled = false;
                }

                // 获取蓝色通道
                attrProp.idProp = (int)TUCAM_IDPROP.TUIDP_CHNLGAIN;
                attrProp.nIdxChn = 3;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetAttr(m_opCam.hIdxTUCam, ref attrProp))
                {
                    tbBlue.Enabled = true;
                    tbvBlue.Enabled = true;
                    labnBlue.Enabled = true;

                    m_bBlueRange = false;
                    tbBlue.SetRange((int)attrProp.dbValMin, (int)attrProp.dbValMax);
                    tbBlue.Value = (int)attrProp.dbValMax;
                }
                else
                {
                    tbBlue.Enabled = false;
                    tbvBlue.Enabled = false;
                    labnBlue.Enabled = false;
                }

                // 获取饱和度值
                attrProp.idProp = (int)TUCAM_IDPROP.TUIDP_SATURATION;
                attrProp.nIdxChn = 0;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetAttr(m_opCam.hIdxTUCam, ref attrProp))
                {
                    tbSaturation.Enabled = true;
                    tbvSaturation.Enabled = true;
                    labnSaturation.Enabled = true;

                    m_bSaturationRange = false;
                    tbSaturation.SetRange((int)attrProp.dbValMin, (int)attrProp.dbValMax);
                    tbSaturation.Value = (int)attrProp.dbValMax;
                }
                else
                {
                    tbSaturation.Enabled = false;
                    tbvSaturation.Enabled = false;
                    labnSaturation.Enabled = false;
                }

                // 获取色调值
                attrProp.idProp = (int)TUCAM_IDPROP.TUIDP_HUE;
                attrProp.nIdxChn = 0;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetAttr(m_opCam.hIdxTUCam, ref attrProp))
                {
                    tbHue.Enabled = true;
                    tbvHue.Enabled = true;
                    labnHue.Enabled = true;

                    m_bHueRange = false;
                    tbHue.SetRange((int)attrProp.dbValMin, (int)attrProp.dbValMax);
                    tbHue.Value = (int)attrProp.dbValMax;
                }
                else
                {
                    tbHue.Enabled = false;
                    tbvHue.Enabled = false;
                    labnHue.Enabled = false;
                }

                // 获取亮度值
                attrProp.idProp = (int)TUCAM_IDPROP.TUIDP_LIGHT;
                attrProp.nIdxChn = 0;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetAttr(m_opCam.hIdxTUCam, ref attrProp))
                {
                    tbLight.Enabled = true;
                    tbvLight.Enabled = true;
                    labnLight.Enabled = true;

                    m_bLightRange = false;
                    tbLight.SetRange((int)attrProp.dbValMin, (int)attrProp.dbValMax);
                    tbLight.Value = (int)attrProp.dbValMax;
                }
                else
                {
                    tbLight.Enabled = false;
                    tbvLight.Enabled = false;
                    labnLight.Enabled = false;
                }

                if (m_nPID == 0xE40D)
                {
                    SHNradio.Hide();
                    Gloabalradio.Hide();
                }

            }
        }

        #endregion


        #region //刷新界面值

        private void RefreshValue(TUCAM_OPEN openCam)
        {
            if (0 != (int)openCam.hIdxTUCam/*m_opCam.hIdxTUCam*/)
            {
                int     nVal  = 0;
                double  dbVal = 0;

                // 获取当前分辨率值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Capa_GetValue(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_RESOLUTION, ref nVal))
                {
                    ResCombox.SelectedIndexChanged -= new EventHandler(this.ResCombox_SelectedIndexChanged);
                    ResCombox.SelectedIndex = nVal;
                    ResCombox.SelectedIndexChanged += new EventHandler(this.ResCombox_SelectedIndexChanged);
                }

                // 获取水平镜像值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Capa_GetValue(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_HORIZONTAL, ref nVal))
                {
                    bool Htemp = false;
                    if (0 == nVal)
                    {
                        Htemp = false;
                    }
                    else
                    {
                        Htemp = true;
                    }
                    HFlipcheck.Checked = Htemp;
                }

                // 获取垂直镜像值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Capa_GetValue(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_VERTICAL, ref nVal))
                {
                    bool Vtemp = false;
                    if (0 == nVal)
                    {
                        Vtemp = false;
                    }
                    else
                    {
                        Vtemp = true;
                    }
                    VFlipcheck.Checked = Vtemp;
                }

                // 获取风扇档位
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Capa_GetValue(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_FAN_GEAR, ref nVal))
                {
                    Curtempcombox.Enabled = true;
                    Curtempcombox.SelectedIndexChanged -= new EventHandler(this.Curtempcombox_SelectedIndexChanged);
                    Curtempcombox.SelectedIndex = nVal;
                    Curtempcombox.SelectedIndexChanged += new EventHandler(this.Curtempcombox_SelectedIndexChanged);
                }
                else
                {
                    Curtempcombox.Enabled = false;
                }

                // 获取当前曝光时间
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_EXPOSURETM, ref dbVal, 0))
                {
                    UpdateExposureTime((ulong)(dbVal * 1000));
                }
                
                // 获取当前左色阶值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_LFTLEVELS, ref dbVal, 0))
                {    
                    nVal = (int)dbVal;

                    LevelLtextBox.Text = nVal.ToString();
                    LevelLtrackBar.Value = nVal;
                }

                // 获取当前右色阶值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_RGTLEVELS, ref dbVal, 0))
                {  
                    nVal = (int)dbVal;

                    LevelRtextBox.Text = nVal.ToString();
                    LevelRtrackBar.Value = nVal;
                }

//                 //获取当前温度
//                 if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_TEMPERATURE, ref dbVal, 0))
//                 {
//                     nVal = (int)dbVal;
// 
//                     CoolingtextBox.Text = (nVal+50).ToString() + " ℃";;
//                     CoolingtrackBar.Value = nVal;
// 
//                     m_bCoolChange = true;
//                 }

                // 获取当前增益值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_GLOBALGAIN, ref dbVal, 0))
                {
                 
                     m_nGain = (int)dbVal;
                     TUCamera.OutputDebugString("Gain=" + m_nGain.ToString());
                     if (m_nMaxGain > 5)
                     {
                         GaintextBox.Text = m_nGain.ToString();
                         GaintrackBar.Value = m_nGain;
                     }
                     else
                     {
                         // 获取当前CMS模式
                         if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Capa_GetValue(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_IMGMODESELECT, ref nVal))
                         {
                             m_nGain = (1 == nVal) ? 3 : m_nGain;
                             CMSradio.Show();
                         }
                         else
                         {
                             CMSradio.Hide();
                         }

                         switch (m_nGain)
                         {
                             case 1:
                                 {
                                     HDRradio.Checked = false;
                                     HGradio.Checked = true;
                                     LGradio.Checked = false;
                                     CMSradio.Checked = false;
                                 }
                                 break;
                             case 2:
                                 {
                                     HDRradio.Checked = false;
                                     HGradio.Checked = false;
                                     LGradio.Checked = true;
                                     CMSradio.Checked = false;
                                 }
                                 break;
                             case 3:
                                 {
                                     HDRradio.Checked = false;
                                     HGradio.Checked = false;
                                     LGradio.Checked = false;
                                     CMSradio.Checked = true;
                                 }
                                 break;
                             case 0:
                             default:
                                 {
                                     HDRradio.Checked = true;
                                     HGradio.Checked = false;
                                     LGradio.Checked = false;
                                     CMSradio.Checked = false;
                                 }
                                 break;
                         }  
                     }             
                }

                // 获取触发属性
                TUCAM_TRIGGER_ATTR tgrAttr;

                tgrAttr.nTgrMode = (int)TUCAM_CAPTURE_MODES.TUCCM_SEQUENCE;
                tgrAttr.nFrames  = 1;
                tgrAttr.nBufFrames = 2;
                tgrAttr.nDelayTm = 0;
                tgrAttr.nExpMode = (int)TUCAM_TRIGGER_EXP.TUCTE_EXPTM;
                tgrAttr.nEdgeMode = (int)TUCAM_TRIGGER_EDGE.TUCTD_RISING;

                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Cap_GetTrigger(/*m_opCam.hIdxTUCam*/openCam.hIdxTUCam, ref tgrAttr))
                {
                    m_nTriMode = tgrAttr.nTgrMode;
                    m_nTriExp  = tgrAttr.nExpMode;
                    m_nTriEdge = tgrAttr.nEdgeMode;

                    m_uiTriFrame = (uint)tgrAttr.nFrames;

                    m_uiTriDelay = (uint)(tgrAttr.nDelayTm / 1000);
                    DelaystextBox.Text = m_uiTriDelay.ToString();
                    DelaystrackBar.Value = tgrAttr.nDelayTm;

                    switch (m_nTriMode)
                    {
                        case (int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_STANDARD:
                        {
                            Offradio.Checked = false;
                            Standardradio.Checked = true;
                            SHNradio.Checked = false;
                            Gloabalradio.Checked = false;
                            SWTcheck.Checked = false;
                        }
                        break;

                        case (int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_SYNCHRONOUS:
                        {
                            Offradio.Checked = false;
                            Standardradio.Checked = false;
                            SHNradio.Checked = true;
                            Gloabalradio.Checked = false;
                            SWTcheck.Checked = false;
                        }
                        break;

                        case (int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_GLOBAL:
                        {
                            Offradio.Checked = false;
                            Standardradio.Checked = false;
                            SHNradio.Checked = false;
                            Gloabalradio.Checked = true;
                            SWTcheck.Checked = false;
                        }
                        break;

                        case (int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_SOFTWARE:
                        {
                            Offradio.Checked = false;
                            Standardradio.Checked = false;
                            SHNradio.Checked = false;
                            Gloabalradio.Checked = false;
                            SWTcheck.Checked = true;
                        }
                        break;

                        case (int)TUCAM_CAPTURE_MODES.TUCCM_SEQUENCE:

                        default:
                        {
                            Offradio.Checked = true;
                            Standardradio.Checked = false;
                            SHNradio.Checked = false;
                            Gloabalradio.Checked = false;
                            SWTcheck.Checked = false;
                        }
                        break;
                    }

                    bool tempexp = false;
                    if (0 == m_nTriExp)
                    {
                        tempexp = false;
                    }
                    else if (1 == m_nTriExp)
                    {
                        tempexp = true;
                    }
                    // 触发曝光时间模式
                    if (!tempexp)
                    {
                        Timedradio.Checked = true;
                        Widthradio.Checked = false;
                    }
                    else
                    {
                        Timedradio.Checked = false;
                        Widthradio.Checked = true;
                    }

                    bool tempedge = false;
                    if (0 == m_nTriEdge)
                    {
                        tempedge = false;
                    }
                    else if (1 == m_nTriEdge)
                    {
                        tempedge = true;
                    }

                    // 触发边沿模式
                    if (tempedge)
                    {
                        Risingradio.Checked = true;
                        Fallingradio.Checked = false;
                    }
                    else
                    {
                        Risingradio.Checked = false;
                        Fallingradio.Checked = true;
                    }

                } 

                // 获取当前红色通道值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(openCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_CHNLGAIN, ref dbVal, 1))
                {
                    nVal = (int)dbVal;

                    tbvRed.Text = string.Format("{0:F1}", (dbVal / 2.0f));
                    tbRed.Value = nVal;
                }

                // 获取当前绿色通道值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(openCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_CHNLGAIN, ref dbVal, 2))
                {
                    nVal = (int)dbVal;

                    tbvGreen.Text = string.Format("{0:F1}", (dbVal / 2.0f));
                    tbGreen.Value = nVal;
                }

                // 获取当前蓝色通道值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(openCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_CHNLGAIN, ref dbVal, 3))
                {
                    nVal = (int)dbVal;

                    tbvBlue.Text = string.Format("{0:F1}", (dbVal / 2.0f));
                    tbBlue.Value = nVal;
                }

                // 获取当前饱和度值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(openCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_SATURATION, ref dbVal, 0))
                {
                    nVal = (int)dbVal;

                    tbvSaturation.Text = nVal.ToString();
                    tbSaturation.Value = nVal;
                }

                // 获取当前色调值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(openCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_HUE, ref dbVal, 0))
                {
                    nVal = (int)dbVal;

                    tbvHue.Text = nVal.ToString();
                    tbHue.Value = nVal;
                }

                // 获取当前亮度值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(openCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_LIGHT, ref dbVal, 0))
                {
                    nVal = (int)dbVal;

                    tbvLight.Text = nVal.ToString();
                    tbLight.Value = nVal;
                }

                // 拍照
                m_nPicNum = 1;
                PicnumtextBox.Text = m_nPicNum.ToString();
                m_nFmtSave = (int)TUIMG_FORMATS.TUFMT_TIF;
                TIFCheck.Checked = true;
                m_szPicName = "TS";
                PicnametextBox.Text = m_szPicName;

                WidthtextBox.Text = m_uiWidth.ToString();
                HeighttextBox.Text = m_uiHeight.ToString();
                HoffsettextBox.Text = m_uiHOffset.ToString();
                VoffsettextBox.Text = m_uiVOffset.ToString();

                InitOutputTrigger();
                //获取触发输出属性
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Cap_GetTriggerOut(m_opCam.hIdxTUCam, ref tgrOutAttr))
                {
                    tgrOutput.nTgrOutPort = tgrOutAttr.nTgrOutPort;
                    switch (tgrOutAttr.nTgrOutPort)
                    {
                        case (int)TUCAM_OUTPUTTRG_PORT.TUPORT_ONE:
                            tgrOutput.TgrPort1.nTgrOutMode = tgrOutAttr.nTgrOutMode;
                            tgrOutput.TgrPort1.nEdgeMode = tgrOutAttr.nEdgeMode;
                            tgrOutput.TgrPort1.nDelayTm = tgrOutAttr.nDelayTm;
                            tgrOutput.TgrPort1.nWidth = tgrOutAttr.nWidth;
                            break;
                        case (int)TUCAM_OUTPUTTRG_PORT.TUPORT_TWO:
                            tgrOutput.TgrPort2.nTgrOutMode = tgrOutAttr.nTgrOutMode;
                            tgrOutput.TgrPort2.nEdgeMode = tgrOutAttr.nEdgeMode;
                            tgrOutput.TgrPort2.nDelayTm = tgrOutAttr.nDelayTm;
                            tgrOutput.TgrPort2.nWidth = tgrOutAttr.nWidth;
                            break;
                        case (int)TUCAM_OUTPUTTRG_PORT.TUPORT_THREE:
                            tgrOutput.TgrPort3.nTgrOutMode = tgrOutAttr.nTgrOutMode;
                            tgrOutput.TgrPort3.nEdgeMode = tgrOutAttr.nEdgeMode;
                            tgrOutput.TgrPort3.nDelayTm = tgrOutAttr.nDelayTm;
                            tgrOutput.TgrPort3.nWidth = tgrOutAttr.nWidth;
                            break;
                        default:
                            break;
                    }
                    
                    m_nTgrPort = tgrOutAttr.nTgrOutPort;
                    m_nKind = tgrOutAttr.nTgrOutMode;
                    m_nTriEdge = tgrOutAttr.nEdgeMode;
                    m_nDelay = tgrOutAttr.nDelayTm;
                    m_nWidth = tgrOutAttr.nWidth;

                    comboBoxPort.SelectedIndex = tgrOutAttr.nTgrOutPort;

                    updateDelayTime(m_nDelay);
                    updateWidth(m_nWidth);
                    updateRadio();
                    EnableOutputTriggerControl(m_nKind);

                }
            }
        }

        #endregion
        //更新曝光时间
        private void UpdateExposureTime(ulong dwExp)
        {
            m_uMin = (uint)(dwExp / (60 * 1000 * 1000));
            m_uSec = (uint)((dwExp / (1000 * 1000)) % 60);
            m_uMs = (uint)((dwExp / 1000) % 1000);
            m_uUs = (uint)((dwExp % 1000));

            MinUpDown.Value = m_uMin;
            SecUpDown.Value = m_uSec;
            MsUpDown.Value = m_uMs;
            UsUpDown.Value = m_uUs;
        }
        //初始化绘制资源
        private void InitDrawingResource()
        {
            int nSize = 0;
            unsafe
            {
                nSize = sizeof(BITMAPINFOHEADER); 
                //memset(&m_bmpInfo, 0, nSize);
            }

            m_bmpInfo.biSize	    = nSize;
            m_bmpInfo.biPlanes	    = 1;
            m_bmpInfo.biBitCount    = 24;
            m_bmpInfo.biCompression = 0;

            hDraw = ShowpictureBox.Handle;
            hMainWin = TUCamera.FindWindow(null, "SamplePro");
            m_hDC = TUCamera.GetDC(hDraw);
            m_hDib= TUCamera.DrawDibOpen();
        }
 


        //WaitForFrame线程
        public void WaitForFrame()
        {
            int nCliWidth  = 0;
            int nCliHeight = 0;

            m_nDrawOffX  = 0;
            m_nDrawOffY  = 0;
            m_nDrawWidth = 0;
            m_nDrawHeight= 0;
            m_nCurWidth  = 0;
            m_nCurHeight = 0;

            while (m_bWaitting)
            {
                // 计算帧率
                m_dwFrmCnt++;                                  // 帧数加1
                m_dwITm = TUCamera.GetTickCount() - m_dwSTm;   // 计算间隔时间 ms

                if (m_dwITm > 1000)
                {
                    m_fFps = m_dwFrmCnt * 1000000.0f/ m_dwITm;
                    TUCamera.PostMessage(hMainWin, REFRESH_FRAMELABEL, 0, (int)m_fFps);
                    m_dwSTm    = TUCamera.GetTickCount();

                    m_dwFrmCnt = 0;
                }


                m_drawframe.ucFormatGet = (byte)TUFRM_FORMATS.TUFRM_FMT_RGB888;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Buf_WaitForFrame(m_opCamList[m_nCamIndex].hIdxTUCam, ref m_drawframe))
                {
                    #region 改变显示区域
                    if (ShowpictureBox.Width != m_drawframe.usWidth || ShowpictureBox.Height != m_drawframe.usHeight || m_nCliWidth != nCliWidth || m_nCliHeight != nCliHeight)
                    {
                         m_nCurWidth  = m_bmpInfo.biWidth  = m_drawframe.usWidth;
                         m_nCurHeight = m_bmpInfo.biHeight = m_drawframe.usHeight;

                         nCliWidth = ShowpictureBox.Width;
                         nCliHeight = ShowpictureBox.Height;

                         float fScaleX = nCliWidth * 1.0f / m_nCurWidth;
                         float fScaleY = nCliHeight * 1.0f / m_nCurHeight;

                        m_fScale = fScaleX > fScaleY ? fScaleY : fScaleX;
                        m_fScale = (float)((int)(m_fScale * 100) / 100.0f);

                        if (m_fScale < 1)
                        {
                            m_nDrawWidth = (int)(m_fScale * m_nCurWidth);
                            m_nDrawHeight = (int)(m_fScale * m_nCurHeight);
                        }
                        else
                        {
                            m_nDrawWidth = m_nCurWidth;
                            m_nDrawHeight = m_nCurHeight;
                        }

                        m_nDrawWidth = (m_nDrawWidth >> 2) << 2;
                        m_nDrawHeight= (m_nDrawHeight >> 2) << 2;

                        m_nDrawOffX = (nCliWidth - m_nDrawWidth) / 2;
                        m_nDrawOffY = (nCliHeight - m_nDrawHeight) / 2;
                    }
                    #endregion

                    #region 绘制图像
                    if (null != m_drawframe.pBuffer)
                    {
                        //                         int nSize = (int)(m_drawframe.uiImgSize + m_drawframe.usHeader);
                        //                         byte[] pBuf = new byte[nSize];
                        //                         Marshal.Copy(m_drawframe.pBuffer, pBuf, 0, nSize);
                        //                         Buffer.BlockCopy(pBuf, (int)(m_drawframe.usHeader), pBuf, 0, (int)(m_drawframe.uiImgSize));       // 偏移头部
                        //                         TUCamera.DrawDibDraw(m_hDib, m_hDC, m_nDrawOffX, m_nDrawOffY,m_nDrawWidth, m_nDrawHeight,
                        //                             ref m_bmpInfo, pBuf, 0, 0, m_bmpInfo.biWidth, m_bmpInfo.biHeight, 0);

                        //1. 构造Bitmap进行显示
                        ////m_drawframe.uiImgSize = m_drawframe.usWidth * m_drawframe.usHeight * m_drawframe.ucChannels * m_drawframe.ucElemBytes;
                        
                        //int nSize = (int)(m_drawframe.uiImgSize + m_drawframe.usHeader);
                        //byte[] pBuf = new byte[nSize];
                        //Marshal.Copy(m_drawframe.pBuffer, pBuf, 0, nSize);
                        //Buffer.BlockCopy(pBuf, (int)(m_drawframe.usHeader), pBuf, 0, (int)(m_drawframe.uiImgSize));       // 偏移头部
                        
                        //GCHandle handle = GCHandle.Alloc(pBuf, GCHandleType.Pinned);
                        //IntPtr imagePtr = handle.AddrOfPinnedObject();
                        //if (handle.IsAllocated)
                        //    handle.Free();

                        //Bitmap bitmap;       
                        //if (m_drawframe.ucChannels == 3)
                        //{
                        //    bitmap = new Bitmap(m_nCurWidth, m_nCurHeight, m_nCurWidth * 3, m_drawframe.ucElemBytes == 1 ? PixelFormat.Format24bppRgb : PixelFormat.Format48bppRgb, imagePtr);
                        //}
                        //else
                        //{
                        //    bitmap = new Bitmap(m_nCurWidth, m_nCurHeight, m_nCurWidth * 3, m_drawframe.ucElemBytes == 1 ? PixelFormat.Format8bppIndexed : PixelFormat.Format16bppGrayScale, imagePtr);
                        //}

                        //ShowpictureBox.Image = bitmap;

                        //2..使用SDK接口进行绘制
                        m_drawing.pFrame = Marshal.AllocHGlobal(Marshal.SizeOf(m_drawframe));
                        Marshal.StructureToPtr(m_drawframe, m_drawing.pFrame, true);

                        m_drawing.nDstX = m_nDrawOffX;
                        m_drawing.nDstY = m_nDrawOffY;
                        m_drawing.nDstWidth = m_nDrawWidth;
                        m_drawing.nDstHeight = m_nDrawHeight;

                        m_drawing.nSrcX = 0;
                        m_drawing.nSrcY = 0;
                        m_drawing.nSrcWidth = m_nCurWidth;
                        m_drawing.nSrcHeight = m_nCurHeight;

                        TUCamera.TUCAM_Draw_Frame(m_opCamList[m_nCamIndex].hIdxTUCam, ref m_drawing);
                    }
                    #endregion

                    #region 保存图片
                    if (m_bSaving || m_bTrigger)
                    {
                        string szFName;
                        // 文件夹是否存在，不存在则创建
                        if (false == Directory.Exists(m_strFilePath))
                        {
                            Directory.CreateDirectory(m_strFilePath, null);
                        }

                        // 获取系统时间
                        DateTime now = DateTime.Now;
                        if (UsertimeCheck.Checked)
                        {
                            szFName = m_strFilePath + "\\" + now.Year.ToString() + now.Month.ToString() + now.Day.ToString() + now.Hour.ToString() + now.Minute.ToString() + now.Second.ToString() + now.Millisecond.ToString();
                        }
                        else
                        {
                            szFName = m_strFilePath + "\\" + m_szPicName + /*now.Day.ToString() + */now.Hour.ToString() + now.Minute.ToString() + now.Second.ToString() + now.Millisecond.ToString();
                        }

                        bool bRet = true;

                        do 
                        {
                            int nFmt = m_nFmtSave;
                            fileSaveDraw.pstrSavePath = Marshal.StringToHGlobalAnsi(szFName);  // path

                            //struct to intptr
                            fileSaveDraw.pFrame = Marshal.AllocHGlobal(Marshal.SizeOf(m_drawframe));
                            Marshal.StructureToPtr(m_drawframe, fileSaveDraw.pFrame, true);

                            // Format RAW
                            if (nFmt  ==  (int)TUIMG_FORMATS.TUFMT_RAW)
                            {
                                nFmt &= ~(int)TUIMG_FORMATS.TUFMT_RAW;
                                fileSaveDraw.nSaveFmt = (int)TUIMG_FORMATS.TUFMT_RAW;

                                // Get RAW data
                                m_drawframe.ucFormatGet = (byte)TUFRM_FORMATS.TUFRM_FMT_RAW;
                                if (TUCAMRET.TUCAMRET_SUCCESS != TUCamera.TUCAM_Buf_CopyFrame(/*m_opCam.hIdxTUCam*/m_opCamList[m_nCamIndex].hIdxTUCam, ref m_drawframe))
                                {
                                    bRet = false;
                                    break;
                                }

                                // Save RAW data
                                if (TUCAMRET.TUCAMRET_SUCCESS != TUCamera.TUCAM_File_SaveImage(/*m_opCam.hIdxTUCam*/m_opCamList[m_nCamIndex].hIdxTUCam, fileSaveDraw))
                                {
                                    bRet = false;
                                    break;
                                }
                            }

                            // Format other
                            if (0 != nFmt)
                            {
                                fileSaveDraw.nSaveFmt = nFmt;
                                
                                // Get other format data
                                m_drawframe.ucFormatGet = (byte)TUFRM_FORMATS.TUFRM_FMT_USUAl;
                                if (TUCAMRET.TUCAMRET_SUCCESS != TUCamera.TUCAM_Buf_CopyFrame(/*m_opCam.hIdxTUCam*/m_opCamList[m_nCamIndex].hIdxTUCam, ref m_drawframe))
                                {
                                    bRet = false;
                                    break;
                                }

                                // Save other format data
                                if (TUCAMRET.TUCAMRET_SUCCESS != TUCamera.TUCAM_File_SaveImage(/*m_opCam.hIdxTUCam*/m_opCamList[m_nCamIndex].hIdxTUCam, fileSaveDraw))
                                {
                                    bRet = false;
                                    break;
                                }
                            }

                        } while (false);
                                       
                        if (bRet)
                        {
                            m_nCntSave++;
                            TUCamera.PostMessage(hMainWin, REFRESH_CAPTURELABEL, 0, (int)m_nCntSave);

                            // 拍照结束
                            if (m_nCntSave >= m_nPicNum)
                            {
                                m_bSaving = false;         
                            }
                        }
                    }
#endregion
                }
            }
            WaitForFrameThread.Abort();
        }

        //Byte to struct
        public static object BytesToStuct(byte[] bytes, Type type)
        {
            //得到结构体的大小
            int size = System.Runtime.InteropServices.Marshal.SizeOf(type);
            //byte数组长度小于结构体的大小
            if (size > bytes.Length)
            {
                //返回空
                return null;
            }
            //分配结构体大小的内存空间
            IntPtr structPtr = System.Runtime.InteropServices.Marshal.AllocHGlobal(size);
            //将byte数组拷到分配好的内存空间
            System.Runtime.InteropServices.Marshal.Copy(bytes, 0, structPtr, size);
            //将内存空间转换为目标结构体
            object obj = System.Runtime.InteropServices.Marshal.PtrToStructure(structPtr, type);
            //释放内存空间
            System.Runtime.InteropServices.Marshal.FreeHGlobal(structPtr);
            //返回结构体
            return obj;
        }
 
        //Trigger使能控制
        private void EnableTriggerControl(bool bEnable)
        {
            Offradio.Enabled = bEnable;
            Standardradio.Enabled = bEnable;
            SHNradio.Enabled = bEnable;
            Gloabalradio.Enabled = bEnable;
            Timedradio.Enabled = bEnable;
            Widthradio.Enabled = bEnable;
            Risingradio.Enabled = bEnable;
            Fallingradio.Enabled = bEnable;

            m_uiTriFrame = 1;

            m_uiTriDelay = 0;
            DelaystextBox.Text = m_uiTriDelay.ToString();

            DelaystrackBar.Value = 1;

            DelaystextBox.Enabled = bEnable;
            Applybutton.Enabled = bEnable;
            Snapbutton.Enabled = bEnable;

            DelaystrackBar.Enabled = bEnable;
            SWTcheck.Enabled = bEnable;

            if (bEnable)
            {
                // 获取触发属性
                TUCAM_TRIGGER_ATTR tgrAttr;
                tgrAttr.nTgrMode = (int)TUCAM_CAPTURE_MODES.TUCCM_SEQUENCE;
                tgrAttr.nFrames = 2;
                tgrAttr.nBufFrames = 2;
                tgrAttr.nDelayTm = 0;
                tgrAttr.nExpMode = (int)TUCAM_TRIGGER_EXP.TUCTE_EXPTM;
                tgrAttr.nEdgeMode = (int)TUCAM_TRIGGER_EDGE.TUCTD_RISING;
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Cap_GetTrigger(m_opCam.hIdxTUCam, ref tgrAttr))
                {
                    m_nTriMode = tgrAttr.nTgrMode;
                    m_nTriExp = tgrAttr.nExpMode;
                    m_nTriEdge = tgrAttr.nEdgeMode;

                    m_uiTriFrame = (uint)tgrAttr.nFrames;

                    m_uiTriDelay = (uint)tgrAttr.nDelayTm / 1000;
                    DelaystextBox.Text = m_uiTriDelay.ToString();

                    DelaystrackBar.Value = tgrAttr.nDelayTm;

                    switch (m_nTriMode)
                    {
                        case (int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_STANDARD:
                            {
                                Offradio.Checked = false;
                                Standardradio.Checked = true;
                                SHNradio.Checked = false;
                                Gloabalradio.Checked = false;
                                SWTcheck.Checked = false;

                            }
                            break;
                        case (int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_SYNCHRONOUS:
                            {
                                Offradio.Checked = false;
                                Standardradio.Checked = false;
                                SHNradio.Checked = true;
                                Gloabalradio.Checked = false;
                                SWTcheck.Checked = false;
                            }
                            break;
                        case (int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_GLOBAL:
                            {
                                Offradio.Checked = false;
                                Standardradio.Checked = false;
                                SHNradio.Checked = false;
                                Gloabalradio.Checked = true;
                                SWTcheck.Checked = false;
                            }
                            break;
                        case (int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_SOFTWARE:
                            {
                                Offradio.Checked = false;
                                Standardradio.Checked = false;
                                SHNradio.Checked = false;
                                Gloabalradio.Checked = false;
                                SWTcheck.Checked = true;
                            }
                            break;
                        case (int)TUCAM_CAPTURE_MODES.TUCCM_SEQUENCE:
                        default:
                            {
                                Offradio.Checked = true;
                                Standardradio.Checked = false;
                                SHNradio.Checked = false;
                                Gloabalradio.Checked = false;
                                SWTcheck.Checked = false;
                            }
                            break;
                    }

                    bool tempexp = false;
                    if (1 == m_nTriExp)
                    {
                        tempexp = true;
                    }
                    else if (0 == m_nTriExp)
                    {
                        tempexp = false;
                    }
                    // 触发曝光时间模式
                    if (tempexp)
                    {
                        Timedradio.Checked = false;
                        Widthradio.Checked = true;

                        DelaystrackBar.Enabled = false;
                        DelaystextBox.Enabled = false;
                    }
                    else
                    {
                        Timedradio.Checked = true;
                        Widthradio.Checked = false;
                    }

                    bool tempedge = false;
                    if (0 == m_nTriEdge)
                    {
                        tempedge = false;
                    }
                    else if (1 == m_nTriEdge)
                    {
                        tempedge = true;
                    }
                    // 触发边沿模式
                    if (tempedge)
                    {
                        Risingradio.Checked = true;
                        Fallingradio.Checked = false;
                    }
                    else
                    {
                        Risingradio.Checked = false;
                        Fallingradio.Checked = true;
                    }

                }
            }
        }
        //使能控制
        private void EnableControl(bool bLiving)
        {
            LiveButton.Enabled = true;
            ResCombox.Enabled = !bLiving;
            CaptureButton.Enabled = bLiving;
            //Recordbutton.Enabled = bLiving;

            // 色阶
            LevelLlabel.Enabled = true;
            LevelLtrackBar.Enabled = true;
            LevelRlabel.Enabled = true;
            LevelRtrackBar.Enabled = true;

            // 制冷
            //Coolinglabel.Enabled = true;
            //CoolingtrackBar.Enabled = true;

            // 拍照
            PicnametextBox.Enabled = true;

            
        }
        //帧率值改变
        private void SDKSLabel_TextChanged(object sender, EventArgs e)
        {
        }
        //消息处理
        protected override void WndProc(ref System.Windows.Forms.Message m)
        {
            switch (m.Msg)
            {
                case REFRESH_FRAMELABEL:
                    int nFps = (int)m.LParam;
                    FrameSpeedLabel.Text = (nFps / 1000.0f).ToString("f2") + "fps";
                    break;

                case REFRESH_TEMPERATURELABEL:
                    if (0 != (int)m_opCam.hIdxTUCam)
                    {
                        if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_TEMPERATURE, ref dblVal, 0))
                        {
                            Currtemplabel.Text = dblVal.ToString("f2") + "℃";
                        }
                    }
                    break;
                case REFRESH_CAPTURELABEL:
                    if (m_bTrigger)
                    {
                        //CaptureMSGLabel.Text = "Capturing " + ((int)(m.LParam) * m_nFmtCnt).ToString() + "/" + ((m_nPicNum * m_nFmtCnt)).ToString() + "success!";
                    }
                    else
                    {
                        CaptureMSGLabel.Text = "Capturing " + ((int)(m.LParam) * m_nFmtCnt).ToString() + "/" + ((m_nPicNum * m_nFmtCnt)).ToString() + "success!";
                    }

                    if ((int)m.LParam == m_nPicNum)
                    {
                        CaptureMSGLabel.Text = "";
                    }

                    break;
                default:
                    base.WndProc(ref m);
                    break;
            }
        }
        //定时刷新温度值
        private void TemperatureTM_Tick(object sender, EventArgs e)
        {
            TUCamera.PostMessage(hMainWin, REFRESH_TEMPERATURELABEL, 0, 0);
        }

        #region Start/Wait for frame
        private void StartWaitForFrame(TUCAM_OPEN openCam)
        {
            if (m_bWaitting)
                return;

            m_bWaitting = true;

            if ((IntPtr)0 == m_hThdWaitForFrame)
            {
                m_drawframe.pBuffer = IntPtr.Zero;
                m_drawframe.ucFormatGet = (byte)TUFRM_FORMATS.TUFRM_FMT_RGB888;
                m_drawframe.uiRsdSize = 1;                                                                                      // how many frames do you want

                int nValue = 0;
                if ((int)TUCAM_CAPTURE_MODES.TUCCM_SEQUENCE != m_nTriMode)
                {
                   nValue = (int)TUCamera.TUCAM_Cap_GetTrigger(openCam.hIdxTUCam, ref attrTgr);
                   attrTgr.nTgrMode = m_nTriMode;
                   nValue = (int)TUCamera.TUCAM_Cap_SetTrigger(openCam.hIdxTUCam, attrTgr);
                }
                else
                {
                   nValue = (int)TUCamera.TUCAM_Cap_GetTrigger(openCam.hIdxTUCam, ref attrTgr);
                   attrTgr.nTgrMode = (int)TUCAM_CAPTURE_MODES.TUCCM_SEQUENCE;
                   attrTgr.nFrames = 1;                                                                                        // TUCCM_SEQUENCE must set 1 frame
                   attrTgr.nBufFrames = 2;
                    nValue = (int)TUCamera.TUCAM_Cap_SetTrigger(openCam.hIdxTUCam, attrTgr);
                }

                TUCamera.TUCAM_Buf_Alloc(openCam.hIdxTUCam, ref m_drawframe);                                                   // Alloc buffer after set resolution or set ROI attribute
                TUCamera.TUCAM_Cap_Start(openCam.hIdxTUCam, (uint)attrTgr.nTgrMode);                                            // Start capture


                TUCAM_TRIGGER_ATTR tgrAttr;
                tgrAttr.nTgrMode = 0;
                tgrAttr.nExpMode = 0;
                tgrAttr.nFrames = 0;
                tgrAttr.nBufFrames = 0;
                tgrAttr.nDelayTm = 0;
                tgrAttr.nEdgeMode = 0;

                TUCAMRET triggerResult = TUCamera.TUCAM_Cap_GetTrigger(m_opCam.hIdxTUCam, ref tgrAttr);
                if (triggerResult == TUCAMRET.TUCAMRET_SUCCESS)
                {
                    Console.WriteLine("triggerResult :{0}，frames:{1}", triggerResult, tgrAttr.nFrames);
                }


                m_dwFrmCnt = 0;                                                                                                 // reset frame count
                m_dwSTm = TUCamera.GetTickCount();                                                                              // reset start tick count

                m_hThdWaitForFrame = TUCamera.CreateEvent(HANDLE.Zero, false, true, string.Empty);

                WaitForFrameThread.Start();

                LiveButton.Text = "Stop";
            }

            EnableControl(m_bWaitting);
            EnableTriggerControl(!m_bWaitting);
        }
        private void StopWaitForFrame(TUCAM_OPEN openCam)
        {
            if (!m_bWaitting)
                return;

            m_bSaving = false;
            m_bWaitting = false;

            if ((IntPtr)0 != m_hThdWaitForFrame)
            {
                TUCamera.TUCAM_Buf_AbortWait(openCam.hIdxTUCam);             // If you called TUCAM_Buf_WaitForFrames()

                TUCamera.WaitForSingleObject(m_hThdWaitForFrame, 0xFFFFFFFF);
                TUCamera.CloseHandle(m_hThdWaitForFrame);
                m_hThdWaitForFrame = (IntPtr)0;

                TUCamera.TUCAM_Cap_Stop(openCam.hIdxTUCam);                  // Stop capture   
                TUCamera.TUCAM_Buf_Release(openCam.hIdxTUCam);               // Release alloc buffer after stop capture and quit drawing thread

                LiveButton.Text = "Live";
            }

            EnableControl(m_bWaitting);
            EnableTriggerControl(!m_bWaitting);
        }
        #endregion

        #region Camera Control mode
        /// <summary>
        /// Camera Control mode
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //改变分辨率
        private void ResCombox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (0 != (int)m_opCam.hIdxTUCam)
            {
                TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_RESOLUTION, ResCombox.SelectedIndex);
            }

            SetROIButton.Text = "Set ROI";
            ROIcheck.Checked = false;
            //ROIcheck.Enabled = true;

            Hoffsetlabel.Enabled = true;
            Voffsetlabel.Enabled = true;
            Widthlabel.Enabled = true;
            Heightlabel.Enabled = true;

            HoffsettextBox.Enabled = true;
            VoffsettextBox.Enabled = true;
            WidthtextBox.Enabled = true;
            HeighttextBox.Enabled = true;

            //切换分辨率后刷新显示界面
            ShowpictureBox.Refresh();
        }
        //LiveButton
        private void LiveButton_Click(object sender, EventArgs e)
        {
            WaitForFrameThread = new System.Threading.Thread(new ThreadStart(WaitForFrame));

            m_nTriMode = (int)TUCAM_CAPTURE_MODES.TUCCM_SEQUENCE;
            m_bTrigger = false;

            if (m_bWaitting)
            {
                StopWaitForFrame(m_opCamList[m_nCamIndex]);
            }
            else
            {
                StartWaitForFrame(m_opCamList[m_nCamIndex]);
            }

            EnableControl(m_bWaitting);
        }
        //Min值改变
        private void MinUpDown_ValueChanged(object sender, EventArgs e)
        {
            m_uMin = (uint)MinUpDown.Value;
        }
        //Sec值改变
        private void SecUpDown_ValueChanged(object sender, EventArgs e)
        {
             m_uSec = (uint)SecUpDown.Value;
        }
        //Ms值改变
        private void MsUpDown_ValueChanged(object sender, EventArgs e)
        {
             m_uMs = (uint)MsUpDown.Value;
        }
        //Us值改变
        private void UsUpDown_ValueChanged(object sender, EventArgs e)
        {
             m_uUs = (uint)UsUpDown.Value;
        }
        //OKButton
        private void OKButton_Click(object sender, EventArgs e)
        {
            ulong dwExp = m_uMin * 60 * 1000 * 1000 + m_uSec * 1000 * 1000 + m_uMs * 1000 + m_uUs;
            double dblExp = dwExp / 1000.0f;
            double dbtemp = 0;

            if (0 != (int)m_opCam.hIdxTUCam)
            {
                TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_EXPOSURETM, dblExp, 0);

                TUCamera.TUCAM_Prop_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_EXPOSURETM, ref dbtemp, 0);

                UpdateExposureTime((ulong)(dbtemp * 1000));
            }
        }

        #endregion

        #region More Parameters mode
        /// <summary>
        /// More Parameters mode
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //HDR状态改变
        private void HDRradio_CheckedChanged(object sender, EventArgs e)
        {
            if (m_nMaxGain > 5)
            {
                return;
            }
            if (HDRradio.Checked)
            {
                m_nGain = 0;
                int nVal = 0;
                //HDRradio.Checked = true;
                HGradio.Checked = false;
                LGradio.Checked = false;
                CMSradio.Checked = false;
                if (0 != (int)m_opCam.hIdxTUCam)
                {
                    TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)(TUCAM_IDPROP.TUIDP_GLOBALGAIN), m_nGain, 0);
                    if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_IMGMODESELECT, ref nVal))
                    {
                        switch (m_nImgMode)
                        {
                            case 1:
                                {
                                    if (nVal != 0)
                                        TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)(TUCAM_IDCAPA.TUIDC_IMGMODESELECT), 0);
                                }
                                break;
                            case 2:
                                {
                                    if (nVal != 2)
                                        TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)(TUCAM_IDCAPA.TUIDC_IMGMODESELECT), 2);
                                }
                                break;
                            case 0:
                            default:
                                break;
                        }
                    }

                }
            }
           
        }
        //HightCain状态改变
        private void HGradio_CheckedChanged(object sender, EventArgs e)
        {
            if (m_nMaxGain > 5)
            {
                return;
            }

            if (HGradio.Checked)
            {
                m_nGain = 1;
                int nVal = 0;
                //HGradio.Checked = true;
                HDRradio.Checked = false;
                LGradio.Checked = false;
                CMSradio.Checked = false;
                if (0 != (int)m_opCam.hIdxTUCam)
                {
                    TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)(TUCAM_IDPROP.TUIDP_GLOBALGAIN), m_nGain, 0);
                    if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_IMGMODESELECT, ref nVal))
                    {
                        switch (m_nImgMode)
                        {
                            case 1:
                                {
                                    if (nVal != 0)
                                        TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)(TUCAM_IDCAPA.TUIDC_IMGMODESELECT), 0);
                                }
                                break;
                            case 2:
                                {
                                    if (nVal != 2)
                                        TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)(TUCAM_IDCAPA.TUIDC_IMGMODESELECT), 2);
                                }
                                break;
                            case 0:
                            default:
                                break;
                        }
                    }
                }
            }
           
        }
        //LowGain状态改变
        private void LGradio_CheckedChanged(object sender, EventArgs e)
        {
            if (m_nMaxGain > 5)
            {
                return;
            }

            if (LGradio.Checked)
            {
                m_nGain = 2;
                int nVal = 0;
                HDRradio.Checked = false;
                HGradio.Checked = false;
                //LGradio.Checked = true;
                CMSradio.Checked = false;
                if (0 != (int)m_opCam.hIdxTUCam)
                {
                    TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)(TUCAM_IDPROP.TUIDP_GLOBALGAIN), m_nGain, 0);
                    if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_IMGMODESELECT, ref nVal))
                    {
                        switch (m_nImgMode)
                        {
                            case 1:
                                {
                                    if (nVal != 0)
                                        TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)(TUCAM_IDCAPA.TUIDC_IMGMODESELECT), 0);
                                }
                                break;
                            case 2:
                                {
                                    if (nVal != 2)
                                        TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)(TUCAM_IDCAPA.TUIDC_IMGMODESELECT), 2);
                                }
                                break;
                            case 0:
                            default:
                                break;
                        }
                    }
                }
            }
            
        }
        // CMS 状态改变
        private void CMSradio_CheckedChanged(object sender, EventArgs e)
        {
            if (m_nMaxGain > 5)
            {
                return;
            }
           // CMSradio.Checked = true;
            if (CMSradio.Checked)
            {
                HDRradio.Checked = false;
                HGradio.Checked = false;
                LGradio.Checked = false;
                m_nGain = 3;
                int nVal = 0;
                if (0 != (int)m_opCam.hIdxTUCam)
                {
                    TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)(TUCAM_IDPROP.TUIDP_GLOBALGAIN), 0, 0);
                    if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_IMGMODESELECT, ref nVal))
                    {
                        if (nVal != 1)
                            TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)(TUCAM_IDCAPA.TUIDC_IMGMODESELECT), 1);
                    }
                }
            }
            
        }

        // Gain调整
        private void GaintrackBar_ValueChanged(object sender, EventArgs e)
        {
            if (!m_bGainRange)
            {
                m_bGainRange = true;
                return;
            }

            m_nGain = GaintrackBar.Value;

            // 设置左色阶值
            if (0 != (int)m_opCam.hIdxTUCam)
            {
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_GLOBALGAIN, (1.0f * m_nGain), 0))
                {
                    GaintextBox.Text = m_nGain.ToString();
                }
            }
        }

        //水平翻转
        private void HFlipcheck_CheckedChanged(object sender, EventArgs e)
        {
            int nVal = 0;

            if (HFlipcheck.Checked == true)
            {
                nVal = 1;
            }
            else
            {
                nVal = 0;
            }

            if (0 != (int)m_opCam.hIdxTUCam)
            {
                TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_HORIZONTAL, nVal);
            }
        }
        //垂直翻转
        private void VFlipcheck_CheckedChanged(object sender, EventArgs e)
        {
            int nVal = 0;

            if (VFlipcheck.Checked == true)
            {
                nVal = 1;
            }
            else
            {
                nVal = 0;
            }

            if (0 != (int)m_opCam.hIdxTUCam)
            {
                TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_VERTICAL, nVal);
            }
        }
        //自动
        private void AutoLevelcheck_CheckedChanged(object sender, EventArgs e)
        {

        }
        //左色阶
        private void LevelLtrackBar_ValueChanged(object sender, EventArgs e)
        {
            int nLLevel = LevelLtrackBar.Value;
            int nRLevel = LevelRtrackBar.Value;

            if (nLLevel >= nRLevel)
            {
                nRLevel = nLLevel + 1;
                LevelRtrackBar.Value = nRLevel;

                LevelRtextBox.Text = nRLevel.ToString();
            }

            // 设置左色阶值
            if (0 != (int)m_opCam.hIdxTUCam)
            {
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_LFTLEVELS, (1.0f * (double)LevelLtrackBar.Value), 0))
                {
                    LevelLtextBox.Text = LevelLtrackBar.Value.ToString();
                }
            }
        }
        //右色阶
        private void LevelRtrackBar_ValueChanged(object sender, EventArgs e)
        {
            if (!m_bRLvlRange)
            {
                m_bRLvlRange = true;
                return;
            }

            int nLLevel = LevelLtrackBar.Value;
            int nRLevel = LevelRtrackBar.Value;

            if (nLLevel >= nRLevel)
            {
                nLLevel = nRLevel - 1;
                nLLevel = nLLevel < 0 ? 0 : nLLevel;
                LevelLtrackBar.Value = nLLevel;

                LevelLtextBox.Text = nLLevel.ToString();
            }

            // 设置右色阶值
            if (0 != (int)m_opCam.hIdxTUCam)
            {
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_RGTLEVELS, (/*1.0f **/ (double)LevelRtrackBar.Value), 0))
                {
                    LevelRtextBox.Text = LevelRtrackBar.Value.ToString();
                }
            }
        }
        //温度
        private void CoolingtrackBar_ValueChanged(object sender, EventArgs e)
        {
//             if (false == m_bCoolChange)
//                 return;

            if (0 != (int)m_opCam.hIdxTUCam)
            {
                int nVal = CoolingtrackBar.Value/* - m_nMidTemp*/;
                CoolingtextBox.Text = (nVal - 50).ToString() + " ℃";

                TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_TEMPERATURE, nVal, 0);
            }
        }
        //Fan选择
        private void Curtempcombox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (0 != (int)m_opCam.hIdxTUCam)
            {
                TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_FAN_GEAR, Curtempcombox.SelectedIndex);
            }
        }
        //默认按键
        private void DefaultButton_Click(object sender, EventArgs e)
        {
            // 获取色阶范围
            attrProp.nIdxChn = 0;                    // 使用默认通道
            attrProp.idProp = (int)TUCAM_IDPROP.TUIDP_LFTLEVELS;
            if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetAttr(m_opCam.hIdxTUCam, ref attrProp))
            {
                LevelLtrackBar.SetRange((int)attrProp.dbValMin, (int)attrProp.dbValMax);
                LevelLtrackBar.Value = (int)attrProp.dbValMin;
            }

            attrProp.idProp = (int)TUCAM_IDPROP.TUIDP_RGTLEVELS;
            if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetAttr(m_opCam.hIdxTUCam, ref attrProp))
            {
                LevelRtrackBar.SetRange((int)attrProp.dbValMin, (int)attrProp.dbValMax);
                LevelRtrackBar.Value = (int)attrProp.dbValMax;
            }

            HFlipcheck.Checked = false;
            VFlipcheck.Checked = false;

            HDRradio.Checked = true;

//          Curtempcombox.SelectedIndex = 2;
            CoolingtrackBar.Value = 40;
        }
        #endregion

        #region Trigger mode
        /// <summary>
        /// Trigger mode
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //Offradio
        private void Offradio_CheckedChanged(object sender, EventArgs e)
        {
            m_nTriMode = (int)TUCAM_CAPTURE_MODES.TUCCM_SEQUENCE;

            Timedradio.Enabled = false;
            Widthradio.Enabled = false;
            Risingradio.Enabled = false;
            Fallingradio.Enabled = false;

            DelaystrackBar.Enabled = false;
            DelaystextBox.Enabled = false;
        }
        //Standarradio
        private void Standardradio_CheckedChanged(object sender, EventArgs e)
        {
            m_nTriMode = (int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_STANDARD;

            Timedradio.Enabled = true;
            Widthradio.Enabled = true;
            Risingradio.Enabled = true;
            Fallingradio.Enabled = true;

            bool temp = false;
            if (0 == m_nTriExp)
            {
                temp = false;
            }
            else if (1 == m_nTriExp)
            {
                temp = true;
            }

            DelaystextBox.Enabled = !temp;
            DelaystrackBar.Enabled = !temp;
        }
        //SHNradio
        private void SHNradio_CheckedChanged(object sender, EventArgs e)
        {
            m_nTriMode = (int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_SYNCHRONOUS;
            m_nTriExp = (int)TUCAM_TRIGGER_EXP.TUCTE_WIDTH;

            Timedradio.Checked = false;
            Widthradio.Checked = true;

            Timedradio.Enabled = false;
            Widthradio.Enabled = true;
            Risingradio.Enabled = true;
            Fallingradio.Enabled = true;

            DelaystextBox.Enabled = false;
            DelaystrackBar.Enabled = false;
        }
        //Gloabalradio
        private void Gloabalradio_CheckedChanged(object sender, EventArgs e)
        {
            m_nTriMode = (int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_GLOBAL;

            Timedradio.Enabled = true;
            Widthradio.Enabled = true;
            Risingradio.Enabled = true;
            Fallingradio.Enabled = true;

            DelaystextBox.Enabled = false;

            DelaystrackBar.Enabled = false;
        }
        //Timedradio
        private void Timedradio_CheckedChanged(object sender, EventArgs e)
        {
            m_nTriExp = (int)TUCAM_TRIGGER_EXP.TUCTE_EXPTM;

             DelaystrackBar.Enabled = true;
             DelaystextBox.Enabled = true;

        }
        //Widthradio
        private void Widthradio_CheckedChanged(object sender, EventArgs e)
        {
            m_nTriExp = (int)TUCAM_TRIGGER_EXP.TUCTE_WIDTH;

            //m_uiTriFrame = 1;

            m_uiTriDelay = 0;
            DelaystextBox.Text = m_uiTriDelay.ToString();

            DelaystrackBar.Value = 0;

            DelaystextBox.Enabled = false;
            DelaystrackBar.Enabled = false;
   
        }
        //Risingradio
        private void Risingradio_CheckedChanged(object sender, EventArgs e)
        {
            m_nTriEdge = (int)TUCAM_TRIGGER_EDGE.TUCTD_RISING;
        }
        //Fallingradio
        private void Fallingradio_CheckedChanged(object sender, EventArgs e)
        {
            m_nTriEdge = (int)TUCAM_TRIGGER_EDGE.TUCTD_FAILING;
        }
        //SWTcheck
        private void SWTcheck_CheckedChanged(object sender, EventArgs e)
        {
            bool bSfw = SWTcheck.Checked;

            if (m_bWaitting)
            {
                // 关闭预览
                StopWaitForFrame(m_opCamList[m_nCamIndex]);
                if (m_nTriMode == (int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_SOFTWARE)
                {
                    SWTcheck.Checked = false;
                }
            }

            if (bSfw)
            {
                m_nTriMode = (int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_SOFTWARE;
            }
            else
            {
                m_nTriMode = (int)TUCAM_CAPTURE_MODES.TUCCM_SEQUENCE;
            }

            Offradio.Enabled = !bSfw;
            Standardradio.Enabled = !bSfw;
            SHNradio.Enabled = !bSfw;
            Gloabalradio.Enabled = !bSfw;
            Timedradio.Enabled = !bSfw;
            Widthradio.Enabled = !bSfw;
            Risingradio.Enabled = !bSfw;
            Fallingradio.Enabled = !bSfw;

            m_uiTriDelay = 0;
            DelaystextBox.Text = m_uiTriDelay.ToString();

            DelaystrackBar.Value = 0;

            DelaystextBox.Enabled = !bSfw;
 
            DelaystrackBar.Enabled = !bSfw;
   
        }
        //Snapbutton
        private void Snapbutton_Click(object sender, EventArgs e)
        {
            PicnametextBox.Text = m_szPicName;

            if (0 != (int)m_opCam.hIdxTUCam)
            {
                TUCamera.TUCAM_Cap_DoSoftwareTrigger(m_opCam.hIdxTUCam);
            }
        }
        //Updowbutton
        private void Updatebutton_Click(object sender, EventArgs e)
        {
            DelaystrackBar.Value = (int)m_uiTriDelay;
        }
        //Applybutton
        private void Applybutton_Click(object sender, EventArgs e)
        {
            if ((int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_SYNCHRONOUS == m_nTriMode 
                || (int)TUCAM_CAPTURE_MODES.TUCCM_TRIGGER_GLOBAL == m_nTriMode)
            {
                m_uiTriDelay = 0;
                DelaystextBox.Text = m_uiTriDelay.ToString();

                DelaystrackBar.Value = 0;
            }

            m_nCntSave = 0;

            // 关闭预览
            if (m_bWaitting)
            {
                StopWaitForFrame(m_opCamList[m_nCamIndex]);
                EnableControl(m_bWaitting);
            }

            TUCAM_TRIGGER_ATTR tgrAttr;

            tgrAttr.nTgrMode = m_nTriMode;
            tgrAttr.nExpMode = m_nTriExp;
            tgrAttr.nEdgeMode = m_nTriEdge;
            tgrAttr.nFrames = 1;
            tgrAttr.nBufFrames = 3;
            tgrAttr.nDelayTm = (int)m_uiTriDelay * 1000;

            m_bTrigger = (m_nTriMode == (int)TUCAM_CAPTURE_MODES.TUCCM_SEQUENCE) ? false : true; 

            // 设置触发属性
            TUCAMRET result = TUCamera.TUCAM_Cap_SetTrigger(m_opCam.hIdxTUCam, tgrAttr);
            Console.WriteLine("trigger result :{0:X}", result);

            if (!m_bWaitting)
            {
                WaitForFrameThread = new System.Threading.Thread(new ThreadStart(WaitForFrame));
                StartWaitForFrame(m_opCamList[m_nCamIndex]);
                EnableControl(m_bWaitting);
            }

            if (m_nTriMode == (int)TUCAM_CAPTURE_MODES.TUCCM_SEQUENCE)
            {
                ResCombox.Enabled = true;
                LiveButton.Enabled = true;
                CaptureButton.Enabled = true;
            }
            else
            {
                ResCombox.Enabled = false;
                LiveButton.Enabled = false;
                CaptureButton.Enabled = false;
            }

            Snapbutton.Enabled = m_bWaitting;
            SWTcheck.Enabled = m_bWaitting;
            ShowpictureBox.Refresh();
        }

        //DelaystrackBar
        private void DelaystrackBar_ValueChanged(object sender, EventArgs e)
        {
            //if (NULL != m_sldDelay.GetSafeHwnd())
            {
                m_uiTriDelay = (uint)DelaystrackBar.Value;
                DelaystextBox.Text = m_uiTriDelay.ToString();
            }
        }
        //DelaystextBox
        private void DelaystextBox_TextChanged(object sender, EventArgs e)
        {
            DelaystextBox.Text = m_uiTriDelay.ToString();
        }
        //Delaytextbox limit input
        private void DelaystextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            try
            {
                int kc = (int)e.KeyChar;
                if ((kc < 48 || kc > 57) && kc != 8)
                    e.Handled = true;
            }
            catch (Exception)
            {
            }
        }

        #endregion

        #region Image Capture Mode
        /// <summary>
        /// Image Capture Mode
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //CaptureButton
        private void CaptureButton_Click(object sender, EventArgs e)
        {
            if (m_szPicName == "" && !UsertimeCheck.Checked)
            {
                MessageBox.Show("Capture picture name must be not empty!");
                return;
            }

            if (m_nPicNum > 0 && m_nFmtCnt > 0)
            {
                m_nCntSave = 0;         // 保存计数
                m_bSaving = true;
            }
            else
            {
                MessageBox.Show("Capture picture number and format must be more than 1!");
            }
        }
        //BrowseButton
        private void BrowseButton_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog sfd = new FolderBrowserDialog();

            if (sfd.ShowDialog() == DialogResult.OK)
            {
                m_strFilePath = sfd.SelectedPath;
                PathtextBox.Text = m_strFilePath;
            }
        }
        //PicnametextBox
        private void PicnametextBox_TextChanged(object sender, EventArgs e)
        {
            m_szPicName = PicnametextBox.Text;
        }
        //UsertimeCheck
        private void UsertimeCheck_CheckedChanged(object sender, EventArgs e)
        {
            if (UsertimeCheck.Checked == true)
            {
                PicnametextBox.Enabled = false;
            }
            else
            {
                PicnametextBox.Enabled = true;
            }
        }
        //TIFCheck
        private void TIFCheck_CheckedChanged(object sender, EventArgs e)
        {
            if (TIFCheck.Checked == true)
            {
                m_nFmtSave |= (int)(TUIMG_FORMATS.TUFMT_TIF);
                m_nFmtCnt++;
            }
            else
            {
                m_nFmtSave &= ~(int)(TUIMG_FORMATS.TUFMT_TIF);
                m_nFmtCnt--;
            }
        }
        //RAWCheck
        private void RAWCheck_CheckedChanged(object sender, EventArgs e)
        {
            if (RAWCheck.Checked == true)
            {
                m_nFmtSave |= (int)(TUIMG_FORMATS.TUFMT_RAW);
                m_nFmtCnt++;
            }
            else
            {
                m_nFmtSave &= ~(int)(TUIMG_FORMATS.TUFMT_RAW);
                m_nFmtCnt--;
            }
        }
        //JPGCheck
        private void JPGCheck_CheckedChanged(object sender, EventArgs e)
        {
            if (JPGCheck.Checked == true)
            {
                m_nFmtSave |= (int)(TUIMG_FORMATS.TUFMT_JPG);
                m_nFmtCnt++;
            }
            else
            {
                m_nFmtSave &= ~(int)(TUIMG_FORMATS.TUFMT_JPG);
                m_nFmtCnt--;
            }
        }
        //PNGCheck
        private void PNGCheck_CheckedChanged(object sender, EventArgs e)
        {
            if (PNGCheck.Checked == true)
            {
                m_nFmtSave |= (int)(TUIMG_FORMATS.TUFMT_PNG);
                m_nFmtCnt++;
            }
            else
            {
                m_nFmtSave &= ~(int)(TUIMG_FORMATS.TUFMT_PNG);
                m_nFmtCnt--;
            }
        }
        //BMPCheck
        private void BMPCheck_CheckedChanged(object sender, EventArgs e)
        {
            if (BMPCheck.Checked == true)
            {
                m_nFmtSave |= (int)(TUIMG_FORMATS.TUFMT_BMP);
                m_nFmtCnt++;
            }
            else
            {
                m_nFmtSave &= ~(int)(TUIMG_FORMATS.TUFMT_BMP);
                m_nFmtCnt--;
            }

        }
        #endregion



        //Picnumtextbox
        private void PicnumtextBox_TextChanged(object sender, EventArgs e)
        {
            if (PicnumtextBox.Text == "")
            {
                m_nPicNum = 0;
            }
            else
            {
                m_nPicNum = int.Parse((PicnumtextBox.Text));
                PicnumtextBox.Text = m_nPicNum.ToString();
                PicnumtextBox.Refresh();
            }
        }
        //Picnumtextbox limit input
        private void PicnumtextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            try
            {
                int kc = (int)e.KeyChar;
                if ((kc < 48 || kc > 57) && kc != 8)
                    e.Handled = true;
            }
            catch (Exception)
            {
            }
        }

        #region ROI mode and infomation mode
        /// <summary>
        /// ROI mode and infomation mode
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //SetROIButton
        private void SetROIButton_Click(object sender, EventArgs e)
        {
            if (m_bWaitting)
            {
                StopWaitForFrame(m_opCamList[m_nCamIndex]);
                EnableControl(m_bWaitting);
            }

            TUCAM_ROI_ATTR roiAttr;

            if (ROIcheck.Checked)
            {
                roiAttr.bEnable = false;
                roiAttr.nVOffset = 0;
                roiAttr.nHOffset = 0;
                roiAttr.nWidth = (int)m_uiWidth;
                roiAttr.nHeight = (int)m_uiHeight;

                ROIcheck.Checked = false;

                Hoffsetlabel.Enabled = true;
                Voffsetlabel.Enabled = true;
                Widthlabel.Enabled = true;
                Heightlabel.Enabled = true;

                HoffsettextBox.Enabled = true;
                VoffsettextBox.Enabled = true;
                WidthtextBox.Enabled = true;
                HeighttextBox.Enabled = true;

                m_uiWidth = (uint)roiAttr.nWidth;
                m_uiHeight = (uint)roiAttr.nHeight;

                TUCamera.TUCAM_Cap_SetROI(/*m_opCam.hIdxTUCam*/m_opCamList[m_nCamIndex].hIdxTUCam, roiAttr);

                SetROIButton.Text = "Set ROI";
            }
            else
            {
                roiAttr.bEnable = true;
                roiAttr.nVOffset = (int)((m_uiVOffset >> 2) << 2);
                roiAttr.nHOffset = (int)((m_uiHOffset >> 2) << 2);
                roiAttr.nWidth = (int)((m_uiWidth >> 2) << 2);
                roiAttr.nHeight = (int)((m_uiHeight >> 2) << 2);


                TUCamera.TUCAM_Cap_SetROI(/*m_opCam.hIdxTUCam*/m_opCamList[m_nCamIndex].hIdxTUCam, roiAttr);

                TUCamera.TUCAM_Cap_GetROI(/*m_opCam.hIdxTUCam*/m_opCamList[m_nCamIndex].hIdxTUCam, ref roiAttr);

                m_uiVOffset = (uint)roiAttr.nVOffset;
                m_uiHOffset = (uint)roiAttr.nHOffset;
                m_uiWidth = (uint)roiAttr.nWidth;
                m_uiHeight = (uint)roiAttr.nHeight;

                ROIcheck.Checked = true;
                //ROIcheck.Enabled = false;
                
                Hoffsetlabel.Enabled = false;
                Voffsetlabel.Enabled = false;
                Widthlabel.Enabled = false;
                Heightlabel.Enabled = false;

                HoffsettextBox.Enabled = false;
                VoffsettextBox.Enabled = false;
                WidthtextBox.Enabled = false;
                HeighttextBox.Enabled = false;

                SetROIButton.Text = "Set Full";
            }

            WidthtextBox.Text = m_uiWidth.ToString();
            HeighttextBox.Text = m_uiHeight.ToString();

            HoffsettextBox.Text = m_uiHOffset.ToString();
            VoffsettextBox.Text = m_uiVOffset.ToString();

            ShowpictureBox.Refresh();

            if (!m_bWaitting)
            {
                WaitForFrameThread = new System.Threading.Thread(new ThreadStart(WaitForFrame));
                StartWaitForFrame(m_opCamList[m_nCamIndex]);
                EnableControl(m_bWaitting);
            }
        }
        //HoffsettextBox
        private void HoffsettextBox_TextChanged(object sender, EventArgs e)
        {
            if (HoffsettextBox.Text == "")
            {
                m_uiHOffset = 0;
            }
            else
            {
                m_uiHOffset = uint.Parse(HoffsettextBox.Text);
            }
        }
        //Hoffsettextbox limit input
        private void HoffsettextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            try
            {
                int kc = (int)e.KeyChar;
                if ((kc < 48 || kc > 57) && kc != 8)
                    e.Handled = true;
            }
            catch (Exception)
            {
            }
        }
        //Hoffsettextboxleave
        private void HoffsettextBox_Leave(object sender, EventArgs e)
        {
            uint m_nTempWidth = 0;
            if (m_uiHOffset > 2048)
            {
                m_uiHOffset = 2048;
            }
            else
            {
                m_nTempWidth = m_uiHOffset / 4;
                m_uiHOffset = m_nTempWidth * 4;
            }
            HoffsettextBox.Text = m_uiHOffset.ToString();
        }
        //VoffsettextBox
        private void VoffsettextBox_TextChanged(object sender, EventArgs e)
        {
            if (VoffsettextBox.Text == "")
            {
                m_uiVOffset = 0;
            }
            else
            {
                m_uiVOffset = uint.Parse(VoffsettextBox.Text);
            }
        }
        //Voffsettextbox limit input
        private void VoffsettextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            try
            {
                int kc = (int)e.KeyChar;
                if ((kc < 48 || kc > 57) && kc != 8)
                    e.Handled = true;
            }
            catch (Exception)
            {
            }
        }
        //Voffsettextboxleave
        private void VoffsettextBox_Leave(object sender, EventArgs e)
        {
            if (m_uiVOffset > 2048)
            {
                m_uiVOffset = 2048;
            }
            VoffsettextBox.Text = m_uiVOffset.ToString();
        }
        //WidthtextBox
        private void WidthtextBox_TextChanged(object sender, EventArgs e)
        {      
            if (WidthtextBox.Text == "")
            {
                m_uiWidth = 100;
            }
            else
            {
                m_uiWidth = uint.Parse(WidthtextBox.Text);
            }
        }
        //Widtntext limit input
        private void WidthtextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            try
            {
                int kc = (int)e.KeyChar;
                if ((kc < 48 || kc > 57) && kc != 8)
                    e.Handled = true;
            }
            catch (Exception)
            {
            }  
        }
        //WidthtextBoxLeave
        private void WidthtextBox_Leave(object sender, EventArgs e)
        {
            uint m_nTempWidth = 0;
            if (m_uiWidth > 2048)
            {
                m_uiWidth = 2048;
            }
            else
            {
                m_nTempWidth = m_uiWidth / 4;
                m_uiWidth = m_nTempWidth * 4;
            }
            WidthtextBox.Text = m_uiWidth.ToString();
        }
        //HeighttextBox
        private void HeighttextBox_TextChanged(object sender, EventArgs e)
        {
            if (HeighttextBox.Text == "")
            {
                m_uiHeight = 100;
            }
            else
            {
                m_uiHeight = uint.Parse(HeighttextBox.Text);
            }
        }
        //Heighttextbox limit input
        private void HeighttextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            try
            {
                int kc = (int)e.KeyChar;
                if ((kc < 48 || kc > 57) && kc != 8)
                    e.Handled = true;
            }
            catch (Exception)
            {
            }
        }
        //HeighttextBox Leave
        private void HeighttextBox_Leave(object sender, EventArgs e)
        {
            uint m_nTempHeight = 0;
            if (m_uiHeight > 2048)
            {
                m_uiHeight = 2048;
            }
            else
            {
                m_nTempHeight = m_uiHeight / 4;
                m_uiHeight = m_nTempHeight * 4;
            }
            HeighttextBox.Text = m_uiHeight.ToString();
        }
        //ROIcheck
        private void ROIcheck_CheckedChanged(object sender, EventArgs e)
        {
        }

        #endregion

        #region Other
        //WriteSN button
        private void Writebutton_Click(object sender, EventArgs e)
        {
            TUCAM_REG_RW regC;
            regC.nRegType = (int)TUREG_FORMATS.TUREG_SN;
            regC.nBufSize = 64;
            string snstr = m_szSN ;
            regC.pBuf = Marshal.StringToHGlobalAnsi(snstr);

            if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Reg_Write(m_opCam.hIdxTUCam, regC))
            {
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Reg_Read(m_opCam.hIdxTUCam, regC))
                {
                    string str = Marshal.PtrToStringAnsi(regC.pBuf);
                    SNLabel.Text = Marshal.PtrToStringAnsi(regC.pBuf);
                }
                MessageBox.Show("Write SN successed!");
            }
            else
            {
                MessageBox.Show("Write SN failed!");
            }

            InitInformation(m_opCamList[m_nCamIndex]);
        }
        //SNtextbox
        private void SNtextBox_TextChanged(object sender, EventArgs e)
        {
            m_szSN = SNtextBox.Text;
        }
        //SNLabel
        private void SNLabel_TextChanged(object sender, EventArgs e)
        {
            SNLabel.Text = m_szSN;
        }

        #endregion


        //CameraIndex Changed
        private void CamCombox_SelectedValueChanged(object sender, EventArgs e)
        {
            //停止取图
            if (m_bWaitting)
            {
                StopWaitForFrame(m_opCamList[m_nCamIndex]);
                EnableControl(m_bWaitting);
            }

            //切换相机后开始取图
            m_nCamIndex = CamCombox.SelectedIndex;
            m_opCam = m_opCamList[m_nCamIndex];

            //开始取图
            if (!m_bWaitting)
            {
                WaitForFrameThread = new System.Threading.Thread(new ThreadStart(WaitForFrame));
                StartWaitForFrame(m_opCamList[m_nCamIndex]);
                EnableControl(m_bWaitting);
            }

             InitInformation(m_opCamList[m_nCamIndex]);
             InitCameraControl(m_opCamList[m_nCamIndex]);
             RefreshValue(m_opCamList[m_nCamIndex]);

             //刷新显示区域（去除阴影）
             ShowpictureBox.Refresh();
        }

        #region Color mode
        private void tbRed_ValueChanged(object sender, EventArgs e)
        {
            if (!m_bRedRange)
            {
                m_bRedRange = true;
                return;
            }

            // 设置红色通道值
            if (0 != (int)m_opCam.hIdxTUCam)
            {
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_CHNLGAIN, (1.0f * (double)tbRed.Value), 1))
                {
                    tbvRed.Text = string.Format("{0:F1}", (tbRed.Value / 2.0f));
                }
            }
        }

        private void tbGreen_ValueChanged(object sender, EventArgs e)
        {
            if (!m_bGreenRange)
            {
                m_bGreenRange = true;
                return;
            }

            // 设置绿色通道值
            if (0 != (int)m_opCam.hIdxTUCam)
            {
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_CHNLGAIN, (1.0f * (double)tbGreen.Value), 2))
                {
                    tbvGreen.Text = string.Format("{0:F1}", (tbGreen.Value / 2.0f));
                }
            }
        }

        private void tbBlue_ValueChanged(object sender, EventArgs e)
        {
            if (!m_bBlueRange)
            {
                m_bBlueRange = true;
                return;
            }

            // 设置蓝色通道值
            if (0 != (int)m_opCam.hIdxTUCam)
            {
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_CHNLGAIN, (1.0f * (double)tbBlue.Value), 3))
                {
                    tbvBlue.Text = string.Format("{0:F1}", (tbBlue.Value / 2.0f));
                }
            }
        }

        private void tbSaturation_ValueChanged(object sender, EventArgs e)
        {
            if (!m_bSaturationRange)
            {
                m_bSaturationRange = true;
                return;
            }

            // 设置饱和度值
            if (0 != (int)m_opCam.hIdxTUCam)
            {
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_SATURATION, (1.0f * (double)tbSaturation.Value), 0))
                {
                    tbvSaturation.Text = tbSaturation.Value.ToString();
                }
            }
        }

        private void tbHue_ValueChanged(object sender, EventArgs e)
        {
            if (!m_bHueRange)
            {
                m_bHueRange = true;
                return;
            }

            // 设置色调值
            if (0 != (int)m_opCam.hIdxTUCam)
            {
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_HUE, (1.0f * (double)tbHue.Value), 0))
                {
                    tbvHue.Text = tbHue.Value.ToString();
                }
            }
        }

        private void tbLight_ValueChanged(object sender, EventArgs e)
        {
            if (!m_bLightRange)
            {
                m_bLightRange = true;
                return;
            }

            // 设置色调值
            if (0 != (int)m_opCam.hIdxTUCam)
            {
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_LIGHT, (1.0f * (double)tbLight.Value), 0))
                {
                    tbvLight.Text = tbLight.Value.ToString();
                }
            }
        }

        private void chkAWB_CheckedChanged(object sender, EventArgs e)
        {
            if (chkAWB.Checked)
            {
                TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_ATWBALANCE, 2);

                labnRed.Enabled = false;
                labnGreen.Enabled = false;
                labnBlue.Enabled = false;

                tbRed.Enabled = false;
                tbGreen.Enabled = false;
                tbBlue.Enabled = false;

                tbvRed.Enabled = false;
                tbvGreen.Enabled = false;
                tbvBlue.Enabled = false;
            }
            else
            {
                TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_ATWBALANCE, 0);

                int nVal = 0;
                double dbVal = 0;
                
                // 获取当前红色通道值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_CHNLGAIN, ref dbVal, 1))
                {
                    nVal = (int)dbVal;

                    tbvRed.Text = string.Format("{0:F1}", (dbVal / 2.0f));
                    tbRed.Value = nVal;
                }

                // 获取当前绿色通道值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_CHNLGAIN, ref dbVal, 2))
                {
                    nVal = (int)dbVal;

                    tbvGreen.Text = string.Format("{0:F1}", (dbVal / 2.0f));
                    tbGreen.Value = nVal;
                }

                // 获取当前蓝色通道值
                if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_CHNLGAIN, ref dbVal, 3))
                {
                    nVal = (int)dbVal;

                    tbvBlue.Text = string.Format("{0:F1}", (dbVal / 2.0f));
                    tbBlue.Value = nVal;
                }
                 
                labnRed.Enabled = true;
                labnGreen.Enabled = true;
                labnBlue.Enabled = true;

                tbRed.Enabled = true;
                tbGreen.Enabled = true;
                tbBlue.Enabled = true;

                tbvRed.Enabled = true;
                tbvGreen.Enabled = true;
                tbvBlue.Enabled = true;
            }
        }

        public void wb_timer(object source, System.Timers.ElapsedEventArgs e)
        {
            int nVal = 0;
            double dbVal = 0;

            if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_ATWBALANCE, ref nVal))
            {
                if (0 == nVal)
                {
                    // 获取当前红色通道值
                    if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_CHNLGAIN, ref dbVal, 1))
                    {
                        nVal = (int)dbVal;

                        tbvRed.Text = string.Format("{0:F1}", (dbVal / 2.0f));
                        tbRed.Value = nVal;
                    }

                    // 获取当前绿色通道值
                    if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_CHNLGAIN, ref dbVal, 2))
                    {
                        nVal = (int)dbVal;

                        tbvGreen.Text = string.Format("{0:F1}", (dbVal / 2.0f));
                        tbGreen.Value = nVal;
                    }

                    // 获取当前蓝色通道值
                    if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Prop_GetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDPROP.TUIDP_CHNLGAIN, ref dbVal, 3))
                    {
                        nVal = (int)dbVal;

                        tbvBlue.Text = string.Format("{0:F1}", (dbVal / 2.0f));
                        tbBlue.Value = nVal;
                    }


                    labnRed.Enabled = true;
                    labnGreen.Enabled = true;
                    labnBlue.Enabled = true;

                    tbRed.Enabled = true;
                    tbGreen.Enabled = true;
                    tbBlue.Enabled = true;

                    tbvRed.Enabled = true;
                    tbvGreen.Enabled = true;
                    tbvBlue.Enabled = true;

                    timer.Enabled = false;
                }
            }
        }

        private void btnWB_Click(object sender, EventArgs e)
        {
            if (0 != (int)m_opCam.hIdxTUCam)
            {
                TUCamera.TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, (int)TUCAM_IDCAPA.TUIDC_ATWBALANCE, 1);

                btnWB.Enabled = false;

                labnRed.Enabled = false;
                labnGreen.Enabled = false;
                labnBlue.Enabled = false;

                tbRed.Enabled = false;
                tbGreen.Enabled = false;
                tbBlue.Enabled = false;

                tbvRed.Enabled = false;
                tbvGreen.Enabled = false;
                tbvBlue.Enabled = false;

                timer.Enabled = true;
            }
        }
        #endregion

        private void groupBox13_Enter(object sender, EventArgs e)
        {

        }

        #region OutputTrigger

        private void InitOutputTrigger()
        {
            tgrOutput.nTgrOutPort = 0;
            tgrOutput.TgrPort1.nTgrOutMode = 5;
            tgrOutput.TgrPort1.nEdgeMode = 0;
            tgrOutput.TgrPort1.nDelayTm = 0;
            tgrOutput.TgrPort1.nWidth = 5000;


            tgrOutput.TgrPort2.nTgrOutMode = 4;
            tgrOutput.TgrPort2.nEdgeMode = 0;
            tgrOutput.TgrPort2.nDelayTm = 0;
            tgrOutput.TgrPort2.nWidth = 5000;

            tgrOutput.TgrPort3.nTgrOutMode = 3;
            tgrOutput.TgrPort3.nEdgeMode = 0;
            tgrOutput.TgrPort3.nDelayTm = 0;
            tgrOutput.TgrPort3.nWidth = 5000;

            EnableOutputTriggerControl(true);
            Int32 nPortCnt = 3;
            if (TUCAMRET.TUCAMRET_SUCCESS == TUCamera.TUCAM_Cap_GetTriggerOut(m_opCam.hIdxTUCam, ref tgrOutAttr))
            {

            }
            else
            {
                EnableOutputTriggerControl(false);
            }

            comboBoxPort.Items.Clear();
            for (int i = 0; i < nPortCnt; i++)
            {
                switch (i)
                {
                    case 1:
                        comboBoxPort.Items.Add("2");
                        break;
                    case 2:
                        comboBoxPort.Items.Add("3");
                        break;
                    case 0:
                    default:
                        comboBoxPort.Items.Add("1");
                        break;
                }
            }
            comboBoxPort.SelectedIndex = 0;

        }

        private void EnableOutputTriggerControl(bool enable)
        {
            comboBoxPort.Enabled = enable;
            radioButtonExpStart.Enabled = enable;
            radioButtonReadOutEnd.Enabled = enable;
            radioButtonGlbExp.Enabled = enable;
            radioButtonLow.Enabled = enable;
            radioButtonHight.Enabled = enable;
            groupBoxEdge.Enabled = enable;
            numericUpDownDelayMs.Enabled = enable;
            numericUpDownDelaySec.Enabled = enable;
            numericUpDownDelayUs.Enabled = enable;
            numericUpDownWidthMs.Enabled = enable;
            numericUpDownWidthSec.Enabled = enable;
            numericUpDownWidthUs.Enabled = enable;
        }

        private void EnableOutputTriggerControl(int nKind)
        {
            switch (nKind)
            {
                case (int)TUCAM_OUTPUTTRG_KIND.TUOPT_GND:
                case (int)TUCAM_OUTPUTTRG_KIND.TUOPT_VCC:
                    radioButtonFalling.Enabled = false;
                    radioButtonRising.Enabled = false;

                    numericUpDownDelaySec.Enabled = false;
                    numericUpDownDelayMs.Enabled = false;
                    numericUpDownDelayUs.Enabled = false;

                    numericUpDownWidthSec.Enabled = false;
                    numericUpDownWidthMs.Enabled = false;
                    numericUpDownWidthUs.Enabled = false;
                    break;
                case (int)TUCAM_OUTPUTTRG_KIND.TUOPT_EXPGLOBAL:
                    radioButtonFalling.Enabled = true;
                    radioButtonRising.Enabled = true;

                    numericUpDownDelaySec.Enabled = true;
                    numericUpDownDelayMs.Enabled = true;
                    numericUpDownDelayUs.Enabled = true;

                    numericUpDownWidthSec.Enabled = false;
                    numericUpDownWidthMs.Enabled = false;
                    numericUpDownWidthUs.Enabled = false;
                    break;
                default:
                    radioButtonFalling.Enabled = true;
                    radioButtonRising.Enabled = true;

                    numericUpDownDelaySec.Enabled = true;
                    numericUpDownDelayMs.Enabled = true;
                    numericUpDownDelayUs.Enabled = true;

                    numericUpDownWidthSec.Enabled = true;
                    numericUpDownWidthMs.Enabled = true;
                    numericUpDownWidthUs.Enabled = true;
                    break;
            }
        }


        private void comboBoxPort_SelectedIndexChanged(object sender, EventArgs e)
        {
            int selectedPort = comboBoxPort.SelectedIndex;
            m_nTgrPort = selectedPort;
            switch (selectedPort)
            {
                case 0:
                    m_nKind = tgrOutput.TgrPort1.nTgrOutMode;
                    m_nEdge = tgrOutput.TgrPort1.nEdgeMode;
                    m_nWidth = tgrOutput.TgrPort1.nWidth;
                    m_nDelay = tgrOutput.TgrPort1.nDelayTm;
                    break;
                case 1:
                    m_nKind = tgrOutput.TgrPort2.nTgrOutMode;
                    m_nEdge = tgrOutput.TgrPort2.nEdgeMode;
                    m_nWidth = tgrOutput.TgrPort2.nWidth;
                    m_nDelay = tgrOutput.TgrPort2.nDelayTm;
                    break;
                case 2:
                    m_nKind = tgrOutput.TgrPort3.nTgrOutMode;
                    m_nEdge = tgrOutput.TgrPort3.nEdgeMode;
                    m_nWidth = tgrOutput.TgrPort3.nWidth;
                    m_nDelay = tgrOutput.TgrPort3.nDelayTm;
                    break;
                default:
                    break;
            }

            updateRadio();
            updateDelayTime(m_nDelay);
            updateWidth(m_nWidth);
            updateOutPutTgr();

        }

        private void radioButtonExpStart_CheckedChanged(object sender, EventArgs e)
        {
            m_nKind = (int) TUCAM_OUTPUTTRG_KIND.TUOPT_EXPSTART;
            updateRadio();
            updateOutPutTgr();
        }

        private void radioButtonReadOutEnd_CheckedChanged(object sender, EventArgs e)
        {
            m_nKind = (int)TUCAM_OUTPUTTRG_KIND.TUOPT_READEND;
            updateRadio();
            updateOutPutTgr();
        }

        private void radioButtonGlbExp_CheckedChanged(object sender, EventArgs e)
        {
            m_nKind = (int)TUCAM_OUTPUTTRG_KIND.TUOPT_EXPGLOBAL;
            updateRadio();
            updateOutPutTgr();
        }

        private void radioButtonLow_CheckedChanged(object sender, EventArgs e)
        {
            m_nKind = (int)TUCAM_OUTPUTTRG_KIND.TUOPT_GND;
            updateRadio();
            updateOutPutTgr();
        }

        private void radioButtonHight_CheckedChanged(object sender, EventArgs e)
        {
            m_nKind = (int)TUCAM_OUTPUTTRG_KIND.TUOPT_VCC;
            updateRadio();
            updateOutPutTgr();
        }

        private void updateRadio()
        {
            radioButtonHight.CheckedChanged -= radioButtonHight_CheckedChanged;
            radioButtonLow.CheckedChanged -= radioButtonLow_CheckedChanged;
            radioButtonExpStart.CheckedChanged -= radioButtonExpStart_CheckedChanged;
            radioButtonGlbExp.CheckedChanged -= radioButtonGlbExp_CheckedChanged;
            radioButtonReadOutEnd.CheckedChanged -= radioButtonReadOutEnd_CheckedChanged;
            radioButtonRising.CheckedChanged -= radioButtonRising_CheckedChanged;
            radioButtonFalling.CheckedChanged -= radioButtonFalling_CheckedChanged;

            radioButtonRising.Checked = m_nEdge == 0 ? true : false;
            radioButtonFalling.Checked = m_nEdge == 0 ? false : true;

            switch (m_nKind)
            {
                case (int)TUCAM_OUTPUTTRG_KIND.TUOPT_VCC:
                    radioButtonHight.Checked = true;
                    radioButtonLow.Checked = false;
                    radioButtonExpStart.Checked = false;
                    radioButtonGlbExp.Checked = false;
                    radioButtonReadOutEnd.Checked = false;
                    break;
                case (int)TUCAM_OUTPUTTRG_KIND.TUOPT_GND:
                    radioButtonHight.Checked = false;
                    radioButtonLow.Checked = true;
                    radioButtonExpStart.Checked = false;
                    radioButtonGlbExp.Checked = false;
                    radioButtonReadOutEnd.Checked = false;
                    break;
                case (int)TUCAM_OUTPUTTRG_KIND.TUOPT_EXPGLOBAL:
                    radioButtonHight.Checked = false;
                    radioButtonLow.Checked = false;
                    radioButtonExpStart.Checked = false;
                    radioButtonGlbExp.Checked = true;
                    radioButtonReadOutEnd.Checked = false;
                    break;
                case (int)TUCAM_OUTPUTTRG_KIND.TUOPT_READEND:
                    radioButtonHight.Checked = false;
                    radioButtonLow.Checked = false;
                    radioButtonExpStart.Checked = false;
                    radioButtonGlbExp.Checked = false;
                    radioButtonReadOutEnd.Checked = true;
                    break;
                case (int)TUCAM_OUTPUTTRG_KIND.TUOPT_EXPSTART:
                    radioButtonHight.Checked = false;
                    radioButtonLow.Checked = false;
                    radioButtonExpStart.Checked = true;
                    radioButtonGlbExp.Checked = false;
                    radioButtonReadOutEnd.Checked = false;
                    break;
                default:
                    break;
            }
            radioButtonHight.CheckedChanged += radioButtonHight_CheckedChanged;
            radioButtonLow.CheckedChanged += radioButtonLow_CheckedChanged;
            radioButtonExpStart.CheckedChanged += radioButtonExpStart_CheckedChanged;
            radioButtonGlbExp.CheckedChanged += radioButtonGlbExp_CheckedChanged;
            radioButtonReadOutEnd.CheckedChanged += radioButtonReadOutEnd_CheckedChanged;
            radioButtonRising.CheckedChanged += radioButtonRising_CheckedChanged;
            radioButtonFalling.CheckedChanged += radioButtonFalling_CheckedChanged;
        }

        private void updateDelayTime(int delayTime)
        {
            m_nDelaySec = (delayTime / (1000 * 1000)) % 60;
            m_nDelayMs = (delayTime / 1000) % 1000;
            m_nDelayUs = (delayTime % 1000);

            numericUpDownDelaySec.Value = m_nDelaySec;
            numericUpDownDelayMs.Value = m_nDelayMs;
            numericUpDownDelayUs.Value = m_nDelayUs;

        }

        private void updateWidth(int width)
        {
            m_nWidthSec = (width / (1000 * 1000)) % 60;
            m_nWidthMs = (width / 1000) % 1000;
            m_nWidthUs = width % 1000;

            numericUpDownWidthSec.Value = m_nWidthSec;
            numericUpDownWidthMs.Value = m_nWidthMs;
            numericUpDownWidthUs.Value = m_nWidthUs;
        }

        private void updateOutPutTgr()
        {
            m_nDelay = m_nDelaySec * 1000 * 1000 + m_nDelayMs * 1000 + m_nDelayUs;
            if (m_nDelay > 10000000)
            {
                m_nDelay = 10000000;
                updateDelayTime(m_nDelay);

                m_nDelaySec = 10;
                m_nDelayMs = 0;
                m_nDelayUs = 0;
            }

            m_nWidth = m_nWidthSec * 1000 * 1000 + m_nWidthMs * 1000 + m_nDelayUs;
            if (m_nWidth > 10000000)
            {
                m_nWidth = 10000000;
                updateWidth(m_nWidth);

                m_nWidthSec = 10;
                m_nWidthMs = 0;
                m_nWidthUs = 0;
            }

            if (m_nWidth < 1)
            {
                m_nWidth = 1;
                updateWidth(m_nWidth);

                m_nWidthSec = 0;
                m_nWidthMs = 0;
                m_nWidthUs = 1;
            }

            TUCAM_TRGOUT_ATTR triggerOutAttr;
            triggerOutAttr.nTgrOutPort = m_nTgrPort;
            triggerOutAttr.nTgrOutMode = m_nKind;
            triggerOutAttr.nEdgeMode = m_nEdge;
            triggerOutAttr.nDelayTm = m_nDelay;
            triggerOutAttr.nWidth = m_nWidth;

            switch (m_nTgrPort)
            {
                case (int)TUCAM_OUTPUTTRG_PORT.TUPORT_ONE:
                        tgrOutput.nTgrOutPort = 0;
                        tgrOutput.TgrPort1.nTgrOutMode = triggerOutAttr.nTgrOutMode;
                        tgrOutput.TgrPort1.nEdgeMode = triggerOutAttr.nEdgeMode;
                        tgrOutput.TgrPort1.nDelayTm = triggerOutAttr.nDelayTm;
                        tgrOutput.TgrPort1.nWidth = triggerOutAttr.nWidth;
                        break;
                case (int)TUCAM_OUTPUTTRG_PORT.TUPORT_TWO:

                        tgrOutput.TgrPort2.nTgrOutMode = triggerOutAttr.nTgrOutMode;
                        tgrOutput.TgrPort2.nEdgeMode = triggerOutAttr.nEdgeMode;
                        tgrOutput.TgrPort2.nDelayTm = triggerOutAttr.nDelayTm;
                        tgrOutput.TgrPort2.nWidth = triggerOutAttr.nWidth;
                        break;
                case (int)TUCAM_OUTPUTTRG_PORT.TUPORT_THREE:

                        tgrOutput.TgrPort3.nTgrOutMode = triggerOutAttr.nTgrOutMode;
                        tgrOutput.TgrPort3.nEdgeMode = triggerOutAttr.nEdgeMode;
                        tgrOutput.TgrPort3.nDelayTm = triggerOutAttr.nDelayTm;
                        tgrOutput.TgrPort3.nWidth = triggerOutAttr.nWidth;
                    break;
                default:
                    break;
            }

            TUCamera.TUCAM_Cap_SetTriggerOut(m_opCam.hIdxTUCam, triggerOutAttr);
            EnableOutputTriggerControl(m_nKind);

        }


        private void radioButtonRising_CheckedChanged(object sender, EventArgs e)
        {
            m_nEdge = 0;
            updateRadio();
            updateOutPutTgr();
        }

        private void radioButtonFalling_CheckedChanged(object sender, EventArgs e)
        {
            m_nEdge = 1;
            updateRadio();
            updateOutPutTgr();
        }

        private void numericUpDownDelaySec_ValueChanged(object sender, EventArgs e)
        {
            int nSec = (int)numericUpDownDelaySec.Value;
            m_nDelaySec = nSec;
            updateOutPutTgr();
        }

        private void numericUpDownDelayMs_ValueChanged(object sender, EventArgs e)
        {
            int nMSec = (int)numericUpDownDelayMs.Value;
            m_nDelayMs = nMSec;
            updateOutPutTgr();
        }

        private void numericUpDownDelayUs_ValueChanged(object sender, EventArgs e)
        {
            int nUSec = (int)numericUpDownDelayUs.Value;
            m_nDelayUs = nUSec;
            updateOutPutTgr();
        }

        private void numericUpDownWidthSec_ValueChanged(object sender, EventArgs e)
        {
            int nSec = (int)numericUpDownWidthSec.Value;
            m_nWidthSec = nSec;

            updateOutPutTgr();
        }

        private void numericUpDownWidthMs_ValueChanged(object sender, EventArgs e)
        {
            int nMSec = (int)numericUpDownWidthMs.Value;
            m_nWidthMs = nMSec;
            updateOutPutTgr();
        }

        private void numericUpDownWidthUs_ValueChanged(object sender, EventArgs e)
        {
            int nUSec = (int)numericUpDownWidthUs.Value;
            m_nWidthUs = nUSec;
            updateOutPutTgr();
        }

        private void numericUpDownDelaySec_KeyUp(object sender, KeyEventArgs e)
        {
            int nSec = (int)numericUpDownDelaySec.Value;
            if (nSec > 10)
            {
                nSec = 10;
                delayUpdownControlEventBlock(true);
                numericUpDownWidthSec.Value = nSec;
                numericUpDownWidthMs.Value = 0;
                numericUpDownWidthUs.Value = 0;
                delayUpdownControlEventBlock(false);
            }
            m_nDelaySec = nSec;
            updateOutPutTgr();
        }

        private void numericUpDownDelayMs_KeyUp(object sender, KeyEventArgs e)
        {
            if (m_nDelaySec == 10)
                return;

            int nMSec = (int)numericUpDownDelayMs.Value;
            if (nMSec > 999)
            {
                if (m_nDelaySec == 10)
                    nMSec = 0;
                else
                    nMSec = 999; 
                delayUpdownControlEventBlock(true);
                numericUpDownWidthMs.Value = nMSec;
                delayUpdownControlEventBlock(false);
            }
            m_nDelayMs = nMSec;
            updateOutPutTgr();
        }

        private void numericUpDownDelayUs_KeyUp(object sender, KeyEventArgs e)
        {
            int nUSec = (int)numericUpDownDelayUs.Value;
            if (nUSec > 999)
            {
                if (m_nDelaySec == 10)
                    nUSec = 0;
                else
                    nUSec = 999;
                delayUpdownControlEventBlock(true);
                numericUpDownDelayUs.Value = nUSec;
                delayUpdownControlEventBlock(false);
            }
            m_nDelayUs = nUSec;
            updateOutPutTgr();
        }

        private void numericUpDownWidthSec_KeyUp(object sender, KeyEventArgs e)
        {
            int nSec = (int)numericUpDownWidthSec.Value;
            if (nSec > 10)
            {
                nSec = 10;
                widthUpdownControlEventBlock(true);
                numericUpDownWidthSec.Value = nSec;
                numericUpDownWidthMs.Value = 0;
                numericUpDownWidthUs.Value = 0;
                widthUpdownControlEventBlock(false);
            }
            m_nWidthSec = nSec;

            updateOutPutTgr();
        }

        private void numericUpDownWidthMs_KeyUp(object sender, KeyEventArgs e)
        {
            int nMSec = (int)numericUpDownWidthMs.Value;
            if (nMSec > 999)
            {
                nMSec = 999;
                widthUpdownControlEventBlock(true);
                numericUpDownWidthMs.Value = nMSec;
                widthUpdownControlEventBlock(false);
            }
            m_nWidthMs = nMSec;
            updateOutPutTgr();
        }

        private void numericUpDownWidthUs_KeyUp(object sender, KeyEventArgs e)
        {
            int nUSec = (int)numericUpDownWidthUs.Value;
            if (nUSec > 999)
            {
                nUSec = 999;
                widthUpdownControlEventBlock(true);
                numericUpDownWidthUs.Value = nUSec;
                widthUpdownControlEventBlock(false);
            }
            m_nWidthUs = nUSec;
            updateOutPutTgr();
        }

        private void delayUpdownControlEventBlock(bool block)
        {
            if (block)
            {
                numericUpDownDelaySec.ValueChanged -= numericUpDownDelaySec_ValueChanged;
                numericUpDownDelayMs.ValueChanged -= numericUpDownDelayMs_ValueChanged;
                numericUpDownDelayUs.ValueChanged -= numericUpDownDelayUs_ValueChanged;
            }
            else
            {
                numericUpDownDelaySec.ValueChanged += numericUpDownDelaySec_ValueChanged;
                numericUpDownDelayMs.ValueChanged += numericUpDownDelayMs_ValueChanged;
                numericUpDownDelayUs.ValueChanged += numericUpDownDelayUs_ValueChanged;
            }
        }
        private void widthUpdownControlEventBlock(bool block)
        {
            if (block)
            {
                numericUpDownWidthSec.ValueChanged -= numericUpDownWidthSec_ValueChanged;
                numericUpDownWidthMs.ValueChanged -= numericUpDownWidthMs_ValueChanged;
                numericUpDownWidthUs.ValueChanged -= numericUpDownWidthUs_ValueChanged;
            }
            else
            {
                numericUpDownWidthSec.ValueChanged += numericUpDownWidthSec_ValueChanged;
                numericUpDownWidthMs.ValueChanged += numericUpDownWidthMs_ValueChanged;
                numericUpDownWidthUs.ValueChanged += numericUpDownWidthUs_ValueChanged;
            }
        }
        #endregion

    }
}
