// CameraControlMode.cpp : ʵļ
//

#include "stdafx.h"
#include "SamplePro.h"
#include "SampleProDlg.h"
#include "CameraControlMode.h"
#include "RoiSet/DlgRoiSet.h"

#include "Information.h"
#include "CameraControl.h"
#include "ImageCapture.h"
#include "ColorControl.h"
#include "MoreParameters.h"
#include "ROI.h"
#include "Trigger.h"
#include "OutputTrigger.h"
#include "Others.h"
#include "MemoryManager.h"
#include "RollingScanManager.h"

#include <io.h>
#include <process.h>
#include <Shlwapi.h>
#pragma comment(lib, "shlwapi.lib")

#pragma comment(lib, "vfw32.lib")

#ifndef _WIN64
#pragma comment(lib, "../sdk/lib/x86/TUCam.lib")
#pragma comment(lib, "../sdk/lib/x86/GlobalSubject.lib")
#pragma comment(lib, "../sdk/lib/x86/MPTiff.lib")
#else
#pragma comment(lib, "../sdk/lib/x64/TUCam.lib")
#pragma comment(lib, "../sdk/lib/x64/GlobalSubject.lib")
#pragma comment(lib, "../sdk/lib/x64/MPTiff.lib")
#endif

#ifdef OPENCV_TEST_CENTER
#define TEST_CENTER
#endif

#define TUIMG_RAWHEADER 0x58 
#define TUIMG_SAVE_RAWHEADER 0x400 

// CCameraControlMode Ի
IMPLEMENT_DYNAMIC(CCameraControlMode, CDialog)

CCameraControlMode::CCameraControlMode(CWnd* pParent /*=NULL*/)
	: CDialog(CCameraControlMode::IDD, pParent)
    , m_nPicNum(0)
    , m_bUseTm(FALSE)
    , m_szPicName(_T(""))
    , m_nRecTm(5)
	, m_uiTriFrame(0)
	, m_nTriMode(0)
	, m_fFps(0.0)
    , m_nCntSave(0)
    , m_nBufferNum(16)
    , m_hToBeSavedFramesEvent(NULL)
    , m_hThdDiskLoop(NULL)
    , m_hToBeProcessedFramesEvent(NULL)
    , m_hThdAcqLoop(NULL)
    , m_acqSavedFrames(0)
{
	m_strFilePath			= _T("");
	m_nCamCtlView_Heigth	= 0;
	m_nCamCtlView_Width		= 0;
	m_nFactScreen_Width		= 0;
	m_nFactScreen_Heigth	= 0;
	m_nScrollWindow_Y		= 0;
    m_nScrollMaxHeight      = 0;

    //m_uiExpStep             = 1;
	//m_bshow                 = FALSE;
	m_vecframe.clear();
	m_vecopCam.clear();
	m_vectgrAttr.clear();

    m_bWaitting             = FALSE;
	m_bWaitting2            = FALSE;
	m_bWaitting3            = FALSE;
	m_bWaitting4            = FALSE;
	m_bShowScroll			= FALSE;
    m_bLiving               = FALSE;
    m_bSaving               = FALSE;

	m_vecSaving.clear();
	m_bvecRoiEnable.clear();

	m_bRoiEnable            = FALSE;

    m_bTgrMode              = FALSE;
    m_bTrigger              = FALSE;
	m_bChk                  = FALSE;

    m_hThdDraw              = NULL;
    m_hThdTrigger           = NULL;
	m_hThdWaitForFrame      = NULL;
	m_hThdWaitForFrame2     = NULL;
	m_hThdWaitForFrame3     = NULL;
	m_hThdWaitForFrame4     = NULL;

    m_opCam.hIdxTUCam       = NULL;
    m_opCam.uiIdxOpen       = 0;

    m_itApi.pstrConfigPath  = _T("");
    m_itApi.uiCamCount      = 0;

    m_nFmtSave              = 0;
    m_nFmtCnt               = 0;

	m_nCamIndex             = 0;
    m_nopCamCount           = 0;

    m_nCurWidth             = 0;
    m_nCurHeight            = 0;
	m_nCurChannel           = 1;
	m_nCurWidth2            = 0;
	m_nCurHeight2           = 0;
	m_nCurWidth3            = 0;
	m_nCurHeight3           = 0;
	m_nCurWidth4            = 0;
	m_nCurHeight4           = 0;
    m_nCliWidth             = 0;
    m_nCliHeight            = 0;
	m_nCliWidth1            = 0;
	m_nCliHeight1           = 0;

    m_fScale                = 1.0f;
    m_nDrawOffX             = 0;
    m_nDrawOffY             = 0;
    m_nDrawWidth            = 0;
    m_nDrawHeight           = 0;

	m_fScale2               = 1.0f;
	m_nDrawOffX2            = 0;
	m_nDrawOffY2            = 0;
	m_nDrawWidth2           = 0;
	m_nDrawHeight2          = 0;

	m_fScale3               = 1.0f;
	m_nDrawOffX3            = 0;
	m_nDrawOffY3            = 0;
	m_nDrawWidth3           = 0;
	m_nDrawHeight3          = 0;

	m_fScale4               = 1.0f;
	m_nDrawOffX4            = 0;
	m_nDrawOffY4            = 0;
	m_nDrawWidth4           = 0;
	m_nDrawHeight4          = 0;

    m_nPID                  = 0;
	m_nBCD                  = 0;

    m_uHOffset              = 0;
    m_uVOffset              = 0;
    m_uWidth                = 100;
    m_uHeight               = 100;
    m_bRecording            = FALSE;
	m_dwFccHandler          = MAKETAG('D', 'I', 'B', ' ');

	for (int i=0; i<PAGE_CNT; ++i) 
	{
		m_tabPage[i] = NULL;
	}
	m_bshow0                = TRUE;
	m_bshow1                = FALSE;
	m_bshow2                = FALSE;
	m_bshow3                = FALSE;
	m_bshow4                = FALSE;
	m_bshow5                = FALSE;
	m_bshow6                = FALSE;
	m_bshow7                = FALSE;
	m_nheight               = 220;

	m_nDepth                = 16;
	m_nDepth2               = 16;
	m_nDepth3               = 16;
	m_nDepth4               = 16;

    m_uiCapTimes            = 0;
    m_uiCapFrames           = 0;
    m_uiRecTimes            = 0;
    m_nImgMode              = 0;

    m_nTriMode = TUCCM_SEQUENCE; 
	m_nMoveX                = 0;
	m_nMoveY                = 0;

	Showlabel.nChannels     = 1;
	Showlabel.nR            = 0;
	Showlabel.nG            = 0;
	Showlabel.nB            = 0;
	Showlabel.nScale        = 0;
	Showlabel.nPosX         = 0;
	Showlabel.nPosY         = 0;
	Showlabel.nWidth        = 0;
	Showlabel.nHeight       = 0;

	m_bFit                  = TRUE;
	m_bCameralink           = FALSE;
	m_bPreview              = TRUE;
	m_nImgSize              = 0;
	m_vecBuf.clear();
	m_nRamBufCnt            = 0;
	m_bImgToRam             = FALSE;
	m_bImgToDisk            = FALSE;
	m_nStackNum             = 1;
    m_nStackNumCnt          = -1;
    m_isVertically          = FALSE;
	m_bTimeStamp            = FALSE;
	m_bFixHeader            = FALSE;
    InitializeCriticalSection(&m_csToBeSavedFrames);
    InitializeCriticalSection(&m_csToBeProcessedFrames);
}

CCameraControlMode::~CCameraControlMode()
{
	for (int i=0; i<PAGE_CNT; ++i) 
	{
		if (m_tabPage[i] != NULL) 
		{
			delete [] m_tabPage[i];
			m_tabPage[i] = NULL;
		}
	}
	DeleteObject(hBrush);

    DeleteCriticalSection(&m_csToBeSavedFrames);
    DeleteCriticalSection(&m_csToBeProcessedFrames);
}

void CCameraControlMode::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //DDX_Control(pDX, IDC_TAB, m_tab);
    DDX_Control(pDX, IDC_BTN_INFO, m_btnInfo);
    DDX_Control(pDX, IDC_BTN_ControlControl, m_btnCtrl);
    DDX_Control(pDX, IDC_BTN_ImageCapture, m_btnImgCap);
    DDX_Control(pDX, IDC_BTN_ROI, m_btnROI);
    DDX_Control(pDX, IDC_BTN_Trigger, m_btnTrigger);
    DDX_Control(pDX, IDC_BTN_MorePara, m_btnImgAdjustment);
	DDX_Control(pDX, IDC_BTN_OutPutTriger, m_btnOutputTrigger);
}


BEGIN_MESSAGE_MAP(CCameraControlMode, CDialog)
	//ON_NOTIFY(TCN_SELCHANGE, IDC_TAB, OnSelchangeTab)
	ON_WM_SIZE()
	ON_WM_VSCROLL()
	ON_WM_CREATE()
    ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_INFO, &CCameraControlMode::OnBnClickedBtnInfo)
	ON_BN_CLICKED(IDC_BTN_ControlControl, &CCameraControlMode::OnBnClickedBtnControlcontrol)
	ON_BN_CLICKED(IDC_BTN_ImageCapture, &CCameraControlMode::OnBnClickedBtnImagecapture)
	ON_BN_CLICKED(IDC_BTN_ROI, &CCameraControlMode::OnBnClickedBtnRoi)
	ON_BN_CLICKED(IDC_BTN_Trigger, &CCameraControlMode::OnBnClickedBtnTrigger)
	ON_BN_CLICKED(IDC_BTN_OutPutTriger, &CCameraControlMode::OnBnClickedBtnOutputtriger)
	ON_BN_CLICKED(IDC_BTN_MorePara, &CCameraControlMode::OnBnClickedBtnMorepara)	
    ON_WM_CTLCOLOR()
    ON_WM_SETFOCUS()
	ON_MESSAGE(WM_DEVICECHANGE, OnDeviceChange)
END_MESSAGE_MAP()

// صȴ
int cnt = 0;
void CCameraControlMode::OnCallbackBuffer(void *pClient)
{
	CCameraControlMode *pIn = (CCameraControlMode *)pClient;
	PUCHAR pBuffer = NULL;
	INT nVal = 0;
	TUCAM_RAWIMG_HEADER Frame;
	if (NULL != pIn->m_opCam.hIdxTUCam)
	{
		if (TUCAMRET_SUCCESS == TUCAM_Buf_GetData(pIn->m_opCam.hIdxTUCam, &Frame))
		{
			// ֡
			pIn->m_dwFrmCnt++;                              // ֡1
			pIn->m_dwITm = GetTickCount() - pIn->m_dwSTm;   // ʱ ms
			if (pIn->m_dwITm > 1000)
			{
				pIn->m_fFps = pIn->m_dwFrmCnt * 1000000.0f / pIn->m_dwITm;

				if (NULL != pIn->m_tabPage[1])
					pIn->m_tabPage[1]->PostMessage(TUMSG_FPS, NULL, (LPARAM)pIn->m_fFps);

				pIn->m_dwSTm = GetTickCount();
				pIn->m_dwFrmCnt = 0;
			}
            
            pIn->AcqProcessedImg(&Frame);

			if (TUCAMRET_SUCCESS == TUCAM_Capa_GetValue(pIn->m_opCam.hIdxTUCam, TUIDC_TIMESTAMPENBALE, &nVal))
			{
				if (0x01 == nVal)
				{
					TUDBG_PRINTF("[OnCallbackBuffer]:Count:%ld, Time_start:%.3fms, Time_last:%.3fms\n", Frame.uiIndex, Frame.dblTimeStamp, Frame.dblTimeLast);
				}
			}
		}
	}
}

void __cdecl CCameraControlMode::DiskThreadLoop(LPVOID lParam)
{
    OutputDebugString(_T("Enter disk thread loop!\n"));

    CCameraControlMode *pIn = (CCameraControlMode *)lParam;

    INT  i = pIn->m_nCamIndex;

    while (pIn->m_vecSaving[i])
    {
        pIn->SaveImgToDisk();
    }

    SetEvent(pIn->m_hThdDiskLoop);
    OutputDebugString(_T("Leave disk thread loop!\n"));
    _endthread();
}

void __cdecl CCameraControlMode::AcqThreadLoop(LPVOID lParam)
{
    OutputDebugString(_T("Enter acq thread loop!\n"));

    CCameraControlMode *pIn = (CCameraControlMode *)lParam;

    INT  i = pIn->m_nCamIndex;

    while (pIn->m_vecSaving[i])
    {
        pIn->AcqSavedImg();
    }

    SetEvent(pIn->m_hThdAcqLoop);
    OutputDebugString(_T("Leave acq thread loop!\n"));
    _endthread();
}

// ȴ߳ʵ
void __cdecl CCameraControlMode::WaitForFrameThread(LPVOID lParam)
{
    OutputDebugString(_T("Enter wait for frame thread!\n"));

    CCameraControlMode *pIn = (CCameraControlMode *)lParam;

	int nTimeStamp = 0;
    int nCliWidth  = 0;
    int nCliHeight = 0;
    int i = 0;
    int nRet = 0;

    pIn->m_nDrawOffX  = 0;
    pIn->m_nDrawOffY  = 0;
    pIn->m_nDrawWidth = 0;
    pIn->m_nDrawHeight= 0;
    pIn->m_nCurWidth  = 0;
    pIn->m_nCurHeight = 0;
	
    while (pIn->m_bWaitting)
    {
		/*if (pIn->m_nCamIndex == i)
		{
			// ֡
			pIn->m_dwFrmCnt++;                              // ֡1
			pIn->m_dwITm = GetTickCount() - pIn->m_dwSTm;   // ʱ ms
			if (pIn->m_dwITm > 1000)
			{
				pIn->m_fFps = pIn->m_dwFrmCnt * 1000000.0f / pIn->m_dwITm;

				if(NULL != pIn->m_tabPage[1])
					pIn->m_tabPage[1]->PostMessage(TUMSG_FPS, NULL, (LPARAM)pIn->m_fFps);

				pIn->m_dwSTm    = GetTickCount();
				pIn->m_dwFrmCnt = 0;
			}
		}*/

		pIn->m_vecframe[i].ucFormatGet = TUFRM_FMT_USUAl;

		nRet = TUCAM_Buf_WaitForFrame(pIn->m_vecopCam[i].hIdxTUCam, &pIn->m_vecframe[i]);

        if (TUCAMRET_SUCCESS == nRet)
        {
			/*int nVal = 0;
			if (TUCAMRET_SUCCESS == TUCAM_Capa_GetValue(pIn->m_opCam.hIdxTUCam, TUIDC_TIMESTAMPENBALE, &nVal))
			{
				TUCAM_IMG_HEADER imgHeader;
				memcpy(&imgHeader, pIn->m_vecframe[i].pBuffer, sizeof(TUCAM_IMG_HEADER));
			    if (0x01 == nVal)
				{
					TUDBG_PRINTF("[TUCAM_Buf_WaitForFrame]:dblConversionFactor:%f\n", imgHeader.dblConversionFactor);
				}
			}*/

            // ıʾ
			if ((pIn->m_nCurWidth != pIn->m_vecframe[i].usWidth || pIn->m_nCurHeight != pIn->m_vecframe[i].usHeight || pIn->m_nCliWidth1 != nCliWidth || pIn->m_nCliHeight1 != nCliHeight ) && pIn->m_bFit)
			{
				if (1 == pIn->m_nopCamCount)
				{
					pIn->m_bFit = FALSE;
				}

				pIn->m_nCurWidth  = pIn->m_vecframe[i].usWidth;
				pIn->m_nCurHeight = pIn->m_vecframe[i].usHeight;
                pIn->m_nCurChannel = pIn->m_vecframe[i].ucChannels;

				nCliWidth = pIn->m_nCliWidth1;
				nCliHeight= pIn->m_nCliHeight1;

				float fScaleX = pIn->m_nCliWidth1 * 1.0f / pIn->m_nCurWidth;
				float fScaleY = pIn->m_nCliHeight1 * 1.0f / pIn->m_nCurHeight;

				pIn->m_fScale = fScaleX > fScaleY ? fScaleY : fScaleX;
				pIn->m_fScale = (float)((int)(pIn->m_fScale * 100) / 100.0f);

				if (pIn->m_fScale < 1)
				{
					pIn->m_nDrawWidth = (int)(pIn->m_fScale * pIn->m_nCurWidth);
					pIn->m_nDrawHeight= (int)(pIn->m_fScale * pIn->m_nCurHeight);
				}
				else
				{
					pIn->m_nDrawWidth = pIn->m_nCurWidth;
					pIn->m_nDrawHeight= pIn->m_nCurHeight;
					pIn->m_fScale = 1.0f;
				}

				pIn->m_nDrawWidth = max(4, (pIn->m_nDrawWidth >> 2) << 2);
				pIn->m_nDrawHeight= max(4, (pIn->m_nDrawHeight >> 2) << 2);   

				pIn->m_nDrawOffX = (pIn->m_nCliWidth1 - pIn->m_nDrawWidth) / 2 ;
				pIn->m_nDrawOffY = (pIn->m_nCliHeight1 - pIn->m_nDrawHeight) / 2;
               
			}

            if (NULL != pIn->m_vecframe[i].pBuffer)
            {
                //PUCHAR pBuf = pIn->m_frame.pBuffer + pIn->m_frame.usHeader;

                pIn->m_drawing.pFrame     = &pIn->m_vecframe[i];
 
                pIn->m_drawing.nDstX      = pIn->m_nDrawOffX;
                pIn->m_drawing.nDstY      = pIn->m_nDrawOffY;
                pIn->m_drawing.nDstWidth  = pIn->m_nDrawWidth;
                pIn->m_drawing.nDstHeight = pIn->m_nDrawHeight;

                pIn->m_drawing.nSrcX      = 0;
                pIn->m_drawing.nSrcY      = 0;
                pIn->m_drawing.nSrcWidth  = pIn->m_nCurWidth;
                pIn->m_drawing.nSrcHeight = pIn->m_nCurHeight;

				if (pIn->m_bPreview)
				{
					// ͼ
					TUCAM_Draw_Frame(pIn->m_vecopCam[i].hIdxTUCam, &pIn->m_drawing);
 				}
             
#ifdef TEST_CENTER	
				pIn->DrawCenter(pIn->m_vecframe[i]);
#endif
				// ʾͼϢ
				pIn->ShowImageInfo(pIn->m_vecframe[i]);

                // ¼
				if (pIn->m_bRecording && pIn->m_nCamIndex == i)
				{
					TUCAM_Rec_AppendFrame(pIn->m_vecopCam[i].hIdxTUCam, &pIn->m_vecframe[i]);
				}

                // ͼƬ
				pIn->SaveImgToDisk(pIn->m_vecframe[i]);
            }
        }
    }

    SetEvent(pIn->m_hThdWaitForFrame);
    OutputDebugString(_T("Leave wait for frame thread!\n"));
    _endthread();
}

// ȴ߳ʵ
void __cdecl CCameraControlMode::WaitForFrame2Thread(LPVOID lParam)
{
	OutputDebugString(_T("Enter wait for frame2 thread!\n"));

	CCameraControlMode *pIn = (CCameraControlMode *)lParam;

	int nCliWidth  = 0;
	int nCliHeight = 0;

	int i = 1;

	pIn->m_nDrawOffX2  = 0;
	pIn->m_nDrawOffY2  = 0;
	pIn->m_nDrawWidth2 = 0;
	pIn->m_nDrawHeight2= 0;
	pIn->m_nCurWidth2  = 0;
	pIn->m_nCurHeight2 = 0;

	while (pIn->m_bWaitting2)
	{

		pIn->m_vecframe[i].ucFormatGet = TUFRM_FMT_USUAl;

		int nRet = 0;
		nRet = TUCAM_Buf_WaitForFrame(pIn->m_vecopCam[i].hIdxTUCam, &pIn->m_vecframe[i]);

		if (TUCAMRET_SUCCESS == nRet) 
		{

			// ıʾ
			if (pIn->m_nCurWidth2 != pIn->m_vecframe[i].usWidth || pIn->m_nCurHeight2 != pIn->m_vecframe[i].usHeight || pIn->m_nCliWidth1 != nCliWidth || pIn->m_nCliHeight1 != nCliHeight )
			{

				pIn->m_nCurWidth2  = pIn->m_vecframe[i].usWidth;
				pIn->m_nCurHeight2 = pIn->m_vecframe[i].usHeight;

				nCliWidth = pIn->m_nCliWidth1;
				nCliHeight= pIn->m_nCliHeight1;

				float fScaleX = pIn->m_nCliWidth1 * 1.0f / pIn-> m_nCurWidth2;
				float fScaleY = pIn->m_nCliHeight1 * 1.0f / pIn->m_nCurHeight2;

				pIn->m_fScale2 = fScaleX > fScaleY ? fScaleY : fScaleX;
				pIn->m_fScale2 = (float)((int)(pIn->m_fScale2 * 100) / 100.0f);

				if (pIn->m_fScale2 < 1)
				{
					pIn->m_nDrawWidth2 = (int)(pIn->m_fScale2 * pIn->m_nCurWidth2);
					pIn->m_nDrawHeight2= (int)(pIn->m_fScale2 * pIn->m_nCurHeight2);
				}
				else
				{
					pIn->m_nDrawWidth2 = pIn->m_nCurWidth2;
					pIn->m_nDrawHeight2= pIn->m_nCurHeight2;
					pIn->m_fScale2 = 1.0f;
				}

				pIn->m_nDrawWidth2 = max(4, (pIn->m_nDrawWidth2 >> 2) << 2);
				pIn->m_nDrawHeight2= max(4, (pIn->m_nDrawHeight2 >> 2) << 2);   

				pIn->m_nDrawOffX2 = (pIn->m_nCliWidth1 - pIn->m_nDrawWidth2) / 2  + pIn->m_nCliWidth1;
				pIn->m_nDrawOffY2 = (pIn->m_nCliHeight1 - pIn->m_nDrawHeight2) / 2;

			}

			if (NULL != pIn->m_vecframe[i].pBuffer)
			{
				pIn->m_drawing2.pFrame     = &pIn->m_vecframe[i];

				pIn->m_drawing2.nDstX      = pIn->m_nDrawOffX2;
				pIn->m_drawing2.nDstY      = pIn->m_nDrawOffY2;
				pIn->m_drawing2.nDstWidth  = pIn->m_nDrawWidth2;
				pIn->m_drawing2.nDstHeight = pIn->m_nDrawHeight2;

				pIn->m_drawing2.nSrcX      = 0;
				pIn->m_drawing2.nSrcY      = 0;
				pIn->m_drawing2.nSrcWidth  = pIn->m_nCurWidth2;
				pIn->m_drawing2.nSrcHeight = pIn->m_nCurHeight2;

				// ͼ
				TUCAM_Draw_Frame(pIn->m_vecopCam[i].hIdxTUCam, &pIn->m_drawing2);

				// ¼
				if (pIn->m_bRecording && pIn->m_nCamIndex == i)
				{
					TUCAM_Rec_AppendFrame(pIn->m_vecopCam[i].hIdxTUCam, &pIn->m_vecframe[i]);
				}

				// ͼƬ
				pIn->SaveImgToDisk(pIn->m_vecframe[i]);
			}

		}

	}

	SetEvent(pIn->m_hThdWaitForFrame2);

	OutputDebugString(_T("Leave wait for frame2 thread!\n"));

	_endthread();
}


// ȴ߳ʵ
void __cdecl CCameraControlMode::WaitForFrame3Thread(LPVOID lParam)
{
	OutputDebugString(_T("Enter wait for frame3 thread!\n"));

	CCameraControlMode *pIn = (CCameraControlMode *)lParam;

	int nCliWidth  = 0;
	int nCliHeight = 0;

	int i = 2;

	pIn->m_nDrawOffX3  = 0;
	pIn->m_nDrawOffY3  = 0;
	pIn->m_nDrawWidth3 = 0;
	pIn->m_nDrawHeight3= 0;
	pIn->m_nCurWidth3  = 0;
	pIn->m_nCurHeight3 = 0;

	while (pIn->m_bWaitting3)
	{
		pIn->m_vecframe[i].ucFormatGet = TUFRM_FMT_USUAl;

		int nRet = 0;
		nRet = TUCAM_Buf_WaitForFrame(pIn->m_vecopCam[i].hIdxTUCam, &pIn->m_vecframe[i]);

		if (TUCAMRET_SUCCESS == nRet) 
		{

			// ıʾ
			if (pIn->m_nCurWidth3 != pIn->m_vecframe[i].usWidth || pIn->m_nCurHeight3 != pIn->m_vecframe[i].usHeight || pIn->m_nCliWidth1 != nCliWidth || pIn->m_nCliHeight1 != nCliHeight )
			{
				pIn->m_nCurWidth3  = pIn->m_vecframe[i].usWidth;
				pIn->m_nCurHeight3 = pIn->m_vecframe[i].usHeight;

				nCliWidth = pIn->m_nCliWidth1;
				nCliHeight= pIn->m_nCliHeight1;

				float fScaleX = pIn->m_nCliWidth1 * 1.0f / pIn-> m_nCurWidth3;
				float fScaleY = pIn->m_nCliHeight1 * 1.0f / pIn->m_nCurHeight3;

				pIn->m_fScale3 = fScaleX > fScaleY ? fScaleY : fScaleX;
				pIn->m_fScale3 = (float)((int)(pIn->m_fScale3 * 100) / 100.0f);

				if (pIn->m_fScale3 < 1)
				{
					pIn->m_nDrawWidth3 = (int)(pIn->m_fScale3 * pIn->m_nCurWidth3);
					pIn->m_nDrawHeight3= (int)(pIn->m_fScale3 * pIn->m_nCurHeight3);
				}
				else
				{
					pIn->m_nDrawWidth3 = pIn->m_nCurWidth3;
					pIn->m_nDrawHeight3= pIn->m_nCurHeight3;
					pIn->m_fScale3 = 1.0f;
				}

				pIn->m_nDrawWidth3 = max(4, (pIn->m_nDrawWidth3 >> 2) << 2);
				pIn->m_nDrawHeight3= max(4, (pIn->m_nDrawHeight3 >> 2) << 2);   

				pIn->m_nDrawOffX3 = (pIn->m_nCliWidth1 - pIn->m_nDrawWidth3) / 2 ;
				pIn->m_nDrawOffY3 = (pIn->m_nCliHeight1 - pIn->m_nDrawHeight3) / 2 + pIn->m_nCliHeight1;

			}

			if (NULL != pIn->m_vecframe[i].pBuffer)
			{
				pIn->m_drawing3.pFrame     = &pIn->m_vecframe[i];

				pIn->m_drawing3.nDstX      = pIn->m_nDrawOffX3;
				pIn->m_drawing3.nDstY      = pIn->m_nDrawOffY3;
				pIn->m_drawing3.nDstWidth  = pIn->m_nDrawWidth3;
				pIn->m_drawing3.nDstHeight = pIn->m_nDrawHeight3;

				pIn->m_drawing3.nSrcX      = 0;
				pIn->m_drawing3.nSrcY      = 0;
				pIn->m_drawing3.nSrcWidth  = pIn->m_nCurWidth3;
				pIn->m_drawing3.nSrcHeight = pIn->m_nCurHeight3;

				// ͼ
				TUCAM_Draw_Frame(pIn->m_vecopCam[i].hIdxTUCam, &pIn->m_drawing3);

				// ¼
				if (pIn->m_bRecording && pIn->m_nCamIndex == i)
				{
					TUCAM_Rec_AppendFrame(pIn->m_vecopCam[i].hIdxTUCam, &pIn->m_vecframe[i]);
				}

				// ͼƬ
				pIn->SaveImgToDisk(pIn->m_vecframe[i]);
			}
		}

	}

	SetEvent(pIn->m_hThdWaitForFrame3);

	OutputDebugString(_T("Leave wait for frame3 thread!\n"));

	_endthread();
}

// ȴ߳ʵ
void __cdecl CCameraControlMode::WaitForFrame4Thread(LPVOID lParam)
{
	OutputDebugString(_T("Enter wait for frame4 thread!\n"));

	CCameraControlMode *pIn = (CCameraControlMode *)lParam;

	int nCliWidth  = 0;
	int nCliHeight = 0;

	int i = 3;

	pIn->m_nDrawOffX4  = 0;
	pIn->m_nDrawOffY4  = 0;
	pIn->m_nDrawWidth4 = 0;
	pIn->m_nDrawHeight4= 0;
	pIn->m_nCurWidth4  = 0;
	pIn->m_nCurHeight4 = 0;

	while (pIn->m_bWaitting4)
	{
		pIn->m_vecframe[i].ucFormatGet = TUFRM_FMT_USUAl;

		int nRet = 0;
		nRet = TUCAM_Buf_WaitForFrame(pIn->m_vecopCam[i].hIdxTUCam, &pIn->m_vecframe[i]);

		if (TUCAMRET_SUCCESS == nRet) 
		{

			// ıʾ
			if (pIn->m_nCurWidth4 != pIn->m_vecframe[i].usWidth || pIn->m_nCurHeight4 != pIn->m_vecframe[i].usHeight || pIn->m_nCliWidth1 != nCliWidth || pIn->m_nCliHeight1 != nCliHeight )
			{
				pIn->m_nCurWidth4  = pIn->m_vecframe[i].usWidth;
				pIn->m_nCurHeight4 = pIn->m_vecframe[i].usHeight;

				nCliWidth = pIn->m_nCliWidth1;
				nCliHeight= pIn->m_nCliHeight1;

				float fScaleX = pIn->m_nCliWidth1 * 1.0f / pIn-> m_nCurWidth4;
				float fScaleY = pIn->m_nCliHeight1 * 1.0f / pIn->m_nCurHeight4;

				pIn->m_fScale4 = fScaleX > fScaleY ? fScaleY : fScaleX;
				pIn->m_fScale4 = (float)((int)(pIn->m_fScale4 * 100) / 100.0f);

				if (pIn->m_fScale4 < 1)
				{
					pIn->m_nDrawWidth4 = (int)(pIn->m_fScale4 * pIn->m_nCurWidth4);
					pIn->m_nDrawHeight4= (int)(pIn->m_fScale4 * pIn->m_nCurHeight4);
				}
				else
				{
					pIn->m_nDrawWidth4 = pIn->m_nCurWidth4;
					pIn->m_nDrawHeight4= pIn->m_nCurHeight4;
					pIn->m_fScale4 = 1.0f;
				}

				pIn->m_nDrawWidth4 = max(4, (pIn->m_nDrawWidth4 >> 2) << 2);
				pIn->m_nDrawHeight4= max(4, (pIn->m_nDrawHeight4 >> 2) << 2);   

				pIn->m_nDrawOffX4 = (pIn->m_nCliWidth1 - pIn->m_nDrawWidth4) / 2  + pIn->m_nCliWidth1;;
				pIn->m_nDrawOffY4 = (pIn->m_nCliHeight1 - pIn->m_nDrawHeight4) / 2 + pIn->m_nCliHeight1;

			}

			if (NULL != pIn->m_vecframe[i].pBuffer)
			{

				//PUCHAR pBuf = pIn->m_vecframe[i].pBuffer + pIn->m_vecframe[i].usHeader;

				pIn->m_drawing4.pFrame     = &pIn->m_vecframe[i];

				pIn->m_drawing4.nDstX      = pIn->m_nDrawOffX4;
				pIn->m_drawing4.nDstY      = pIn->m_nDrawOffY4;
				pIn->m_drawing4.nDstWidth  = pIn->m_nDrawWidth4;
				pIn->m_drawing4.nDstHeight = pIn->m_nDrawHeight4;

				pIn->m_drawing4.nSrcX      = 0;
				pIn->m_drawing4.nSrcY      = 0;
				pIn->m_drawing4.nSrcWidth  = pIn->m_nCurWidth4;
				pIn->m_drawing4.nSrcHeight = pIn->m_nCurHeight4;

				// ͼ
				TUCAM_Draw_Frame(pIn->m_vecopCam[i].hIdxTUCam, &pIn->m_drawing4);

				// ¼
				if (pIn->m_bRecording && pIn->m_nCamIndex == i)
				{
					TUCAM_Rec_AppendFrame(pIn->m_vecopCam[i].hIdxTUCam, &pIn->m_vecframe[i]);
				}

				// ͼƬ
				pIn->SaveImgToDisk(pIn->m_vecframe[i]);
			}
		}
	}

	SetEvent(pIn->m_hThdWaitForFrame4);

	OutputDebugString(_T("Leave wait for frame4 thread!\n"));

	_endthread();
}


// ʾͼϢ
BOOL CCameraControlMode::ShowImageInfo(TUCAM_FRAME &frame)            
{
	if (frame.pBuffer == NULL || m_nopCamCount != 1)
	{
		return FALSE;
	}

	USHORT nGrayValue = 0;
	int nWidth = frame.usWidth;
	int nHeight= frame.usHeight;
	int nXPos  = max(m_nMoveX-m_nDrawOffX,0),nYPos = max(m_nMoveY-m_nDrawOffY,0);
	int nImgWidth = (int)(nXPos/m_fScale);
	int nImgHeight= (int)(nYPos/m_fScale);
    int nScale =(int) (m_fScale*100);
	int nLength= 0;
	CString sz;
    nImgWidth  = min(nImgWidth,(nWidth-1));
    nImgHeight = min(nImgHeight,(nHeight-1));

	if ((Showlabel.nPosX == nImgWidth && Showlabel.nPosY == nImgHeight) || (m_nMoveX < m_nDrawOffX || m_nMoveX >(m_nDrawWidth + m_nDrawOffX)|| m_nMoveY < m_nDrawOffY || m_nMoveY>(m_nDrawHeight+m_nDrawOffY)))
	{
		nImgWidth = Showlabel.nPosX;
		nImgHeight= Showlabel.nPosY;
	}
	else
	{
		if(frame.ucChannels == 1)
		{
			int nFlipHeight = min(max(nHeight-nImgHeight-1,0),(nHeight-1));
			TUCAM_Get_GrayValue(m_opCam.hIdxTUCam, nImgWidth, nFlipHeight, &nGrayValue);
			Showlabel.nR            = nGrayValue;
			Showlabel.nG            = nGrayValue;
			Showlabel.nB            = nGrayValue;
		}
		else
		{
			int nElem = frame.ucElemBytes;
			int nLength = nImgWidth*nImgHeight*nElem*frame.ucChannels;

			if (nElem == 1)
			{
				UCHAR *pSrc = frame.pBuffer+frame.usHeader+nLength;
				Showlabel.nR  = *(pSrc+2);
				Showlabel.nG  = *(pSrc+1);
				Showlabel.nB  = *(pSrc);
			}
			else
			{
				USHORT *pSrc = (USHORT *)(frame.pBuffer+frame.usHeader+nLength);
				Showlabel.nR  = *(pSrc+2);
				Showlabel.nG  = *(pSrc+1);
				Showlabel.nB  = *(pSrc);
			}
		}
	}

	if(frame.ucChannels == 1)
	{
		if (frame.ucElemBytes == 2)
		{
			sz.Format(_T("Gray Value:%05d"),Showlabel.nG);
		}
		else
		{
			sz.Format(_T("Gray Value:%03d"),Showlabel.nG);
		}
	}
	else
	{
		if (frame.ucElemBytes == 2)
		{
			sz.Format(_T("R:%05d,G:%05d,B:%05d"),Showlabel.nR, Showlabel.nG, Showlabel.nB);
		}
		else
		{
			sz.Format(_T("R:%03d,G:%03d,B:%03d"),Showlabel.nR, Showlabel.nG, Showlabel.nB);
		}
	}

	Showlabel.nChannels     = frame.ucChannels;
	Showlabel.nScale        = nScale;
	Showlabel.nPosX         = nImgWidth;
	Showlabel.nPosY         = nImgHeight;
	Showlabel.nWidth        = nWidth;
	Showlabel.nHeight       = nHeight;
	

	HPEN hpM = CreatePen(PS_SOLID, 1, RGB(160, 160, 160));

	SetBkColor(m_hDC,RGB(160, 160, 160));
	//SetBkMode(m_hDC, TRANSPARENT);

	SelectObject(m_hDC, hpM);
	SetTextColor(m_hDC,RGB(255, 255, 255));

	TextOut(m_hDC,10,m_nCliHeight1-70,sz.GetBuffer(),sz.GetLength());
	sz.Format(_T("%d%%,X:%04d,Y:%04d"), Showlabel.nScale, Showlabel.nPosX, Showlabel.nPosY);
	TextOut(m_hDC,10,m_nCliHeight1-54,sz.GetBuffer(),sz.GetLength());
	sz.Format(_T("Size:%dx%d"),Showlabel.nWidth, Showlabel.nHeight);
	TextOut(m_hDC,10,m_nCliHeight1-38,sz.GetBuffer(),sz.GetLength());
	DeleteObject(hpM);

	//HGDIOBJ hbr = GetStockObject(NULL_BRUSH);
	//SelectObject(m_hDC, hbr);
	//DeleteObject(hbr);

	return TRUE;
}

BOOL CCameraControlMode::DrawCenter(TUCAM_FRAME &frame)
{
	if (frame.pBuffer == NULL || frame.ucChannels != 1)
	{
		return FALSE;
	}

	int i = 0, j = 0;
	///UINT nLeftTop = 0, nRightTop = 0, nLeftBottom = 0, nRightBottom = 0;
	int nOrgSize = 50; //20 40
	int nSize = (int)(nOrgSize * m_fScale);
	int nWidth = frame.usWidth;
	int nHeight = frame.usHeight;
	int nElem = frame.ucElemBytes;
	int nLCenter = (m_nDrawWidth) / 2;
	int nTCenter = (m_nDrawHeight) / 2;

	HPEN hpM = CreatePen(PS_SOLID, 1, RGB(0, 255, 0));	// Green PS_DOT
	SelectObject(m_hDC, hpM);

	MoveToEx(m_hDC, m_nDrawOffX + nLCenter, m_nDrawOffY + nTCenter - nSize * 2, NULL);
	LineTo(m_hDC, m_nDrawOffX + nLCenter, m_nDrawOffY + nTCenter + nSize * 2);

	MoveToEx(m_hDC, m_nDrawOffX + nLCenter - nSize * 2, m_nDrawOffY + nTCenter, NULL);
	LineTo(m_hDC, m_nDrawOffX + nLCenter + nSize * 2, m_nDrawOffY + nTCenter);
	Ellipse(m_hDC, m_nDrawOffX + nLCenter - nSize, m_nDrawOffY + nTCenter - nSize, m_nDrawOffX + nLCenter + nSize, m_nDrawOffY + nTCenter + nSize);

	HPEN hpH = CreatePen(PS_SOLID, 1, RGB(255, 255, 0));	// Green PS_DOT
	SelectObject(m_hDC, hpH);
	Ellipse(m_hDC, m_nDrawOffX + nLCenter - nSize * 2, m_nDrawOffY + nTCenter - nSize * 2, m_nDrawOffX + nLCenter + nSize * 2, m_nDrawOffY + nTCenter + nSize * 2);

	SetBkMode(m_hDC, TRANSPARENT);
	HGDIOBJ hbr = GetStockObject(NULL_BRUSH);
	SelectObject(m_hDC, hbr);
	DeleteObject(hpM);
	DeleteObject(hpH);
	DeleteObject(hbr);

	return TRUE;
}

void CCameraControlMode::InitDrawingResource()
{
    int nSize = sizeof(BITMAPINFOHEADER);

    memset(&m_bmpInfo, 0, nSize);
    m_bmpInfo.biSize	    = nSize;
    m_bmpInfo.biPlanes	    = 1;
    m_bmpInfo.biBitCount    = 24;
    m_bmpInfo.biCompression = BI_RGB;

    HWND hDraw = ((CSampleProDlg *)(this->GetParent()))->m_PicViewMode.GetDlgItem(IDC_STA_PIC)->GetSafeHwnd();

    m_hDC = ::GetDC(hDraw);
    m_hDib= ::DrawDibOpen();
}

void CCameraControlMode::UnInitDrawingResource()
{
    if (NULL != m_hDib)
    {
        ::DrawDibClose(m_hDib);
        m_hDib = NULL;
    }

    if (NULL != m_hDC)
    {
        HWND hDraw = ((CSampleProDlg *)(this->GetParent()))->m_PicViewMode.GetDlgItem(IDC_STA_PIC)->GetSafeHwnd();
        ::ReleaseDC(hDraw, m_hDC);
        m_hDC = NULL;
    }
}


void CCameraControlMode::InitInformation()
{
	if (m_tabPage[0] != NULL) ((Information*)m_tabPage[0])->InitInformation();
}

void CCameraControlMode::InitInformationNone()
{
	if (m_tabPage[0] != NULL) ((Information*)m_tabPage[0])->InitInformationNone();
}

void CCameraControlMode::InitControlRange()
{
	if (m_tabPage[0] != NULL) ((Information*)m_tabPage[0])->InitControlRange();
	if (m_tabPage[1] != NULL) ((CameraControl*)m_tabPage[1])->InitControlRange();
	if (m_tabPage[2] != NULL) ((ImageCapture*)m_tabPage[2])->InitControlRange();
	if (m_tabPage[3] != NULL) ((ROI*)m_tabPage[3])->InitControlRange();
	if (m_tabPage[4] != NULL) ((Trigger*)m_tabPage[4])->InitControlRange();
	if (m_tabPage[5] != NULL) ((OutputTrigger*)m_tabPage[5])->InitControlRange();
	if (m_tabPage[6] != NULL) ((MoreParameters*)m_tabPage[6])->InitControlRange();
}

void CCameraControlMode::RefreshValue()
{
	if (m_tabPage[0] != NULL) ((Information*)m_tabPage[0])->RefreshValue();
	if (m_tabPage[1] != NULL) ((CameraControl*)m_tabPage[1])->RefreshValue();
	if (m_tabPage[2] != NULL) ((ImageCapture*)m_tabPage[2])->RefreshValue();
	if (m_tabPage[3] != NULL) ((ROI*)m_tabPage[3])->RefreshValue();
	if (m_tabPage[4] != NULL) ((Trigger*)m_tabPage[4])->RefreshValue();
	if (m_tabPage[5] != NULL) ((OutputTrigger*)m_tabPage[5])->RefreshValue();
	if (m_tabPage[6] != NULL) ((MoreParameters*)m_tabPage[6])->RefreshValue();
}

void CCameraControlMode::UpdateExposureTime(DWORD dwExp)
{
	if (m_tabPage[1] != NULL) ((CameraControl*)m_tabPage[1])->UpdateExposureTime(dwExp);
}

void CCameraControlMode::EnableControl(BOOL bLiving /*= FALSE*/)
{
   
}

void CCameraControlMode::UpdataInvalidate()
{
	((CSampleProDlg *)this->GetParent())->m_PicViewMode.GetDlgItem(IDC_STA_PIC)->Invalidate();
}

void CCameraControlMode::UpdataPic()
{
	//((CSampleProDlg *)this->GetParent())->m_PicViewMode.GetDlgItem(IDC_STA_PIC)->Invalidate();
	((CSampleProDlg *)this->GetParent())->m_PicViewMode.RefreshPic(FALSE);
}

void CCameraControlMode::ProgressStatus(int nCur,int nMin, int nMax, BOOL bShow)
{
	if (bShow)
	{
		((CSampleProDlg *)(this->GetParent()))->m_Progrss.ShowWindow(SW_SHOW);
		((CSampleProDlg *)(this->GetParent()))->m_Progrss.m_Progress.SetRange(0,nMax);
		((CSampleProDlg *)(this->GetParent()))->m_Progrss.m_Progress.SetPos(nCur);
		CString sz;
		sz.Format(_T("%d/%d"), nCur, nMax);
		((CSampleProDlg *)(this->GetParent()))->m_Progrss.GetDlgItem(IDC_STA_STATUS)->SetWindowText(sz);   
		((CSampleProDlg *)(this->GetParent()))->m_Progrss.Invalidate();
		((CSampleProDlg *)(this->GetParent()))->m_Progrss.UpdateWindow();
	}
	else
	{
		((CSampleProDlg *)(this->GetParent()))->m_Progrss.ShowWindow(SW_HIDE);
	}
	
}

void CCameraControlMode::StartWaitForFrame()
{
    if (m_bWaitting)
    {
        return;
    }

	m_bWaitting  = TRUE;
	m_bWaitting2 = TRUE;
	m_bWaitting3 = TRUE;
	m_bWaitting4 = TRUE;

	Showlabel.nR = 0;
	Showlabel.nG = 0;
	Showlabel.nB = 0;

    if (NULL == m_hThdWaitForFrame && NULL == m_hThdWaitForFrame2 && NULL == m_hThdWaitForFrame3 && NULL == m_hThdWaitForFrame4) 
    {
        m_frame.pBuffer     = NULL;
		if( m_nTriMode == TUCCM_SEQUENCE  || m_nPID == DHYANA_400DC_PID)
			m_frame.ucFormatGet = TUFRM_FMT_USUAl;
		else
			m_frame.ucFormatGet = TUFRM_FMT_RAW;

        m_frame.uiRsdSize   = 1;                            // how many frames do you want

		m_dwFrmCnt = 0;                                     // reset frame count
		m_dwSTm    = GetTickCount();                        // reset start tick count

		UINT32 nSize = m_vecframe.size();
		for (UINT32 i=0; i<nSize; i++)
		{
			m_vecframe[i].pBuffer = NULL;
		}
		m_vecframe.clear();

		m_bFit = TRUE;

		if (m_nopCamCount != m_vecframe.size())
		{
			for(UINT32 i =0; i< m_nopCamCount; i++)
			{
				TUCAM_Buf_Alloc(m_vecopCam[i].hIdxTUCam, &m_frame);       // Alloc buffer after set resolution or set ROI attribute
				TUCAM_Cap_Start(m_vecopCam[i].hIdxTUCam, m_nTriMode);     // Start capture
				m_vecframe.push_back(m_frame);
			}
		}

		if (m_nopCamCount > 0)
		{
			m_hThdWaitForFrame  = CreateEvent(NULL, TRUE, FALSE, NULL);
			_beginthread(WaitForFrameThread, 0, this);          // Start capturing thread
		}

		if (m_nopCamCount > 1)
		{
			m_hThdWaitForFrame2 = CreateEvent(NULL, TRUE, FALSE, NULL);
			_beginthread(WaitForFrame2Thread, 0, this);       // Start capturing thread
		}

		if (m_nopCamCount > 2)
		{
			m_hThdWaitForFrame3 = CreateEvent(NULL, TRUE, FALSE, NULL);
			_beginthread(WaitForFrame3Thread, 0, this);       // Start capturing thread
		}

		if (m_nopCamCount > 3)
		{
			m_hThdWaitForFrame4 = CreateEvent(NULL, TRUE, FALSE, NULL);
			_beginthread(WaitForFrame4Thread, 0, this);       // Start capturing thread
		}

		m_nImgSize = m_frame.usWidth * m_frame.usHeight * m_frame.ucElemBytes * m_frame.ucChannels;

        if (TUCCM_SEQUENCE != m_nTriMode)
        {
            if(m_tabPage[1] !=NULL)
            {
                ///((CameraControl*)m_tabPage[1])->RefreshBtn(FALSE);
                ((CameraControl*)m_tabPage[1])->BtnShow(TRUE);
                ((CameraControl*)m_tabPage[1])->GetDlgItem(IDC_BTN_ONCEAE)->EnableWindow(FALSE);
            }

			if (NULL != m_tabPage[2])
			{
				///((ImageCapture*)m_tabPage[2])->GetDlgItem(IDC_STA_TOTAL)->EnableWindow(FALSE);
				///((ImageCapture*)m_tabPage[2])->GetDlgItem(IDC_EDT_PICNUM)->EnableWindow(FALSE);
				///((ImageCapture*)m_tabPage[2])->GetDlgItem(IDC_SPN_PICNUM)->EnableWindow(FALSE);
				((ImageCapture*)m_tabPage[2])->RefreshBtn(TRUE);
			}

            if(m_tabPage[3] !=NULL)
                ((ROI*)m_tabPage[3])->GetDlgItem(IDC_CHK_ROI)->EnableWindow(FALSE);

        }
        else
        {
            if(NULL != m_tabPage[1])
            {
                ((CameraControl*)m_tabPage[1])->BtnShow(m_bWaitting);
            }

			if (NULL != m_tabPage[1] && m_bTimeStamp)
			{
				((CameraControl*)m_tabPage[1])->GetDlgItem(IDC_BTN_ONCEAE)->EnableWindow(TRUE);
			}

            if (NULL != m_tabPage[2])    
            {
                ((ImageCapture*)m_tabPage[2])->RefreshBtn(TRUE);
                ((ImageCapture*)m_tabPage[2])->GetDlgItem(IDC_STA_TOTAL)->EnableWindow(TRUE);
                ((ImageCapture*)m_tabPage[2])->GetDlgItem(IDC_EDT_PICNUM)->EnableWindow(TRUE);
                ((ImageCapture*)m_tabPage[2])->GetDlgItem(IDC_SPN_PICNUM)->EnableWindow(TRUE);
            }

            if(m_tabPage[3] !=NULL)
                ((ROI*)m_tabPage[3])->GetDlgItem(IDC_CHK_ROI)->EnableWindow(TRUE);

            /*if(NULL != m_tabPage[4])
                ((Trigger*)m_tabPage[4])->EnableTriggerControl(FALSE);*/
        }
    }
}

void CCameraControlMode::StopWaitForFrame()
{
    if (!m_bWaitting)
    {
        return;
    }

	m_bWaitting = FALSE;

	if (NULL != m_hThdWaitForFrame || NULL != m_hThdWaitForFrame2  || NULL != m_hThdWaitForFrame3  || NULL != m_hThdWaitForFrame4)
	{      
		for(UINT32 i =0; i< m_nopCamCount; i++)
		{
			m_vecSaving[i] = FALSE;

			if (i == 0)
			{
				m_bWaitting  = FALSE;
			}

			if (i == 1)
			{
				m_bWaitting2 = FALSE;
			}

			if (i == 2)
			{
				m_bWaitting3 = FALSE;
			}

			if (i == 3)
			{
				m_bWaitting4 = FALSE;
			}

			TUCAM_Buf_AbortWait(m_vecopCam[i].hIdxTUCam);             // If you called TUCAM_Buf_WaitForFrames()

			if (NULL != m_hThdWaitForFrame  && i== 0)
			{
				WaitForSingleObject(m_hThdWaitForFrame, INFINITE);
				CloseHandle(m_hThdWaitForFrame);	
				m_hThdWaitForFrame = NULL;
			}

			if ((NULL != m_hThdWaitForFrame2) && i== 1)
			{
				WaitForSingleObject(m_hThdWaitForFrame2, INFINITE);
				CloseHandle(m_hThdWaitForFrame2);	
				m_hThdWaitForFrame2 = NULL;
			}

			if ((NULL != m_hThdWaitForFrame3) && i== 2)
			{
				WaitForSingleObject(m_hThdWaitForFrame3, INFINITE);
				CloseHandle(m_hThdWaitForFrame3);	
				m_hThdWaitForFrame3 = NULL;
			}

			if ((NULL != m_hThdWaitForFrame4) && i== 3)
			{
				WaitForSingleObject(m_hThdWaitForFrame4, INFINITE);
				CloseHandle(m_hThdWaitForFrame4);	
				m_hThdWaitForFrame4 = NULL;
			}

			TUCAM_Cap_Stop(m_vecopCam[i].hIdxTUCam);                  // Stop capture   
			TUCAM_Buf_Release(m_vecopCam[i].hIdxTUCam);               // Release alloc buffer after stop capture and quit drawing thread
		}

        if (TUCCM_SEQUENCE != m_nTriMode)
        {
            if(NULL != m_tabPage[1])
            {
                ///((CameraControl*)m_tabPage[1])->RefreshBtn(FALSE);
                ((CameraControl*)m_tabPage[1])->BtnShow(FALSE);
            }
        }
        else
        {
            if(NULL != m_tabPage[1])
            {
                ///((CameraControl*)m_tabPage[1])->RefreshBtn(TRUE);
                ((CameraControl*)m_tabPage[1])->BtnShow(m_bWaitting);
            }
        }

		/*if (NULL != m_tabPage[4])
		{
			((Trigger*)m_tabPage[4])->EnableTriggerControl(TRUE);
			((Trigger*)m_tabPage[4])->RefreshGlobalreset();
		}*/

        if (NULL != m_tabPage[2])
        {
            Sleep(100);
            ((ImageCapture*)m_tabPage[2])->RefreshBtn(FALSE);
			((ImageCapture*)m_tabPage[2])->RefreshCapture();

			if ((MoreParameters*)m_tabPage[6] != NULL)
			{
				(MoreParameters*)m_tabPage[6]->GetDlgItem(IDC_BTN_DEFAULT)->EnableWindow(TRUE);
			}
        }
    }
}

void CCameraControlMode::StartSaveFrames()
{ 
    m_nStackNumCnt = -1;
    m_acqSavedFrames = 0;
    m_nodesCount = CreateProcessedNodes(m_nBufferNum);

    TUDBG_PRINTF("StartSaveFrames:Create %d nodes.\n", m_nodesCount);

    std::queue<PTUCAM_RAWIMG_HEADER>  toBeSavedFrames;
    swap(toBeSavedFrames, m_toBeSavedFrames);

    m_hToBeSavedFramesEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

    m_hThdDiskLoop = CreateEvent(NULL, TRUE, FALSE, NULL);
    _beginthread(DiskThreadLoop, 0, this);


    std::queue<PTUCAM_RAWIMG_HEADER>  toBeProcessedFrames;
    swap(toBeProcessedFrames, m_toBeProcessedFrames);

    m_hToBeProcessedFramesEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

    m_hThdAcqLoop = CreateEvent(NULL, TRUE, FALSE, NULL);
    _beginthread(AcqThreadLoop, 0, this);
}

void CCameraControlMode::StopSaveFrames()
{
    if (NULL != m_hToBeSavedFramesEvent)
    {
        SetEvent(m_hToBeSavedFramesEvent);
    }

    if (NULL != m_hThdDiskLoop)
    {
        WaitForSingleObject(m_hThdDiskLoop, INFINITE);
        CloseHandle(m_hThdDiskLoop);
        m_hThdDiskLoop = NULL;
    }

    CloseHandle(m_hToBeSavedFramesEvent);
    m_hToBeSavedFramesEvent = NULL;


    if (NULL != m_hToBeProcessedFramesEvent)
    {
        SetEvent(m_hToBeProcessedFramesEvent);
    }

    if (NULL != m_hThdAcqLoop)
    {
        WaitForSingleObject(m_hThdAcqLoop, INFINITE);
        CloseHandle(m_hThdAcqLoop);
        m_hThdAcqLoop = NULL;
    }

    CloseHandle(m_hToBeProcessedFramesEvent);
    m_hToBeProcessedFramesEvent = NULL;

    DestroyProcessedNodes();

    if ((MoreParameters*)m_tabPage[6] != NULL)
    {
        (MoreParameters*)m_tabPage[6]->GetDlgItem(IDC_BTN_DEFAULT)->EnableWindow(TRUE);
    }
}

LRESULT CCameraControlMode::OnDeviceChange(WPARAM wParam, LPARAM lParam)
{
	//if (m_nopCamCount > 1)
	{
		return FALSE;	
	}

	PDEV_BROADCAST_HDR pHdr = (PDEV_BROADCAST_HDR)lParam;    		
	if (DBT_DEVTYP_DEVICEINTERFACE == pHdr->dbch_devicetype) 
	{   
		PDEV_BROADCAST_DEVICEINTERFACE pDevInf = (PDEV_BROADCAST_DEVICEINTERFACE)pHdr;			 
		CString str, msg;					
		if (DBT_DEVICEREMOVECOMPLETE == wParam) 
		{
			if (m_bWaitting)
			{
				StopWaitForFrame();
			}

			TUCAM_Dev_Close(m_opCam.hIdxTUCam);     // ر
			TUCAM_Draw_Uninit(m_opCam.hIdxTUCam);   // ͷŻͼԴ
			TUCAM_Api_Uninit();                     // ͷSDK Դ
		
			InitInformationNone();
		} 
		else if (DBT_DEVICEARRIVAL == wParam) 
		{
			// ʼSDK API
			TUCAM_Api_Init(&m_itApi, 10000/*60000*/);

			if (0 == m_itApi.uiCamCount)
			{
				AfxMessageBox(_T("Please confirm if the camera is connected or in a ready state!"));
				return TRUE;   
			}

			m_opCam.uiIdxOpen = 0;
			TUCAM_Dev_Open(&m_opCam);

			if (NULL == m_opCam.hIdxTUCam)
			{   
				AfxMessageBox(_T("Open camera failed!"));
				return TRUE;  
			}

			// ȡͨ
			TUCAM_VALUE_INFO valInfo;
			valInfo.nValue = 1;
			valInfo.nID = TUIDI_CAMERA_CHANNELS;
			TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo);

			m_itDraw.hWnd       = ((CSampleProDlg *)(this->GetParent()))->m_PicViewMode.GetDlgItem(IDC_STA_PIC)->GetSafeHwnd();
			m_itDraw.ucChannels = valInfo.nValue;
			m_itDraw.nWidth     = 2048;
			m_itDraw.nHeight    = 2048;
			TUCAM_Draw_Init(m_opCam.hIdxTUCam, m_itDraw);

			TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, TUIDC_VERCORRECTION, 1);

			InitInformation();
			InitControlRange();
			RefreshValue();

			if (m_bWaitting)
			{
				StartWaitForFrame();
			}
		} 						
	}

	return FALSE;	
}

GUID EZDEV_H = {0x00873fdf, 0x61a8, 0x11d1, {0xaa, 0x5e, 0x00, 0xc0, 0x4f, 0xb1, 0x72, 0x8b}};	// h version
GUID EZDEV_L = {0xA5DCBF10, 0x6530, 0x11D2, {0x90, 0x1F, 0x00, 0xC0, 0x4F, 0xB9, 0x51, 0xED}};	// libusb version
GUID EZDEV_U = {0x65E8773D, 0x8F56, 0x11D0, {0xA3, 0xB9, 0x00, 0xA0, 0xC9, 0x22, 0x31, 0x96}};	// uvc version

bool CCameraControlMode::FlipVertically(TUCAM_FRAME &frame)
{
	if (NULL == frame.pBuffer)
	{
		return FALSE;
	}

	int i = 0;

	USHORT usHeight = frame.usHeight;
	USHORT usHalfHei = usHeight / 2;
	UINT32 uiWidthStep = frame.uiWidthStep;

	PUCHAR pSwap = new UCHAR[uiWidthStep];
	PUCHAR pHead = NULL;
	PUCHAR pTail = NULL;

	pHead = frame.pBuffer + frame.usHeader;
	pTail = frame.pBuffer + frame.usHeader + (usHeight - 1) * uiWidthStep;

	if (NULL == pSwap)
	{
		return FALSE;
	}

	for (i = 0; i<usHalfHei; ++i)
	{
		memcpy(pSwap, pTail, uiWidthStep);
		memcpy(pTail, pHead, uiWidthStep);
		memcpy(pHead, pSwap, uiWidthStep);

		pHead += uiWidthStep;
		pTail -= uiWidthStep;
	}

	TUCAM_DELBUF(pSwap);

	return TRUE;
}

// ͼдӲ
bool CCameraControlMode::SaveImgToDisk(TUCAM_FRAME &frame)
{
	return false;

	if (m_bImgToRam)
	{
		return false;
	}

	///if (m_bSaving || m_bTrigger)
	INT  i  = m_nCamIndex;

	if (m_vecSaving[i])
	{
		// ļǷڣ򴴽
		if (!PathIsDirectory(m_strFilePath))
		{
			CreateDirectory(m_strFilePath, NULL);
		}

		CString szFName;
		szFName.Format(_T("%s\\%s_%d_%d"), m_strFilePath, m_szPicName, m_uiCapTimes, m_uiCapFrames);

		bool bRet = true;

		do
		{
			int nFmt = m_nFmtSave;
			TUCAM_FRAME tuframe;
			TUCAM_FILE_SAVE fileSave;

			fileSave.nSaveFmt = nFmt;
			memcpy(&tuframe, &frame, sizeof(TUCAM_FRAME));
			fileSave.pFrame = &tuframe;
			fileSave.pstrSavePath = (PCHAR)szFName.GetBuffer(0);  // path

			if (!IsDhyana400DC())
			{
				// Get RAW data
				frame.ucFormatGet = TUFRM_FMT_RAW;
				if (TUCAMRET_SUCCESS != TUCAM_Buf_CopyFrame(m_vecopCam[i].hIdxTUCam, &frame))
				{
					bRet = false;
					break;
				}
			}

			// Format RAW
			if (nFmt & TUFMT_RAW)
			{
				nFmt &= ~TUFMT_RAW;
			}

			if (0 != nFmt)
			{
				fileSave.nSaveFmt = nFmt;

				// Save other format data(TIFF/BMP/PNG/JPEG)
				if (TUCAMRET_SUCCESS != TUCAM_File_SaveImage(m_vecopCam[i].hIdxTUCam, fileSave))
				{
					bRet = false;
					break;
				}
			}

			if (m_nFmtSave & TUFMT_RAW)
			{
				fileSave.nSaveFmt = TUFMT_RAW;

				CString szFRawName;
				szFRawName.Format(_T("%s\\%s_%d_%d-offset_%d-w_%d-h_%d-Mono%d"), m_strFilePath, m_szPicName, m_uiCapTimes, m_uiCapFrames, frame.usHeader, frame.usWidth, frame.usHeight, (2 == frame.ucElemBytes ? 16 : 8));

				fileSave.pstrSavePath = (PCHAR)szFRawName.GetBuffer(0);  // path
				// Save RAW data
				if (TUCAMRET_SUCCESS != TUCAM_File_SaveImage(m_vecopCam[i].hIdxTUCam, fileSave))
				{
					bRet = false;
					break;
				}
			}

		} while (0);

		if (bRet)
		{
			m_uiCapFrames++;
			m_nCntSave++;

			// ս
			if (m_nCntSave >= m_nPicNum)
			{
				m_vecSaving[i] = FALSE;

				m_tabPage[2]->PostMessage(TUMSG_CAP, NULL, (LPARAM)m_nCntSave);
			}
		}
		return bRet;
	}

	return false;
}

//  Get the system memory size
bool CCameraControlMode::GetSystemMemorySize(UINT64 &uiMemTotal, UINT64 &uiMemFree)
{
    MEMORYSTATUSEX memsStat;
    memsStat.dwLength = sizeof(memsStat);

    if (!GlobalMemoryStatusEx(&memsStat))
    {
        uiMemTotal = 0;
        uiMemFree = 0;
        return false;
    }

    uiMemFree = memsStat.ullAvailPhys;
    uiMemTotal = memsStat.ullTotalPhys;

#ifndef _WIN64
    uiMemFree = (UINT64)(memsStat.ullAvailVirtual * 0.7f);
    uiMemFree = min(uiMemFree, 1073741824);                                                       // 1GB

    //  UINT64 uiTotal = TUMIN(uiMemTotal, 3221225472);                                                 // 3GB-3.75GB
    //  uiMemFree = TUMIN(memsStat.ullAvailVirtual, TUMAX(0, (uiTotal - (uiMemTotal - uiMemFree))));    // 4GB
#endif

    return true;
}

int CCameraControlMode::CreateProcessedNodes(int count)
{
    for (int i = m_processedNodes.size(); i < count; ++i)
    {
        PBUFFER_NODE pBufNode = new BUFFER_NODE();

        if (NULL != pBufNode)
        {
            pBufNode->nID = i;
            pBufNode->nBufSize = m_nImgSize + sizeof(TUCAM_RAWIMG_HEADER) + 1024;
            pBufNode->pBuf = new(std::nothrow) unsigned char[pBufNode->nBufSize];

            if (NULL == pBufNode->pBuf)
            {
                break;
            }

            memset(pBufNode->pBuf, 0, pBufNode->nBufSize);
            m_processedNodes.push_back(pBufNode);
        }
    }

    int nNodes = (int)m_processedNodes.size() - 1;

    for (int i = 0; i < nNodes; ++i)
    {
        m_processedNodes.at(i)->pBufNodeNext = m_processedNodes.at(i + 1);                      // next nodes pointer
        m_processedNodes.at(nNodes - 1)->pBufNodePrev = m_processedNodes.at(nNodes - i - 1);    // prev nodes pointer
    }

    m_processedNodes.at(nNodes)->pBufNodeNext = m_processedNodes.at(0);                         
    m_processedNodes.at(0)->pBufNodePrev = m_processedNodes.at(nNodes);                         

    m_currentNodes = m_processedNodes.at(0);    

    return (int)m_processedNodes.size();
}

void CCameraControlMode::DestroyProcessedNodes()
{
    int nSize = m_processedNodes.size();

    for (int i = 0; i<nSize; ++i)
    {
        m_processedNodes.at(i)->pBufNodeNext = NULL;
        m_processedNodes.at(i)->pBufNodePrev = NULL;
        TUCAM_DELBUF(m_processedNodes.at(i)->pBuf);

        PBUFFER_NODE pNode = m_processedNodes.at(i);
        TUCAM_DELOBJ(pNode);
    }
    
    m_processedNodes.clear();
}

void CCameraControlMode::ProcesseFrame(PTUCAM_RAWIMG_HEADER dst, PTUCAM_RAWIMG_HEADER src)
{
    memcpy(dst, src, sizeof(TUCAM_RAWIMG_HEADER));
//  dst->pImgData = m_currentNodes->pBuf + sizeof(TUCAM_RAWIMG_HEADER);
    dst->pImgData = m_currentNodes->pBuf;

    UINT32 widthStep = src->usWidth * src->ucElemBytes * src->ucChannels;

    int fixSrcPos = (widthStep << 1) + TUIMG_SAVE_RAWHEADER;
    int fixDstPos = TUIMG_SAVE_RAWHEADER;

    // Flip and Copy
    if (!m_isVertically)
    {
        fixSrcPos = (src->usHeight - 3) * widthStep + TUIMG_SAVE_RAWHEADER;
        fixDstPos = fixSrcPos + (widthStep << 1);
        FlipVertically(dst, src, widthStep, TUIMG_SAVE_RAWHEADER);
    }
    else
    {
        memcpy(m_currentNodes->pBuf + TUIMG_SAVE_RAWHEADER/*sizeof(TUCAM_RAWIMG_HEADER)*/, src->pImgData, src->uiImgSize);
    }

    // fix header
	if (widthStep > TUIMG_RAWHEADER && m_bFixHeader)
    {
        memcpy(dst->pImgData + fixDstPos, dst->pImgData + fixSrcPos, TUIMG_RAWHEADER);
    }
}

bool CCameraControlMode::FlipVertically(PTUCAM_RAWIMG_HEADER dst, PTUCAM_RAWIMG_HEADER src, const UINT32 &widthStep, int header /*= 1024*/)
{
    if (NULL == dst || NULL == dst->pImgData || NULL == src || NULL == src->pImgData)
    {
        return false;
    }

    int i = 0;

    USHORT height = src->usHeight;

    PUCHAR pHead = NULL;
    PUCHAR pTail = NULL;

    pHead = dst->pImgData + header;
    pTail = src->pImgData + (height - 1) * widthStep;

    for (i = 0; i < height; ++i)
    {
        memcpy(pHead, pTail, widthStep);

        pHead += widthStep;
        pTail -= widthStep;
    }

    return true;
}

void CCameraControlMode::AcqSavedImg()
{
    if (NULL == m_hToBeSavedFramesEvent)
        return;

    if (m_acqSavedFrames >= m_nPicNum)
        return;

    int size = 0;
    PTUCAM_RAWIMG_HEADER frame = NULL;

    EnterCriticalSection(&m_csToBeProcessedFrames);
    size = m_toBeProcessedFrames.size();
    LeaveCriticalSection(&m_csToBeProcessedFrames);

    if (size >= m_nodesCount - 1)
    {
        char sz[64] = { 0 };
        sprintf(sz, _T("AcqSavedImg:To be process has %d frames, it's full.\n"), size);
        OutputDebugString(sz);
    }

    INT  i = m_nCamIndex;

    while (0 == size && m_vecSaving[i])
    {
        WaitForSingleObject(m_hToBeProcessedFramesEvent, 1);

        EnterCriticalSection(&m_csToBeProcessedFrames);
        size = m_toBeProcessedFrames.size();
        LeaveCriticalSection(&m_csToBeProcessedFrames);
    }

    if (size > 0)
    {
        int savedCnt = 0;
        EnterCriticalSection(&m_csToBeSavedFrames);
        savedCnt = m_toBeSavedFrames.size();
        LeaveCriticalSection(&m_csToBeSavedFrames);

        if (savedCnt < m_nodesCount)
        {
            EnterCriticalSection(&m_csToBeProcessedFrames);
            frame = m_toBeProcessedFrames.front();
            m_toBeProcessedFrames.pop();
            LeaveCriticalSection(&m_csToBeProcessedFrames);

            PTUCAM_RAWIMG_HEADER rawHeader = (PTUCAM_RAWIMG_HEADER)(m_currentNodes->pBuf);
            ProcesseFrame(rawHeader, frame);

            m_currentNodes = m_currentNodes->pBufNodeNext;
            ++m_acqSavedFrames;

            EnterCriticalSection(&m_csToBeSavedFrames);
            m_toBeSavedFrames.push(rawHeader);
            LeaveCriticalSection(&m_csToBeSavedFrames);

            SetEvent(m_hToBeSavedFramesEvent);
        }
    }
}

void CCameraControlMode::AcqProcessedImg(PTUCAM_RAWIMG_HEADER frame)
{
    if (NULL == m_hToBeProcessedFramesEvent)
        return;

    int size = 0;

    EnterCriticalSection(&m_csToBeProcessedFrames);
    size = m_toBeProcessedFrames.size();
    LeaveCriticalSection(&m_csToBeProcessedFrames);

    if (size < /*m_nBufferNum*/m_nodesCount)
    {
        EnterCriticalSection(&m_csToBeProcessedFrames);
        m_toBeProcessedFrames.push(frame);
        LeaveCriticalSection(&m_csToBeProcessedFrames);

        SetEvent(m_hToBeProcessedFramesEvent);
    }
}

void CCameraControlMode::SaveImgToDisk()
{
    int size = 0;
    PTUCAM_RAWIMG_HEADER frame = NULL;

    EnterCriticalSection(&m_csToBeSavedFrames);
    size = m_toBeSavedFrames.size();
    LeaveCriticalSection(&m_csToBeSavedFrames);

    if (size >= m_nodesCount - 1)
    {
        char sz[64] = { 0 };
        sprintf(sz, _T("SaveImgToDisk:To be saved buffer has %d frames.\n"), size);
        OutputDebugString(sz);
    }

    INT  i = m_nCamIndex;

    while (0 == size && m_vecSaving[i])
    {
        WaitForSingleObject(m_hToBeSavedFramesEvent, 1);

        EnterCriticalSection(&m_csToBeSavedFrames);
        size = m_toBeSavedFrames.size();
        LeaveCriticalSection(&m_csToBeSavedFrames);
    }

    if (size > 0)
    {
        EnterCriticalSection(&m_csToBeSavedFrames);
        frame = m_toBeSavedFrames.front();
        m_toBeSavedFrames.pop();
        LeaveCriticalSection(&m_csToBeSavedFrames);

        SaveImgToDisk(frame, TUIMG_SAVE_RAWHEADER);
    }
}

bool CCameraControlMode::SaveImgToDisk(TUCAM_RAWIMG_HEADER Frame)
{
	INT  i = m_nCamIndex;

	if (m_vecSaving[i])
	{
		// ļǷڣ򴴽
		if (!PathIsDirectory(m_strFilePath))
		{
			CreateDirectory(m_strFilePath, NULL);
		}

		bool bRet = true;

		bRet = CombMPFile(Frame.pImgData, Frame.usWidth, Frame.usHeight, Frame.ucChannels, 2 == Frame.ucElemBytes ? 16 : 8);

		if (bRet)
		{
			m_uiCapFrames++;
			m_nCntSave++;

			// ս
			if (m_nCntSave >= m_nPicNum)
			{
				m_vecSaving[i] = FALSE;
	
				CloseMPFile();

				m_tabPage[2]->PostMessage(TUMSG_CAP, NULL, (LPARAM)m_nCntSave);
			}
			else
			{
				if (0 == m_nCntSave % m_nStackNum)
				{
					CloseMPFile();
					CreateMultiFile(&Frame);
				}
			}
		}
		return bRet;
	}

	return false;
}

bool CCameraControlMode::SaveImgToDisk(PTUCAM_RAWIMG_HEADER frame, int header /*= 1024*/)
{
    if (NULL == frame)
        return false;

    INT  i = m_nCamIndex;

    if (!m_vecSaving[i])
    {
        CloseMultiFile(frame);
        return false;
    }        

    if (-1 == m_nStackNumCnt)
    {
        CreateMultiFile(frame);
        ++m_nStackNumCnt;
    }

    bool bRet = true;
    
    if ((0 == m_nStackNumCnt) && (m_nFmtSave & TUFMT_RAW))
    {
        CombMPFile(frame->pImgData, frame->usWidth, frame->usHeight, frame->ucChannels, 2 == frame->ucElemBytes ? 16 : 8, TUIMG_SAVE_RAWHEADER);
    }
    else
    {
        CombMPFile(frame->pImgData + TUIMG_SAVE_RAWHEADER, frame->usWidth, frame->usHeight, frame->ucChannels, 2 == frame->ucElemBytes ? 16 : 8);
    }

    if (!bRet)
        return false;

    ++m_uiCapFrames;
    ++m_nCntSave;
    ++m_nStackNumCnt;

    // capture finished
    if (m_nCntSave >= m_nPicNum)
    {
        m_vecSaving[i] = FALSE;

        CloseMultiFile();

        m_tabPage[2]->PostMessage(TUMSG_CAP, NULL, (LPARAM)m_nCntSave);
    }
    else
    {
        if (m_nStackNumCnt == m_nStackNum)
        {
            CloseMultiFile();
        }
    }

    return bRet;
}

bool CCameraControlMode::CreateMultiFile(PTUCAM_RAWIMG_HEADER frame)
{
    CString szFName;

    if (m_nFmtSave & TUFMT_TIF)
    {
        szFName.Format(_T("%s\\%s_%d_%d.tif"), m_strFilePath, m_szPicName, m_uiCapTimes, m_uiCapFrames);
    }
    else if ((m_nFmtSave & TUFMT_RAW) && (m_nStackNum > 1))
    {
        szFName.Format(_T("%s\\%s_%d_%d-offset_%d-stack_%d-w_%d-h_%d-Mono%d.raw"), m_strFilePath, m_szPicName, m_uiCapTimes, m_uiCapFrames, TUIMG_SAVE_RAWHEADER/*sizeof(TUCAM_RAWIMG_HEADER)*/, m_nStackNum, frame->usWidth, frame->usHeight, (2 == frame->ucElemBytes ? 16 : 8));
    }
    else
    {
        szFName.Format(_T("%s\\%s_%d_%d-offset_%d-w_%d-h_%d-Mono%d.raw"), m_strFilePath, m_szPicName, m_uiCapTimes, m_uiCapFrames, TUIMG_SAVE_RAWHEADER/*sizeof(TUCAM_RAWIMG_HEADER)*/, frame->usWidth, frame->usHeight, (2 == frame->ucElemBytes ? 16 : 8));
    }

    CreatMPFile(szFName.GetBuffer());

    return true;
}

void CCameraControlMode::CloseMultiFile(PTUCAM_RAWIMG_HEADER frame)
{
    if (m_nStackNumCnt >= 0)
    {
        CloseMPFile();
    
        if (NULL != frame && (m_nFmtSave & TUFMT_RAW) && m_nStackNumCnt > 1 && (m_nStackNumCnt != m_nStackNum))
        {
            CString oldName;
            oldName.Format(_T("%s\\%s_%d_%d-offset_%d-stack_%d-w_%d-h_%d-Mono%d.raw"), m_strFilePath, m_szPicName, m_uiCapTimes, 1, TUIMG_SAVE_RAWHEADER, m_nStackNum, frame->usWidth, frame->usHeight, (2 == frame->ucElemBytes ? 16 : 8));

            CString newName;
            newName.Format(_T("%s\\%s_%d_%d-offset_%d-stack_%d-w_%d-h_%d-Mono%d.raw"), m_strFilePath, m_szPicName, m_uiCapTimes, 1, TUIMG_SAVE_RAWHEADER, m_nStackNumCnt, frame->usWidth, frame->usHeight, (2 == frame->ucElemBytes ? 16 : 8));

            CFile::Rename(oldName, newName);
        }
    }
    
    m_nStackNumCnt = -1;
}


#include <vector>
BOOL CCameraControlMode::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Create a resize gripper
	CRect initRect;						

	GetClientRect(initRect);
	initRect.left = initRect.right - GetSystemMetrics(SM_CXHSCROLL);
	initRect.top  = initRect.bottom - GetSystemMetrics(SM_CYVSCROLL);

	DWORD dwStyle = WS_CHILD | 
		SBS_SIZEBOX | 
		SBS_SIZEBOXBOTTOMRIGHTALIGN | 
		SBS_SIZEGRIP | 
		WS_VISIBLE;

	hBrush = CreateSolidBrush(RGB(178, 178, 178));

	DEV_BROADCAST_DEVICEINTERFACE NotificationFilter;
	ZeroMemory(&NotificationFilter, sizeof(NotificationFilter));
	NotificationFilter.dbcc_size	   = sizeof(NotificationFilter); 
	NotificationFilter.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE;
//	NotificationFilter.dbcc_classguid  = *(LPGUID)EMCore->DeviceGUID();	
	NotificationFilter.dbcc_classguid  = EZDEV_H;
	m_hHDevNotify = RegisterDeviceNotification(m_hWnd, &NotificationFilter, DEVICE_NOTIFY_WINDOW_HANDLE);

	NotificationFilter.dbcc_classguid  = EZDEV_L;
	m_hLDevNotify = RegisterDeviceNotification(m_hWnd, &NotificationFilter, DEVICE_NOTIFY_WINDOW_HANDLE);

	NotificationFilter.dbcc_classguid  = EZDEV_U;
	m_hUDevNotify = RegisterDeviceNotification(m_hWnd, &NotificationFilter, DEVICE_NOTIFY_WINDOW_HANDLE);


	// ʼ
	//m_fntEdit.CreatePointFont(130, _T("Arial"));
	
    

    // ʼԴ
    InitDrawingResource();

	if(m_vecopCam.size() != 0)
		m_vecopCam.clear();
	if(0 != m_vecframe.size())
		m_vecframe.clear();
	if (m_vecSaving.size() != 0)
		m_vecSaving.clear();
	if (m_bvecRoiEnable.size() != 0)
		m_bvecRoiEnable.clear();
    // ȡǰַ
	CString strPath;
	GetCurrentDirectory(MAX_PATH, strPath.GetBuffer(MAX_PATH));

    m_itApi.pstrConfigPath = (LPSTR)(LPCTSTR)strPath;
    m_itApi.uiCamCount = 0;

    // ʼSDK API
    TUCAM_Api_Init(&m_itApi, 10000/*60000*/);

    if (0 == m_itApi.uiCamCount)
    {
        AfxMessageBox(_T("Please confirm if the camera is connected or in a ready state!"));
        return TRUE;   
    }

    m_nopCamCount   = min(m_itApi.uiCamCount, 4);

	m_opCam.uiIdxOpen = 0;
    TUCAM_Dev_Open(&m_opCam);

    if (NULL == m_opCam.hIdxTUCam)
    {   
        AfxMessageBox(_T("Open camera failed!"));
        return TRUE;  
    }

	// עص
	TUCAM_Buf_DataCallBack(m_opCam.hIdxTUCam, OnCallbackBuffer, this);

    // ȡͨ
	for (UINT32 i = 0; i < m_itApi.uiCamCount; i++)
	{
		// Ŀǰֻ֧4̨
		if (i > 3)
		{
			break;
		}

		m_opCam.uiIdxOpen = i;
		TUCAM_Dev_Open(&m_opCam);
		m_vecopCam.push_back(m_opCam);
		m_vecSaving.push_back(m_bSaving);
		m_bvecRoiEnable.push_back(m_bRoiEnable);
		// ȡPIDֵ
		TUCAM_VALUE_INFO valInfo;
		valInfo.nID = TUIDI_PRODUCT;
		TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo);
		m_nPID = valInfo.nValue;

		valInfo.nID = TUIDI_BCDDEVICE;
		TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo);
		m_nBCD = valInfo.nValue;

		// ȡͨ
		valInfo.nValue = 1;
		valInfo.nID = TUIDI_CAMERA_CHANNELS;
		TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo);

        TUCAM_VALUE_INFO valWidth;
        TUCAM_VALUE_INFO valHeight;
        int nChnnels = (1 == m_frame.ucChannels) ? 1 : 4;

        int nIdxRes = 0;
        if (TUCAMRET_SUCCESS == TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, TUIDC_RESOLUTION, &nIdxRes))
        {
            valWidth.nTextSize = nIdxRes;
            valHeight.nTextSize = nIdxRes;
        }

        valWidth.nID = TUIDI_CURRENT_WIDTH;
        if (TUCAMRET_SUCCESS != TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valWidth))
        {
            valWidth.nValue = 0;
        }

        valHeight.nID = TUIDI_CURRENT_HEIGHT;
        if (TUCAMRET_SUCCESS != TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valHeight))
        {
            valHeight.nValue = 0;
        }

        m_nImgSize = valWidth.nValue * valHeight.nValue * 2;
        
		if (m_itApi.uiCamCount > 1)
			TUCAM_Capa_SetValue(m_vecopCam[i].hIdxTUCam, TUIDC_CAM_MULTIPLE, m_itApi.uiCamCount);

		m_itDraw.hWnd       = ((CSampleProDlg *)(this->GetParent()))->m_PicViewMode.GetDlgItem(IDC_STA_PIC)->GetSafeHwnd();
		m_itDraw.ucChannels = valInfo.nValue;
		m_itDraw.nWidth     = 2048;
		m_itDraw.nHeight    = 2048;
		TUCAM_Draw_Init(m_opCam.hIdxTUCam, m_itDraw);
		TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, TUIDC_VERCORRECTION, 1);
	}

	m_opCam = m_vecopCam[0];

    // ͼƬļ·
    strcat(strPath.GetBuffer(MAX_PATH), "\\img");
    m_strFilePath = strPath;

	hAccKey = ::LoadAccelerators(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME));

	// TABƽ
	CString str;
	for (int i=0; i<PAGE_CNT; ++i) 
	{
		switch (i) 
		{
			case 0: if (m_tabPage[i] == NULL) (m_tabPage[i] = new Information(m_opCam, this));      break;
			case 1: if (m_tabPage[i] == NULL) (m_tabPage[i] = new CameraControl(m_opCam, this));    break;
		    case 2: if (m_tabPage[i] == NULL) (m_tabPage[i] = new ImageCapture(m_opCam, this));     break;
			case 3: if (m_tabPage[i] == NULL) (m_tabPage[i] = new ROI(m_opCam, this));              break;
			case 4: if (m_tabPage[i] == NULL) (m_tabPage[i] = new Trigger(m_opCam, this));          break;
			case 5: if (m_tabPage[i] == NULL) (m_tabPage[i] = new OutputTrigger(m_opCam, this));    break;
			case 6: if (m_tabPage[i] == NULL) (m_tabPage[i] = new MoreParameters(m_opCam, this));   break;
		}
		m_tabPage[i]->Create(IDD_DLG_INF+i, this);   
		m_tabPage[i]->ShowWindow(/*i==0 ? SW_SHOW :*/ SW_HIDE);
	}

	// m_tab.SetCurSel(0);

	if(m_bshow0)
	{      
		m_btnInfo.SetText("Camera Information                                     ");
	}
	else
	{
		m_btnInfo.SetText("Camera Information                                     >>");
	}

    OnBnClickedBtnControlcontrol();

	// ½
	UpdateData(FALSE);
	
	if (IsDhyana400BSIV3())
	{
		GetDlgItem(IDC_BTN_Trigger)->SetWindowText("TriggerRollingshutter Control                      >>");		
	}
	return TRUE;
}

void CCameraControlMode::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	//ǰĻ߶ < ߶ȣù
	if (m_nFactScreen_Width < 0 || m_nFactScreen_Heigth < 0 )
	{
		;
	}
	else
	{
		SetScrollSize(m_nFactScreen_Width, m_nCamCtlView_Heigth);
	}
}

void CCameraControlMode::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: ڴϢ/Ĭֵ	
	int nMaxPos = 0;

	GetScrollInfo(SB_VERT, &m_Scrollinfo, SIF_ALL);
	nMaxPos = m_Scrollinfo.nMax-m_Scrollinfo.nPage+1;
    m_nScrollMaxHeight = nMaxPos;

	switch (nSBCode)
	{
		case SB_BOTTOM:																// ײ
		{
			ScrollWindow(0, (m_Scrollinfo.nPos-nMaxPos)*STEP_VSCROLL);				// Ļ
			m_Scrollinfo.nPos = nMaxPos;
			SetScrollInfo(SB_VERT, &m_Scrollinfo, SIF_ALL);							// »λ	 
		}
		break;

		case SB_TOP:																// 
		{
			ScrollWindow(0, (m_Scrollinfo.nPos-m_Scrollinfo.nMin)*STEP_VSCROLL);	// Ļ
			m_Scrollinfo.nPos = m_Scrollinfo.nMin;
			SetScrollInfo(SB_VERT, &m_Scrollinfo, SIF_ALL);
		}
		break;

		case SB_LINEUP:																// ϼͷ
		{
			m_Scrollinfo.nPos -= 1;
			if (m_Scrollinfo.nPos < m_Scrollinfo.nMin)
			{
				m_Scrollinfo.nPos = m_Scrollinfo.nMin;
				break;
			}
			SetScrollInfo(SB_VERT, &m_Scrollinfo, SIF_ALL);
			ScrollWindow(0, STEP_VSCROLL);
		}
		break;

		case SB_LINEDOWN:															// ¼ͷ
		{
			m_Scrollinfo.nPos += 1;
			if (m_Scrollinfo.nPos > nMaxPos)
			{
				m_Scrollinfo.nPos = nMaxPos;
				break;
			}
			SetScrollInfo(SB_VERT, &m_Scrollinfo, SIF_ALL);
			ScrollWindow(0, -STEP_VSCROLL);
		}
		break;

		case SB_PAGEUP:																// Ϸհ
		{
			int cx = 5;
			cx = min(cx, (m_Scrollinfo.nPos-m_Scrollinfo.nMin));
			m_Scrollinfo.nPos -= cx;
			SetScrollInfo(SB_VERT, &m_Scrollinfo, SIF_ALL);
			ScrollWindow(0, cx*STEP_VSCROLL);
		}
		break;

		case SB_PAGEDOWN:															// ·հ
		{
			int cx = 5;
			cx = min(cx, (nMaxPos-m_Scrollinfo.nPos));
			m_Scrollinfo.nPos += cx;
			SetScrollInfo(SB_VERT, &m_Scrollinfo, SIF_ALL);
			ScrollWindow(0, -cx*STEP_VSCROLL);
		}
		break;

		case SB_ENDSCROLL:															// 뿪飬϶
		break;
		case SB_THUMBPOSITION: 
		break;

		case SB_THUMBTRACK:															// ϶
		{
			ScrollWindow(0, (m_Scrollinfo.nPos-nPos)*STEP_VSCROLL);
			m_Scrollinfo.nPos = nPos;
			SetScrollInfo(SB_VERT, &m_Scrollinfo, SIF_ALL);
		}
		break;		
	}

	m_nScrollWindow_Y = m_Scrollinfo.nPos*STEP_VSCROLL;

	//Invalidate(FALSE);

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

//ù
void CCameraControlMode::SetScrollSize(int nWidth, int nHeigth)
{
	CRect rt;
	this->GetClientRect(&rt);

	int i = rt.Width();
	int j = rt.Height();
	int nMaxPos = 0;
	int nPos    = 0;

	//ôֱ
	m_Scrollinfo.cbSize	 = sizeof(m_Scrollinfo);
	m_Scrollinfo.fMask	 = SIF_ALL;

	//ͨ¹ϵ䳤/ȣͷ= nPage/(nMax+2),nPageȡֵ-1ʱ᲻
	m_Scrollinfo.nPage	   = rt.Height() / STEP_VSCROLL;
	m_Scrollinfo.nMax	   = m_nheight / STEP_VSCROLL - 1;   // m_nCamCtlView_Heigth
	m_Scrollinfo.nMin	   = 0;
	m_Scrollinfo.nTrackPos = 0;
	m_Scrollinfo.nPos	   = m_nScrollWindow_Y / STEP_VSCROLL; //0

	//ùϢ
	SetScrollInfo(SB_VERT, &m_Scrollinfo);

	//ֵ
	if ((int)m_Scrollinfo.nPage <= m_Scrollinfo.nMax)
	{
		m_bShowScroll = FALSE;
	}
	else
	{
		m_bShowScroll = TRUE;
	}

	//Ļָԭ״
	if (0 == m_nScrollWindow_Y)
	{
		ScrollWindow(0, 0);
	}
	else
	{
		nMaxPos = m_Scrollinfo.nMax - m_Scrollinfo.nPage + 1;
		nPos = nMaxPos * m_Scrollinfo.nPos / m_nScrollMaxHeight;
		ScrollWindow(0, (m_Scrollinfo.nPos - nPos )*STEP_VSCROLL);
		m_nScrollMaxHeight = nMaxPos;
		m_Scrollinfo.nPos = nPos;
		SetScrollInfo(SB_VERT, &m_Scrollinfo);
		m_nScrollWindow_Y = m_Scrollinfo.nPos*STEP_VSCROLL;
	}

	//ScrollWindow(0, m_nScrollWindow_Y);
	//m_nScrollWindow_Y = 0;

	Invalidate();
}

void CCameraControlMode::OnDestroy()
{
    CDialog::OnDestroy();

    if (m_bWaitting)
    {
        StopWaitForFrame();
    }

    // TODO: ڴ˴Ϣ

    UnInitDrawingResource();                // ͷŻԴ

	for (UINT i = 0; i < m_itApi.uiCamCount; i++ )
	{
		TUCAM_Dev_Close(m_vecopCam[i].hIdxTUCam);
		TUCAM_Draw_Uninit(m_vecopCam[i].hIdxTUCam);
	}

    TUCAM_Api_Uninit();                     // ͷSDK Դ

	if (m_hHDevNotify != NULL)
		UnregisterDeviceNotification(m_hHDevNotify);

	if (m_hLDevNotify != NULL)
		UnregisterDeviceNotification(m_hLDevNotify);

	if (m_hUDevNotify != NULL)
		UnregisterDeviceNotification(m_hUDevNotify);
}


BOOL CCameraControlMode::OnBnClickedBtnLive()
{
    // TODO: ڴӿؼ֪ͨ

    if (m_bWaitting)
    {
		if (m_bRecording)
		{
			if(m_tabPage[2] !=NULL)
				((ImageCapture*)m_tabPage[2])->OnBnClickedBtnRec();
		}

        StopWaitForFrame();
    }
    else
    {
        StartWaitForFrame();
        
		UpdataPic();
        //((CSampleProDlg *)this->GetParent())->m_PicViewMode.Invalidate();

        if(m_tabPage[2] !=NULL)
            ((ImageCapture*)m_tabPage[2])->RefreshBtn(m_bWaitting);

        if(m_tabPage[6] !=NULL)
            ((MoreParameters*)m_tabPage[6])->RefreshBtn();

        /*if(m_tabPage[4] !=NULL)
            ((Trigger*)m_tabPage[4])->EnableTriggerControl(!m_bWaitting);*/
    }

	return true;
}

BOOL CCameraControlMode::PreTranslateMessage(MSG* pMsg)
{
    if((pMsg->wParam == VK_ESCAPE))
    {  
        return TRUE;  
    }

    if ((pMsg->wParam == VK_RETURN))
    {
        UpdateData();
        return TRUE;
	}

    return CDialog::PreTranslateMessage(pMsg);
}

BOOL CCameraControlMode::OnBtnRoiFunction()
{
    // TODO: ڴӿؼ֪ͨ
    BOOL bWaitting = m_bWaitting;

    if (bWaitting)
    {
        StopWaitForFrame();
    }

    TUCAM_ROI_ATTR roiAttr;

    // ȡͨ
    TUCAM_VALUE_INFO valInfo;
    valInfo.nValue = 1;
    valInfo.nID = TUIDI_CAMERA_CHANNELS;
    TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo);

    TUCAM_VALUE_INFO valWidth;
    TUCAM_VALUE_INFO valHeight;
    int nChnnels = (1 == m_frame.ucChannels) ? 1 : 3;

    int nDepth = 0;
    int elemByte = 1;
    if (TUCAMRET_SUCCESS == TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, TUIDC_BITOFDEPTH, &nDepth))
    {
        elemByte = (8 == nDepth) ? 1 : 2;
    }

    if (m_bChk)
    {
        roiAttr.bEnable = FALSE;
        roiAttr.nVOffset= 0;
        roiAttr.nHOffset= 0;
        roiAttr.nWidth  = m_nDrawWidth;
        roiAttr.nHeight = m_nDrawHeight;

        m_bChk          =FALSE;
        TUCAM_Cap_SetROI(m_opCam.hIdxTUCam, roiAttr);
        
        int nIdxRes = 0;
        if (TUCAMRET_SUCCESS == TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, TUIDC_RESOLUTION, &nIdxRes))
        {
            valWidth.nTextSize = nIdxRes;
            valHeight.nTextSize = nIdxRes;
        }

        valWidth.nID = TUIDI_CURRENT_WIDTH;
        if (TUCAMRET_SUCCESS != TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valWidth))
        {
            valWidth.nValue = 0;
        }

        valHeight.nID = TUIDI_CURRENT_HEIGHT;
        if (TUCAMRET_SUCCESS != TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valHeight))
        {
            valHeight.nValue = 0;
        }

        m_nImgSize = valWidth.nValue * valHeight.nValue * elemByte * nChnnels;
    }
    else
    {
        roiAttr.bEnable = TRUE;
        roiAttr.nVOffset= ((m_uVOffset >> 2) << 2);
        roiAttr.nHOffset= ((m_uHOffset >> 2) << 2);
        roiAttr.nWidth  = ((m_uWidth >> 2) << 2);
        roiAttr.nHeight = ((m_uHeight >> 2) << 2);

        m_bChk         =TRUE;

        TUCAM_Cap_SetROI(m_opCam.hIdxTUCam, roiAttr);

        TUCAM_Cap_GetROI(m_opCam.hIdxTUCam, &roiAttr);

        m_uVOffset = roiAttr.nVOffset;
        m_uHOffset = roiAttr.nHOffset;
        m_uWidth   = roiAttr.nWidth;
        m_uHeight  = roiAttr.nHeight;

        m_nImgSize = roiAttr.nWidth * roiAttr.nHeight * elemByte * nChnnels;
    }
   
	m_bvecRoiEnable[m_nCamIndex] = m_bChk;

    if (m_tabPage[2] != NULL)
        ((ImageCapture*)m_tabPage[2])->SetBufferNum(m_nBufferNum);

    if (bWaitting)
    {
        StartWaitForFrame();   // ʼȡͼ
    }

	if(m_tabPage[1] !=NULL)
		((CameraControl*)m_tabPage[1])->RefreshRate();

	UpdataPic();

	return true;
}

BOOL CCameraControlMode::OnChkRoiFunction()
{
    // ȡͨ
    TUCAM_VALUE_INFO valInfo;
    valInfo.nValue = 1;
    valInfo.nID = TUIDI_CAMERA_CHANNELS;
    TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo);

    TUCAM_VALUE_INFO valWidth;
    TUCAM_VALUE_INFO valHeight;
    int nChnnels = (1 == m_frame.ucChannels) ? 1 : 3;

    int nDepth = 0;
    int elemByte = 1;
    if (TUCAMRET_SUCCESS == TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, TUIDC_BITOFDEPTH, &nDepth))
    {
        elemByte = (8 == nDepth) ? 1 : 2;
    }

    if (m_bChk)
    {
		CRect rc;
		((CSampleProDlg *)this->GetParent())->m_PicViewMode.GetDlgItem(IDC_STA_PIC)->GetWindowRect(&rc);

		float fScale = m_fScale;//min(m_fScale, 1.0f);
		//rc.left += max(m_nDrawOffX, 0);
		//rc.top  += max(m_nDrawOffY, 0);
		rc.left += m_nDrawOffX;
		rc.top  += m_nDrawOffY;
		rc.right = rc.left + min(m_nDrawWidth, rc.Width() - (m_nDrawHeight > m_nCliHeight ? 20 : 0));
		rc.bottom= rc.top + min(m_nDrawHeight,rc.Height() - (m_nDrawWidth > m_nCliWidth ? 20 : 0));
     
        CDlgRoiSet dlgRoiSet;
        dlgRoiSet.SetPreviewRect(rc);
        dlgRoiSet.SetScale(1.0f / fScale);
        dlgRoiSet.SetMaxWidthHeight(m_nCurWidth, m_nCurHeight);

        if (dlgRoiSet.DoModal() == IDOK)
        {
            // ȡѡߴ缰λ
            CRect rect;
            dlgRoiSet.GetPreviewRect(rect);
            int nVOff = (int)((rect.top - rc.top) / fScale);
            int nHOff = (int)((rect.left - rc.left) / fScale);
            int nWid  = (int)(rect.Width() / fScale);
            int nHei  = (int)(rect.Height() / fScale);

            nVOff = ((nVOff >> 2) << 2);
            nHOff = ((nHOff >> 2) << 2);
            nWid  = ((nWid >> 2) << 2);
            nHei  = ((nHei >> 2) << 2);

            BOOL bWaitting = m_bWaitting;

            if (m_bWaitting)
            {
                StopWaitForFrame();   // ֹͣȡͼ
            }

            TUCAM_ROI_ATTR roiAttr;
            roiAttr.bEnable = TRUE;
            roiAttr.nVOffset= m_uVOffset = ((nVOff >> 2) << 2);
            roiAttr.nHOffset= m_uHOffset = ((nHOff >> 2) << 2);
            roiAttr.nWidth  = m_uWidth   = ((nWid >> 2) << 2);
            roiAttr.nHeight = m_uHeight  = ((nHei >> 2) << 2);

            TUCAM_Cap_SetROI(m_opCam.hIdxTUCam, roiAttr);

            TUCAM_Cap_GetROI(m_opCam.hIdxTUCam, &roiAttr);

            m_uVOffset = roiAttr.nVOffset;
            m_uHOffset = roiAttr.nHOffset;
            m_uWidth   = roiAttr.nWidth;
            m_uHeight  = roiAttr.nHeight;

            m_nImgSize = roiAttr.nWidth * roiAttr.nHeight * elemByte * nChnnels;

            if (bWaitting)
            {
                StartWaitForFrame();   // ʼȡͼ
            }
        }
        else
        {
            m_bChk = FALSE;
        }
    }
    else
    {

        BOOL bWaitting = m_bWaitting;

        if (m_bWaitting)
        {
            StopWaitForFrame();   // ֹͣȡͼ
        }

        TUCAM_ROI_ATTR roiAttr;
        roiAttr.bEnable = FALSE;
        roiAttr.nVOffset= 0;
        roiAttr.nHOffset= 0;
        roiAttr.nWidth  = 0;
        roiAttr.nHeight = 0;

        TUCAM_Cap_SetROI(m_opCam.hIdxTUCam, roiAttr);

        int nIdxRes = 0;
        if (TUCAMRET_SUCCESS == TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, TUIDC_RESOLUTION, &nIdxRes))
        {
            valWidth.nTextSize = nIdxRes;
            valHeight.nTextSize = nIdxRes;
        }

        valWidth.nID = TUIDI_CURRENT_WIDTH;
        if (TUCAMRET_SUCCESS != TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valWidth))
        {
            valWidth.nValue = 0;
        }

        valHeight.nID = TUIDI_CURRENT_HEIGHT;
        if (TUCAMRET_SUCCESS != TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valHeight))
        {
            valHeight.nValue = 0;
        }

        m_nImgSize = valWidth.nValue * valHeight.nValue * elemByte * nChnnels;

        if (bWaitting)
        {
            StartWaitForFrame();   // ʼȡͼ
        }
    }

	if(m_tabPage[1] !=NULL)
		((CameraControl*)m_tabPage[1])->RefreshRate();
    
	 UpdataPic();

	return true;
}

BOOL CCameraControlMode::OnBtnRecord()
{
	if (m_bRecording)
	{	
		m_bRecording = FALSE;
		TUCAM_Rec_Stop(m_opCam.hIdxTUCam);
	}
	else  
	{
		int nPos = 0;
		int nCnt = 1;
		CString szFName;
		CString szTmp;

		// ļǷڣ򴴽
		if (!PathIsDirectory(m_strFilePath))
		{
			CreateDirectory(m_strFilePath, NULL);
		}

		szTmp.Format(_T("%s\\%s_%d"), m_strFilePath, m_szPicName, m_uiRecTimes);
		szFName = szTmp + _T(".avi");

		// If File exists, delete it 
		CFileFind fileFind;

		if (fileFind.FindFile(szFName))
		{
			CFile::Remove(szFName);
		}

		TUCAM_REC_SAVE recSave;
		recSave.fFps    = m_fFps / 1000;
		recSave.nCodec  = m_dwFccHandler;
		recSave.pstrSavePath = szFName.GetBuffer();
		

		if (TUCAMRET_SUCCESS == TUCAM_Rec_Start(m_opCam.hIdxTUCam, recSave))
		{
			m_bRecording = TRUE;
			SetDlgItemText(IDC_BTN_REC, _T("Stop Record"));                   
		}
	}
	return true;
}

BOOL CCameraControlMode::OnRefreshLevelRange()
{
	if(m_tabPage[6] !=NULL)
		((MoreParameters*)m_tabPage[6])->RefreshLevelRange();
	return true;
}

BOOL CCameraControlMode::OnBtnRefreshRaw(BOOL bRaw)
{
	if(m_tabPage[2] !=NULL)
		((ImageCapture*)m_tabPage[2])->RefreshBtnRaw(bRaw);
	return true;
}

/*ת*/
BOOL CCameraControlMode::SetRotate(int nRotate, bool bRight)
{
	BOOL bWaitting = m_bWaitting;

	if (m_bWaitting)
	{
		StopWaitForFrame();   // ֹͣȡͼ
	}

	if (bRight)
	{
		TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, TUIDC_ROTATE_L90, 0);
		TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, TUIDC_ROTATE_R90, nRotate);
	}
	else
	{
		TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, TUIDC_ROTATE_R90, 0);
		TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, TUIDC_ROTATE_L90, nRotate);
	}

	if (bWaitting)
	{
		StartWaitForFrame();   // ʼȡͼ
	}

	UpdataPic();

	return true;
}

BOOL CCameraControlMode::OnCaptureSnap()
{
	if(m_tabPage[2] !=NULL)
	{
		((ImageCapture*)m_tabPage[2])->OnBnClickedBtnCapture();
	}
	return true;
}

BOOL CCameraControlMode::OnCaptureRecord()
{
	if(m_tabPage[2] !=NULL)
	{
		((ImageCapture*)m_tabPage[2])->OnBnClickedBtnRec();
	}
	return true;
}


BOOL CCameraControlMode::OnCaptureTriger()
{
	if(m_bLiving)
	{
		if(m_tabPage[3] !=NULL)
			((CameraControl*)m_tabPage[1])->OnBnClickedBtnLive();
	}
	
    return true;
}

BOOL CCameraControlMode::OnCapturePlay()
{
	if(m_tabPage[1] !=NULL)
	{
		((CameraControl*)m_tabPage[1])->OnBnClickedBtnLive();
	}
    return true;
}
// info ť
void CCameraControlMode::OnBnClickedBtnInfo()
{
	// TODO: ڴӿؼ֪ͨ
    if (NULL == m_tabPage[0])
    {
        return;
    }
    
	m_bshow0 = !m_bshow0;
	CButton *btn = (CButton *)GetDlgItem(IDC_BTN_INFO);
	btn->GetWindowRect(&rectSmall);
    ScreenToClient(&rectSmall);
	if(m_bshow0)
	{      
		m_tabPage[0]->GetClientRect(&rectLarge);
		m_tabPage[0]->MoveWindow(rectSmall.left, rectSmall.bottom, rectLarge.Width(), rectLarge.Height());
		m_tabPage[0]->ShowWindow(SW_SHOW);
//      this->SetDlgItemText(IDC_BTN_INFO, "Camera Information                                     ");
        m_btnInfo.SetText("Camera Information                                     ");
        m_btnInfo.UpdateData();
	}
	else
	{
		m_tabPage[0]->ShowWindow(SW_HIDE);
//      this->SetDlgItemText(IDC_BTN_INFO, "Camera Information                                     >>");
        m_btnInfo.SetText("Camera Information                                     >>");
        m_btnInfo.UpdateData();
	}

	UpdateControl();
}


void CCameraControlMode::OnBnClickedBtnControlcontrol()
{
	// TODO: ڴӿؼ֪ͨ
    if (NULL == m_tabPage[1])
    {
        return;
    }

	m_bshow1 = !m_bshow1;
	CButton *btn = (CButton *)GetDlgItem(IDC_BTN_ControlControl);
	btn->GetWindowRect(&rectSmall);
    ScreenToClient(&rectSmall);
	if(m_bshow1)
	{      
		m_tabPage[1]->GetClientRect(&rectLarge);
		m_tabPage[1]->MoveWindow(rectSmall.left, rectSmall.bottom, rectLarge.Width(), rectLarge.Height());
		m_tabPage[1]->ShowWindow(SW_SHOW);
//		this->SetDlgItemText(IDC_BTN_ControlControl, "Camera Control                                           ");
        m_btnCtrl.SetText("Camera Control                                           ");
	}
	else
	{
		m_tabPage[1]->ShowWindow(SW_HIDE);
//      this->SetDlgItemText(IDC_BTN_ControlControl, "Camera Control                                           >>");
        m_btnCtrl.SetText("Camera Control                                           >>");
	}

	UpdateControl();
}

void CCameraControlMode::OnBnClickedBtnImagecapture()
{
	// TODO: ڴӿؼ֪ͨ
    if (NULL == m_tabPage[2])
    {
        return;
    }

	m_bshow2 = !m_bshow2;
	CButton *btn = (CButton *)GetDlgItem(IDC_BTN_ImageCapture);
	btn->GetWindowRect(&rectSmall);
    ScreenToClient(&rectSmall);
	if(m_bshow2)
	{      
		m_tabPage[2]->GetClientRect(&rectLarge);
		m_tabPage[2]->MoveWindow(rectSmall.left, rectSmall.bottom, rectLarge.Width(), rectLarge.Height());
		m_tabPage[2]->ShowWindow(SW_SHOW);
//		this->SetDlgItemText(IDC_BTN_ImageCapture, "Image Capture                                            ");
        m_btnImgCap.SetText("Image Capture                                            ");
	} 
	else
	{
		m_tabPage[2]->ShowWindow(SW_HIDE); 
//      this->SetDlgItemText(IDC_BTN_ImageCapture, "Image Capture                                            >>");
        m_btnImgCap.SetText("Image Capture                                            >>");
	} 

	UpdateControl();
}

void CCameraControlMode::OnBnClickedBtnRoi()
{
    // TODO: ڴӿؼ֪ͨ
    if (NULL == m_tabPage[3])
    {
        return;
    }

    m_bshow3 = !m_bshow3;
    CButton *btn = (CButton *)GetDlgItem(IDC_BTN_ROI);
    btn->GetWindowRect(&rectSmall);
    ScreenToClient(&rectSmall);
    if(m_bshow3)
    {      
        m_tabPage[3]->GetClientRect(&rectLarge);
        m_tabPage[3]->MoveWindow(rectSmall.left, rectSmall.bottom, rectLarge.Width(), rectLarge.Height());
        m_tabPage[3]->ShowWindow(SW_SHOW);
//      this->SetDlgItemText(IDC_BTN_ROI, "ROI                                                           ");
        m_btnROI.SetText("ROI                                                           ");
    } 
    else
    {
        m_tabPage[3]->ShowWindow(SW_HIDE); 
//      this->SetDlgItemText(IDC_BTN_ROI, "ROI                                                           >>");
        m_btnROI.SetText("ROI                                                           >>");
    }

    UpdateControl();
}

void CCameraControlMode::OnBnClickedBtnTrigger()
{
    // TODO: ڴӿؼ֪ͨ
    if (NULL == m_tabPage[4])
    {
        return;
    }

    m_bshow4 = !m_bshow4;
    CButton *btn = (CButton *)GetDlgItem(IDC_BTN_Trigger);
    btn->GetWindowRect(&rectSmall);
    ScreenToClient(&rectSmall);
    if(m_bshow4)
    {      
        m_tabPage[4]->GetClientRect(&rectLarge);
        m_tabPage[4]->MoveWindow(rectSmall.left, rectSmall.bottom, rectLarge.Width(), rectLarge.Height());
        m_tabPage[4]->ShowWindow(SW_SHOW);
		m_btnTrigger.SetText("Trigger                                                      ");
		if (IsDhyana400BSIV3())
		{
			m_btnTrigger.SetText("TriggerRollingshutter Control                     ");
		}
    }
    else
    {
        m_tabPage[4]->ShowWindow(SW_HIDE);
        m_btnTrigger.SetText("Trigger                                                      >>");
		if (IsDhyana400BSIV3())
		{
			m_btnTrigger.SetText("TriggerRollingshutter Control                     >>");
		}
    }
    UpdateControl();
}

void CCameraControlMode::OnBnClickedBtnOutputtriger()
{
	// TODO: ڴӿؼ֪ͨ
	if (NULL == m_tabPage[5])
	{
		return;
	}

	m_bshow5 = !m_bshow5;
	CButton *btn = (CButton *)GetDlgItem(IDC_BTN_OutPutTriger);
	btn->GetWindowRect(&rectSmall);
	ScreenToClient(&rectSmall);
	if(m_bshow5)
	{      
		m_tabPage[5]->GetClientRect(&rectLarge);
		m_tabPage[5]->MoveWindow(rectSmall.left, rectSmall.bottom, rectLarge.Width(), rectLarge.Height());
		m_tabPage[5]->ShowWindow(SW_SHOW);
		//		this->SetDlgItemText(IDC_BTN_MorePara, "Image Adjustment                                       ");
		m_btnOutputTrigger.SetText("OutputTrigger                                           ");
	}
	else
	{
		m_tabPage[5]->ShowWindow(SW_HIDE);
		//      this->SetDlgItemText(IDC_BTN_MorePara, "Image Adjustment                                       >>");
		m_btnOutputTrigger.SetText("OutputTrigger                                           >>");
	}
	UpdateControl();
}

void CCameraControlMode::OnBnClickedBtnMorepara()
{
	// TODO: ڴӿؼ֪ͨ
    if (NULL == m_tabPage[6])
    {
        return;
    }

	m_bshow6 = !m_bshow6;
	CButton *btn = (CButton *)GetDlgItem(IDC_BTN_MorePara);
	btn->GetWindowRect(&rectSmall);
    ScreenToClient(&rectSmall);
	if(m_bshow6)
	{      
		m_tabPage[6]->GetClientRect(&rectLarge);
		m_tabPage[6]->MoveWindow(rectSmall.left, rectSmall.bottom, rectLarge.Width(), rectLarge.Height());
		m_tabPage[6]->ShowWindow(SW_SHOW);
//		this->SetDlgItemText(IDC_BTN_MorePara, "Image Adjustment                                       ");
        m_btnImgAdjustment.SetText("Image Adjustment                                      ");
	}
	else
	{
		m_tabPage[6]->ShowWindow(SW_HIDE);
//      this->SetDlgItemText(IDC_BTN_MorePara, "Image Adjustment                                       >>");
        m_btnImgAdjustment.SetText("Image Adjustment                                      >>");
	}
	UpdateControl();
}


void CCameraControlMode::UpdateControl()
{
    CButton *btn = (CButton *)GetDlgItem(IDC_BTN_INFO);
	btn->GetWindowRect(&rectSmall);
    ScreenToClient(&rectSmall);
	if(m_bshow0)
	{   
		m_tabPage[0]->ShowWindow(SW_HIDE);
		m_tabPage[0]->GetClientRect(&rectLarge);
		m_tabPage[0]->MoveWindow(rectSmall.left, rectSmall.bottom, rectLarge.Width(), rectLarge.Height());
		m_tabPage[0]->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BTN_ControlControl)->MoveWindow(rectSmall.left,rectSmall.bottom+rectLarge.Height()+5, rectSmall.Width(), rectSmall.Height());
	}
	else
	{
		GetDlgItem(IDC_BTN_ControlControl)->MoveWindow(rectSmall.left,rectSmall.bottom+5, rectSmall.Width(), rectSmall.Height());
	}

	btn = (CButton *)GetDlgItem(IDC_BTN_ControlControl);
	btn->GetWindowRect(&rectSmall);
    ScreenToClient(&rectSmall);
	if(m_bshow1)
	{     
		m_tabPage[1]->ShowWindow(SW_HIDE);
		m_tabPage[1]->GetClientRect(&rectLarge);
		m_tabPage[1]->MoveWindow(rectSmall.left, rectSmall.bottom, rectLarge.Width(), rectLarge.Height());
		m_tabPage[1]->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BTN_ImageCapture)->MoveWindow(rectSmall.left,rectSmall.bottom+rectLarge.Height()+5, rectSmall.Width(), rectSmall.Height());
	}
	else
	{
		GetDlgItem(IDC_BTN_ImageCapture)->MoveWindow(rectSmall.left,rectSmall.bottom+5, rectSmall.Width(), rectSmall.Height());
	}

	btn = (CButton *)GetDlgItem(IDC_BTN_ImageCapture);
	btn->GetWindowRect(&rectSmall);
    ScreenToClient(&rectSmall);
	if(m_bshow2)
	{    
		m_tabPage[2]->ShowWindow(SW_HIDE);
		m_tabPage[2]->GetClientRect(&rectLarge);
		m_tabPage[2]->MoveWindow(rectSmall.left, rectSmall.bottom, rectLarge.Width(), rectLarge.Height());
		m_tabPage[2]->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BTN_ROI)->MoveWindow(rectSmall.left,rectSmall.bottom+rectLarge.Height()+5, rectSmall.Width(), rectSmall.Height());
	}
	else
	{
		GetDlgItem(IDC_BTN_ROI)->MoveWindow(rectSmall.left,rectSmall.bottom+5, rectSmall.Width(), rectSmall.Height());
	}

    btn = (CButton *)GetDlgItem(IDC_BTN_ROI);
    btn->GetWindowRect(&rectSmall);
    ScreenToClient(&rectSmall);
    if(m_bshow3)
    {    
        m_tabPage[3]->ShowWindow(SW_HIDE);
        m_tabPage[3]->GetClientRect(&rectLarge);
        m_tabPage[3]->MoveWindow(rectSmall.left, rectSmall.bottom, rectLarge.Width(), rectLarge.Height());
        m_tabPage[3]->ShowWindow(SW_SHOW);
        GetDlgItem(IDC_BTN_Trigger)->MoveWindow(rectSmall.left,rectSmall.bottom+rectLarge.Height()+5, rectSmall.Width(), rectSmall.Height());
    }
    else
    {
        GetDlgItem(IDC_BTN_Trigger)->MoveWindow(rectSmall.left,rectSmall.bottom+5, rectSmall.Width(), rectSmall.Height());
    }

	btn = (CButton *)GetDlgItem(IDC_BTN_Trigger);
	btn->GetWindowRect(&rectSmall);
    ScreenToClient(&rectSmall);
	if(m_bshow4)
	{    
		m_tabPage[4]->ShowWindow(SW_HIDE);
		m_tabPage[4]->GetClientRect(&rectLarge);
		m_tabPage[4]->MoveWindow(rectSmall.left, rectSmall.bottom, rectLarge.Width(), rectLarge.Height());
		m_tabPage[4]->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BTN_OutPutTriger)->MoveWindow(rectSmall.left,rectSmall.bottom+rectLarge.Height()+5, rectSmall.Width(), rectSmall.Height());
	}
	else
	{
		GetDlgItem(IDC_BTN_OutPutTriger)->MoveWindow(rectSmall.left,rectSmall.bottom+5, rectSmall.Width(), rectSmall.Height());
	}

	btn = (CButton *)GetDlgItem(IDC_BTN_OutPutTriger);
	btn->GetWindowRect(&rectSmall);
    ScreenToClient(&rectSmall);

	if(m_bshow5)
	{    
		m_tabPage[5]->ShowWindow(SW_HIDE);
		m_tabPage[5]->GetClientRect(&rectLarge);
		m_tabPage[5]->MoveWindow(rectSmall.left, rectSmall.bottom, rectLarge.Width(), rectLarge.Height());
		m_tabPage[5]->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BTN_MorePara)->MoveWindow(rectSmall.left,rectSmall.bottom+rectLarge.Height()+5, rectSmall.Width(), rectSmall.Height());
	}
	else
	{
		GetDlgItem(IDC_BTN_MorePara)->MoveWindow(rectSmall.left,rectSmall.bottom+5, rectSmall.Width(), rectSmall.Height());
	}

	btn = (CButton *)GetDlgItem(IDC_BTN_MorePara);
	btn->GetWindowRect(&rectSmall);
    ScreenToClient(&rectSmall);
	if(m_bshow6)
	{    
		m_tabPage[6]->ShowWindow(SW_HIDE);
		m_tabPage[6]->GetClientRect(&rectLarge);
		m_tabPage[6]->MoveWindow(rectSmall.left, rectSmall.bottom, rectLarge.Width(), rectLarge.Height());
		m_tabPage[6]->ShowWindow(SW_SHOW);
        CRect rect;
        this->GetWindowRect(&rect);
        ScreenToClient(&rect);
        int height = max(rect.Height(),(rectSmall.bottom+ rectLarge.Height()));
        m_nheight = height+m_nScrollWindow_Y;
        SetScrollSize(m_nFactScreen_Width, height);
	}
	else
	{
        CRect rect;
        this->GetWindowRect(&rect);
        ScreenToClient(&rect);
        int height = max(rect.Height(),rectSmall.bottom);
        m_nheight = height+m_nScrollWindow_Y;
        SetScrollSize(m_nFactScreen_Width, height);
	}

    // ½
	//UpdateData(FALSE);
}
HBRUSH CCameraControlMode::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
    HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

    // TODO:  ڴ˸ DC κ

    if (pWnd->GetDlgCtrlID() == IDC_BTN_INFO || pWnd->GetDlgCtrlID() == IDC_BTN_ControlControl || 
        pWnd->GetDlgCtrlID() == IDC_BTN_ImageCapture || pWnd->GetDlgCtrlID() == IDC_BTN_ROI || 
        pWnd->GetDlgCtrlID() == IDC_BTN_Trigger || pWnd->GetDlgCtrlID() == IDC_BTN_OutPutTriger || pWnd->GetDlgCtrlID() == IDC_BTN_MorePara)
    {
        //HBRUSH hBrush = CreateSolidBrush(RGB(178, 178, 178));
        pDC->SetBkColor(RGB(178, 178, 178));

        return hBrush;
    }


    // TODO:  ĬϵĲ軭ʣ򷵻һ
    return hbr;
}

void CCameraControlMode::OnSetFocus(CWnd* pOldWnd)
{
    CDialog::OnSetFocus(pOldWnd);

    // TODO: ڴ˴Ϣ

}

// 
int CCameraControlMode::ChangeCamIndex(int nCamIndex)
{ 
	if (nCamIndex+1 > (int)m_itApi.uiCamCount)
	{
		return -1;
	}

	if (m_nCamIndex == nCamIndex)
	{
		return -1;
	}

	m_nCamIndex = nCamIndex;

	if (m_bWaitting)
	{
		StopWaitForFrame();
		m_bLiving = TRUE;
	}
	// עص
	TUCAM_Buf_DataCallBack(m_opCam.hIdxTUCam, NULL, this);
	m_opCam = m_vecopCam[nCamIndex];

	if (m_tabPage[0] != NULL) ((Information*)m_tabPage[0])->RefreshOpen(m_opCam);
	if (m_tabPage[1] != NULL) ((CameraControl*)m_tabPage[1])->RefreshOpen(m_opCam);
	if (m_tabPage[2] != NULL) ((ImageCapture*)m_tabPage[2])->RefreshOpen(m_opCam);
	if (m_tabPage[3] != NULL) ((ROI*)m_tabPage[3])->RefreshOpen(m_opCam);
	if (m_tabPage[4] != NULL) ((Trigger*)m_tabPage[4])->RefreshOpen(m_opCam);
	if (m_tabPage[5] != NULL) ((OutputTrigger*)m_tabPage[5])->RefreshOpen(m_opCam);
	if (m_tabPage[6] != NULL) ((MoreParameters*)m_tabPage[6])->RefreshOpen(m_opCam);

	//InitInformation();
	//InitControlRange();
	//RefreshValue();
	if (m_tabPage[0] != NULL) ((Information*)m_tabPage[0])->InitInformation();

	if (m_tabPage[0] != NULL) ((Information*)m_tabPage[0])->InitControlRange();
	if (m_tabPage[1] != NULL) ((CameraControl*)m_tabPage[1])->InitControlRange();
	///if (m_tabPage[2] != NULL) ((ImageCapture*)m_tabPage[2])->InitControlRange();
	if (m_tabPage[3] != NULL) ((ROI*)m_tabPage[3])->InitControlRange();
	if (m_tabPage[4] != NULL) ((Trigger*)m_tabPage[4])->InitControlRange();
	if (m_tabPage[5] != NULL) ((OutputTrigger*)m_tabPage[5])->InitControlRange();
	if (m_tabPage[6] != NULL) ((MoreParameters*)m_tabPage[6])->InitControlRange();

	if (m_tabPage[0] != NULL) ((Information*)m_tabPage[0])->RefreshValue();
	if (m_tabPage[1] != NULL) ((CameraControl*)m_tabPage[1])->RefreshValue();
	///if (m_tabPage[2] != NULL) ((ImageCapture*)m_tabPage[2])->RefreshValue();
	if (m_tabPage[3] != NULL) ((ROI*)m_tabPage[3])->RefreshValue();
	if (m_tabPage[4] != NULL) ((Trigger*)m_tabPage[4])->RefreshValue();
	if (m_tabPage[5] != NULL) ((OutputTrigger*)m_tabPage[5])->RefreshValue();
	if (m_tabPage[6] != NULL) ((MoreParameters*)m_tabPage[6])->RefreshValue();

	/*if (TUCCM_SEQUENCE != m_nTriMode)
	{
		if(NULL != m_tabPage[1])
		{
			((CameraControl*)m_tabPage[1])->RefreshBtn(FALSE);
		}
	}
	else
	{
		if(NULL != m_tabPage[1])
		{
			((CameraControl*)m_tabPage[1])->RefreshBtn(TRUE);
		}
	}*/

	// עص
	TUCAM_Buf_DataCallBack(m_opCam.hIdxTUCam, OnCallbackBuffer, this);

	if(m_bLiving && NULL != m_opCam.hIdxTUCam)
	{
		m_bLiving = FALSE;
		StartWaitForFrame();  
	}

	UpdateControl();

	return 1;
}

