#pragma once

// CCameraControlMode Ի
#define UPSPIN					-1				         // عʱ༭ϼͷ
#define DOWNSPIN				1				         // ع¼༭¼ͷ
	
#define STEP_VSCROLL			10		
#define STEP_MOVE				50

#include <vfw.h>
#include "../sdk/inc/TUCamApi.h"                         // SDKͷļ
#include "../sdk/inc/MPTiff.h"
#include "afxwin.h"
#include "afxcmn.h"
#include <dbt.h>
#include "TUButton.h"
#include <queue>
#include <vector>


#define  PAGE_CNT 7                                     // ܹ7TabС
#define  MAKETAG(a,b,c,d) (a | (b << 8) | (c << 16) | (d << 24))
#define  TUDBG_PRINTF(format,...)	{char dbgMsg[1024] = {0}; sprintf_s(dbgMsg, "" format"", ##__VA_ARGS__); OutputDebugStringA(dbgMsg);}

#define FL20BW_PID_SSC183IM1    0xE40D                   // FL20BW 
#define DHYANA_D401D_PID        0xE005                   // Dhyana401D
#define DHYANA_D201D_PID        0xE007                   // Dhyana201D
#define DHYANA_400BSIV2_PID     0xE408                   // Dhyana400BSIV2
#define DHYANA_D4040_PID        0xE40E                   // Dhyana4040
#define DHYANA_400DC_PID        0xEC03                   // Dhyana400DC
#define DHYANA_D95V2_PID        0xE40F                   // Dhyana95V2.0
#define DHYANA_D95V1_PID        0xE406                   // Dhyana95V1.0

#define DHYANA_1605BSI_PID      0xE424                   // Dhyana1605BSI
#define DHYANA_ULTRA1605_PID    0xE425                   // Dhyana Ultra 1605

#define  TUMSG_LABEL  WM_USER + 0x224                    // Ϣʶ               

// typedef enum the image mode support 400bsi
typedef enum
{
	TUIM_BSICMS          = 0x01,             // cms mode
	TUIM_BSIHDR          = 0x02,             // hdr mode
	TUIM_BSIGLOBAL_RESET = 0x03,             // global reset
}TUCAM_IMAGE_400BSIMODES;

// typedef enum the image mode support 400bsiv3
typedef enum
{
	TUIM_CMS          = 0x01,             // cms mode
	TUIM_HDR          = 0x02,             // hdr mode
	TUIM_HIGHSPEED    = 0x03,             // high speed hg lg
	TUIM_GLOBAL_RESET = 0x04,             // global reset
}TUCAM_IMAGE_400BSIV3MODES;

// the show label
typedef struct _tagSHOWLABEL_ATTR
{
	UINT   nChannels;                          // [in/out] The Channels
	UINT   nR;                                 // [in/out] The nR
	UINT   nG;                                 // [in/out] The nG
	UINT   nB;                                 // [in/out] The nB
    UINT   nScale;                             // [in/out] The Scale
	UINT   nPosX;                              // [in/out] The x pos
	UINT   nPosY;                              // [in/out] The y pos
	UINT   nWidth;                             // [in/out] The width
	UINT   nHeight;                            // [in/out] The height

}SHOWLABEL_ATTR, *PSHOWLABEL_ATTR;

//  ڵϢ
typedef struct _tagBUFFER_NODE
{
    int             nID;                        // node ID
    int             nBufSize;                   // buffer size
    unsigned char   *pBuf;                      // buffer pointer

    _tagBUFFER_NODE *pBufNodeNext;        // next node pointer
    _tagBUFFER_NODE *pBufNodePrev;        // prev node pointer

} BUFFER_NODE, *PBUFFER_NODE;

typedef std::vector<UCHAR *> TUCAM_VECBUF;
typedef std::vector<BOOL>    TUCAM_VECSAVE;
typedef std::vector<BOOL>    TUCAM_VECROI;
typedef std::vector<PBUFFER_NODE> TUCAM_VECNODES;

class CCameraControlMode : public CDialog
{
	DECLARE_DYNAMIC(CCameraControlMode)

public:
	CCameraControlMode(CWnd* pParent = NULL);           // ׼캯
	virtual ~CCameraControlMode();
	CDialog *m_tabPage[PAGE_CNT];                       // ӶԻָ

	BOOL ShowImageInfo(TUCAM_FRAME &frame);             // ʾͼϢ
	BOOL DrawCenter(TUCAM_FRAME &frame);
    void InitDrawingResource();                         // ʼԴ
    void UnInitDrawingResource();                       // ʼԴ

	void InitInformationNone();
    void InitInformation();                             // ʼϢ
    void InitControlRange();                            // ʼؼΧ
    void EnableControl(BOOL bLiving = FALSE);           // ؼʹ  
	void UpdataPic();                                   // ˢʾ
	void UpdataInvalidate();                            // ˢʾ
//  void EnableTriggerControl(BOOL bEnable = FALSE);    // ʹ
    void RefreshValue();                                // ˢ¿ؼֵ
    void UpdateExposureTime(DWORD dwExp);               // عʱ 

    void ProgressStatus(int nCur, int nMin, int nMax, BOOL bShow = TRUE);             // ؼʹ    

    void StartWaitForFrame();  
    void StopWaitForFrame();  
    void StartSaveFrames();
    void StopSaveFrames();

	int ChangeCamIndex(int nCamIndex = 0);              // 

	static void OnCallbackBuffer(void *pClient);

	bool FlipVertically(TUCAM_FRAME &frame);            // frameݴֱ
	bool SaveImgToDisk(TUCAM_FRAME &frame);
    bool SaveImgToDisk(TUCAM_RAWIMG_HEADER Frame);
  
    bool GetSystemMemorySize(UINT64 &uiMemTotal, UINT64 &uiMemFree); // ȡڴϢ

    int CreateProcessedNodes(int count);
    void DestroyProcessedNodes();

    void ProcesseFrame(PTUCAM_RAWIMG_HEADER dst, PTUCAM_RAWIMG_HEADER src);
    bool FlipVertically(PTUCAM_RAWIMG_HEADER dst, PTUCAM_RAWIMG_HEADER src, const UINT32 &widthStep, int header = 1024);

    void AcqSavedImg();
    void AcqProcessedImg(PTUCAM_RAWIMG_HEADER frame);

    void SaveImgToDisk();
    bool SaveImgToDisk(PTUCAM_RAWIMG_HEADER frame, int header = 1024);

    bool CreateMultiFile(PTUCAM_RAWIMG_HEADER frame);
    void CloseMultiFile(PTUCAM_RAWIMG_HEADER frame = NULL);

// Ի
	enum { IDD = IDD_DLG_CTL}; 

protected:
	//LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam); // ôƶ
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧
	virtual BOOL OnInitDialog();

	DECLARE_MESSAGE_MAP()

public:
	HACCEL hAccKey;
	HBRUSH hBrush;
public:

    static void __cdecl AcqThreadLoop(LPVOID lParam);       // ݻȡ߳ʵ
    static void __cdecl DiskThreadLoop(LPVOID lParam);      // ߳ʵ

    static void __cdecl WaitForFrameThread(LPVOID lParam);  // ȴ߳ʵ
	static void __cdecl WaitForFrame2Thread(LPVOID lParam); // ȴ߳ʵ
	static void __cdecl WaitForFrame3Thread(LPVOID lParam); // ȴ߳ʵ
	static void __cdecl WaitForFrame4Thread(LPVOID lParam); // ȴ߳ʵ

	CFont				m_fntEdit;						// ģ
	CString				m_strFilePath;					// ļַ
	BOOL				m_bShowScroll;					// Ƿʾ

	int					m_nCamCtlView_Width;			// 
	int					m_nCamCtlView_Heigth;			// ߶
	int					m_nFactScreen_Width;			// ʵʴڿ
	int					m_nFactScreen_Heigth;			// ʵʴڸ߶
	int					m_nScrollWindow_Y;				// Ļָԭ״
    int					m_nScrollMaxHeight;				// Ļָԭ״

	SCROLLINFO			m_Scrollinfo;					// Ϣ

    /* ʼ */
    TUCAM_INIT          m_itApi;                        // ʼSDK
    TUCAM_OPEN          m_opCam;                        // 

	std::vector<TUCAM_OPEN>		m_vecopCam;             // 
	std::vector<TUCAM_FRAME>	m_vecframe;             // ֡
	std::vector<TUCAM_TRIGGER_ATTR>		m_vectgrAttr;   // ṹ

	BOOL                m_bWaitting;                    // 
	BOOL                m_bWaitting2;                   // 
	BOOL                m_bWaitting3;                   // 
	BOOL                m_bWaitting4;                   // 
	BOOL                m_bLiving;                      // Ԥ

	TUCAM_VECSAVE       m_vecSaving;                    // ͼ񱣴
	BOOL                m_bSaving;                      // ͼ񱣴

	TUCAM_VECROI        m_bvecRoiEnable;
	BOOL                m_bRoiEnable;

	int                 m_nCntSave;                     // 
	int                 m_nFmtSave;                     // ʽ
	int                 m_nFmtCnt;                      // ʽ

    char                m_cPath[MAX_PATH];              // ·

    /* λͼƲ */
    HANDLE              m_hThdDraw;                     // ʾ߳̾
    BITMAPINFOHEADER    m_bmpInfo;                      // λͼͷϢ
    HDC				    m_hDC;                          // λͼDC
    HDRAWDIB		    m_hDib;                         // λͼDIB
    TUCAM_FRAME         m_frame;                        // ֡
    TUCAM_DRAW_INIT     m_itDraw;                       // Ƴʼ
    TUCAM_DRAW          m_drawing;                      // Ʋ
	TUCAM_DRAW          m_drawing2;                     // Ʋ
	TUCAM_DRAW          m_drawing3;                     // Ʋ
	TUCAM_DRAW          m_drawing4;                     // Ʋ

    /* ֡ʼ */
    DWORD               m_dwSTm;                        // ʼ
    DWORD               m_dwITm;                        // ʱ
    DWORD               m_dwFrmCnt;                     // ֡ͳ
    float               m_fFps;                         // ֡

    /*  */
	float               m_fScale;                       // ű
	float               m_fScale2;                      // ű
	float               m_fScale3;                      // ű
	float               m_fScale4;                      // ű

	int                 m_nCurWidth;                    // ǰ
	int                 m_nCurHeight;                   // ǰ߶
	int                 m_nCurChannel;                  // ǰͨ
	int                 m_nCliWidth;                    // ǰͻ˿
	int                 m_nCliHeight;                   // ǰͻ˸߶

	int                 m_nCliWidth1;                   // ǰͻ˿
	int                 m_nCliHeight1;                  // ǰͻ˸߶
   
	int                 m_nCurWidth2;                   // ǰ
	int                 m_nCurHeight2;                  // ǰ߶

	int                 m_nCurWidth3;                   // ǰ
	int                 m_nCurHeight3;                  // ǰ߶

	int                 m_nCurWidth4;                   // ǰ
	int                 m_nCurHeight4;                  // ǰ߶

	int                 m_nDrawOffX;                    // ˮƽƫ  
	int                 m_nDrawOffY;                    // ֱƫ
	int                 m_nDrawWidth;                   // ƿ
	int                 m_nDrawHeight;                  // Ƹ߶

	int                 m_nDrawOffX2;                   // ˮƽƫ  
	int                 m_nDrawOffY2;                   // ֱƫ
	int                 m_nDrawWidth2;                  // ƿ
	int                 m_nDrawHeight2;                 // Ƹ߶

	int                 m_nDrawOffX3;                   // ˮƽƫ  
	int                 m_nDrawOffY3;                   // ֱƫ
	int                 m_nDrawWidth3;                  // ƿ
	int                 m_nDrawHeight3;                 // Ƹ߶

	int                 m_nDrawOffX4;                   // ˮƽƫ  
	int                 m_nDrawOffY4;                   // ֱƫ
	int                 m_nDrawWidth4;                  // ƿ
	int                 m_nDrawHeight4;                 // Ƹ߶
    
	int					m_nPID;                         // PID
	int                 m_nBCD;

    /*  */
    BOOL                m_bTgrMode;                     // ģʽ
    BOOL                m_bTrigger;                     // ״̬
    HANDLE              m_hThdTrigger;                  // ߳̾
    
    HANDLE              m_hThdDiskLoop;                 // ݱ߳̾
    
    HANDLE              m_hThdAcqLoop;                  // ݻȡ߳̾

	HANDLE              m_hThdWaitForFrame;             // ݲ߳̾

	HANDLE              m_hThdWaitForFrame2;            // ݲ߳̾

	HANDLE              m_hThdWaitForFrame3;            // ݲ߳̾

	HANDLE              m_hThdWaitForFrame4;            // ݲ߳̾

    int                 m_nCnt;

	UINT                m_uiTriFrame;                   // ֡

	UINT32              m_nopCamCount;                  // 
    /* ImageName+Times+Frames*/
    UINT                m_uiCapTimes;                   // 
    UINT                m_uiCapFrames;                  // ֡
    UINT                m_uiRecTimes;                   // 

	DWORD				m_dwTmTrigger;

	HDEVNOTIFY			m_hHDevNotify;
	HDEVNOTIFY			m_hLDevNotify;
	HDEVNOTIFY			m_hUDevNotify;
    
public:
	/**/
	BOOL OnBnClickedBtnLive();

	/*ROIť*/
	BOOL OnBtnRoiFunction();

	/*ԶROI*/
	BOOL OnChkRoiFunction();

	/*¼*/
	BOOL OnBtnRecord();

	/*ɫ׷Χˢ*/
	BOOL OnRefreshLevelRange();

	/*Rawťˢ*/
	BOOL OnBtnRefreshRaw(BOOL bRaw = FALSE);

	/*ת*/
	BOOL SetRotate(int nRotate, bool bRight = TRUE);

	/*ı䴰ڴС*/
	afx_msg void OnSize(UINT nType, int cx, int cy);

	/*¼*/
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);

	/*ùߴС*/
	void SetScrollSize(int nWidth, int nHeigth);

	/*ر*/
    afx_msg void OnDestroy();

	/*INFOť*/
	afx_msg void OnBnClickedBtnInfo();

    afx_msg void OnBnClickedBtnControlcontrol();
    afx_msg void OnBnClickedBtnImagecapture();
    afx_msg void OnBnClickedBtnMorepara();
    afx_msg void OnBnClickedBtnRoi();
    afx_msg void OnBnClickedBtnTrigger();
	afx_msg void OnBnClickedBtnOutputtriger();

	/*ܽѡ*/
	//afx_msg void OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult);
    
	/*ṵ̈*/
    virtual BOOL PreTranslateMessage(MSG* pMsg);

    void UpdateControl();

	INT                 m_nPicNum;    // ͼƬ
    BOOL                m_bUseTm;
    CString             m_szPicName;  // ļϢ
	int                 m_nRecTm;     // ¼ʱ

    int m_nTriMode;

	int                 m_nCamIndex;  // 
	/* ¼ */
    BOOL                m_bRecording;                   // Ƿ¼  
    
	/* ǩҳ */
	//CTabCtrl            m_tab;                          //һCTabģ

	
	/* ROI */
	BOOL               m_bChk;
	UINT               m_uHOffset;
    UINT               m_uVOffset;
    UINT               m_uWidth;
    UINT               m_uHeight;

	DWORD              m_dwFccHandler;                //   

	BOOL               OnCaptureSnap();               // View 
	BOOL               OnCaptureRecord();             // View ¼
	BOOL               OnCaptureTriger();             // View 
	BOOL               OnCapturePlay();               // Viww Ԥ
    
	BOOL               m_bshow0;                      //ʾǷı־λ
	BOOL               m_bshow1;                      //ʾǷı־λ
	BOOL               m_bshow2;                      //ʾǷı־λ
	BOOL               m_bshow3;                      //ʾǷı־λ
	BOOL               m_bshow4;                      //ʾǷı־λ
	BOOL               m_bshow5;                      //ʾǷı־λ
	BOOL               m_bshow6;                      //ʾǷı־λ
	BOOL               m_bshow7;                      //ʾǷı־λ

	CRect              rectSmall;                     //ʱʾС
	CRect              rectLarge;                     //չʱʾ
	int                m_nheight;                     //߶

	int                m_nDepth;                      //λ
	int                m_nDepth2;                     //λ
	int                m_nDepth3;                     //λ
	int                m_nDepth4;                     //λ

	int                m_nImgMode;                    //ͼģʽ

    afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg LRESULT OnDeviceChange(WPARAM wParam, LPARAM lParam);

    CTUButton m_btnInfo;
    CTUButton m_btnCtrl;
    CTUButton m_btnImgCap;
    CTUButton m_btnROI;
    CTUButton m_btnTrigger;
	CTUButton m_btnOutputTrigger;
    CTUButton m_btnImgAdjustment;
    afx_msg void OnSetFocus(CWnd* pOldWnd);

	int                m_nMoveX;                   // ͼλX
	int                m_nMoveY;                   // ͼλY
 
	SHOWLABEL_ATTR     Showlabel;                  // ͼϢʾ
	BOOL               m_bFit;                     // ͼӦ
	BOOL               m_bCameralink;
	BOOL               m_bPreview;
	bool               IsDhyana1605()     { return m_nPID == 0xE424 || m_nPID == 0xE425; }
	bool               IsDhyana400BSIV3() { return m_nPID == 0xE419 || m_nPID == 0xE420; }
	bool               IsDhyana400DC()    { return m_nPID == 0xEC03; }
	bool               IsDhyana95V2()     { return m_nPID == 0xE40F; }
	bool               IsDhyana401D()     { return m_nPID == 0xE005; }
	bool               IsDhyana95V2New()  { return m_nPID == 0xE40F && m_nBCD >= 0x2000; }
	bool               IsDhyana401DNew()  { return m_nPID == 0xE005 && m_nBCD >= 0x2000; }
	bool               IsDhyanaFL20BW()   { return m_nPID == 0xE40D; }
	bool               IsDhyana201D()     { return m_nPID == 0xE007; }
	bool IsDhyana400BSIV3New() { return IsDhyana400BSIV3() && m_nBCD >= 0x2000; }

	int                m_nImgSize;
	TUCAM_VECBUF       m_vecBuf;                   // ͼ
	int                m_nRamBufCnt;               // ڴ
	BOOL               m_bImgToRam;                // ͼдڴ
	BOOL               m_bImgToDisk;               // ͼдӲ
	int                m_nStackNum;
    int                m_nBufferNum;
    BOOL               m_isVertically;
    int                m_nStackNumCnt;
	BOOL               m_bTimeStamp;
    int m_acqSavedFrames;
    HANDLE m_hToBeSavedFramesEvent;
    CRITICAL_SECTION   m_csToBeSavedFrames;
    std::queue<PTUCAM_RAWIMG_HEADER>  m_toBeSavedFrames;

    HANDLE m_hToBeProcessedFramesEvent;
    CRITICAL_SECTION   m_csToBeProcessedFrames;
    std::queue<PTUCAM_RAWIMG_HEADER>  m_toBeProcessedFrames;

    int m_nodesCount;
    PBUFFER_NODE m_currentNodes;
    TUCAM_VECNODES m_processedNodes;
	bool               m_bFixHeader;
};
