// ImageCapture.cpp : implementation file
//

#include "stdafx.h"
#include "SamplePro.h"
#include "ImageCapture.h"
#include "MoreParameters.h"
//#include "afxdialogex.h"
#include "CompressDialog.h"
#include <io.h>
#include "Raminfo.h"

#define IDT_GET_RECORD_TIME   0x66
#define IDT_SPC_RECORD_TIME   1000  // Interval 1 Second
#define IDT_GET_CAPTURE_MSG   0x67
#define IDT_SPC_CAPTURE_MSG   10   // Interval 0.01 Second

// ImageCapture dialog

IMPLEMENT_DYNAMIC(ImageCapture, CDialog)

ImageCapture::ImageCapture(TUCAM_OPEN &opCam,CCameraControlMode* pParent)
	: CDialog(ImageCapture::IDD, pParent)
	, m_nPicNum(0)
    , m_szPicName(_T(""))
	, m_nStackNum(1)
	, m_nBufferNum(16)
{
	m_opCam                 = opCam;
	m_ccmode                = pParent;
	m_nFmtSave              = 0;
    m_nFmtCnt               = 0;

	m_bSaving               = FALSE;
	m_bRecording            = FALSE;

    m_dwFccHandler          = MAKETAG('D', 'I', 'B', ' ');
    m_dwTimeCnt             = 0;

	m_dwSTm                 = 0;
	m_dwITm                 = 0;
	m_bStopPreviewFlag      = false;
}

ImageCapture::~ImageCapture()
{

}

void ImageCapture::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDT_PATH, m_strFilePath);
	DDX_Text(pDX, IDC_EDT_PICNUM, m_nPicNum);
	DDX_Control(pDX, IDC_CHK_TIF, m_chkTif);
	DDX_Control(pDX, IDC_CHK_RAW, m_chkRaw);
	DDX_Text(pDX, IDC_EDT_PICNAME, m_szPicName);
	DDX_Text(pDX, IDC_EDT_STACKNUM, m_nStackNum);
	DDX_Text(pDX, IDC_EDT_BUFFERNUM, m_nBufferNum);
}


BEGIN_MESSAGE_MAP(ImageCapture, CDialog)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BTN_CAPTURE, &ImageCapture::OnBnClickedBtnCapture)
	ON_BN_CLICKED(IDC_BTN_BROWSE, &ImageCapture::OnBnClickedBtnBrowse)
	ON_BN_CLICKED(IDC_CHK_TIF, &ImageCapture::OnBnClickedChkTif)
	ON_BN_CLICKED(IDC_CHK_RAW, &ImageCapture::OnBnClickedChkRaw)
	ON_BN_CLICKED(IDC_BTN_REC, &ImageCapture::OnBnClickedBtnRec)
	ON_BN_CLICKED(IDC_BTN_CODEC, &ImageCapture::OnBnClickedBtnCodec)
	ON_MESSAGE(TUMSG_CAP, OnTUMessageCap)
    ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_PICNUM, &ImageCapture::OnDeltaposSpnPicnum)
    ON_EN_CHANGE(IDC_EDT_PICNAME, &ImageCapture::OnEnChangeEdtPicname)
    ON_WM_DESTROY()
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_STACKNUM, &ImageCapture::OnDeltaposSpnStacknum)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_BUFFERNUM, &ImageCapture::OnDeltaposSpnBuffernum)
END_MESSAGE_MAP()


// ImageCapture message handlers

void ImageCapture::InitControlRange()
{
	RefreshBtn();
    SetTimer(IDT_GET_CAPTURE_MSG, IDT_SPC_CAPTURE_MSG, NULL);

	/*TUCAM_VALUE_INFO valInfo;
	// ȡUSBӿ
	valInfo.nID = TUIDI_BUS;
	if (TUCAMRET_SUCCESS == TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo))
	{
		if (0x200 == valInfo.nValue || 0x300 == valInfo.nValue)
		{
			GetDlgItem(IDC_STA_BUFFER)->ShowWindow(SW_HIDE);
			GetDlgItem(IDC_EDT_BUFFERNUM)->ShowWindow(SW_HIDE);
			GetDlgItem(IDC_SPN_BUFFERNUM)->ShowWindow(SW_HIDE);
		}
	}*/
}

void ImageCapture::RefreshValue()
{
	// 
	m_strFilePath = m_ccmode->m_strFilePath;
	m_nPicNum = 1;
	m_nFmtCnt = 1;
//	m_nFmtSave = TUFMT_RAW;
//	m_chkTif.SetCheck(FALSE);
//	m_chkRaw.SetCheck(TRUE);
    m_nFmtSave = TUFMT_TIF;
    m_chkTif.SetCheck(TRUE);
    m_chkRaw.SetCheck(FALSE);
	m_szPicName = _T("TS");
	m_ccmode->m_szPicName = m_szPicName;
	m_ccmode->m_nFmtSave  = m_nFmtSave;
	m_ccmode->m_nPicNum   = m_nPicNum;
	m_ccmode->m_nFmtCnt   = m_nFmtCnt;
    m_nIdxFcc             = 0xFF;

	UpdateData(FALSE);
}

void ImageCapture::RefreshOpen(TUCAM_OPEN &opCam)             // ˢ
{
	m_opCam  = opCam;
}
void ImageCapture::RefreshBtn(BOOL bLiving)
{
	//GetDlgItem(IDC_BTN_CAPTURE)->EnableWindow(bLiving);
	GetDlgItem(IDC_BTN_REC)->EnableWindow(bLiving);
}

void ImageCapture::RefreshBtnRaw(BOOL bRaw)
{
	if(bRaw)
		m_chkRaw.EnableWindow(bRaw);
	else
	{
		m_chkRaw.SetCheck(bRaw);      
		m_chkRaw.EnableWindow(bRaw);
	}
}

void ImageCapture::OnTimer(UINT_PTR nIDEvent)
{
    // TODO: ڴϢ/Ĭֵ

    if (IDT_GET_RECORD_TIME == nIDEvent)
    {
        m_dwTimeCnt++;

        CString sz;
        sz.Format(_T("%02d : %02d"), m_dwTimeCnt / 60, m_dwTimeCnt % 60);
        GetDlgItem(IDC_STA_RECTM)->SetWindowText(sz);
    }
    else if (IDT_GET_CAPTURE_MSG == nIDEvent)
    {
        int nCntCap = m_ccmode->m_nCntSave * m_ccmode->m_nFmtCnt;
        int nCntTol = m_ccmode->m_nPicNum * m_ccmode->m_nFmtCnt;
		int i       = m_ccmode->m_nCamIndex;

		m_bSaving = m_ccmode->m_vecSaving[i];

		CString sz;
		if (nCntCap == nCntTol || !m_ccmode->m_bWaitting || (!m_bSaving && !m_ccmode->m_bImgToDisk))
		{
			RefreshCapture();

			if (m_bStopPreviewFlag)
			{
				m_bStopPreviewFlag = false;
				m_ccmode->StopWaitForFrame();
			}
		}
		else
		{
			sz.Format(_T("Capturing %d/%d success!"), nCntCap, nCntTol);
			GetDlgItem(IDC_STA_CAPTURE)->SetWindowText(sz);
			m_bCapture = true;
		}
    }

    CDialog::OnTimer(nIDEvent);
}

LRESULT ImageCapture::OnTUMessageCap(WPARAM wParam, LPARAM lParam)
{
	int nCntCap = (int)lParam * m_ccmode->m_nFmtCnt;
	int nCntTol = m_ccmode->m_nPicNum * m_ccmode->m_nFmtCnt;

	CString sz;
	sz.Format(_T("Capturing %d/%d success!"), nCntCap, nCntTol);
	GetDlgItem(IDC_STA_CAPTURE)->SetWindowText(sz);

	int i = m_ccmode->m_nCamIndex;

	m_bSaving = m_ccmode->m_vecSaving[i];

	if ((nCntCap == nCntTol || !m_ccmode->m_bWaitting || !m_bSaving)/* && TUCCM_SEQUENCE == m_ccmode->m_nTriMode*/)
	{
		Sleep(500);
		RefreshCapture();
        m_ccmode->StopSaveFrames();

		if (m_bStopPreviewFlag)
		{
			m_bStopPreviewFlag = false;
			m_ccmode->StopWaitForFrame();
		}
	}

	return 0;
}

BOOL ImageCapture::PreTranslateMessage(MSG* pMsg)
{
    // TODO: ڴרô/û
    if((pMsg->wParam == VK_ESCAPE))
    {  
        return TRUE;  
    }

    if ((pMsg->message == WM_KEYDOWN) && (pMsg->wParam == VK_RETURN))
    {
        UpdateData();
		
		switch (GetFocus()->GetDlgCtrlID())
		{
		case IDC_EDT_BUFFERNUM:       
			SetBufferNum(m_nBufferNum);
			break;

		case IDC_EDT_STACKNUM:
			m_ccmode->m_nStackNum = max(m_nStackNum, 1);
			m_nStackNum = m_ccmode->m_nStackNum;
			break;

		default:
			break;
		}
        return TRUE;
    }
    
	if(TranslateAccelerator(m_hWnd,m_ccmode->hAccKey,pMsg))  
	{    
		return TRUE;    
	}  
    
    return CDialog::PreTranslateMessage(pMsg);
}

void ImageCapture::OnBnClickedBtnCapture()
{
	// TODO: Add your control notification handler code here
	if (m_ccmode->m_bImgToDisk)
	{
		return;
	}

	UpdateData();
	int i = m_ccmode->m_nCamIndex;

    if (m_bSaving)
    {
		m_bSaving = FALSE;
		
		m_ccmode->m_vecSaving[i] = m_bSaving;

        Sleep(600);

        m_ccmode->StopSaveFrames();

        if (m_ccmode->m_nStackNumCnt >= 0)
        {
            TUCAM_RAWIMG_HEADER frame;
            frame.ucElemBytes = m_ccmode->m_vecframe[i].ucElemBytes;
            frame.usWidth = m_ccmode->m_vecframe[i].usWidth;
            frame.usHeight = m_ccmode->m_vecframe[i].usHeight;

            m_ccmode->CloseMultiFile(&frame);
        }

		RefreshCapture();

		if ((MoreParameters*)m_ccmode->m_tabPage[6] != NULL)
		{
			(MoreParameters*)m_ccmode->m_tabPage[6]->GetDlgItem(IDC_BTN_DEFAULT)->EnableWindow(TRUE);
		}
    }
    else
    {
        m_nStackNum = max(m_nStackNum, 1);

        if (m_nFmtSave & TUFMT_TIF)
        {
            INT64 nMpTifMax = 1;
            nMpTifMax = (4 * 1024 * 1024) / max(1, (m_ccmode->m_nImgSize / 1024));
            m_nStackNum = min(m_nStackNum, nMpTifMax);
        }

        UpdateData(FALSE);

        m_ccmode->m_szPicName = m_szPicName;
        m_ccmode->m_nPicNum   = m_nPicNum;
        m_ccmode->m_nCntSave  = 0;
        m_ccmode->m_uiCapFrames = 1;
        m_ccmode->m_uiCapTimes++;
        m_ccmode->m_nStackNum = m_nStackNum;

        if (m_szPicName == "")
        {
            AfxMessageBox(_T("Capture picture name must be not empty!"));
            return;
        }

        if (!PathIsDirectory(m_strFilePath))
        {
            CreateDirectory(m_strFilePath, NULL);
        }

        if (m_nPicNum > 0 && m_nFmtCnt > 0)
        {
			m_bStopPreviewFlag = !m_ccmode->m_bWaitting;
			if (m_bStopPreviewFlag)
			{
				m_ccmode->StartWaitForFrame();
			}

			m_bSaving = TRUE;
			m_ccmode->m_nCntSave = 0;         // 
			m_ccmode->m_vecSaving[i] = m_bSaving;

            m_ccmode->StartSaveFrames();

            GetDlgItem(IDC_BTN_CAPTURE)->SetWindowText("Stop Capture");
			m_bCapture = true;
			EnableControl(FALSE);
        }
        else
        {
            AfxMessageBox(_T("Capture picture number and format must be more than 1!"));
        }

		if ((MoreParameters*)m_ccmode->m_tabPage[6] != NULL)
		{
			(MoreParameters*)m_ccmode->m_tabPage[6]->GetDlgItem(IDC_BTN_DEFAULT)->EnableWindow(FALSE);
		}
    }
}


void ImageCapture::EnableControl(BOOL bEnable)
{
	GetDlgItem(IDC_BTN_BROWSE)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHK_RAW)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHK_TIF)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDT_PICNAME)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDT_PICNUM)->EnableWindow(bEnable);
	GetDlgItem(IDC_SPN_PICNUM)->EnableWindow(bEnable);

	GetDlgItem(IDC_EDT_STACKNUM)->EnableWindow(bEnable);
	GetDlgItem(IDC_SPN_STACKNUM)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDT_BUFFERNUM)->EnableWindow(bEnable);
	GetDlgItem(IDC_SPN_BUFFERNUM)->EnableWindow(bEnable);
}

size_t ImageCapture::GetTotalRamMB()
{
    MEMORYSTATUSEX status;
    status.dwLength = sizeof(status);
    GlobalMemoryStatusEx(&status);
    // Right shift by 20 bytes converts bytes to megabytes
    return (size_t)(status.ullTotalPhys >> 20);
}

size_t ImageCapture::GetAvailRamMB()
{
    MEMORYSTATUSEX status;
    status.dwLength = sizeof(status);
    GlobalMemoryStatusEx(&status);

#ifndef _WIN64
    UINT64 uiMemFree = (UINT64)(status.ullAvailPhys * 0.7f);
    uiMemFree = min(uiMemFree, 1073741824);

    // Right shift by 20 bytes converts bytes to megabytes
    return (size_t)(uiMemFree >> 20);
#else
    // Right shift by 20 bytes converts bytes to megabytes
    return (size_t)(status.ullAvailPhys >> 20);
#endif
}

void ImageCapture::UpdateToBeSavedFramesMax()
{
    static const size_t totalRamMB = GetTotalRamMB();
    const size_t availRamMB = GetAvailRamMB();
    /* We allow allocation of memory up to bigger value from these:
    - 80% of total RAM
    - whole available RAM reduced by 2048MB (former 1GB limit seemed to
    activate Windows swapping and caused huge performance glitches) */
#ifndef _WIN64
    const size_t dontTouchRamMB = 128;
#else
    const size_t dontTouchRamMB = std::min<size_t>(totalRamMB * (100 - 80) / 100, 2048);
#endif

    const size_t maxFreeRamMB =
        (availRamMB >= dontTouchRamMB) ? availRamMB - dontTouchRamMB : 0;
    // Left shift by 20 bits "converts" megabytes to bytes
    const size_t maxFreeRamBytes = maxFreeRamMB << 20;

    const size_t frameBytes = m_ccmode->m_nImgSize + sizeof(TUCAM_RAWIMG_HEADER) + 1024;
    const size_t maxNewFrameCount = (frameBytes == 0) ? 0 : maxFreeRamBytes / frameBytes;
    
    m_nBufferNumMax = (int)(maxNewFrameCount >> 1);
}

void ImageCapture::SetBufferNum(int nFrames)
{
	BOOL bLiving = m_ccmode->m_bWaitting;

	if (bLiving)
	{
		m_ccmode->StopWaitForFrame();
	}

    UpdateToBeSavedFramesMax();

    m_nBufferNum = max(nFrames, 2);
    m_nBufferNum = min(m_nBufferNum, m_nBufferNumMax);
	TUCAM_TRIGGER_ATTR tgrAttr;
	TUCAM_Cap_GetTrigger(m_opCam.hIdxTUCam, &tgrAttr);
	tgrAttr.nBufFrames = m_nBufferNum;
    m_ccmode->m_nBufferNum = m_nBufferNum;
	// ô
	TUCAM_Cap_SetTrigger(m_opCam.hIdxTUCam, tgrAttr);

	if (bLiving)
	{
		m_ccmode->StartWaitForFrame();
		m_ccmode->UpdataPic();
	}
	UpdateData(FALSE);
}

void ImageCapture::RefreshCapture()
{
	GetDlgItem(IDC_STA_CAPTURE)->SetWindowText("");
	if (m_bCapture)
	{
		m_bCapture = false;
		GetDlgItem(IDC_BTN_CAPTURE)->SetWindowText("Capture");
		EnableControl(TRUE);
	}
}

void ImageCapture::OnBnClickedBtnBrowse()
{
	// TODO: Add your control notification handler code here
	CString szTitle;
    szTitle.LoadString(IDS_SELECT_TITTLE);

    TCHAR szDir[MAX_PATH];
    BROWSEINFO bi; 
    ITEMIDLIST*pidl; 

    bi.hwndOwner	= NULL; 
    bi.pidlRoot		= NULL;
    bi.pszDisplayName = szDir; 
    bi.lpszTitle	= szTitle/*_T("Select a directory")*/; 
    bi.ulFlags		= 80 ;
//  bi.ulFlags		= BIF_RETURNONLYFSDIRS/*80*/; 
    bi.lpfn			= NULL; 
    bi.lParam		= 0; 
    bi.iImage		= 0;

    pidl = SHBrowseForFolder(&bi);

    if (pidl && SHGetPathFromIDList(pidl, szDir))
    {
        if (szDir[3]) _tcscat(szDir, _T("\\"));		
        GetDlgItem(IDC_EDT_PATH)->SetWindowText(szDir);
        m_strFilePath = szDir;
		m_ccmode->m_strFilePath =m_strFilePath;
    }
}  



void ImageCapture::OnBnClickedChkTif()
{
	// TODO: Add your control notification handler code here
	/*if (m_chkTif.GetCheck())
	{
		m_nFmtSave |= TUFMT_TIF;
		m_nFmtCnt++;
	}
	else
	{
		m_nFmtSave &= ~TUFMT_TIF;
		m_nFmtCnt--;
	}
	m_ccmode->m_nFmtSave  = m_nFmtSave;
	m_ccmode->m_nFmtCnt   = m_nFmtCnt;*/

	if (m_chkTif.GetCheck())
	{
		m_nFmtSave = TUFMT_TIF;
		m_nFmtCnt  = 1;
		m_chkRaw.SetCheck(FALSE);
	}
	else
	{
		m_nFmtSave &= ~TUFMT_TIF;
		m_nFmtCnt = 0;
	}
	m_ccmode->m_nFmtSave = m_nFmtSave;
	m_ccmode->m_nFmtCnt = m_nFmtCnt;
}


void ImageCapture::OnBnClickedChkRaw()
{
	// TODO: Add your control notification handler code here
	/*if (m_chkRaw.GetCheck())
	{
		m_nFmtSave |= TUFMT_RAW;
		m_nFmtCnt++;
	}
	else
	{
		m_nFmtSave &= ~TUFMT_RAW;
		m_nFmtCnt--;
	}
	m_ccmode->m_nFmtSave  = m_nFmtSave;
	m_ccmode->m_nFmtCnt   = m_nFmtCnt;*/

	if (m_chkRaw.GetCheck())
	{
		m_nFmtSave = TUFMT_RAW;
		m_nFmtCnt  = 1;
		m_chkTif.SetCheck(FALSE);
	}
	else
	{
		m_nFmtSave &= ~TUFMT_RAW;
		m_nFmtCnt = 0;
	}
	m_ccmode->m_nFmtSave = m_nFmtSave;
	m_ccmode->m_nFmtCnt = m_nFmtCnt;
}


void ImageCapture::OnBnClickedBtnRec()
{
	// TODO: Add your control notification handler code here
    UpdateData();
    m_ccmode->m_szPicName = m_szPicName;

	if (m_ccmode->m_bRecording)
    {	
        m_ccmode->OnBtnRecord();
        KillTimer(IDT_GET_RECORD_TIME);
        SetDlgItemText(IDC_BTN_REC, _T("Record"));
        SetDlgItemText(IDC_STA_RECTM, _T(""));

		GetDlgItem(IDC_BTN_CODEC)->EnableWindow(TRUE);
		GetDlgItem(IDC_BTN_BROWSE)->EnableWindow(TRUE); 
		GetDlgItem(IDC_EDT_PICNAME)->EnableWindow(TRUE);
        GetDlgItem(IDC_BTN_CAPTURE)->EnableWindow(TRUE);  

		GetDlgItem(IDC_EDT_STACKNUM)->EnableWindow(TRUE);
		GetDlgItem(IDC_SPN_STACKNUM)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDT_BUFFERNUM)->EnableWindow(TRUE);
		GetDlgItem(IDC_SPN_BUFFERNUM)->EnableWindow(TRUE);
    }
	else  
	{
		m_dwTimeCnt = 0;
        m_ccmode->m_uiRecTimes++;
		m_ccmode->OnBtnRecord();
		SetDlgItemText(IDC_BTN_REC, _T("Stop Record"));                   
		SetTimer(IDT_GET_RECORD_TIME, IDT_SPC_RECORD_TIME, NULL);

		GetDlgItem(IDC_BTN_CODEC)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_BROWSE)->EnableWindow(FALSE); 
		GetDlgItem(IDC_EDT_PICNAME)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_CAPTURE)->EnableWindow(FALSE); 

		GetDlgItem(IDC_EDT_STACKNUM)->EnableWindow(FALSE);
		GetDlgItem(IDC_SPN_STACKNUM)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDT_BUFFERNUM)->EnableWindow(FALSE);
		GetDlgItem(IDC_SPN_BUFFERNUM)->EnableWindow(FALSE);
	}
}


void ImageCapture::OnBnClickedBtnCodec()
{
	// TODO: Add your control notification handler code here
	CCompressDialog dlgCompress;

    dlgCompress.m_nIdxFcc = m_nIdxFcc;
    if (IDOK == dlgCompress.DoModal())
    {
        m_dwFccHandler = dlgCompress.GetCompressorFccHandler();
        m_nIdxFcc      = dlgCompress.GetCurrentFcc();
		m_ccmode->m_dwFccHandler = m_dwFccHandler;
    }
}

void ImageCapture::OnDeltaposSpnPicnum(NMHDR *pNMHDR, LRESULT *pResult)
{
    LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
    // TODO: ڴӿؼ֪ͨ

    m_nPicNum = GetDlgItemInt(IDC_EDT_PICNUM);

    if (pNMUpDown->iDelta < 0)
    {
        if (m_nPicNum >= 999)
        {
            return;
        }
        m_nPicNum += 1;

        CString strUs;
        strUs.Format(_T("%d"), m_nPicNum);
        GetDlgItem(IDC_EDT_PICNUM)->SetWindowText(strUs);
    }
    else if (pNMUpDown->iDelta > 0)
    {
        if (m_nPicNum == 0)
        {
            return;
        }

        if (m_nPicNum < 2)
        {
            m_nPicNum = 1;
        }
        else
        {
            m_nPicNum -= 1;
        }       

        CString strUs;
        strUs.Format(_T("%d"), m_nPicNum);
        GetDlgItem(IDC_EDT_PICNUM)->SetWindowText(strUs);
    }

    *pResult = 0;
}

void ImageCapture::OnEnChangeEdtPicname()
{
    // TODO:  ÿؼ RICHEDIT ؼ
    // ʹ֪ͨд CDialog::OnInitDialog()
    //  CRichEditCtrl().SetEventMask()
    // ͬʱ ENM_CHANGE ־㵽С

    // TODO:  ڴӿؼ֪ͨ

    CString szTemp = m_szPicName;

    UpdateData();

//  GetDlgItem(IDC_EDT_PICNUM)->GetWindowText(szTemp);

    if (-1 != m_szPicName.Find('\\') || -1 != m_szPicName.Find('/') || -1 != m_szPicName.Find(':') || -1 != m_szPicName.Find('?') || -1 != m_szPicName.Find('<') || -1 != m_szPicName.Find('>') || -1 != m_szPicName.Find('|') || -1 != m_szPicName.Find(','))
    {
        m_szPicName = szTemp;
        UpdateData(FALSE);
    }        
}

void ImageCapture::OnDestroy()
{
    CDialog::OnDestroy();

    // TODO: ڴ˴Ϣ
   KillTimer(IDT_GET_CAPTURE_MSG);
}


void ImageCapture::OnDeltaposSpnStacknum(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO:  ڴӿؼ֪ͨ

	m_nStackNum = GetDlgItemInt(IDC_EDT_STACKNUM);

	if (pNMUpDown->iDelta < 0)
	{
		m_nStackNum += 1;

		CString strUs;
		strUs.Format(_T("%d"), m_nStackNum);
		GetDlgItem(IDC_EDT_STACKNUM)->SetWindowText(strUs);
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_nStackNum == 1)
		{
			return;
		}

		if (m_nStackNum < 2)
		{
			m_nStackNum = 1;
		}
		else
		{
			m_nStackNum -= 1;
		}

		CString strUs;
		strUs.Format(_T("%d"), m_nStackNum);
		GetDlgItem(IDC_EDT_STACKNUM)->SetWindowText(strUs);
	}
	m_ccmode->m_nStackNum = m_nStackNum;
	*pResult = 0;
}


void ImageCapture::OnDeltaposSpnBuffernum(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// m_nBufferNum:  ڴӿؼ֪ͨ
	m_nBufferNum = GetDlgItemInt(IDC_EDT_BUFFERNUM);

	if (pNMUpDown->iDelta < 0)
	{
		/*if (m_nBufferNum >= m_nPicNum)
		{
			return;
		}*/
		m_nBufferNum += 1;

		CString strUs;
		strUs.Format(_T("%d"), m_nBufferNum);
		GetDlgItem(IDC_EDT_BUFFERNUM)->SetWindowText(strUs);
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_nBufferNum == 1)
		{
			return;
		}

		if (m_nBufferNum < 2)
		{
			m_nBufferNum = 1;
		}
		else
		{
			m_nBufferNum -= 1;
		}

		CString strUs;
		strUs.Format(_T("%d"), m_nBufferNum);
		GetDlgItem(IDC_EDT_BUFFERNUM)->SetWindowText(strUs);
	}

	SetBufferNum(m_nBufferNum);
	*pResult = 0;
}
