// ROI.cpp : implementation file
//

#include "stdafx.h"
#include "SamplePro.h"
#include "Information.h"
//#include "afxdialogex.h"

// Information dialog

IMPLEMENT_DYNAMIC(Information, CDialog)

Information::Information(TUCAM_OPEN &opCam, CCameraControlMode* pParent)
	: CDialog(Information::IDD, pParent)
{
	m_opCam                 = opCam;
	m_ccmode                = pParent;
}

//Information::~Information()
//{
//}

void Information::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//DDX_Control(pDX, IDC_DLGTUCAMABOUT, m_lvStrings);
	DDX_Control(pDX, IDC_CMB_CAMINDEX, m_cmbCamIndex);
}


BEGIN_MESSAGE_MAP(Information, CDialog)
	ON_CBN_SELCHANGE(IDC_CMB_CAMINDEX, &Information::OnCbnSelchangeCmbCamindex)
END_MESSAGE_MAP()

BOOL Information::OnInitDialog() 
{
	CDialog::OnInitDialog();

	if (NULL != m_opCam.hIdxTUCam)
	{
		BOOL    bShowFW = TRUE;
		BOOL    bCameralink = FALSE;
		CString sz;
		TUCAM_VALUE_INFO valInfo;

		// ȡ
		valInfo.nID = TUIDI_CAMERA_MODEL;
		if (TUCAMRET_SUCCESS == TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo))
		{
			sz = valInfo.pText;
			GetDlgItem(IDC_STA_CAMERA)->SetWindowText(sz);
		}

		// ȡ
		m_cmbCamIndex.ResetContent();
		CString szCam;
		for (UINT i=0; i<m_ccmode->m_itApi.uiCamCount; ++i)
		{
			TUCAM_Dev_GetInfo(m_ccmode->m_vecopCam[i].hIdxTUCam, &valInfo);
			sz = valInfo.pText;
			szCam.Format("_%d",i+1);
			szCam = sz + szCam;
			m_cmbCamIndex.InsertString(i, szCam);
		}
		m_cmbCamIndex.SetCurSel(0);

		// ȡ̼汾
		valInfo.nID = TUIDI_VERSION_FRMW;
		if (TUCAMRET_SUCCESS == TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo))
		{
			sz.Format("%x",valInfo.nValue);
			GetDlgItem(IDC_STA_FW)->SetWindowText(sz);
		} 

		// ȡTUCAM-API汾
		valInfo.nID = TUIDI_VERSION_API;
		if (TUCAMRET_SUCCESS == TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo))
		{
			sz = valInfo.pText;
			GetDlgItem(IDC_STA_SDKS)->SetWindowText(sz);
		}

		// ȡUSBӿ
		valInfo.nID = TUIDI_BUS;
		if (TUCAMRET_SUCCESS == TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo))
		{
			if (0x200 == valInfo.nValue || 0x210 == valInfo.nValue)
			{
				GetDlgItem(IDC_STA_USB)->SetWindowText("2.0");
			}
			else if(0x03 == valInfo.nValue)
			{
				GetDlgItem(IDC_STA_USBNAME)->SetWindowText("CameraLink");
				GetDlgItem(IDC_STA_USB)->SetWindowText("FireBird");
				bCameralink = TRUE;
			}
			else if(0x04 == valInfo.nValue)
			{
				GetDlgItem(IDC_STA_USBNAME)->SetWindowText("CameraLink");
				GetDlgItem(IDC_STA_USB)->SetWindowText("Euresys");
				bCameralink = TRUE;
			}
			else
			{
				GetDlgItem(IDC_STA_USB)->SetWindowText("3.0");
			}

		}

		// ȡSNֵ
		char cSN[TUSN_SIZE] = {0};

		TUCAM_REG_RW regRW;
		regRW.nRegType= TUREG_SN;
		regRW.pBuf    = &cSN[0];
		regRW.nBufSize= TUSN_SIZE;

		if (TUCAMRET_SUCCESS == TUCAM_Reg_Read(m_opCam.hIdxTUCam, regRW))
		{
			GetDlgItem(IDC_STA_SN)->SetWindowText(cSN);
		}

		if (bCameralink)
		{
			if (m_ccmode->IsDhyana1605() || m_ccmode->IsDhyana95V2New() || m_ccmode->IsDhyana401DNew() || m_ccmode->IsDhyana400BSIV3New())
			{
				bShowFW = TRUE;
			}
			else
			{
				bShowFW = FALSE;
			}
		}

		if (!bShowFW)
		{
			GetDlgItem(IDC_STA_SNNAME)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_FWNAME)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_SN)->ShowWindow(SW_HIDE);
			GetDlgItem(IDC_STA_FW)->ShowWindow(SW_HIDE);
		}
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void Information::InitInformationNone()
{
	GetDlgItem(IDC_STA_CAMERA)->SetWindowText("");
	GetDlgItem(IDC_STA_FW)->SetWindowText("");
	GetDlgItem(IDC_STA_USB)->SetWindowText("");
	GetDlgItem(IDC_STA_SN)->SetWindowText("");
}

// Information message handlers
void Information::InitInformation()
{
    if (NULL != m_opCam.hIdxTUCam)
    {
		BOOL    bShowFW = TRUE;
		BOOL    bCameralink = FALSE;
        CString sz;
        TUCAM_VALUE_INFO valInfo;

        // ȡ
        valInfo.nID = TUIDI_CAMERA_MODEL;
        if (TUCAMRET_SUCCESS == TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo))
        {
            sz = valInfo.pText;
            GetDlgItem(IDC_STA_CAMERA)->SetWindowText(sz);
        }

        // ȡ̼汾
        valInfo.nID = TUIDI_VERSION_FRMW;
        if (TUCAMRET_SUCCESS == TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo))
        {
			if (0 != valInfo.nValue)
			{
				sz.Format("%x",valInfo.nValue);
				GetDlgItem(IDC_STA_FW)->SetWindowText(sz);
			}
			else
			{
				sz = valInfo.pText;

				if (sz.GetLength() > 12)
				{
					sz.Insert(sz.GetLength() / 2, "\n");
				}

				GetDlgItem(IDC_STA_FW)->SetWindowText(sz/*valInfo.pText*/);
			}
        } 
        
        // ȡTUCAM-API汾
        valInfo.nID = TUIDI_VERSION_API;
        if (TUCAMRET_SUCCESS == TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo))
        {
            sz = valInfo.pText;
            GetDlgItem(IDC_STA_SDKS)->SetWindowText(sz);
        }

        // ȡUSBӿ
        valInfo.nID = TUIDI_BUS;
        if (TUCAMRET_SUCCESS == TUCAM_Dev_GetInfo(m_opCam.hIdxTUCam, &valInfo))
        {
            if (0x210 == valInfo.nValue)
            {
                 GetDlgItem(IDC_STA_USB)->SetWindowText("2.0");
            }
			else if(0x03 == valInfo.nValue)
			{
				GetDlgItem(IDC_STA_USBNAME)->SetWindowText("CameraLink");
				GetDlgItem(IDC_STA_USB)->SetWindowText("FireBird");
				bCameralink = TRUE;
			}
			else if(0x04 == valInfo.nValue)
			{
				GetDlgItem(IDC_STA_USBNAME)->SetWindowText("CameraLink");
				GetDlgItem(IDC_STA_USB)->SetWindowText("Euresys");
				bCameralink = TRUE;
			}
            else
            {
                GetDlgItem(IDC_STA_USB)->SetWindowText("3.0");
            }
        }

        // ȡSNֵ
        char cSN[TUSN_SIZE] = {0};

        TUCAM_REG_RW regRW;
        regRW.nRegType= TUREG_SN;
        regRW.pBuf    = &cSN[0];
        regRW.nBufSize= TUSN_SIZE;

        if (TUCAMRET_SUCCESS == TUCAM_Reg_Read(m_opCam.hIdxTUCam, regRW))
        {
            GetDlgItem(IDC_STA_SN)->SetWindowText(cSN);
        }

		if (bCameralink)
		{
			if (m_ccmode->IsDhyana1605() || m_ccmode->IsDhyana95V2New() || m_ccmode->IsDhyana401DNew() || m_ccmode->IsDhyana400BSIV3New())
			{
				bShowFW = TRUE;
			}
			else
			{
				bShowFW = FALSE;
			}
		}

		if (!bShowFW)
		{
			GetDlgItem(IDC_STA_SNNAME)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_FWNAME)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_SN)->ShowWindow(SW_HIDE);
			GetDlgItem(IDC_STA_FW)->ShowWindow(SW_HIDE);
		}

		m_ccmode->m_bCameralink = bCameralink;
    }

	// ʼ
	//m_fntEdit.CreatePointFont(130, _T("Arial"));
    //GetDlgItem(IDC_STA_INFO)->SetFont(&m_fntEdit);
}

void Information::InitControlRange()                          // ʼΧ
{

}

void Information::RefreshValue()                             // ʼֵ
{

}

void Information::RefreshOpen(TUCAM_OPEN &opCam)             // ˢ
{
	m_opCam  = opCam;
}

BOOL Information::PreTranslateMessage(MSG* pMsg)
{
    // TODO: ڴרô/û
    if((pMsg->wParam == VK_ESCAPE))
    {  
        return TRUE;  
    }

    if ((pMsg->wParam == VK_RETURN))
    {
        //UpdateData();
        return TRUE;
    }

    return CDialog::PreTranslateMessage(pMsg);
}

void Information::OnCbnSelchangeCmbCamindex()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	int nVal = m_cmbCamIndex.GetCurSel();
	m_ccmode->ChangeCamIndex(nVal);
}
