#pragma once
class MemoryManager
{
public:
	enum MEMORY_SET_MODE
	{
		ACTUAL = 0,
		PERCENT = 1
	};
	~MemoryManager();
	static MemoryManager *GetInstance();

	void UpdateCurrentPhysicalMemory();
	double GetTotalPhysicalMemoryGB();
	double GetAvailablePhysicalMemoryGB();

	double GetActualPhysicalMemoryGB();
	void SetActualPhysicalMemoryGB(double value) { actualPhysicalMemoryGB = value; }

	int GetPhysicalMemoryPercent() { return physicalMemoryPercent; }
	void SetPhysicalMemoryPercent(int value) { physicalMemoryPercent = value; }

	int GetMemorySetMode() { return memorySetMode; }
	void SetMemorySetMode(MEMORY_SET_MODE mode) { memorySetMode = mode; }

	void SetImageSize(int size) { imageSize = size; }
	int CalculateFrameNumber();

private:
	static MemoryManager *instance;
	MemoryManager();

	BOOL GetSystemMemorySize(UINT64 &uiMemTotal, UINT64 &uiMemFree);
	
	UINT64 totalPhysicalMemory;
	UINT64 availablePhysicalMemory;

	bool memorySetMode;
	double actualPhysicalMemoryGB;
	int physicalMemoryPercent;

	int imageSize;
};

