// OutputTrigger.cpp : ʵļ
//

#include "stdafx.h"
#include "SamplePro.h"
#include "OutputTrigger.h"


// OutputTrigger Ի

IMPLEMENT_DYNAMIC(OutputTrigger, CDialog)

OutputTrigger::OutputTrigger(TUCAM_OPEN &opCam,CCameraControlMode* pParent)
	: CDialog(OutputTrigger::IDD, pParent)
	, m_nTgrPort(0)
	, m_nKind(0)
	, m_nEdge(0)
	, m_nDelay(0)
	, m_nWidth(0)
	, m_uDSec(0)
	, m_uDMs(0)
	, m_uDUs(0)
	, m_uWSec(0)
	, m_uWMs(0)
	, m_uWUs(0)
	, m_bTriggerOutEn(FALSE)
{
	m_opCam                 = opCam;
	m_ccmode                = pParent;

	m_bDSecChange           = TRUE;
	m_bDMsChange            = TRUE;
	m_bDUsChange            = TRUE;
	m_bWSecChange           = TRUE;
	m_bWMsChange            = TRUE;
	m_bWUsChange            = TRUE;

	m_tgrOutAttr.nTgrOutPort= 0;
	m_tgrOutAttr.TgrPort1.nTgrOutMode = 5;
	m_tgrOutAttr.TgrPort1.nEdgeMode = 0;
	m_tgrOutAttr.TgrPort1.nDelayTm = 0;
	m_tgrOutAttr.TgrPort1.nWidth = 5000;


	m_tgrOutAttr.TgrPort2.nTgrOutMode = 4;
	m_tgrOutAttr.TgrPort2.nEdgeMode = 0;
	m_tgrOutAttr.TgrPort2.nDelayTm = 0;
	m_tgrOutAttr.TgrPort2.nWidth = 5000;

	m_tgrOutAttr.TgrPort3.nTgrOutMode = 3;
	m_tgrOutAttr.TgrPort3.nEdgeMode = 0;
	m_tgrOutAttr.TgrPort3.nDelayTm = 0;
	m_tgrOutAttr.TgrPort3.nWidth = 5000;

}

//OutputTrigger::~OutputTrigger()
//{
//}

void OutputTrigger::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDT_DSEC, m_uDSec);
	DDX_Text(pDX, IDC_EDT_DMS, m_uDMs);
	DDX_Text(pDX, IDC_EDT_DUS, m_uDUs);
	DDX_Text(pDX, IDC_EDT_WSEC, m_uWSec);
	DDX_Text(pDX, IDC_EDT_WMS, m_uWMs);
	DDX_Text(pDX, IDC_EDT_WUS, m_uWUs);
	DDX_Control(pDX, IDC_CMB_PORT, m_cmbPort);
	DDV_MinMaxUInt(pDX, m_uDUs, 0, 999);
	DDX_Check(pDX, IDC_CHK_TRIOENABLE, m_bTriggerOutEn);
}


BEGIN_MESSAGE_MAP(OutputTrigger, CDialog)
	ON_CBN_SELCHANGE(IDC_CMB_PORT, &OutputTrigger::OnCbnSelchangeCmbPort)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_DSEC, &OutputTrigger::OnDeltaposSpnDsec)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_DMS, &OutputTrigger::OnDeltaposSpnDms)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_DUS, &OutputTrigger::OnDeltaposSpnDus)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_WSEC, &OutputTrigger::OnDeltaposSpnWsec)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_WMS, &OutputTrigger::OnDeltaposSpnWms)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_WUS, &OutputTrigger::OnDeltaposSpnWus)
	ON_BN_CLICKED(IDC_RADIO_EXPSTART, &OutputTrigger::OnBnClickedRadioExpstart)
	ON_BN_CLICKED(IDC_RADIO_READEND, &OutputTrigger::OnBnClickedRadioReadend)
	ON_BN_CLICKED(IDC_RADIO_GLOEXP, &OutputTrigger::OnBnClickedRadioGloexp)
	ON_BN_CLICKED(IDC_RADIO_LOW, &OutputTrigger::OnBnClickedRadioLow)
	ON_BN_CLICKED(IDC_RADIO_HIGH, &OutputTrigger::OnBnClickedRadioHigh)
	ON_BN_CLICKED(IDC_RADIO_RISE, &OutputTrigger::OnBnClickedRadioRise)
	ON_BN_CLICKED(IDC_RADIO_FALL, &OutputTrigger::OnBnClickedRadioFall)
	ON_EN_CHANGE(IDC_EDT_DUS, &OutputTrigger::OnEnChangeEdtDus)
	ON_EN_CHANGE(IDC_EDT_DMS, &OutputTrigger::OnEnChangeEdtDms)
	ON_EN_CHANGE(IDC_EDT_DSEC, &OutputTrigger::OnEnChangeEdtDsec)
	ON_EN_CHANGE(IDC_EDT_WUS, &OutputTrigger::OnEnChangeEdtWus)
	ON_EN_CHANGE(IDC_EDT_WMS, &OutputTrigger::OnEnChangeEdtWms)
	ON_EN_CHANGE(IDC_EDT_WSEC, &OutputTrigger::OnEnChangeEdtWsec)
	ON_BN_CLICKED(IDC_CHK_TRIOENABLE, &OutputTrigger::OnBnClickedChkTrioenable)
	ON_BN_CLICKED(IDC_RADIO_TRIREADY, &OutputTrigger::OnBnClickedRadioTriready)
END_MESSAGE_MAP()


// OutputTrigger Ϣ

void OutputTrigger::InitControlRange()                        // ʼΧ
{
	TUCAM_TRGOUT_ATTR tgrOutAttr;
	INT nPortCnt = 3;
	if (TUCAMRET_SUCCESS == TUCAM_Cap_GetTriggerOut(m_opCam.hIdxTUCam, &tgrOutAttr))
	{
		EnableOutPutTriggerControl(TRUE);

		if (m_ccmode->IsDhyanaFL20BW() || m_ccmode->IsDhyana401D() || m_ccmode->IsDhyana201D())
		{
			nPortCnt = 2;
			if (!m_ccmode->IsDhyana401DNew())
			{
				GetDlgItem(IDC_RADIO_EXPSTART)->EnableWindow(FALSE);
				GetDlgItem(IDC_RADIO_READEND)->EnableWindow(FALSE);
				GetDlgItem(IDC_RADIO_GLOEXP)->EnableWindow(FALSE);
				GetDlgItem(IDC_RADIO_LOW)->EnableWindow(FALSE);
				GetDlgItem(IDC_RADIO_HIGH)->EnableWindow(FALSE);
			}
		}

		m_cmbPort.ResetContent();
		for (int i=0; i<nPortCnt; ++i)
		{
			switch (i)
			{
			case 1:
				m_cmbPort.InsertString(i, "2");
				break;

			case 2:
				m_cmbPort.InsertString(i, "3");
				break;
			
			case 0:
			default:
				m_cmbPort.InsertString(i, "1");
				break;
			}
		}

		m_cmbPort.SetCurSel(0);
	}
	else
	{
		EnableOutPutTriggerControl(FALSE);
	}
}

void OutputTrigger::RefreshValue()                            // ʼֵ
{
	// ȡ
	TUCAM_TRGOUT_ATTR tgrOutAttr;

	if (TUCAMRET_SUCCESS == TUCAM_Cap_GetTriggerOut(m_opCam.hIdxTUCam, &tgrOutAttr))
	{
		m_tgrOutAttr.nTgrOutPort = tgrOutAttr.nTgrOutPort;
		switch(tgrOutAttr.nTgrOutPort)
		{
		case TUPORT_ONE:
			m_tgrOutAttr.TgrPort1.nTgrOutMode = tgrOutAttr.nTgrOutMode;
			m_tgrOutAttr.TgrPort1.nEdgeMode = tgrOutAttr.nEdgeMode;
			m_tgrOutAttr.TgrPort1.nDelayTm = tgrOutAttr.nDelayTm;
			m_tgrOutAttr.TgrPort1.nWidth = tgrOutAttr.nWidth;
			break;

		case TUPORT_TWO:
			m_tgrOutAttr.TgrPort2.nTgrOutMode = tgrOutAttr.nTgrOutMode;
			m_tgrOutAttr.TgrPort2.nEdgeMode = tgrOutAttr.nEdgeMode;
			m_tgrOutAttr.TgrPort2.nDelayTm = tgrOutAttr.nDelayTm;
			m_tgrOutAttr.TgrPort2.nWidth = tgrOutAttr.nWidth;
			break;

		case TUPORT_THREE:
			m_tgrOutAttr.TgrPort3.nTgrOutMode = tgrOutAttr.nTgrOutMode;
			m_tgrOutAttr.TgrPort3.nEdgeMode = tgrOutAttr.nEdgeMode;
			m_tgrOutAttr.TgrPort3.nDelayTm = tgrOutAttr.nDelayTm;
			m_tgrOutAttr.TgrPort3.nWidth = tgrOutAttr.nWidth;
			break;
		default:
			break;
		}	

		m_nTgrPort = tgrOutAttr.nTgrOutPort;
		m_nKind    = tgrOutAttr.nTgrOutMode;
		m_nEdge    = tgrOutAttr.nEdgeMode;
		m_nDelay   = tgrOutAttr.nDelayTm;
		m_nWidth   = tgrOutAttr.nWidth;

		if (m_ccmode->IsDhyanaFL20BW() || m_ccmode->IsDhyana401D() || m_ccmode->IsDhyana201D())
		{
			m_tgrOutAttr.TgrPort1.nTgrOutMode = TUOPT_READEND;
			m_tgrOutAttr.TgrPort2.nTgrOutMode = TUOPT_EXPSTART;
			m_nKind = (0 == tgrOutAttr.nTgrOutPort) ? TUOPT_READEND : TUOPT_EXPSTART;
		}

		m_cmbPort.SetCurSel(m_nTgrPort);

		UpdateDelayTime(m_nDelay);

		UpdateWidth(m_nWidth);

		UpdateRadio();

		EnableControl(m_nKind);

		// 
		int     nVal = 0;
		// ȡǰʹֵ
		if (TUCAMRET_SUCCESS == TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, TUIDC_ENABLETRIOUT, &nVal))
		{
			m_bTriggerOutEn = (BOOL)nVal;
			UpdateData(FALSE);
		}
	}
}

void OutputTrigger::RefreshOpen(TUCAM_OPEN &opCam)             // ˢ
{
	m_opCam  = opCam;
}
BOOL OutputTrigger::PreTranslateMessage(MSG* pMsg)
{
	// TODO: ڴרô/û
	if((pMsg->wParam == VK_ESCAPE))
	{  
		return TRUE;  
	}

	if ((pMsg->wParam == VK_RETURN))
	{
		UpdateData();
		return TRUE;
	}

	if(TranslateAccelerator(m_hWnd,m_ccmode->hAccKey,pMsg))  
	{    
		return TRUE;    
	}  

	return CDialog::PreTranslateMessage(pMsg);
}

void OutputTrigger::EnableOutPutTriggerControl(BOOL bEnable /*= FALSE*/)
{
	GetDlgItem(IDC_STA_PORT)->EnableWindow(bEnable);
	GetDlgItem(IDC_CMB_PORT)->EnableWindow(bEnable);
	GetDlgItem(IDC_RADIO_EXPSTART)->EnableWindow(bEnable);
	GetDlgItem(IDC_RADIO_READEND)->EnableWindow(bEnable);
	GetDlgItem(IDC_RADIO_GLOEXP)->EnableWindow(bEnable);
	GetDlgItem(IDC_RADIO_LOW)->EnableWindow(bEnable);
	GetDlgItem(IDC_RADIO_HIGH)->EnableWindow(bEnable);
	GetDlgItem(IDC_RADIO_RISE)->EnableWindow(bEnable);
	GetDlgItem(IDC_RADIO_FALL)->EnableWindow(bEnable);

	GetDlgItem(IDC_STA_OUTDELAY)->EnableWindow(bEnable);
	GetDlgItem(IDC_STA_DSEC)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDT_DSEC)->EnableWindow(bEnable);
	GetDlgItem(IDC_SPN_DSEC)->EnableWindow(bEnable);
	GetDlgItem(IDC_STA_DMS)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDT_DMS)->EnableWindow(bEnable);
	GetDlgItem(IDC_SPN_DMS)->EnableWindow(bEnable);
	GetDlgItem(IDC_STA_DUS)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDT_DUS)->EnableWindow(bEnable);
	GetDlgItem(IDC_SPN_DUS)->EnableWindow(bEnable);

	GetDlgItem(IDC_STA_WIDTH)->EnableWindow(bEnable);
	GetDlgItem(IDC_STA_WSEC)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDT_WSEC)->EnableWindow(bEnable);
	GetDlgItem(IDC_SPN_WSEC)->EnableWindow(bEnable);
	GetDlgItem(IDC_STA_WMS)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDT_WMS)->EnableWindow(bEnable);
	GetDlgItem(IDC_SPN_WMS)->EnableWindow(bEnable);
	GetDlgItem(IDC_STA_WUS)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDT_WUS)->EnableWindow(bEnable);
	GetDlgItem(IDC_SPN_WUS)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHK_TRIOENABLE)->EnableWindow(bEnable);
    GetDlgItem(IDC_RADIO_TRIREADY)->EnableWindow(bEnable);
}

void OutputTrigger::EnableControl(INT nKind)  // ģʽлʹ
{
	switch (nKind)
	{
	case TUOPT_GND:
	case TUOPT_VCC:
		{
			GetDlgItem(IDC_RADIO_RISE)->EnableWindow(FALSE);
			GetDlgItem(IDC_RADIO_FALL)->EnableWindow(FALSE);

			GetDlgItem(IDC_STA_OUTDELAY)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_DSEC)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_DSEC)->EnableWindow(FALSE);
			GetDlgItem(IDC_SPN_DSEC)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_DMS)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_DMS)->EnableWindow(FALSE);
			GetDlgItem(IDC_SPN_DMS)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_DUS)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_DUS)->EnableWindow(FALSE);
			GetDlgItem(IDC_SPN_DUS)->EnableWindow(FALSE);

			GetDlgItem(IDC_STA_WIDTH)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_WSEC)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_WSEC)->EnableWindow(FALSE);
			GetDlgItem(IDC_SPN_WSEC)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_WMS)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_WMS)->EnableWindow(FALSE);
			GetDlgItem(IDC_SPN_WMS)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_WUS)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_WUS)->EnableWindow(FALSE);
			GetDlgItem(IDC_SPN_WUS)->EnableWindow(FALSE);
		}
		break;
	case TUOPT_EXPGLOBAL:
	case TUOPT_TRIREADY:
		{
			GetDlgItem(IDC_RADIO_RISE)->EnableWindow(TRUE);
			GetDlgItem(IDC_RADIO_FALL)->EnableWindow(TRUE);

			GetDlgItem(IDC_STA_OUTDELAY)->EnableWindow(TRUE);
			GetDlgItem(IDC_STA_DSEC)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDT_DSEC)->EnableWindow(TRUE);
			GetDlgItem(IDC_SPN_DSEC)->EnableWindow(TRUE);
			GetDlgItem(IDC_STA_DMS)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDT_DMS)->EnableWindow(TRUE);
			GetDlgItem(IDC_SPN_DMS)->EnableWindow(TRUE);
			GetDlgItem(IDC_STA_DUS)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDT_DUS)->EnableWindow(TRUE);
			GetDlgItem(IDC_SPN_DUS)->EnableWindow(TRUE);

			GetDlgItem(IDC_STA_WIDTH)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_WSEC)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_WSEC)->EnableWindow(FALSE);
			GetDlgItem(IDC_SPN_WSEC)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_WMS)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_WMS)->EnableWindow(FALSE);
			GetDlgItem(IDC_SPN_WMS)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_WUS)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_WUS)->EnableWindow(FALSE);
			GetDlgItem(IDC_SPN_WUS)->EnableWindow(FALSE);
		}
		break;
	default:
		{
			GetDlgItem(IDC_RADIO_RISE)->EnableWindow(TRUE);
			GetDlgItem(IDC_RADIO_FALL)->EnableWindow(TRUE);

			GetDlgItem(IDC_STA_OUTDELAY)->EnableWindow(TRUE);
			GetDlgItem(IDC_STA_DSEC)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDT_DSEC)->EnableWindow(TRUE);
			GetDlgItem(IDC_SPN_DSEC)->EnableWindow(TRUE);
			GetDlgItem(IDC_STA_DMS)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDT_DMS)->EnableWindow(TRUE);
			GetDlgItem(IDC_SPN_DMS)->EnableWindow(TRUE);
			GetDlgItem(IDC_STA_DUS)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDT_DUS)->EnableWindow(TRUE);
			GetDlgItem(IDC_SPN_DUS)->EnableWindow(TRUE);

			GetDlgItem(IDC_STA_WIDTH)->EnableWindow(TRUE);
			GetDlgItem(IDC_STA_WSEC)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDT_WSEC)->EnableWindow(TRUE);
			GetDlgItem(IDC_SPN_WSEC)->EnableWindow(TRUE);
			GetDlgItem(IDC_STA_WMS)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDT_WMS)->EnableWindow(TRUE);
			GetDlgItem(IDC_SPN_WMS)->EnableWindow(TRUE);
			GetDlgItem(IDC_STA_WUS)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDT_WUS)->EnableWindow(TRUE);
			GetDlgItem(IDC_SPN_WUS)->EnableWindow(TRUE);
		}
		break;
	}
}

void OutputTrigger::OnCbnSelchangeCmbPort()
{
	// TODO: ڴӿؼ֪ͨ
	m_nTgrPort = m_cmbPort.GetCurSel();
    m_tgrOutAttr.nTgrOutPort = m_nTgrPort;

	switch(m_nTgrPort)
	{
	case TUPORT_ONE:
		m_nKind    = m_tgrOutAttr.TgrPort1.nTgrOutMode;
		m_nEdge    = m_tgrOutAttr.TgrPort1.nEdgeMode;
		m_nDelay   = m_tgrOutAttr.TgrPort1.nDelayTm;
		m_nWidth   = m_tgrOutAttr.TgrPort1.nWidth;
		break;

	case TUPORT_TWO:
		m_nKind    = m_tgrOutAttr.TgrPort2.nTgrOutMode;
		m_nEdge    = m_tgrOutAttr.TgrPort2.nEdgeMode;
		m_nDelay   = m_tgrOutAttr.TgrPort2.nDelayTm;
		m_nWidth   = m_tgrOutAttr.TgrPort2.nWidth;
		break;

	case TUPORT_THREE:
		m_nKind    = m_tgrOutAttr.TgrPort3.nTgrOutMode;
		m_nEdge    = m_tgrOutAttr.TgrPort3.nEdgeMode;
		m_nDelay   = m_tgrOutAttr.TgrPort3.nDelayTm;
		m_nWidth   = m_tgrOutAttr.TgrPort3.nWidth;
		break;
	default:
		break;
	}

	UpdateDelayTime(m_nDelay);

	UpdateWidth(m_nWidth);

	UpdateRadio();

	UpdateOutPutTgr();

}

void OutputTrigger::OnBnClickedRadioExpstart()
{
	// TODO: ڴӿؼ֪ͨ
	m_nKind = TUOPT_EXPSTART;
	UpdateRadio();
	UpdateOutPutTgr();
}

void OutputTrigger::OnBnClickedRadioReadend()
{
	// TODO: ڴӿؼ֪ͨ
	m_nKind = TUOPT_READEND;
	UpdateRadio();
	UpdateOutPutTgr();
}

void OutputTrigger::OnBnClickedRadioGloexp()
{
	// TODO: ڴӿؼ֪ͨ
	m_nKind = TUOPT_EXPGLOBAL;
	UpdateRadio();
	UpdateOutPutTgr();
}

void OutputTrigger::OnBnClickedRadioTriready()
{
	// TODO:  ڴӿؼ֪ͨ
	m_nKind = TUOPT_TRIREADY;
	UpdateRadio();
	UpdateOutPutTgr();
}

void OutputTrigger::OnBnClickedRadioLow()
{
	// TODO: ڴӿؼ֪ͨ
	m_nKind = TUOPT_GND;
	UpdateRadio();
	UpdateOutPutTgr();
}

void OutputTrigger::OnBnClickedRadioHigh()
{
	// TODO: ڴӿؼ֪ͨ
	m_nKind = TUOPT_VCC;
	UpdateRadio();
	UpdateOutPutTgr();
}

void OutputTrigger::OnBnClickedRadioRise()
{
	// TODO: ڴӿؼ֪ͨ
	m_nEdge = 0;
	UpdateRadio();
	UpdateOutPutTgr();
}

void OutputTrigger::OnBnClickedRadioFall()
{
	// TODO: ڴӿؼ֪ͨ
	m_nEdge = 1;
	UpdateRadio();
	UpdateOutPutTgr();
}

void OutputTrigger::OnDeltaposSpnDsec(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: ڴӿؼ֪ͨ
	m_uDSec = GetDlgItemInt(IDC_EDT_DSEC);

	m_bDSecChange = TRUE;

	if (pNMUpDown->iDelta < 0)
	{
		if (m_uDSec >= 59)
		{
			return;
		}
		m_uDSec++;

		CString strSec;
		strSec.Format(_T("%d"), m_uDSec);
		GetDlgItem(IDC_EDT_DSEC)->SetWindowText(strSec);
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_uDSec <= 0)
		{
			return;
		}
		m_uDSec--;

		CString strSec;
		strSec.Format(_T("%d"), m_uDSec);
		GetDlgItem(IDC_EDT_DSEC)->SetWindowText(strSec);
	}
	UpdateOutPutTgr();
	*pResult = 0;
}

void OutputTrigger::OnDeltaposSpnDms(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: ڴӿؼ֪ͨ
	m_uDMs = GetDlgItemInt(IDC_EDT_DMS);
    
	m_bDMsChange = TRUE;

	if (pNMUpDown->iDelta < 0)
	{
		if (m_uDMs >= 999)
		{
			return;
		}
		m_uDMs++;

		CString strMs;
		strMs.Format(_T("%d"), m_uDMs);
		GetDlgItem(IDC_EDT_DMS)->SetWindowText(strMs);
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_uDMs <= 0)
		{
			return;
		}
		m_uDMs--;

		CString strMs;
		strMs.Format(_T("%d"), m_uDMs);
		GetDlgItem(IDC_EDT_DMS)->SetWindowText(strMs);
	}
	UpdateOutPutTgr();
	*pResult = 0;
}

void OutputTrigger::OnDeltaposSpnDus(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: ڴӿؼ֪ͨ
	m_uDUs = GetDlgItemInt(IDC_EDT_DUS);

    m_bDUsChange = TRUE;

	if (pNMUpDown->iDelta < 0)
	{
		if (m_uDUs >= 999)
		{
			return;
		}
		m_uDUs += 1;

		CString strUs;
		strUs.Format(_T("%d"), m_uDUs);
		GetDlgItem(IDC_EDT_DUS)->SetWindowText(strUs);
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_uDUs == 0)
		{
			return;
		}

		if (m_uDUs < 1)
		{
			m_uDUs = 0;
		}
		else
		{
			m_uDUs -= 1;
		}       

		CString strUs;
		strUs.Format(_T("%d"), m_uDUs);
		GetDlgItem(IDC_EDT_DUS)->SetWindowText(strUs);
	}
	UpdateOutPutTgr();
	*pResult = 0;
}

void OutputTrigger::OnDeltaposSpnWsec(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: ڴӿؼ֪ͨ
	m_uWSec = GetDlgItemInt(IDC_EDT_WSEC);

	m_bWSecChange = TRUE;

	if (pNMUpDown->iDelta < 0)
	{
		if (m_uWSec >= 59)
		{
			return;
		}
		m_uWSec++;

		CString strSec;
		strSec.Format(_T("%d"), m_uWSec);
		GetDlgItem(IDC_EDT_WSEC)->SetWindowText(strSec);
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_uWSec <= 0)
		{
			return;
		}
		m_uWSec--;

		CString strSec;
		strSec.Format(_T("%d"), m_uWSec);
		GetDlgItem(IDC_EDT_WSEC)->SetWindowText(strSec);
	}
	UpdateOutPutTgr();
	*pResult = 0;
}

void OutputTrigger::OnDeltaposSpnWms(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: ڴӿؼ֪ͨ
	m_uWMs = GetDlgItemInt(IDC_EDT_WMS);

	m_bWMsChange = TRUE;

	if (pNMUpDown->iDelta < 0)
	{
		if (m_uWMs >= 999)
		{
			return;
		}
		m_uWMs++;

		CString strMs;
		strMs.Format(_T("%d"), m_uWMs);
		GetDlgItem(IDC_EDT_WMS)->SetWindowText(strMs);
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_uWMs <= 0)
		{
			return;
		}
		m_uWMs--;

		CString strMs;
		strMs.Format(_T("%d"), m_uWMs);
		GetDlgItem(IDC_EDT_WMS)->SetWindowText(strMs);
	}
	UpdateOutPutTgr();
	*pResult = 0;
}

void OutputTrigger::OnDeltaposSpnWus(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: ڴӿؼ֪ͨ
	m_uWUs = GetDlgItemInt(IDC_EDT_WUS);

	m_bWUsChange = TRUE;

	if (pNMUpDown->iDelta < 0)
	{
		if (m_uWUs >= 999)
		{
			return;
		}
		m_uWUs += 1;

		CString strUs;
		strUs.Format(_T("%d"), m_uWUs);
		GetDlgItem(IDC_EDT_WUS)->SetWindowText(strUs);
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_uWUs == 0)
		{
			return;
		}

		if (m_uWUs < 1)
		{
			m_uWUs = 1;
		}
		else
		{
			m_uWUs -= 1;
		}       

		CString strUs;
		strUs.Format(_T("%d"), m_uWUs);
		GetDlgItem(IDC_EDT_WUS)->SetWindowText(strUs);
	}
	UpdateOutPutTgr();
	*pResult = 0;
}

void  OutputTrigger::UpdateOutPutTgr()
{
	m_nDelay = m_uDSec *1000 * 1000 + m_uDMs * 1000 + m_uDUs; 
	if (m_nDelay > 10000000)
	{
		m_nDelay = 10000000;
        UpdateDelayTime(m_nDelay);

		m_uDSec = 10;
		m_uDMs  = 0;
		m_uDUs  = 0;
		UpdateData(FALSE);
	}

	m_nWidth = m_uWSec *1000 * 1000 + m_uWMs * 1000 + m_uWUs; 
	if (m_nWidth > 10000000)
	{
		m_nWidth = 10000000;
		UpdateWidth(m_nWidth);

		m_uWSec = 10;
		m_uWMs  = 0;
		m_uWUs  = 0;
		UpdateData(FALSE);
	}

	if (m_nWidth < 1)
	{
		m_nWidth = 1;
		UpdateWidth(m_nWidth);

		m_uWSec = 0;
		m_uWMs  = 0;
		m_uWUs  = 1;
		UpdateData(FALSE);
	}

	TUCAM_TRGOUT_ATTR tgrOutAttr;

	tgrOutAttr.nTgrOutPort = m_nTgrPort;
	tgrOutAttr.nTgrOutMode = m_nKind;
	tgrOutAttr.nEdgeMode   = m_nEdge;
	tgrOutAttr.nDelayTm    = m_nDelay;
	tgrOutAttr.nWidth      = m_nWidth;

	switch(m_nTgrPort)
	{
	case TUPORT_ONE:
		m_tgrOutAttr.TgrPort1.nTgrOutMode = tgrOutAttr.nTgrOutMode;
		m_tgrOutAttr.TgrPort1.nEdgeMode   = tgrOutAttr.nEdgeMode ;
		m_tgrOutAttr.TgrPort1.nDelayTm    = tgrOutAttr.nDelayTm  ;
		m_tgrOutAttr.TgrPort1.nWidth      = tgrOutAttr.nWidth;
		break;

	case TUPORT_TWO:
		m_tgrOutAttr.TgrPort2.nTgrOutMode = tgrOutAttr.nTgrOutMode;
		m_tgrOutAttr.TgrPort2.nEdgeMode   = tgrOutAttr.nEdgeMode ;
		m_tgrOutAttr.TgrPort2.nDelayTm    = tgrOutAttr.nDelayTm  ;
		m_tgrOutAttr.TgrPort2.nWidth      = tgrOutAttr.nWidth;
		break;

	case TUPORT_THREE:
		m_tgrOutAttr.TgrPort3.nTgrOutMode = tgrOutAttr.nTgrOutMode;
		m_tgrOutAttr.TgrPort3.nEdgeMode   = tgrOutAttr.nEdgeMode ;
		m_tgrOutAttr.TgrPort3.nDelayTm    = tgrOutAttr.nDelayTm  ;
		m_tgrOutAttr.TgrPort3.nWidth      = tgrOutAttr.nWidth;
		break;
	default:
		break;
	}

	TUCAM_Cap_SetTriggerOut(m_opCam.hIdxTUCam, tgrOutAttr);

	EnableControl(m_nKind);
}

void OutputTrigger::UpdateDelayTime(int nDelay)
{
	m_bDSecChange           = TRUE;
	m_bDMsChange            = TRUE;
	m_bDUsChange            = TRUE;

	m_uDSec = (nDelay / (1000 * 1000)) % 60;
	m_uDMs  = (nDelay / 1000) % 1000;
	m_uDUs  = nDelay % 1000;

	CString sz;
	sz.Format(_T("%d"), m_uDSec);
	GetDlgItem(IDC_EDT_DSEC)->SetWindowText(sz);
	sz.Format(_T("%d"), m_uDMs);
	GetDlgItem(IDC_EDT_DMS)->SetWindowText(sz);
	sz.Format(_T("%d"), m_uDUs);
	GetDlgItem(IDC_EDT_DUS)->SetWindowText(sz);
}

void OutputTrigger::UpdateWidth(int nWidth)
{
	m_bWSecChange           = TRUE;
	m_bWMsChange            = TRUE;
	m_bWUsChange            = TRUE;

	m_uWSec = (nWidth / (1000 * 1000)) % 60;
	m_uWMs  = (nWidth / 1000) % 1000;
	m_uWUs  = nWidth % 1000;

	CString sz;
	sz.Format(_T("%d"), m_uWSec);
	GetDlgItem(IDC_EDT_WSEC)->SetWindowText(sz);
	sz.Format(_T("%d"), m_uWMs);
	GetDlgItem(IDC_EDT_WMS)->SetWindowText(sz);
	sz.Format(_T("%d"), m_uWUs);
	GetDlgItem(IDC_EDT_WUS)->SetWindowText(sz);
}

void OutputTrigger::UpdateRadio()
{
	if(m_nEdge == 0)
	{
		((CButton *)GetDlgItem(IDC_RADIO_RISE))->SetCheck(TRUE);
		((CButton *)GetDlgItem(IDC_RADIO_FALL))->SetCheck(FALSE);
	}
	else
	{
		((CButton *)GetDlgItem(IDC_RADIO_RISE))->SetCheck(FALSE);
		((CButton *)GetDlgItem(IDC_RADIO_FALL))->SetCheck(TRUE);
	}

	switch (m_nKind)
	{
	case 1:
		{
			((CButton *)GetDlgItem(IDC_RADIO_EXPSTART))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_READEND))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_GLOEXP))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_LOW))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_HIGH))->SetCheck(TRUE);
			((CButton *)GetDlgItem(IDC_RADIO_TRIREADY))->SetCheck(FALSE);

		}
		break;
	case 3:
		{
			((CButton *)GetDlgItem(IDC_RADIO_EXPSTART))->SetCheck(TRUE);
			((CButton *)GetDlgItem(IDC_RADIO_READEND))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_GLOEXP))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_LOW))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_HIGH))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_TRIREADY))->SetCheck(FALSE);

		}
		break;
	case 4:
		{
			((CButton *)GetDlgItem(IDC_RADIO_EXPSTART))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_READEND))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_GLOEXP))->SetCheck(TRUE);
			((CButton *)GetDlgItem(IDC_RADIO_LOW))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_HIGH))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_TRIREADY))->SetCheck(FALSE);

		}
		break;
	case 5:
		{
			((CButton *)GetDlgItem(IDC_RADIO_EXPSTART))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_READEND))->SetCheck(TRUE);
			((CButton *)GetDlgItem(IDC_RADIO_GLOEXP))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_LOW))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_HIGH))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_TRIREADY))->SetCheck(FALSE);
		}
		break;
	case 6:
	    {
		    ((CButton *)GetDlgItem(IDC_RADIO_EXPSTART))->SetCheck(FALSE);
		    ((CButton *)GetDlgItem(IDC_RADIO_READEND))->SetCheck(FALSE);
		    ((CButton *)GetDlgItem(IDC_RADIO_GLOEXP))->SetCheck(FALSE);
		    ((CButton *)GetDlgItem(IDC_RADIO_LOW))->SetCheck(FALSE);
		    ((CButton *)GetDlgItem(IDC_RADIO_HIGH))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_TRIREADY))->SetCheck(TRUE);

		}
		break;
	case 0:
	default:
		{
			((CButton *)GetDlgItem(IDC_RADIO_EXPSTART))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_READEND))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_GLOEXP))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_LOW))->SetCheck(TRUE);
			((CButton *)GetDlgItem(IDC_RADIO_HIGH))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_TRIREADY))->SetCheck(FALSE);
		}
		break;
	}
}

void OutputTrigger::OnEnChangeEdtDus()
{
	// TODO:  ÿؼ RICHEDIT ؼ
	// ͸֪ͨд CDialog::OnInitDialog()
	//  CRichEditCtrl().SetEventMask()
	// ͬʱ ENM_CHANGE ־㵽С

	// TODO:  ڴӿؼ֪ͨ
	if (m_bDUsChange)
	{
		m_bDUsChange = FALSE;
		return;
	}

	CString str; 
	GetDlgItem(IDC_EDT_DUS)->GetWindowText(str);
	m_uDUs = (UINT)atoi(str); 

	if (m_uDUs > 999)
	{
		m_uDUs = 999;
        GetDlgItem(IDC_EDT_DUS)->SetWindowText(_T("999"));
		return;
	}

	UpdateOutPutTgr();
}

void OutputTrigger::OnEnChangeEdtDms()
{
	// TODO:  ÿؼ RICHEDIT ؼ
	// ͸֪ͨд CDialog::OnInitDialog()
	//  CRichEditCtrl().SetEventMask()
	// ͬʱ ENM_CHANGE ־㵽С

	// TODO:  ڴӿؼ֪ͨ
	if (m_bDMsChange)
	{
		m_bDMsChange = FALSE;
		return;
	}

	CString str; 
	GetDlgItem(IDC_EDT_DMS)->GetWindowText(str);
	m_uDMs = (UINT)atoi(str); 

	if (m_uDMs > 999)
	{
		m_uDMs = 999;
		GetDlgItem(IDC_EDT_DMS)->SetWindowText(_T("999"));
		return;
	}

	UpdateOutPutTgr();
}

void OutputTrigger::OnEnChangeEdtDsec()
{
	// TODO:  ÿؼ RICHEDIT ؼ
	// ͸֪ͨд CDialog::OnInitDialog()
	//  CRichEditCtrl().SetEventMask()
	// ͬʱ ENM_CHANGE ־㵽С

	// TODO:  ڴӿؼ֪ͨ
	if (m_bDSecChange)
	{
		m_bDSecChange = FALSE;
		return;
	}

	CString str; 
	GetDlgItem(IDC_EDT_DSEC)->GetWindowText(str);
	m_uDSec = (UINT)atoi(str); 

	if (m_uDSec > 10)
	{
		m_uDSec = 10;
		GetDlgItem(IDC_EDT_DSEC)->SetWindowText(_T("10"));
		return;
	}

	UpdateOutPutTgr();
}

void OutputTrigger::OnEnChangeEdtWus()
{
	// TODO:  ÿؼ RICHEDIT ؼ
	// ͸֪ͨд CDialog::OnInitDialog()
	//  CRichEditCtrl().SetEventMask()
	// ͬʱ ENM_CHANGE ־㵽С

	// TODO:  ڴӿؼ֪ͨ
	if (m_bWUsChange)
	{
		m_bWUsChange = FALSE;
		return;
	}

	CString str; 
	GetDlgItem(IDC_EDT_WUS)->GetWindowText(str);
	m_uWUs = (UINT)atoi(str); 

	if (m_uWUs > 999)
	{
		m_uWUs = 999;
		GetDlgItem(IDC_EDT_WUS)->SetWindowText(_T("999"));
		return;
	}

	UpdateOutPutTgr();
}

void OutputTrigger::OnEnChangeEdtWms()
{
	// TODO:  ÿؼ RICHEDIT ؼ
	// ͸֪ͨд CDialog::OnInitDialog()
	//  CRichEditCtrl().SetEventMask()
	// ͬʱ ENM_CHANGE ־㵽С

	// TODO:  ڴӿؼ֪ͨ
	if (m_bWMsChange)
	{
		m_bWMsChange = FALSE;
		return;
	}

	CString str; 
	GetDlgItem(IDC_EDT_WMS)->GetWindowText(str);
	m_uWMs = (UINT)atoi(str); 

	if (m_uWMs > 999)
	{
		m_uWMs = 999;
		GetDlgItem(IDC_EDT_WMS)->SetWindowText(_T("999"));
		return;
	}

	UpdateOutPutTgr();
}

void OutputTrigger::OnEnChangeEdtWsec()
{
	// TODO:  ÿؼ RICHEDIT ؼ
	// ͸֪ͨд CDialog::OnInitDialog()
	//  CRichEditCtrl().SetEventMask()
	// ͬʱ ENM_CHANGE ־㵽С

	// TODO:  ڴӿؼ֪ͨ
	if (m_bWSecChange)
	{
		m_bWSecChange = FALSE;
		return;
	}

	CString str; 
	GetDlgItem(IDC_EDT_WSEC)->GetWindowText(str);
	m_uWSec = (UINT)atoi(str); 

	if (m_uWSec > 10)
	{
		m_uWSec = 10;
		GetDlgItem(IDC_EDT_WSEC)->SetWindowText(_T("10"));
		return;
	}

	UpdateOutPutTgr();
}

void OutputTrigger::OnBnClickedChkTrioenable()
{
	// TODO:  ڴӿؼ֪ͨ
	UpdateData();
	TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, TUIDC_ENABLETRIOUT, m_bTriggerOutEn);
}
