#pragma once

#include "CameraControlMode.h"
#include "afxwin.h"
// OutputTrigger Ի

// the camera triggerout attribute
typedef struct _tagTUCAM_PATAM_TRGOUTPUT
{                      
	INT32   nTgrOutMode;                           
	INT32   nEdgeMode;                            
	INT32   nDelayTm;                              
	INT32   nWidth;                                
}TUCAM_PATAM_TRGOUTPUT;

typedef struct _tagTUCAM_TRGOUTPUT
{
	INT32   nTgrOutPort;                           // [in/out] The port of triggerout 
	TUCAM_PATAM_TRGOUTPUT TgrPort1;
    TUCAM_PATAM_TRGOUTPUT TgrPort2;
	TUCAM_PATAM_TRGOUTPUT TgrPort3;
}TUCAM_TRGOUTPUT;

class OutputTrigger : public CDialog
{
	DECLARE_DYNAMIC(OutputTrigger)

public:
	//OutputTrigger(CWnd* pParent = NULL);   // ׼캯
	//virtual ~OutputTrigger();
	OutputTrigger(TUCAM_OPEN &opCam,CCameraControlMode* pParent); 
	void InitControlRange();                            // ʼؼΧ
	void RefreshValue();                                // ˢ¿ؼֵ   
	void RefreshOpen(TUCAM_OPEN &opCam);                // ˢ
// Ի
	enum { IDD = IDD_DLG_OUTPUTTRIGER };

	void EnableOutPutTriggerControl(BOOL bEnable = FALSE);    // ʹ

	void EnableControl(INT nKind);                            // ģʽлʹ
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

	virtual BOOL PreTranslateMessage(MSG* pMsg);        // ð
	DECLARE_MESSAGE_MAP()

private:

	TUCAM_OPEN          m_opCam;                        // 
	CCameraControlMode* m_ccmode;                       // ģʽָ

private:

	void UpdateDelayTime(int nDelay);
	void UpdateWidth(int nWidth);
	void UpdateRadio();
	void UpdateOutPutTgr();

public:
	afx_msg void OnCbnSelchangeCmbPort();
	CComboBox m_cmbPort;

	BOOL m_bDSecChange;
	BOOL m_bDMsChange;
	BOOL m_bDUsChange;
	BOOL m_bWSecChange;
	BOOL m_bWMsChange;
	BOOL m_bWUsChange;

	INT m_nTgrPort;
	INT m_nKind;
	INT m_nEdge;
	INT m_nDelay;
	INT m_nWidth;

	UINT m_uDSec;
	UINT m_uDMs;
	UINT m_uDUs;
	UINT m_uWSec;
	UINT m_uWMs;
	UINT m_uWUs;
	
	TUCAM_TRGOUTPUT m_tgrOutAttr;

	afx_msg void OnBnClickedRadioExpstart();
	afx_msg void OnBnClickedRadioReadend();
	afx_msg void OnBnClickedRadioGloexp();
	afx_msg void OnBnClickedRadioLow();
	afx_msg void OnBnClickedRadioHigh();
	afx_msg void OnBnClickedRadioRise();
	afx_msg void OnBnClickedRadioFall();

	afx_msg void OnDeltaposSpnDsec(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposSpnDms(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposSpnDus(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposSpnWsec(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposSpnWms(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposSpnWus(NMHDR *pNMHDR, LRESULT *pResult);

	afx_msg void OnEnChangeEdtDus();
	afx_msg void OnEnChangeEdtDms();
	afx_msg void OnEnChangeEdtDsec();
	afx_msg void OnEnChangeEdtWus();
	afx_msg void OnEnChangeEdtWms();
	afx_msg void OnEnChangeEdtWsec();
	BOOL m_bTriggerOutEn;
	afx_msg void OnBnClickedChkTrioenable();
	afx_msg void OnBnClickedRadioTriready();
};
