// ROI.cpp : implementation file
//

#include "stdafx.h"
#include "SamplePro.h"
#include "ROI.h"
//#include "afxdialogex.h"


// ROI dialog

IMPLEMENT_DYNAMIC(ROI, CDialog)

ROI::ROI(TUCAM_OPEN &opCam,CCameraControlMode* pParent)
	: CDialog(ROI::IDD, pParent)
	, m_uiHOffset(0)
    , m_uiVOffset(0)
    , m_uiWidth(100)
    , m_uiHeight(100)
{
	m_opCam          = opCam;
	m_ccmode         = pParent;
}

//ROI::~ROI()
//{
//}

void ROI::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_CHK_ROI, m_bROI);
	DDX_Text(pDX, IDC_EDT_HOFFSET, m_uiHOffset);
    DDX_Text(pDX, IDC_EDT_VOFFSET, m_uiVOffset);
    DDX_Text(pDX, IDC_EDT_WIDTH, m_uiWidth);
    DDX_Text(pDX, IDC_EDT_HEIGHT, m_uiHeight);
}


BEGIN_MESSAGE_MAP(ROI, CDialog)
	ON_BN_CLICKED(IDC_CHK_ROI, &ROI::OnBnClickedChkRoi)
	ON_BN_CLICKED(IDC_BTN_ROI, &ROI::OnBnClickedBtnRoi)
END_MESSAGE_MAP()


// ROI message handlers

void ROI::InitControlRange()
{
	if (NULL != m_opCam.hIdxTUCam)
	{
		if (m_ccmode->m_nopCamCount > 1)
		{
			GetDlgItem(IDC_CHK_ROI)->ShowWindow(FALSE);
		}
	}
}

void ROI::RefreshValue()
{
	if (NULL != m_opCam.hIdxTUCam)
	{

		BOOL bRoiEnable = FALSE;
		bRoiEnable = m_ccmode->m_bvecRoiEnable[m_ccmode->m_nCamIndex];

		if (bRoiEnable)
		{
			m_ccmode->m_bChk = FALSE;

			m_bROI.SetCheck(TRUE);
			m_bROI.EnableWindow(FALSE);

			TUCAM_ROI_ATTR roiAttr;
			TUCAM_Cap_GetROI(m_opCam.hIdxTUCam, &roiAttr);
			m_uiVOffset = roiAttr.nVOffset;
			m_uiHOffset = roiAttr.nHOffset;
			m_uiWidth   = roiAttr.nWidth ;
			m_uiHeight  = roiAttr.nHeight;

			// ROIؼʹ
			GetDlgItem(IDC_STA_HOFF)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_VOFF)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_WIDTH)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_HEIGHT)->EnableWindow(FALSE);

			GetDlgItem(IDC_EDT_HOFFSET)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_VOFFSET)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_WIDTH)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_HEIGHT)->EnableWindow(FALSE);

			GetDlgItem(IDC_BTN_ROI)->SetWindowText(_T("Set Full"));

		}
		else
		{
			m_ccmode->m_bChk = TRUE;

			m_bROI.SetCheck(FALSE);
			m_bROI.EnableWindow(TRUE);

			m_uiVOffset = 0;
			m_uiHOffset = 0;
			m_uiWidth   = 100;
			m_uiHeight  = 100;

			// ROIؼʹ
			GetDlgItem(IDC_STA_HOFF)->EnableWindow(TRUE);
			GetDlgItem(IDC_STA_VOFF)->EnableWindow(TRUE);
			GetDlgItem(IDC_STA_WIDTH)->EnableWindow(TRUE);
			GetDlgItem(IDC_STA_HEIGHT)->EnableWindow(TRUE);

			GetDlgItem(IDC_EDT_HOFFSET)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDT_VOFFSET)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDT_WIDTH)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDT_HEIGHT)->EnableWindow(TRUE);

			GetDlgItem(IDC_BTN_ROI)->SetWindowText(_T("Set ROI"));

		}
		UpdateData(FALSE);
	}
}

void ROI::RefreshOpen(TUCAM_OPEN &opCam)             // ˢ
{
	m_opCam  = opCam;
}

void ROI::CloseROIState()
{
    // رROI״̬
    m_bROI.SetCheck(FALSE);
    m_bROI.EnableWindow(TRUE);

    GetDlgItem(IDC_STA_HOFF)->EnableWindow(TRUE);
    GetDlgItem(IDC_STA_VOFF)->EnableWindow(TRUE);
    GetDlgItem(IDC_STA_WIDTH)->EnableWindow(TRUE);
    GetDlgItem(IDC_STA_HEIGHT)->EnableWindow(TRUE);

    GetDlgItem(IDC_EDT_HOFFSET)->EnableWindow(TRUE);
    GetDlgItem(IDC_EDT_VOFFSET)->EnableWindow(TRUE);
    GetDlgItem(IDC_EDT_WIDTH)->EnableWindow(TRUE);
    GetDlgItem(IDC_EDT_HEIGHT)->EnableWindow(TRUE);

    GetDlgItem(IDC_BTN_ROI)->SetWindowText(_T("Set ROI"));
}

BOOL ROI::PreTranslateMessage(MSG* pMsg)
{
    // TODO: ڴרô/û
    if((pMsg->wParam == VK_ESCAPE))
    {  
        return TRUE;  
    }

    if ((pMsg->wParam == VK_RETURN))
    {
        //UpdateData();
        return TRUE;
    }

	if(TranslateAccelerator(m_hWnd,m_ccmode->hAccKey, pMsg))  
	{    
		return TRUE;    
	}  

    return CDialog::PreTranslateMessage(pMsg);
}

void ROI::OnBnClickedChkRoi()
{
	// TODO: Add your control notification handler code here
	UpdateData();

	if (m_bROI.GetCheck())
	{
		m_ccmode->m_bChk = TRUE;
		m_ccmode->OnChkRoiFunction();
		
	    m_uiVOffset = m_ccmode->m_uVOffset;
		m_uiHOffset = m_ccmode->m_uHOffset;
		m_uiWidth   = m_ccmode->m_uWidth ;
		m_uiHeight  = m_ccmode->m_uHeight;

		UpdateData(FALSE);

		if(m_ccmode->m_bChk)
		{
			// ROIؼʹ
			GetDlgItem(IDC_STA_HOFF)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_VOFF)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_WIDTH)->EnableWindow(FALSE);
			GetDlgItem(IDC_STA_HEIGHT)->EnableWindow(FALSE);

			GetDlgItem(IDC_EDT_HOFFSET)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_VOFFSET)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_WIDTH)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDT_HEIGHT)->EnableWindow(FALSE);

			GetDlgItem(IDC_BTN_ROI)->SetWindowText(_T("Set Full"));
		}
		else
		{
			m_bROI.SetCheck(FALSE);
			GetDlgItem(IDC_BTN_ROI)->SetWindowText(_T("Set ROI"));
		}
	}
	else
    {
        m_ccmode->m_bChk = FALSE;
		m_ccmode->OnChkRoiFunction();

		// ROIؼʹ
        GetDlgItem(IDC_STA_HOFF)->EnableWindow(TRUE);
        GetDlgItem(IDC_STA_VOFF)->EnableWindow(TRUE);
        GetDlgItem(IDC_STA_WIDTH)->EnableWindow(TRUE);
        GetDlgItem(IDC_STA_HEIGHT)->EnableWindow(TRUE);

        GetDlgItem(IDC_EDT_HOFFSET)->EnableWindow(TRUE);
        GetDlgItem(IDC_EDT_VOFFSET)->EnableWindow(TRUE);
        GetDlgItem(IDC_EDT_WIDTH)->EnableWindow(TRUE);
        GetDlgItem(IDC_EDT_HEIGHT)->EnableWindow(TRUE);

        GetDlgItem(IDC_BTN_ROI)->SetWindowText(_T("Set ROI"));
    }
}


void ROI::OnBnClickedBtnRoi()
{
	// TODO: Add your control notification handler code here
	UpdateData();

	if (m_bROI.GetCheck())
	{
		m_ccmode->m_bChk = TRUE;

        m_bROI.SetCheck(FALSE);
//      m_bROI.EnableWindow(TRUE);

		m_ccmode->OnBtnRoiFunction();

		GetDlgItem(IDC_STA_HOFF)->EnableWindow(TRUE);
		GetDlgItem(IDC_STA_VOFF)->EnableWindow(TRUE);
		GetDlgItem(IDC_STA_WIDTH)->EnableWindow(TRUE);
		GetDlgItem(IDC_STA_HEIGHT)->EnableWindow(TRUE);

		GetDlgItem(IDC_EDT_HOFFSET)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDT_VOFFSET)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDT_WIDTH)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDT_HEIGHT)->EnableWindow(TRUE);

		GetDlgItem(IDC_BTN_ROI)->SetWindowText(_T("Set ROI"));

		UpdateData(FALSE);
	}
	else
	{
		m_ccmode->m_bChk = FALSE;
		m_ccmode->m_uVOffset = m_uiVOffset;
		m_ccmode->m_uHOffset = m_uiHOffset;
		m_ccmode->m_uWidth   = m_uiWidth;
		m_ccmode->m_uHeight  = m_uiHeight;

		m_ccmode->OnBtnRoiFunction();

		m_uiVOffset = m_ccmode->m_uVOffset;
		m_uiHOffset = m_ccmode->m_uHOffset;
		m_uiWidth   = m_ccmode->m_uWidth ;
		m_uiHeight  = m_ccmode->m_uHeight;

		m_bROI.SetCheck(TRUE);
		m_bROI.EnableWindow(FALSE);
        
		GetDlgItem(IDC_STA_HOFF)->EnableWindow(FALSE);
		GetDlgItem(IDC_STA_VOFF)->EnableWindow(FALSE);
		GetDlgItem(IDC_STA_WIDTH)->EnableWindow(FALSE);
		GetDlgItem(IDC_STA_HEIGHT)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDT_HOFFSET)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDT_VOFFSET)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDT_WIDTH)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDT_HEIGHT)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_ROI)->SetWindowText(_T("Set Full"));

		UpdateData(FALSE);
	}
}
