#include "stdafx.h"
#include "SamplePro.h"
#include "Trigger.h"
#include "CameraControl.h"
#include "ImageCapture.h"
#include "RollingScanManager.h"

IMPLEMENT_DYNAMIC(Trigger, CDialog)

Trigger::Trigger(TUCAM_OPEN &opCam,CCameraControlMode* pParent)
	: CDialog(Trigger::IDD, pParent)
	, m_nTriMode(0)
    , m_nTriExp(0)
    , m_nTriEdge(0)
    , m_uSec(0)
    , m_uMs(0)
    , m_uUs(0)
	, m_nTotalFrames(1)
	, lineTimeDelay(0)
	, slitHeight(0)
	, m_nSignalFilter(0)
{
	m_opCam = opCam;
	m_ccmode = pParent;

	m_bTriShow = TRUE;
	m_nPID = 0;
	m_nBCD = 0;
	m_bClTrg = FALSE;
	m_bSlitHeightChange = FALSE;
	m_bLineTimeDelayChange = FALSE;
	RollingScanManager::GetInstance()->SetCameraHandle(m_opCam.hIdxTUCam);
}

//Trigger::~Trigger()
//{
//}

void Trigger::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMB_STATUS, rollingScanModeComboBox);
	DDX_Control(pDX, IDC_SLD_LTDELAY, lineTimeDelaySlider);
	DDX_Text(pDX, IDC_EDT_LTD, lineTimeDelay);
	DDX_Control(pDX, IDC_SLD_SLITHEIGHT, slitHeightSlider);
	DDX_Text(pDX, IDC_EDT_SLIT, slitHeight);
	DDX_Control(pDX, IDC_CMB_RODIR, readoutDirectionComboBox);
	DDX_Control(pDX, IDC_CMB_RODIRRESET, readoutDirectionResetComboBox);
	DDX_Control(pDX, IDC_CMB_SIGINMODE, m_cmbSiginMode);
	DDX_Text(pDX, IDC_EDT_TOTALFRAMES, m_nTotalFrames);
	DDX_Text(pDX, IDC_EDT_SEC, m_uSec);
	DDX_Text(pDX, IDC_EDT_MS, m_uMs);
	DDX_Text(pDX, IDC_EDT_US, m_uUs);
	DDX_Control(pDX, IDC_CHK_STTRIGGER, m_chkSFWTri);
	DDX_Text(pDX, IDC_EDT_SFUS, m_nSignalFilter);
}

BEGIN_MESSAGE_MAP(Trigger, CDialog)
	ON_CBN_SELCHANGE(IDC_CMB_STATUS, &Trigger::OnCbnSelchangeCmbStatus)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLD_LTDELAY, &Trigger::OnNMCustomdrawSldLtdelay)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLD_SLITHEIGHT, &Trigger::OnNMCustomdrawSldSlitheight)
	ON_CBN_SELCHANGE(IDC_CMB_RODIR, &Trigger::OnCbnSelchangeCmbRodir)
	ON_CBN_SELCHANGE(IDC_CMB_RODIRRESET, &Trigger::OnCbnSelchangeCmbRodirreset)
	ON_CBN_SELCHANGE(IDC_CMB_SIGINMODE, &Trigger::OnCbnSelchangeCmbSiginmode)
	ON_BN_CLICKED(IDC_RADIO_OFF, &Trigger::OnBnClickedRadioOff)
	ON_BN_CLICKED(IDC_RADIO_STANDARD, &Trigger::OnBnClickedRadioStandard)
	ON_BN_CLICKED(IDC_RADIO_SYNCHRO, &Trigger::OnBnClickedRadioSynchro)
	ON_BN_CLICKED(IDC_RADIO_GLOABAL, &Trigger::OnBnClickedRadioGloabal)
	ON_BN_CLICKED(IDC_RADIO_TIMED, &Trigger::OnBnClickedRadioTimed)
	ON_BN_CLICKED(IDC_RADIO_WIDTH, &Trigger::OnBnClickedRadioWidth)
	ON_BN_CLICKED(IDC_RADIO_RISING, &Trigger::OnBnClickedRadioRising)
	ON_BN_CLICKED(IDC_RADIO_FALLING, &Trigger::OnBnClickedRadioFalling)
	ON_EN_CHANGE(IDC_EDT_TOTALFRAMES, &Trigger::OnEnChangeEdtTotalframes)
	ON_BN_CLICKED(IDC_BTN_STOP, &Trigger::OnBnClickedBtnStop)
    ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_SEC, &Trigger::OnDeltaposSpnSec)
    ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_MS, &Trigger::OnDeltaposSpnMs)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_US, &Trigger::OnDeltaposSpnUs)
	ON_BN_CLICKED(IDC_BTN_UPDATE, &Trigger::OnBnClickedBtnUpdate)
	ON_BN_CLICKED(IDC_CHK_STTRIGGER, &Trigger::OnBnClickedChkSttrigger)
	ON_BN_CLICKED(IDC_BTN_SNAP, &Trigger::OnBnClickedBtnSnap)
	ON_BN_CLICKED(IDC_BTN_APPLY, &Trigger::OnBnClickedBtnApply)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_SFUS, &Trigger::OnDeltaposSpnSfus)
	ON_BN_CLICKED(IDC_RADIO_STANDARDNONOVERLAP, &Trigger::OnBnClickedRadioStandardnonoverlap)
END_MESSAGE_MAP()

void Trigger::RefreshOpen(TUCAM_OPEN &opCam)
{
	m_opCam = opCam;
}

BOOL Trigger::PreTranslateMessage(MSG* pMsg)
{
    if((pMsg->wParam == VK_ESCAPE))
    {  
        return TRUE;  
    }

    if ((pMsg->wParam == VK_RETURN))
    {
        UpdateData();
		BOOL bLiving = m_ccmode->m_bWaitting;
		switch (GetFocus()->GetDlgCtrlID())
		{
		case IDC_EDT_LTD:
			if (RollingScanManager::GetInstance()->IsSupportRollingScan())
			{
				lineTimeDelay = max(min((int)lineTimeDelay, lineTimeDelaySlider.GetRangeMax()), lineTimeDelaySlider.GetRangeMin());
				RollingScanManager::GetInstance()->SetLineTimeDelay(lineTimeDelay);
				UpdateRollingScanUI();
			}
			break;
		case IDC_EDT_SLIT:
			if (RollingScanManager::GetInstance()->IsSupportRollingScan())
			{
				slitHeight = max(min((int)slitHeight, slitHeightSlider.GetRangeMax()), slitHeightSlider.GetRangeMin());
				RollingScanManager::GetInstance()->SetSlitHeight(slitHeight);
				UpdateRollingScanUI();
			}
			break;
		case IDC_EDT_SEC:
		case IDC_EDT_MS:
		case IDC_EDT_US:
			OnBnClickedBtnUpdate();
			break;
		case IDC_EDT_TOTALFRAMES:
			OnBnClickedBtnApply();
			break;
		case IDC_EDT_SFUS:
			UpdateSignalFilter();
			break;
		default:
			break;
		}
        return TRUE;
    }

	if (TranslateAccelerator(m_hWnd, m_ccmode->hAccKey, pMsg))
	{    
		return TRUE;    
	}  

    return CDialog::PreTranslateMessage(pMsg);
}

void Trigger::InitControlRange()
{
	m_cmbSiginMode.ShowWindow(SW_HIDE);
	m_nPID = m_ccmode->m_nPID;
	m_nBCD = m_ccmode->m_nBCD;

	TUCAM_TRIGGER_ATTR tgrAttr;
	tgrAttr.nTgrMode = TUCCM_SEQUENCE;
	tgrAttr.nFrames = 1;
	tgrAttr.nDelayTm = 0;
	tgrAttr.nExpMode = TUCTE_EXPTM;
	tgrAttr.nEdgeMode = TUCTD_RISING;

	m_nTriEdge = tgrAttr.nEdgeMode;
	m_nTriExp = tgrAttr.nExpMode;
    if (TUCAMRET_SUCCESS == TUCAM_Cap_GetTrigger(m_opCam.hIdxTUCam, &tgrAttr))
    {
		InitRollingScanUI();
		EnableTriggerControl(TRUE);
		m_bTriShow = TRUE;
    }
    else
    {
        EnableTriggerControl(FALSE);
		m_bTriShow = FALSE;
		EnabledDelayTimeUI(m_bTriShow);
    }

	if (m_nPID == DHYANA_400DC_PID || m_nPID == DHYANA_1605BSI_PID || m_nPID == DHYANA_ULTRA1605_PID)
	{
		GetDlgItem(IDC_RADIO_SYNCHRO)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_RADIO_GLOABAL)->ShowWindow(SW_HIDE);
	}

	if (IsDhyana400BSIV2() || IsDhyana400BSIV3())
	{
//		GetDlgItem(IDC_RADIO_GLOABAL)->ShowWindow(SW_HIDE);
        GetDlgItem(IDC_RADIO_GLOABAL)->EnableWindow(FALSE);
	}
}

void Trigger::UpdateTotalFrameUI()
{
	bool visibleFlag = false;

	if (IsDhyana400BSIV3() || IsDhyana95V2New() || IsDhyana401DNew() || IsDhyana400BSIV3New())
	{
		visibleFlag = ((CButton *)GetDlgItem(IDC_RADIO_STANDARD))->GetCheck() || ((CButton *)GetDlgItem(IDC_RADIO_STANDARDNONOVERLAP))->GetCheck();
		visibleFlag = visibleFlag && ((CButton *)GetDlgItem(IDC_RADIO_TIMED))->GetCheck();
	}
	else
	{
		visibleFlag = false;
	}

	GetDlgItem(IDC_STA_TOTAL)->ShowWindow(visibleFlag);
	GetDlgItem(IDC_EDT_TOTALFRAMES)->ShowWindow(visibleFlag);
	GetDlgItem(IDC_BTN_STOP)->ShowWindow(visibleFlag);
}

void Trigger::EnabledDelayTimeUI(BOOL enabled)
{
	GetDlgItem(IDC_STA_DELAY)->EnableWindow(enabled);
	GetDlgItem(IDC_STA_SEC)->EnableWindow(enabled);
	GetDlgItem(IDC_STA_MS)->EnableWindow(enabled);
	GetDlgItem(IDC_STA_US)->EnableWindow(enabled);
	GetDlgItem(IDC_EDT_SEC)->EnableWindow(enabled);
	GetDlgItem(IDC_EDT_MS)->EnableWindow(enabled);
	GetDlgItem(IDC_EDT_US)->EnableWindow(enabled);
	GetDlgItem(IDC_SPN_SEC)->EnableWindow(enabled);
	GetDlgItem(IDC_SPN_MS)->EnableWindow(enabled);
	GetDlgItem(IDC_SPN_US)->EnableWindow(enabled);
	GetDlgItem(IDC_BTN_UPDATE)->EnableWindow(enabled);
}

void Trigger::InitRollingScanUI()
{
	if (!RollingScanManager::GetInstance()->IsSupportRollingScan())
	{
		GetDlgItem(IDC_STATICROLLINGSCANCONTROL)->EnableWindow(FALSE);
		GetDlgItem(IDC_STA_RCSTATUS)->EnableWindow(FALSE);
		GetDlgItem(IDC_CMB_STATUS)->EnableWindow(FALSE);

		GetDlgItem(IDC_STA_RCLTDELAY)->EnableWindow(FALSE);
		GetDlgItem(IDC_SLD_LTDELAY)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDT_LTD)->EnableWindow(FALSE);

		GetDlgItem(IDC_STA_RCSLIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_SLD_SLITHEIGHT)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDT_SLIT)->EnableWindow(FALSE);

		GetDlgItem(IDC_STA_INTERVALT)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDT_INTERVALT)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_LINE_INTERVAL_TIME)->EnableWindow(FALSE);

		GetDlgItem(IDC_STA_RCREADOUTDIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_CMB_RODIR)->EnableWindow(FALSE);

		GetDlgItem(IDC_STA_RCREADOUTRESET)->EnableWindow(FALSE);
		GetDlgItem(IDC_CMB_RODIRRESET)->EnableWindow(FALSE);
		return;
	}

	vector<char *> list;
	RollingScanManager::GetInstance()->GetRollingScanModeList(list);
	ComboBoxAddStringList(&rollingScanModeComboBox, list);

	lineTimeDelaySlider.SetRange(RollingScanManager::GetInstance()->GetMinLineTimeDelay(), RollingScanManager::GetInstance()->GetMaxLineTimeDelay());
	slitHeightSlider.SetRange(RollingScanManager::GetInstance()->GetMinSlitHeight(), RollingScanManager::GetInstance()->GetMaxSlitHeight());

	list.clear();
	RollingScanManager::GetInstance()->GetReadoutDirectionList(list);
	ComboBoxAddStringList(&readoutDirectionComboBox, list);

	list.clear();
	RollingScanManager::GetInstance()->GetReadoutDirectionResetList(list);
	ComboBoxAddStringList(&readoutDirectionResetComboBox, list);	
}

void Trigger::ComboBoxAddStringList(CComboBox *comboBox, vector<char *> &list)
{
	for (int i = 0; i < list.size(); ++i)
	{
		comboBox->InsertString(i, list.at(i));
	}
}

void Trigger::RefreshValue()
{
    TUCAM_TRIGGER_ATTR tgrAttr;
    tgrAttr.nTgrMode = TUCCM_SEQUENCE;
    tgrAttr.nFrames  = 1;
    tgrAttr.nDelayTm = 0;
    tgrAttr.nExpMode = TUCTE_EXPTM;
    tgrAttr.nEdgeMode= TUCTD_RISING;
    if (TUCAMRET_SUCCESS == TUCAM_Cap_GetTrigger(m_opCam.hIdxTUCam, &tgrAttr))
    {
        m_nTriMode = tgrAttr.nTgrMode;
        m_nTriExp  = tgrAttr.nExpMode;
        m_nTriEdge = tgrAttr.nEdgeMode;        
		UpdateDelayTime(tgrAttr.nDelayTm);

        m_ccmode->m_nTriMode   = m_nTriMode;
        RefreshGlobalreset();

		UpdateData(FALSE);
		UpdateRollingScanUI();
		ShowSignalFilter();
    }
}

void Trigger::UpdateRollingScanUI()
{
	if (!RollingScanManager::GetInstance()->IsSupportRollingScan())
	{
		return;
	}
	rollingScanModeComboBox.SetCurSel(RollingScanManager::GetInstance()->GetRollingScanMode());

	int temp = RollingScanManager::GetInstance()->GetLineTimeDelay();
	m_bLineTimeDelayChange = TRUE;
	lineTimeDelaySlider.SetPos(temp);
	m_bLineTimeDelayChange = FALSE;
	CString text;
	text.Format(_T("%d"), temp);
	GetDlgItem(IDC_EDT_LTD)->SetWindowText(text);

	temp = RollingScanManager::GetInstance()->GetSlitHeight();
	m_bSlitHeightChange = TRUE;
	slitHeightSlider.SetPos(temp);
	m_bSlitHeightChange = FALSE;
	text.Format(_T("%d"), temp);
	GetDlgItem(IDC_EDT_SLIT)->SetWindowText(text);

	text.Format(_T("%.2f"), RollingScanManager::GetInstance()->GetLineIntervalTime());
	GetDlgItem(IDC_EDT_INTERVALT)->SetWindowText(text);

	readoutDirectionComboBox.SetCurSel(RollingScanManager::GetInstance()->GetReadoutDirection());
	readoutDirectionResetComboBox.SetCurSel(RollingScanManager::GetInstance()->GetReadoutDirectionReset());
	EnabledRollingScanUI();
}

void Trigger::EnabledRollingScanUI()
{
	if (!RollingScanManager::GetInstance()->IsSupportRollingScan())
	{
		return;
	}
	int rollingScanMode = RollingScanManager::GetInstance()->GetRollingScanMode();

	bool lineTimeDelayMode = rollingScanMode == RollingScanManager::LINE_TIME_DELAY;
	GetDlgItem(IDC_STA_RCLTDELAY)->EnableWindow(lineTimeDelayMode);
	GetDlgItem(IDC_SLD_LTDELAY)->EnableWindow(lineTimeDelayMode);
	GetDlgItem(IDC_EDT_LTD)->EnableWindow(lineTimeDelayMode);
	
	bool slitHeightMode = rollingScanMode == RollingScanManager::SLIT_HEIGHT;
	GetDlgItem(IDC_STA_RCSLIT)->EnableWindow(slitHeightMode);
	GetDlgItem(IDC_SLD_SLITHEIGHT)->EnableWindow(slitHeightMode);
	GetDlgItem(IDC_EDT_SLIT)->EnableWindow(slitHeightMode);

	bool nonOffMode = true; ///nonOffMode = rollingScanMode != RollingScanManager::OFF;
	int  nImgMode = 0;
	TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, TUIDC_IMGMODESELECT, &nImgMode);
	if (0x05 == nImgMode)
	{
		nonOffMode = false;
	}

	GetDlgItem(IDC_STA_INTERVALT)->EnableWindow(nonOffMode);
	GetDlgItem(IDC_EDT_INTERVALT)->EnableWindow(nonOffMode);
	GetDlgItem(IDC_STATIC_LINE_INTERVAL_TIME)->EnableWindow(nonOffMode);

	GetDlgItem(IDC_STA_RCREADOUTDIT)->EnableWindow(nonOffMode);
	GetDlgItem(IDC_CMB_RODIR)->EnableWindow(nonOffMode);

	GetDlgItem(IDC_STA_RCREADOUTRESET)->EnableWindow(nonOffMode);
	GetDlgItem(IDC_CMB_RODIRRESET)->EnableWindow(nonOffMode);

	///nonOffMode = rollingScanMode != RollingScanManager::OFF;
	if (/*nonOffMode &&*/ RollingScanManager::GetInstance()->GetReadoutDirection() != RollingScanManager::DOWN_UP_CYCLE)
	{
		GetDlgItem(IDC_STA_RCREADOUTRESET)->EnableWindow(FALSE);
		GetDlgItem(IDC_CMB_RODIRRESET)->EnableWindow(FALSE);
	}
}

void Trigger::EnableTriggerControl(BOOL bEnable)
{
	if (!m_bTriShow)
	{
		return;
	}

    BOOL bSfwTrigger = FALSE;
	INT  nVal = 0;
    if (bEnable)
	{
		TUCAM_TRIGGER_ATTR tgrAttr;
		tgrAttr.nTgrMode = TUCCM_SEQUENCE;
		tgrAttr.nFrames = 1;
		tgrAttr.nDelayTm = 0;
		tgrAttr.nExpMode = TUCTE_EXPTM;
		tgrAttr.nEdgeMode = TUCTD_RISING;

		if (TUCAMRET_SUCCESS == TUCAM_Cap_GetTrigger(m_opCam.hIdxTUCam, &tgrAttr))
		{
			int nTriExp = tgrAttr.nExpMode;
			((CButton *)GetDlgItem(IDC_RADIO_OFF))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_STANDARD))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_STANDARDNONOVERLAP))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_SYNCHRO))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_GLOABAL))->SetCheck(FALSE);
			m_chkSFWTri.SetCheck(FALSE);

            switch (m_nTriMode)
            {
            case TUCCM_TRIGGER_STANDARD:
				((CButton *)GetDlgItem(IDC_RADIO_STANDARD))->SetCheck(TRUE);
				break;
			case TUCCM_TRIGGER_STANDARD_NONOVERLAP:
				((CButton *)GetDlgItem(IDC_RADIO_STANDARDNONOVERLAP))->SetCheck(TRUE);
				break;
            case TUCCM_TRIGGER_SYNCHRONOUS:
				((CButton *)GetDlgItem(IDC_RADIO_SYNCHRO))->SetCheck(TRUE);
                break;
            case TUCCM_TRIGGER_GLOBAL:
				((CButton *)GetDlgItem(IDC_RADIO_GLOABAL))->SetCheck(TRUE);
                break;
            case TUCCM_TRIGGER_SOFTWARE:
				m_chkSFWTri.SetCheck(TRUE);
				bSfwTrigger = TRUE;
                break;
            case TUCCM_SEQUENCE:
            default:
				((CButton *)GetDlgItem(IDC_RADIO_OFF))->SetCheck(TRUE);
                break;
            }

            if (!nTriExp)
            {
                ((CButton *)GetDlgItem(IDC_RADIO_TIMED))->SetCheck(TRUE);
                ((CButton *)GetDlgItem(IDC_RADIO_WIDTH))->SetCheck(FALSE);
            }
            else
            {
                ((CButton *)GetDlgItem(IDC_RADIO_TIMED))->SetCheck(FALSE);
                ((CButton *)GetDlgItem(IDC_RADIO_WIDTH))->SetCheck(TRUE);
            }

			BOOL bDelay = FALSE;

			if (m_bClTrg)
			{
				if ((0x07 & m_nTriMode) && !nTriExp)
					bDelay = TRUE;
			}
			else
			{
				if ((TUCCM_TRIGGER_STANDARD == m_nTriMode || TUCCM_TRIGGER_STANDARD_NONOVERLAP == m_nTriMode) && !nTriExp)
					bDelay = TRUE;
			}

            // عʱģʽ
			EnabledDelayTimeUI(bDelay);

            // ģʽ
            if (m_nTriEdge)
            {
                ((CButton *)GetDlgItem(IDC_RADIO_RISING))->SetCheck(TRUE);
                ((CButton *)GetDlgItem(IDC_RADIO_FALLING))->SetCheck(FALSE);
            }
            else
            {
                ((CButton *)GetDlgItem(IDC_RADIO_RISING))->SetCheck(FALSE);
                ((CButton *)GetDlgItem(IDC_RADIO_FALLING))->SetCheck(TRUE);
            }
        } 
    }

    GetDlgItem(IDC_RADIO_OFF)->EnableWindow(bEnable && !bSfwTrigger);
    GetDlgItem(IDC_RADIO_STANDARD)->EnableWindow(bEnable && !bSfwTrigger);
	GetDlgItem(IDC_RADIO_STANDARDNONOVERLAP)->EnableWindow(bEnable && !bSfwTrigger);
	GetDlgItem(IDC_RADIO_SYNCHRO)->EnableWindow(bEnable && !bSfwTrigger);
    GetDlgItem(IDC_RADIO_GLOABAL)->EnableWindow(bEnable && !bSfwTrigger && !IsDhyana400BSIV2() && !IsDhyana400BSIV3());

	if (m_bClTrg)
	{
		 GetDlgItem(IDC_RADIO_TIMED)->EnableWindow(bEnable && !bSfwTrigger && TUCCM_SEQUENCE != m_nTriMode);
	}
	else
	{
		GetDlgItem(IDC_RADIO_TIMED)->EnableWindow(bEnable && !bSfwTrigger && TUCCM_TRIGGER_SYNCHRONOUS != m_nTriMode && TUCCM_SEQUENCE != m_nTriMode);
	}

	if (m_ccmode->IsDhyana1605())
	{
		TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, TUIDC_SHUTTER, &nVal);
		GetDlgItem(IDC_RADIO_WIDTH)->EnableWindow((0 == nVal) ? FALSE : (bEnable && !bSfwTrigger && TUCCM_SEQUENCE != m_nTriMode));
	}
	else
	{
		GetDlgItem(IDC_RADIO_WIDTH)->EnableWindow(bEnable && !bSfwTrigger && TUCCM_SEQUENCE != m_nTriMode);
	}
    ///GetDlgItem(IDC_RADIO_WIDTH)->EnableWindow(bEnable && !bSfwTrigger && TUCCM_SEQUENCE != m_nTriMode);
    GetDlgItem(IDC_RADIO_RISING)->EnableWindow(bEnable && !bSfwTrigger && TUCCM_SEQUENCE != m_nTriMode);
    GetDlgItem(IDC_RADIO_FALLING)->EnableWindow(bEnable && !bSfwTrigger && TUCCM_SEQUENCE != m_nTriMode);

    m_chkSFWTri.EnableWindow(bEnable);
    GetDlgItem(IDC_BTN_APPLY)->EnableWindow(bEnable);
    GetDlgItem(IDC_BTN_SNAP)->EnableWindow(bEnable);
    RefreshTrigModeEnable();
	UpdateTotalFrameUI();
}

void Trigger::RefreshTrigModeEnable()
{
	if ((FL20BW_PID_SSC183IM1 == m_nPID) || (DHYANA_D401D_PID == m_nPID) || (DHYANA_D201D_PID == m_nPID) || (DHYANA_D4040_PID == m_nPID))
	{
		GetDlgItem(IDC_RADIO_SYNCHRO)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_GLOABAL)->EnableWindow(FALSE);
	}

	if (IsDhyana400BSIV2() && m_ccmode->m_nImgMode == TUIM_BSIGLOBAL_RESET)
	{
		GetDlgItem(IDC_RADIO_SYNCHRO)->EnableWindow(FALSE);
	}

	if (IsDhyana400BSIV3() && m_ccmode->m_nImgMode == TUIM_GLOBAL_RESET)
	{
		GetDlgItem(IDC_RADIO_SYNCHRO)->EnableWindow(FALSE);
	}
}

void Trigger::RefreshGlobalreset()                       
{
	if (!IsDhyana400BSIV2() && !IsDhyana400BSIV3())
	{
		return;
	}
	TUCAM_TRIGGER_ATTR tgrAttr;
	if (TUCAMRET_SUCCESS != TUCAM_Cap_GetTrigger(m_opCam.hIdxTUCam, &tgrAttr))
	{
		return;
	}

	bool globalResetFlag = false;
	if (IsDhyana400BSIV2() && m_ccmode->m_nImgMode == TUIM_BSIGLOBAL_RESET)
	{
		globalResetFlag = true;
	}

	if (IsDhyana400BSIV3() && m_ccmode->m_nImgMode == TUIM_GLOBAL_RESET)
	{
		globalResetFlag = true;
	}

	if (globalResetFlag)
	{
		if (tgrAttr.nTgrMode == TUCCM_TRIGGER_GLOBAL || tgrAttr.nTgrMode == TUCCM_TRIGGER_SYNCHRONOUS)
		{
			((CButton *)GetDlgItem(IDC_RADIO_OFF))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_STANDARD))->SetCheck(TRUE);
			((CButton *)GetDlgItem(IDC_RADIO_SYNCHRO))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_GLOABAL))->SetCheck(FALSE);
			((CButton *)GetDlgItem(IDC_RADIO_STANDARDNONOVERLAP))->SetCheck(FALSE);
			OnBnClickedRadioStandard();
		}
		GetDlgItem(IDC_RADIO_SYNCHRO)->EnableWindow(FALSE);
	}
	else
	{
		if (GetDlgItem(IDC_RADIO_STANDARD)->IsWindowEnabled() || GetDlgItem(IDC_RADIO_STANDARDNONOVERLAP)->IsWindowEnabled())
			GetDlgItem(IDC_RADIO_SYNCHRO)->EnableWindow(TRUE);
	}   
	GetDlgItem(IDC_RADIO_GLOABAL)->EnableWindow(FALSE);

	if (RollingScanManager::GetInstance()->IsSupportRollingScan())
	{
		GetDlgItem(IDC_STA_RCSTATUS)->EnableWindow(!globalResetFlag);
		GetDlgItem(IDC_CMB_STATUS)->EnableWindow(!globalResetFlag);

		if (globalResetFlag)
		{
			RollingScanManager::GetInstance()->SetRollingScanMode(0);
		}

		RollingScanManager::GetInstance()->UpdateSlitHeightRange();
		///int slitheight = RollingScanManager::GetInstance()->GetSlitHeight();
		slitHeightSlider.SetRange(RollingScanManager::GetInstance()->GetMinSlitHeight(), RollingScanManager::GetInstance()->GetMaxSlitHeight());
		slitHeightSlider.SetTicFreq(1);
		slitHeightSlider.SetLineSize(RollingScanManager::GetInstance()->GetStepSlitHeight());
		///m_bSlitHeightChange = TRUE;
		///slitHeightSlider.SetPos(slitheight);
		///m_bSlitHeightChange = FALSE;
		RollingScanManager::GetInstance()->UpdateLineTimeDelayRange();
		lineTimeDelaySlider.SetRange(RollingScanManager::GetInstance()->GetMinLineTimeDelay(), RollingScanManager::GetInstance()->GetMaxLineTimeDelay());
		int linetimedelay = RollingScanManager::GetInstance()->GetLineTimeDelay();
		lineTimeDelaySlider.SetTicFreq(1);
		m_bLineTimeDelayChange = TRUE;
		lineTimeDelaySlider.SetPos(linetimedelay);
		m_bLineTimeDelayChange = FALSE;

		UpdateRollingScanUI();
	}
}

void Trigger::UpdateTriggerUI()
{
	int rollingScanMode = RollingScanManager::GetInstance()->GetRollingScanMode();
	if (rollingScanMode == RollingScanManager::OFF)
	{
		OnBnClickedRadioOff();
		((CButton *)GetDlgItem(IDC_RADIO_OFF))->SetCheck(TRUE);
		((CButton *)GetDlgItem(IDC_RADIO_STANDARD))->SetCheck(FALSE);
		((CButton *)GetDlgItem(IDC_RADIO_SYNCHRO))->SetCheck(FALSE);
		((CButton *)GetDlgItem(IDC_RADIO_GLOABAL))->SetCheck(FALSE);
		((CButton *)GetDlgItem(IDC_RADIO_STANDARDNONOVERLAP))->SetCheck(FALSE);
		//EnableTriggerControl(FALSE);
	}
}

void Trigger::UpdateDelayTime(DWORD dwExp)
{
    m_uSec = (dwExp / (1000 * 1000)) % 60;
    m_uMs  = (dwExp / 1000) % 1000;
    m_uUs  = dwExp % 1000;

    CString sz;
    sz.Format(_T("%d"), m_uSec);
    GetDlgItem(IDC_EDT_SEC)->SetWindowText(sz);
    sz.Format(_T("%d"), m_uMs);
    GetDlgItem(IDC_EDT_MS)->SetWindowText(sz);
    sz.Format(_T("%d"), m_uUs);
    GetDlgItem(IDC_EDT_US)->SetWindowText(sz);
}

void Trigger::OnCbnSelchangeCmbStatus()
{
	if (!RollingScanManager::GetInstance()->IsSupportRollingScan())
	{
		return;
	}
	RollingScanManager::GetInstance()->SetRollingScanMode(rollingScanModeComboBox.GetCurSel());
	
	RefreshGlobalreset();
}

void Trigger::OnNMCustomdrawSldLtdelay(NMHDR *pNMHDR, LRESULT *pResult)
{
	if (!RollingScanManager::GetInstance()->IsSupportRollingScan())
	{
		return;
	}

	if (m_bLineTimeDelayChange)
	{
		m_bLineTimeDelayChange = FALSE;
		return;
	}

	RollingScanManager::GetInstance()->SetLineTimeDelay(lineTimeDelaySlider.GetPos());
	UpdateRollingScanUI();
}

void Trigger::OnNMCustomdrawSldSlitheight(NMHDR *pNMHDR, LRESULT *pResult)
{
	if (!RollingScanManager::GetInstance()->IsSupportRollingScan())
	{
		return;
	}

	if (m_bSlitHeightChange)
	{
		m_bSlitHeightChange = FALSE;
		return;
	}

	RollingScanManager::GetInstance()->SetSlitHeight(slitHeightSlider.GetPos());
	UpdateRollingScanUI();
}

void Trigger::OnCbnSelchangeCmbRodir()
{	
	if (!RollingScanManager::GetInstance()->IsSupportRollingScan())
	{
		return;
	}
	RollingScanManager::GetInstance()->SetReadoutDirection(readoutDirectionComboBox.GetCurSel());
	UpdateRollingScanUI();
}

void Trigger::OnCbnSelchangeCmbRodirreset()
{
	if (!RollingScanManager::GetInstance()->IsSupportRollingScan())
	{
		return;
	}
	RollingScanManager::GetInstance()->SetReadoutDirectionReset(readoutDirectionResetComboBox.GetCurSel());
	UpdateRollingScanUI();
}

void Trigger::OnCbnSelchangeCmbSiginmode()
{
}

void Trigger::OnBnClickedRadioOff()
{
    m_chkSFWTri.SetCheck(FALSE);
	m_nTriMode = TUCCM_SEQUENCE;
	m_ccmode->m_nTriMode = m_nTriMode;

    GetDlgItem(IDC_RADIO_TIMED)->EnableWindow(FALSE);
    GetDlgItem(IDC_RADIO_WIDTH)->EnableWindow(FALSE);
    GetDlgItem(IDC_RADIO_RISING)->EnableWindow(FALSE);
    GetDlgItem(IDC_RADIO_FALLING)->EnableWindow(FALSE);

	EnabledDelayTimeUI(false);
	OnBnClickedBtnApply();
}

void Trigger::OnBnClickedRadioStandard()
{
	m_nTriMode = TUCCM_TRIGGER_STANDARD;
	m_ccmode->m_nTriMode = m_nTriMode;
    GetDlgItem(IDC_RADIO_TIMED)->EnableWindow(TRUE);
    GetDlgItem(IDC_RADIO_WIDTH)->EnableWindow(TRUE);
    GetDlgItem(IDC_RADIO_RISING)->EnableWindow(TRUE);
    GetDlgItem(IDC_RADIO_FALLING)->EnableWindow(TRUE);

	EnabledDelayTimeUI(!m_nTriExp);

	OnBnClickedBtnApply();
}

void Trigger::OnBnClickedRadioStandardnonoverlap()
{
	m_nTriMode = TUCCM_TRIGGER_STANDARD_NONOVERLAP;
	m_ccmode->m_nTriMode = m_nTriMode;
	GetDlgItem(IDC_RADIO_TIMED)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_WIDTH)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_RISING)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_FALLING)->EnableWindow(TRUE);

	EnabledDelayTimeUI(!m_nTriExp);

	OnBnClickedBtnApply();
}

void Trigger::OnBnClickedRadioSynchro()
{
	m_nTriMode = TUCCM_TRIGGER_SYNCHRONOUS;
	m_ccmode->m_nTriMode = m_nTriMode;

	if (m_bClTrg)
	{
		GetDlgItem(IDC_RADIO_TIMED)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_WIDTH)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_RISING)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_FALLING)->EnableWindow(TRUE);

		EnabledDelayTimeUI(!m_nTriExp);
	}
	else
	{
		m_nTriExp  = TUCTE_WIDTH;
		//((CButton *)GetDlgItem(IDC_RADIO_WIDTH))->SetCheck(TRUE);
		//((CButton *)GetDlgItem(IDC_RADIO_TIMED))->SetCheck(FALSE);

		GetDlgItem(IDC_RADIO_TIMED)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_WIDTH)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_RISING)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_FALLING)->EnableWindow(TRUE);

		EnabledDelayTimeUI(false);
	}

    UpdateData(FALSE);

	OnBnClickedBtnApply();
}

void Trigger::OnBnClickedRadioGloabal()
{
	m_nTriMode = TUCCM_TRIGGER_GLOBAL;
	m_ccmode->m_nTriMode = m_nTriMode;

	if (m_bClTrg)
	{
		GetDlgItem(IDC_RADIO_TIMED)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_WIDTH)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_RISING)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_FALLING)->EnableWindow(TRUE);

		EnabledDelayTimeUI(!m_nTriExp);
	}
	else
	{
		GetDlgItem(IDC_RADIO_TIMED)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_WIDTH)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_RISING)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_FALLING)->EnableWindow(TRUE);

		EnabledDelayTimeUI(false);
	}

    UpdateData(FALSE);

	OnBnClickedBtnApply();
}

void Trigger::OnBnClickedRadioTimed()
{
	m_nTriExp = TUCTE_EXPTM;

	if (m_bClTrg)
	{
		EnabledDelayTimeUI(true);
	}
	else
	{
		EnabledDelayTimeUI(TUCCM_TRIGGER_GLOBAL != m_nTriMode);
	}

    UpdateData(FALSE);

	OnBnClickedBtnApply();
}

void Trigger::OnBnClickedRadioWidth()
{
	m_nTriExp = TUCTE_WIDTH;

	EnabledDelayTimeUI(false);

    UpdateData(FALSE);

	OnBnClickedBtnApply();
}

void Trigger::OnBnClickedRadioRising()
{
	m_nTriEdge = TUCTD_RISING;
	OnBnClickedBtnApply();
}

void Trigger::OnBnClickedRadioFalling()
{
	m_nTriEdge = TUCTD_FAILING;
	OnBnClickedBtnApply();
}

void Trigger::OnEnChangeEdtTotalframes()
{
	UpdateData();
	if (m_nTotalFrames > 0xFFFF)
	{
		m_nTotalFrames = 0xFFFF;
	}
    m_nTotalFrames = max(m_nTotalFrames, 1);

	UpdateData(FALSE);
}

void Trigger::OnBnClickedBtnStop()
{
    OnBnClickedBtnApply();	
}

void Trigger::OnDeltaposSpnSec(NMHDR *pNMHDR, LRESULT *pResult)
{
    LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
    
    m_uSec = GetDlgItemInt(IDC_EDT_SEC);

    if (pNMUpDown->iDelta < 0)
    {
        if (m_uSec >= 59)
        {
            return;
        }
        m_uSec++;

        CString strSec;
        strSec.Format(_T("%d"), m_uSec);
        GetDlgItem(IDC_EDT_SEC)->SetWindowText(strSec);
    }
    else if (pNMUpDown->iDelta > 0)
    {
        if (m_uSec <= 0)
        {
            return;
        }
        m_uSec--;

        CString strSec;
        strSec.Format(_T("%d"), m_uSec);
        GetDlgItem(IDC_EDT_SEC)->SetWindowText(strSec);
    }
    *pResult = 0;
}

void Trigger::OnDeltaposSpnMs(NMHDR *pNMHDR, LRESULT *pResult)
{
    LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
    
    m_uMs = GetDlgItemInt(IDC_EDT_MS);

    if (pNMUpDown->iDelta < 0)
    {
        if (m_uMs >= 999)
        {
            return;
        }
        m_uMs++;

        CString strMs;
        strMs.Format(_T("%d"), m_uMs);
        GetDlgItem(IDC_EDT_MS)->SetWindowText(strMs);
    }
    else if (pNMUpDown->iDelta > 0)
    {
        if (m_uMs <= 0)
        {
            return;
        }
        m_uMs--;

        CString strMs;
        strMs.Format(_T("%d"), m_uMs);
        GetDlgItem(IDC_EDT_MS)->SetWindowText(strMs);
    }
    *pResult = 0;
}

void Trigger::OnDeltaposSpnUs(NMHDR *pNMHDR, LRESULT *pResult)
{
    LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
    
    m_uUs = GetDlgItemInt(IDC_EDT_US);

    if (pNMUpDown->iDelta < 0)
    {
        if (m_uUs >= 999)
        {
            return;
        }
        m_uUs += 1;

        CString strUs;
        strUs.Format(_T("%d"), m_uUs);
        GetDlgItem(IDC_EDT_US)->SetWindowText(strUs);
    }
    else if (pNMUpDown->iDelta > 0)
    {
        if (m_uUs == 0)
        {
            return;
        }

        if (m_uUs < 1)
        {
            m_uUs = 1;
        }
        else
        {
            m_uUs -= 1;
        }       

        CString strUs;
        strUs.Format(_T("%d"), m_uUs);
        GetDlgItem(IDC_EDT_US)->SetWindowText(strUs);
    }

    *pResult = 0;
}

void Trigger::OnBnClickedBtnUpdate()
{
	GetDelayTime();

    OnBnClickedBtnApply();
}

void Trigger::OnBnClickedChkSttrigger()
{
	BOOL bSfw = m_chkSFWTri.GetCheck();

    if (bSfw)
    {
        m_nTriMode = TUCCM_TRIGGER_SOFTWARE;
		m_ccmode->m_nTriMode = m_nTriMode;        
    }
    else
    {
        m_nTriMode = TUCCM_SEQUENCE;
		m_ccmode->m_nTriMode = m_nTriMode;
        ((CButton *)GetDlgItem(IDC_RADIO_OFF))->SetCheck(TRUE);
        ((CButton *)GetDlgItem(IDC_RADIO_STANDARD))->SetCheck(FALSE);
        ((CButton *)GetDlgItem(IDC_RADIO_SYNCHRO))->SetCheck(FALSE);
        ((CButton *)GetDlgItem(IDC_RADIO_GLOABAL))->SetCheck(FALSE);
		((CButton *)GetDlgItem(IDC_RADIO_STANDARDNONOVERLAP))->SetCheck(FALSE);
    }

    GetDlgItem(IDC_RADIO_OFF)->EnableWindow(!bSfw);
    GetDlgItem(IDC_RADIO_STANDARD)->EnableWindow(!bSfw);
	GetDlgItem(IDC_RADIO_STANDARDNONOVERLAP)->EnableWindow(!bSfw);
    GetDlgItem(IDC_RADIO_SYNCHRO)->EnableWindow(!bSfw);
    GetDlgItem(IDC_RADIO_GLOABAL)->EnableWindow(!bSfw && !IsDhyana400BSIV2() && !IsDhyana400BSIV3());
    GetDlgItem(IDC_RADIO_TIMED)->EnableWindow(!bSfw);
    GetDlgItem(IDC_RADIO_WIDTH)->EnableWindow(!bSfw);
    GetDlgItem(IDC_RADIO_RISING)->EnableWindow(!bSfw);
    GetDlgItem(IDC_RADIO_FALLING)->EnableWindow(!bSfw);

	EnabledDelayTimeUI(!bSfw);

	RefreshTrigModeEnable();

	OnBnClickedBtnApply();
}

void Trigger::OnBnClickedBtnSnap()
{
    UpdateData(FALSE);

    if (NULL != m_ccmode->m_tabPage[2])          
        ((ImageCapture*)m_ccmode->m_tabPage[2])->GetDlgItem(IDC_EDT_PICNAME)->GetWindowText(m_ccmode->m_szPicName);

	//IDC_CHK_STTRIGGER
	//ImageSaveManager::GetInstance()->StartCapture();

    if (NULL != m_opCam.hIdxTUCam)
    {
		DWORD dw = GetTickCount();

        TUCAM_Cap_DoSoftwareTrigger(m_opCam.hIdxTUCam);

		m_ccmode->m_dwTmTrigger = GetTickCount();
    }
}

void Trigger::OnBnClickedBtnApply()
{
	UpdateData();
	bool bLiving = m_ccmode->m_bWaitting;
	int delayTime = GetDelayTime();

    if (NULL != m_ccmode->m_tabPage[2])          
        ((ImageCapture*)m_ccmode->m_tabPage[2])->GetDlgItem(IDC_EDT_PICNAME)->GetWindowText(m_ccmode->m_szPicName);

    GetDlgItem(IDC_BTN_APPLY)->EnableWindow(FALSE);
    EnableTriggerControl(FALSE);

	BOOL bTriModeChange = TRUE;
    TUCAM_TRIGGER_ATTR tgrAttr;
    TUCAM_Cap_GetTrigger(m_opCam.hIdxTUCam, &tgrAttr);

    if (tgrAttr.nTgrMode == m_nTriMode)
    {
        bTriModeChange = FALSE;
    }

	if (/*m_ccmode->m_bWaitting*/bLiving)
    {
		if (bTriModeChange)
		{
			m_ccmode->StopWaitForFrame();
		}
    }
    else
    {
        Sleep(1000);

        //if(NULL != m_ccmode->m_tabPage[1])
            //((CameraControl*)m_ccmode->m_tabPage[1])->BtnShow(FALSE);
    }

    if (TUCCM_TRIGGER_SYNCHRONOUS == m_ccmode->m_nTriMode || TUCCM_TRIGGER_GLOBAL == m_ccmode->m_nTriMode || TUCCM_SEQUENCE == m_ccmode->m_nTriMode)
    {
        UpdateData(FALSE);
    }

	tgrAttr.nTgrMode = m_nTriMode;
	tgrAttr.nExpMode = m_nTriExp;
	tgrAttr.nEdgeMode = m_nTriEdge;
	tgrAttr.nFrames   = 1;
    tgrAttr.nBufFrames = m_ccmode->m_nBufferNum;
	tgrAttr.nDelayTm = delayTime;

	if (TUCCM_SEQUENCE < m_ccmode->m_nTriMode && m_ccmode->m_nTriMode < TUCCM_TRIGGER_SOFTWARE || m_ccmode->m_nTriMode == TUCCM_TRIGGER_STANDARD_NONOVERLAP)
	{
		tgrAttr.nFrames = m_nTotalFrames;// -1;   // To RAM
		m_ccmode->m_bImgToRam = FALSE;
		///tgrAttr.nBufFrames = -1;   // To RAM
	}
	else
	{
		m_ccmode->m_bImgToRam = FALSE;
	}

    ///m_ccmode->m_bTrigger = (TUCCM_SEQUENCE != m_nTriMode) ? TRUE : FALSE;
    m_ccmode->m_nTriMode = m_nTriMode;

    // ô
    TUCAM_Cap_SetTrigger(m_opCam.hIdxTUCam, tgrAttr);

    if (TUCCM_SEQUENCE != m_nTriMode)
    {
		if (bTriModeChange)
		{
			m_ccmode->m_nCntSave    = 0;
			m_ccmode->m_uiCapFrames = 1;

			if (bLiving)
			{
				m_ccmode->StartWaitForFrame();
				m_ccmode->UpdataPic();
			}
		}
    }
   
	if(NULL != m_ccmode->m_tabPage[1])
		((CameraControl*)m_ccmode->m_tabPage[1])->RefreshRate();

    GetDlgItem(IDC_BTN_APPLY)->EnableWindow(TRUE);
    EnableTriggerControl(TRUE);
	EnabledRollingScanUI();
	ShowSignalFilter();
	if ((TUCCM_SEQUENCE == m_nTriMode && RollingScanManager::OFF == RollingScanManager::GetInstance()->GetRollingScanMode()) || TUCCM_TRIGGER_SOFTWARE == m_nTriMode || TUCCM_TRIGGER_STANDARD == m_nTriMode || TUCCM_TRIGGER_STANDARD_NONOVERLAP == m_nTriMode)
	{
		GetDlgItem(IDC_STA_RCLTDELAY)->EnableWindow(FALSE);
		GetDlgItem(IDC_SLD_LTDELAY)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDT_LTD)->EnableWindow(FALSE);
		GetDlgItem(IDC_STA_RCSLIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_SLD_SLITHEIGHT)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDT_SLIT)->EnableWindow(FALSE);
	}
}

int Trigger::GetDelayTime()
{
	UpdateData();
	int delayTime = m_uSec * 1000 * 1000 + m_uMs * 1000 + m_uUs;
	if (delayTime > 10000000)
	{
		delayTime = 10000000;
		m_uSec = 10;
		m_uMs = 0;
		m_uUs = 0;
		UpdateData(FALSE);
	}

	return delayTime;
}


void Trigger::OnDeltaposSpnSfus(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO:  ڴӿؼ֪ͨ
	m_nSignalFilter = GetDlgItemInt(IDC_EDT_SFUS);

	if (pNMUpDown->iDelta < 0)
	{
		if (m_nSignalFilter > 1000000)
		{
			m_nSignalFilter = 1000000;
		}
		else
		{
			m_nSignalFilter++;
		}
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_nSignalFilter <= 0)
		{
			m_nSignalFilter = 0;
		}
		else
		{
			m_nSignalFilter--;
		}	
	}

	UpdateSignalFilter();

	*pResult = 0;
}

void Trigger::UpdateSignalFilter()
{
	if (NULL == m_opCam.hIdxTUCam)
	{
		return;
	}

	TUCAM_CAPA_ATTR  attrCapa;
	attrCapa.idCapa = TUIDC_SIGNALFILTER;
	if (TUCAMRET_SUCCESS == TUCAM_Capa_GetAttr(m_opCam.hIdxTUCam, &attrCapa))
	{
		m_nSignalFilter = min(max(m_nSignalFilter, attrCapa.nValMin), attrCapa.nValMax);
		TUCAM_Capa_SetValue(m_opCam.hIdxTUCam, TUIDC_SIGNALFILTER, m_nSignalFilter);
	}

	CString strTxt;
	strTxt.Format(_T("%d"), m_nSignalFilter);
	GetDlgItem(IDC_EDT_SFUS)->SetWindowText(strTxt);
}

void Trigger::ShowSignalFilter()
{
	if (NULL == m_opCam.hIdxTUCam)
	{
		return;
	}

	BOOL bShow = FALSE;
	INT  nVal = 0;
	TUCAM_CAPA_ATTR  attrCapa;
	attrCapa.idCapa = TUIDC_SIGNALFILTER;
	if (TUCAMRET_SUCCESS != TUCAM_Capa_GetAttr(m_opCam.hIdxTUCam, &attrCapa))
	{
		GetDlgItem(IDC_STA_SG)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_EDT_SFUS)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_SPN_SFUS)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STA_SFUS)->ShowWindow(SW_HIDE);
		return;
	}
	else
	{
		TUCAM_Capa_GetValue(m_opCam.hIdxTUCam, TUIDC_SIGNALFILTER, &nVal);
		m_nSignalFilter = nVal;

		CString strTxt;
		strTxt.Format(_T("%d"), m_nSignalFilter);
		GetDlgItem(IDC_EDT_SFUS)->SetWindowText(strTxt);
	}

	TUCAM_TRIGGER_ATTR tgrAttr;
	if (TUCAMRET_SUCCESS == TUCAM_Cap_GetTrigger(m_opCam.hIdxTUCam, &tgrAttr))
	{
		if (TUCCM_SEQUENCE == tgrAttr.nTgrMode || TUCCM_TRIGGER_SOFTWARE == tgrAttr.nTgrMode)
		{
			bShow = FALSE;
		}
		else
		{
			bShow = TRUE;
		}
	}

	GetDlgItem(IDC_STA_SG)->ShowWindow(bShow ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_EDT_SFUS)->ShowWindow(bShow ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_SPN_SFUS)->ShowWindow(bShow ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_STA_SFUS)->ShowWindow(bShow ? SW_SHOW : SW_HIDE);
}

