#pragma once

#include "CameraControlMode.h"
#include "afxwin.h"
#include "afxcmn.h"
#include <vector>
using namespace std;

class Trigger : public CDialog
{
	DECLARE_DYNAMIC(Trigger)

public:
	//Trigger(CWnd* pParent = NULL);
	//virtual ~Trigger();
	Trigger(TUCAM_OPEN &opCam, CCameraControlMode* pParent);
	enum { IDD = IDD_DLG_TRIGER };

	void RefreshOpen(TUCAM_OPEN &opCam);
	void InitControlRange();                            // ʼؼΧ
    void RefreshValue();                                // ˢ¿ؼֵ   
	void EnableTriggerControl(BOOL bEnable = FALSE);    // ʹ
	void RefreshGlobalreset(); // ˢGlobalreset

protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	DECLARE_MESSAGE_MAP()

public:
	afx_msg void OnCbnSelchangeCmbStatus();
	afx_msg void OnNMCustomdrawSldLtdelay(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawSldSlitheight(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnCbnSelchangeCmbRodir();
	afx_msg void OnCbnSelchangeCmbRodirreset();

	afx_msg void OnCbnSelchangeCmbSiginmode();

	afx_msg void OnBnClickedRadioOff();
	afx_msg void OnBnClickedRadioStandard();
	afx_msg void OnBnClickedRadioSynchro();
	afx_msg void OnBnClickedRadioGloabal();

	afx_msg void OnBnClickedRadioTimed();
	afx_msg void OnBnClickedRadioWidth();

	afx_msg void OnBnClickedRadioRising();
	afx_msg void OnBnClickedRadioFalling();

	afx_msg void OnEnChangeEdtTotalframes();
	afx_msg void OnBnClickedBtnStop();

	afx_msg void OnDeltaposSpnSec(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposSpnMs(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposSpnUs(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedBtnUpdate();

	afx_msg void OnBnClickedChkSttrigger();
	afx_msg void OnBnClickedBtnSnap();
	afx_msg void OnBnClickedBtnApply();
	
private:
	TUCAM_OPEN m_opCam;
	CCameraControlMode* m_ccmode;

	CComboBox rollingScanModeComboBox;
	CSliderCtrl lineTimeDelaySlider;
	UINT lineTimeDelay;
	CSliderCtrl slitHeightSlider;
	UINT slitHeight;	
	CComboBox readoutDirectionComboBox;
	CComboBox readoutDirectionResetComboBox;

	CComboBox m_cmbSiginMode;

	int m_nTriMode;
	BOOL m_bTriShow;
	BOOL m_bClTrg;
    int m_nTriExp;
	int m_nTriEdge;
	UINT m_nTotalFrames;

    UINT m_uSec;
    UINT m_uMs;
    UINT m_uUs;

	CButton m_chkSFWTri;

	int  m_nPID;
	int  m_nBCD;

	BOOL m_bSlitHeightChange;
	BOOL m_bLineTimeDelayChange;

private:
	void InitRollingScanUI();
	void ComboBoxAddStringList(CComboBox *comboBox, vector<char *> &list);
	void UpdateRollingScanUI();
	void EnabledRollingScanUI();
	
	void UpdateTriggerUI();
	void RefreshTrigModeEnable();
	void RefreshSoftTrigger();

	void UpdateTotalFrameUI();
	void EnabledDelayTimeUI(BOOL enabled = true);

	void UpdateDelayTime(DWORD dwExp);
	int GetDelayTime();
	bool IsDhyana400BSIV3() { return m_nPID == 0xE419 || m_nPID == 0xE420; }
	bool IsDhyana400BSIV2() { return m_nPID == 0xE408; }
	bool IsDhyana95V2New()  { return m_nPID == 0xE40F && m_nBCD >= 0x2000; }
	bool IsDhyana401DNew()  { return m_nPID == 0xE005 && m_nBCD >= 0x2000; }
	bool IsDhyana400BSIV3New()  { return IsDhyana400BSIV3() && m_nBCD >= 0x2000; }
	
public:
	INT m_nSignalFilter;
	afx_msg void OnDeltaposSpnSfus(NMHDR *pNMHDR, LRESULT *pResult);
	void UpdateSignalFilter();
	void ShowSignalFilter();
	afx_msg void OnBnClickedRadioStandardnonoverlap();
};
